import*as Common from"../common/common.js";import*as Components from"../components/components.js";import*as DataGrid from"../data_grid/data_grid.js";import*as i18n from"../i18n/i18n.js";import*as Platform from"../platform/platform.js";import*as Root from"../root/root.js";import*as SDK from"../sdk/sdk.js";import*as TextUtils from"../text_utils/text_utils.js";import*as UI from"../ui/ui.js";import{Events}from"./CSSOverviewController.js";import{CSSOverviewSidebarPanel}from"./CSSOverviewSidebarPanel.js";const UIStrings={overviewSummary:"Overview summary",colors:"Colors",fontInfo:"Font info",unusedDeclarations:"Unused declarations",mediaQueries:"Media queries",elements:"Elements",externalStylesheets:"External stylesheets",inlineStyleElements:"Inline style elements",styleRules:"Style rules",typeSelectors:"Type selectors",idSelectors:"ID selectors",classSelectors:"Class selectors",universalSelectors:"Universal selectors",attributeSelectors:"Attribute selectors",nonsimpleSelectors:"Non-simple selectors",backgroundColorsS:"Background colors: {PH1}",textColorsS:"Text colors: {PH1}",fillColorsS:"Fill colors: {PH1}",borderColorsS:"Border colors: {PH1}",thereAreNoFonts:"There are no fonts.",thereAreNoUnusedDeclarations:"There are no unused declarations.",thereAreNoMediaQueries:"There are no media queries.",contrastIssues:"Contrast issues",oneOccurrence:"1 occurrence",nOccurrences:"{count} occurrences",contrastIssuesS:"Contrast issues: {PH1}",textColorSOverSBackgroundResults:"Text color {PH1} over {PH2} background results in low contrast for {PH3} elements",aa:"AA",aaa:"AAA",apca:"APCA",element:"Element",declaration:"Declaration",source:"Source",contrastRatio:"Contrast ratio",cssOverviewElements:"CSS Overview Elements",showElement:"Show element"},str_=i18n.i18n.registerUIStrings("css_overview/CSSOverviewCompletedView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);function getBorderString(e){let[t,i,s]=e.hsla();return t=Math.round(360*t),i=Math.round(100*i),s=Math.round(100*s),s=Math.max(0,s-15),`1px solid hsl(${t}deg ${i}% ${s}%)`}export class CSSOverviewCompletedView extends UI.Panel.PanelWithSidebar{constructor(e,t){super("css_overview_completed_view"),this.registerRequiredCSS("css_overview/cssOverviewCompletedView.css",{enableLegacyPatching:!1}),this._controller=e,this._formatter=new Intl.NumberFormat("en-US"),this._mainContainer=new UI.SplitWidget.SplitWidget(!0,!0),this._resultsContainer=new UI.Widget.VBox,this._elementContainer=new DetailsView,this._elementContainer.addEventListener(UI.TabbedPane.Events.TabClosed,(e=>{0===e.data&&this._mainContainer.setSidebarMinimized(!0)})),this._mainContainer.registerRequiredCSS("css_overview/cssOverviewCompletedView.css",{enableLegacyPatching:!0}),this._mainContainer.setMainWidget(this._resultsContainer),this._mainContainer.setSidebarWidget(this._elementContainer),this._mainContainer.setVertical(!1),this._mainContainer.setSecondIsSidebar(!0),this._mainContainer.setSidebarMinimized(!0),this._sideBar=new CSSOverviewSidebarPanel,this.splitWidget().setSidebarWidget(this._sideBar),this.splitWidget().setMainWidget(this._mainContainer);const i=t.model(SDK.CSSModel.CSSModel),s=t.model(SDK.DOMModel.DOMModel);if(!i||!s)throw new Error("Target must provide CSS and DOM models");this._cssModel=i,this._domModel=s,this._domAgent=t.domAgent(),this._linkifier=new Components.Linkifier.Linkifier(20,!0),this._viewMap=new Map,this._sideBar.addItem(i18nString(UIStrings.overviewSummary),"summary"),this._sideBar.addItem(i18nString(UIStrings.colors),"colors"),this._sideBar.addItem(i18nString(UIStrings.fontInfo),"font-info"),this._sideBar.addItem(i18nString(UIStrings.unusedDeclarations),"unused-declarations"),this._sideBar.addItem(i18nString(UIStrings.mediaQueries),"media-queries"),this._sideBar.select("summary"),this._sideBar.addEventListener("ItemSelected",this._sideBarItemSelected,this),this._sideBar.addEventListener("Reset",this._sideBarReset,this),this._controller.addEventListener(Events.Reset,this._reset,this),this._controller.addEventListener(Events.PopulateNodes,this._createElementsView,this),this._resultsContainer.element.addEventListener("click",this._onClick.bind(this)),this._data=null}wasShown(){super.wasShown()}_sideBarItemSelected(e){const t=e.data,i=this._fragment.$(t);i&&i.scrollIntoView()}_sideBarReset(){this._controller.dispatchEventToListeners(Events.Reset)}_reset(){this._resultsContainer.element.removeChildren(),this._mainContainer.setSidebarMinimized(!0),this._elementContainer.closeTabs(),this._viewMap=new Map,CSSOverviewCompletedView.pushedNodes.clear(),this._sideBar.select("summary")}_onClick(e){if(!e.target)return;const t=e.target.dataset,i=t.type;if(!i||!this._data)return;let s;switch(i){case"contrast":{const e=t.section,n=t.key;if(!n)return;s={type:i,key:n,nodes:this._data.textColorContrastIssues.get(n)||[],section:e};break}case"color":{const e=t.color,n=t.section;if(!e)return;let r;switch(n){case"text":r=this._data.textColors.get(e);break;case"background":r=this._data.backgroundColors.get(e);break;case"fill":r=this._data.fillColors.get(e);break;case"border":r=this._data.borderColors.get(e)}if(!r)return;r=Array.from(r).map((e=>({nodeId:e}))),s={type:i,color:e,nodes:r,section:n};break}case"unused-declarations":{const e=t.declaration;if(!e)return;const n=this._data.unusedDeclarations.get(e);if(!n)return;s={type:i,declaration:e,nodes:n};break}case"media-queries":{const e=t.text;if(!e)return;const n=this._data.mediaQueries.get(e);if(!n)return;s={type:i,text:e,nodes:n};break}case"font-info":{const e=t.value;if(!t.path)return;const[n,r]=t.path.split("/");if(!e)return;const a=this._data.fontInfo.get(n);if(!a)return;const o=a.get(r);if(!o)return;const l=o.get(e);if(!l)return;s={type:i,name:`${e} (${n}, ${r})`,nodes:l.map((e=>({nodeId:e})))};break}default:return}e.consume(),this._controller.dispatchEventToListeners(Events.PopulateNodes,s),this._mainContainer.setSidebarMinimized(!1)}_onMouseOver(e){const t=e.composedPath().find((e=>e.dataset&&e.dataset.backendNodeId));if(!t)return;const i=Number(t.dataset.backendNodeId);this._controller.dispatchEventToListeners(Events.RequestNodeHighlight,i)}async _render(e){if(!e||!("backgroundColors"in e)||!("textColors"in e))return;this._data=e;const{elementCount:t,backgroundColors:i,textColors:s,textColorContrastIssues:n,fillColors:r,borderColors:a,globalStyleStats:o,mediaQueries:l,unusedDeclarations:d,fontInfo:c}=this._data,h=this._sortColorsByLuminance(i),m=this._sortColorsByLuminance(s),u=this._sortColorsByLuminance(r),g=this._sortColorsByLuminance(a);this._fragment=UI.Fragment.Fragment.build`
    <div class="vbox overview-completed-view">
      <div $="summary" class="results-section horizontally-padded summary">
        <h1>${i18nString(UIStrings.overviewSummary)}</h1>

        <ul>
          <li>
            <div class="label">${i18nString(UIStrings.elements)}</div>
            <div class="value">${this._formatter.format(t)}</div>
          </li>
          <li>
            <div class="label">${i18nString(UIStrings.externalStylesheets)}</div>
            <div class="value">${this._formatter.format(o.externalSheets)}</div>
          </li>
          <li>
            <div class="label">${i18nString(UIStrings.inlineStyleElements)}</div>
            <div class="value">${this._formatter.format(o.inlineStyles)}</div>
          </li>
          <li>
            <div class="label">${i18nString(UIStrings.styleRules)}</div>
            <div class="value">${this._formatter.format(o.styleRules)}</div>
          </li>
          <li>
            <div class="label">${i18nString(UIStrings.mediaQueries)}</div>
            <div class="value">${this._formatter.format(l.size)}</div>
          </li>
          <li>
            <div class="label">${i18nString(UIStrings.typeSelectors)}</div>
            <div class="value">${this._formatter.format(o.stats.type)}</div>
          </li>
          <li>
            <div class="label">${i18nString(UIStrings.idSelectors)}</div>
            <div class="value">${this._formatter.format(o.stats.id)}</div>
          </li>
          <li>
            <div class="label">${i18nString(UIStrings.classSelectors)}</div>
            <div class="value">${this._formatter.format(o.stats.class)}</div>
          </li>
          <li>
            <div class="label">${i18nString(UIStrings.universalSelectors)}</div>
            <div class="value">${this._formatter.format(o.stats.universal)}</div>
          </li>
          <li>
            <div class="label">${i18nString(UIStrings.attributeSelectors)}</div>
            <div class="value">${this._formatter.format(o.stats.attribute)}</div>
          </li>
          <li>
            <div class="label">${i18nString(UIStrings.nonsimpleSelectors)}</div>
            <div class="value">${this._formatter.format(o.stats.nonSimple)}</div>
          </li>
        </ul>
      </div>

      <div $="colors" class="results-section horizontally-padded colors">
        <h1>${i18nString(UIStrings.colors)}</h1>
        <h2>${i18nString(UIStrings.backgroundColorsS,{PH1:h.length})}</h2>
        <ul>
          ${h.map(this._colorsToFragment.bind(this,"background"))}
        </ul>

        <h2>${i18nString(UIStrings.textColorsS,{PH1:m.length})}</h2>
        <ul>
          ${m.map(this._colorsToFragment.bind(this,"text"))}
        </ul>

        ${n.size>0?this._contrastIssuesToFragment(n):""}

        <h2>${i18nString(UIStrings.fillColorsS,{PH1:u.length})}</h2>
        <ul>
          ${u.map(this._colorsToFragment.bind(this,"fill"))}
        </ul>

        <h2>${i18nString(UIStrings.borderColorsS,{PH1:g.length})}</h2>
        <ul>
          ${g.map(this._colorsToFragment.bind(this,"border"))}
        </ul>
      </div>

      <div $="font-info" class="results-section font-info">
        <h1>${i18nString(UIStrings.fontInfo)}</h1>
        ${c.size>0?this._fontInfoToFragment(c):UI.Fragment.Fragment.build`<div>${i18nString(UIStrings.thereAreNoFonts)}</div>`}
      </div>

      <div $="unused-declarations" class="results-section unused-declarations">
        <h1>${i18nString(UIStrings.unusedDeclarations)}</h1>
        ${d.size>0?this._groupToFragment(d,"unused-declarations","declaration"):UI.Fragment.Fragment.build`<div class="horizontally-padded">${i18nString(UIStrings.thereAreNoUnusedDeclarations)}</div>`}
      </div>

      <div $="media-queries" class="results-section media-queries">
        <h1>${i18nString(UIStrings.mediaQueries)}</h1>
        ${l.size>0?this._groupToFragment(l,"media-queries","text"):UI.Fragment.Fragment.build`<div class="horizontally-padded">${i18nString(UIStrings.thereAreNoMediaQueries)}</div>`}
      </div>
    </div>`,this._resultsContainer.element.appendChild(this._fragment.element())}_createElementsView(e){const{type:t,nodes:i}=e.data;let s="",n="";switch(t){case"contrast":{const{section:t,key:i}=e.data;s=`${t}-${i}`,n=i18nString(UIStrings.contrastIssues);break}case"color":{const{section:t,color:i}=e.data;s=`${t}-${i}`,n=`${i.toUpperCase()} (${t})`;break}case"unused-declarations":{const{declaration:t}=e.data;s=`${t}`,n=`${t}`;break}case"media-queries":{const{text:t}=e.data;s=`${t}`,n=`${t}`;break}case"font-info":{const{name:t}=e.data;s=`${t}`,n=`${t}`;break}}let r=this._viewMap.get(s);r||(r=new ElementDetailsView(this._controller,this._domModel,this._cssModel,this._linkifier),r.populateNodes(i),this._viewMap.set(s,r)),this._elementContainer.appendTab(s,n,r,!0)}_fontInfoToFragment(e){const t=Array.from(e.entries());return UI.Fragment.Fragment.build`
  ${t.map((([e,t])=>UI.Fragment.Fragment.build`<section class="font-family"><h2>${e}</h2> ${this._fontMetricsToFragment(e,t)}</section>`))}
  `}_fontMetricsToFragment(e,t){const i=Array.from(t.entries());return UI.Fragment.Fragment.build`
  <div class="font-metric">
  ${i.map((([t,i])=>{const s=`${e}/${t}`;return UI.Fragment.Fragment.build`
  <div>
  <h3>${t}</h3>
  ${this._groupToFragment(i,"font-info","value",s)}
  </div>`}))}
  </div>`}_groupToFragment(e,t,i,s=""){const n=Array.from(e.entries()).sort(((e,t)=>{const i=e[1];return t[1].length-i.length})),r=n.reduce(((e,t)=>e+t[1].length),0);return UI.Fragment.Fragment.build`<ul>
    ${n.map((([e,n])=>{const a=100*n.length/r,o=1===n.length?i18nString(UIStrings.oneOccurrence):i18nString(UIStrings.nOccurrences,{count:n.length});return UI.Fragment.Fragment.build`<li>
        <div class="title">${e}</div>
        <button data-type="${t}" data-path="${s}" data-${i}="${e}">
          <div class="details">${o}</div>
          <div class="bar-container">
            <div class="bar" style="width: ${a}%;"></div>
          </div>
        </button>
      </li>`}))}
    </ul>`}_contrastIssuesToFragment(e){return UI.Fragment.Fragment.build`
  <h2>${i18nString(UIStrings.contrastIssuesS,{PH1:e.size})}</h2>
  <ul>
  ${[...e.entries()].map((([e,t])=>this._contrastIssueToFragment(e,t)))}
  </ul>
  `}_contrastIssueToFragment(e,t){console.assert(t.length>0);let i=t[0];for(const l of t)Math.abs(l.contrastRatio)<Math.abs(i.contrastRatio)&&(i=l);const s=i.textColor.asString(Common.Color.Format.HEXA),n=i.backgroundColor.asString(Common.Color.Format.HEXA),r=Root.Runtime.experiments.isEnabled("APCA"),a=UI.Fragment.Fragment.build`<li>
      <button
        title="${i18nString(UIStrings.textColorSOverSBackgroundResults,{PH1:s,PH2:n,PH3:t.length})}"
        data-type="contrast" data-key="${e}" data-section="contrast" class="block" $="color">
        Text
      </button>
      <div class="block-title">
        <div class="contrast-warning hidden" $="aa"><span class="threshold-label">${i18nString(UIStrings.aa)}</span></div>
        <div class="contrast-warning hidden" $="aaa"><span class="threshold-label">${i18nString(UIStrings.aaa)}</span></div>
        <div class="contrast-warning hidden" $="apca"><span class="threshold-label">${i18nString(UIStrings.apca)}</span></div>
      </div>
    </li>`;if(r){const e=a.$("apca");i.thresholdsViolated.apca?e.appendChild(UI.Icon.Icon.create("smallicon-no")):e.appendChild(UI.Icon.Icon.create("smallicon-checkmark-square")),e.classList.remove("hidden")}else{const e=a.$("aa");i.thresholdsViolated.aa?e.appendChild(UI.Icon.Icon.create("smallicon-no")):e.appendChild(UI.Icon.Icon.create("smallicon-checkmark-square"));const t=a.$("aaa");i.thresholdsViolated.aaa?t.appendChild(UI.Icon.Icon.create("smallicon-no")):t.appendChild(UI.Icon.Icon.create("smallicon-checkmark-square")),e.classList.remove("hidden"),t.classList.remove("hidden")}const o=a.$("color");return o.style.backgroundColor=n,o.style.color=s,o.style.border=getBorderString(i.backgroundColor),a}_colorsToFragment(e,t){const i=UI.Fragment.Fragment.build`<li>
      <button data-type="color" data-color="${t}" data-section="${e}" class="block" $="color"></button>
      <div class="block-title">${t}</div>
    </li>`,s=i.$("color");s.style.backgroundColor=t;const n=Common.Color.Color.parse(t);if(n)return s.style.border=getBorderString(n),i}_sortColorsByLuminance(e){return Array.from(e.keys()).sort(((e,t)=>{const i=Common.Color.Color.parse(e),s=Common.Color.Color.parse(t);return i&&s?Common.ColorUtils.luminance(s.rgba())-Common.ColorUtils.luminance(i.rgba()):0}))}setOverviewData(e){this._render(e)}}CSSOverviewCompletedView.pushedNodes=new Set;export class DetailsView extends UI.Widget.VBox{constructor(){super(),this._tabbedPane=new UI.TabbedPane.TabbedPane,this._tabbedPane.show(this.element),this._tabbedPane.addEventListener(UI.TabbedPane.Events.TabClosed,(()=>{this.dispatchEventToListeners(UI.TabbedPane.Events.TabClosed,this._tabbedPane.tabIds().length)}))}appendTab(e,t,i,s){this._tabbedPane.hasTab(e)||this._tabbedPane.appendTab(e,t,i,void 0,void 0,s),this._tabbedPane.selectTab(e)}closeTabs(){this._tabbedPane.closeTabs(this._tabbedPane.tabIds())}}export class ElementDetailsView extends UI.Widget.Widget{constructor(e,t,i,s){super(),this._controller=e,this._domModel=t,this._cssModel=i,this._linkifier=s,this._elementGridColumns=[{id:"nodeId",title:i18nString(UIStrings.element),sortable:!0,weight:50,titleDOMFragment:void 0,sort:void 0,align:void 0,width:void 0,fixedWidth:void 0,editable:void 0,nonSelectable:void 0,longText:void 0,disclosure:void 0,allowInSortByEvenWhenHidden:void 0,dataType:void 0,defaultWeight:void 0},{id:"declaration",title:i18nString(UIStrings.declaration),sortable:!0,weight:50,titleDOMFragment:void 0,sort:void 0,align:void 0,width:void 0,fixedWidth:void 0,editable:void 0,nonSelectable:void 0,longText:void 0,disclosure:void 0,allowInSortByEvenWhenHidden:void 0,dataType:void 0,defaultWeight:void 0},{id:"sourceURL",title:i18nString(UIStrings.source),sortable:!1,weight:100,titleDOMFragment:void 0,sort:void 0,align:void 0,width:void 0,fixedWidth:void 0,editable:void 0,nonSelectable:void 0,longText:void 0,disclosure:void 0,allowInSortByEvenWhenHidden:void 0,dataType:void 0,defaultWeight:void 0},{id:"contrastRatio",title:i18nString(UIStrings.contrastRatio),sortable:!0,weight:25,titleDOMFragment:void 0,sort:void 0,align:void 0,width:"150px",fixedWidth:!0,editable:void 0,nonSelectable:void 0,longText:void 0,disclosure:void 0,allowInSortByEvenWhenHidden:void 0,dataType:void 0,defaultWeight:void 0}],this._elementGrid=new DataGrid.SortableDataGrid.SortableDataGrid({displayName:i18nString(UIStrings.cssOverviewElements),columns:this._elementGridColumns,editCallback:void 0,deleteCallback:void 0,refreshCallback:void 0}),this._elementGrid.element.classList.add("element-grid"),this._elementGrid.element.addEventListener("mouseover",this._onMouseOver.bind(this)),this._elementGrid.setStriped(!0),this._elementGrid.addEventListener(DataGrid.DataGrid.Events.SortingChanged,this._sortMediaQueryDataGrid.bind(this)),this.element.appendChild(this._elementGrid.element)}_sortMediaQueryDataGrid(){const e=this._elementGrid.sortColumnId();if(!e)return;const t=DataGrid.SortableDataGrid.SortableDataGrid.StringComparator.bind(null,e);this._elementGrid.sortNodes(t,!this._elementGrid.isSortOrderAscending())}_onMouseOver(e){const t=e.composedPath().find((e=>e.dataset&&e.dataset.backendNodeId));if(!t)return;const i=Number(t.dataset.backendNodeId);this._controller.dispatchEventToListeners(Events.RequestNodeHighlight,i)}async populateNodes(e){if(this._elementGrid.rootNode().removeChildren(),!e.length)return;const[t]=e,i=new Set;let s;if(t.nodeId&&i.add("nodeId"),t.declaration&&i.add("declaration"),t.sourceURL&&i.add("sourceURL"),t.contrastRatio&&i.add("contrastRatio"),i.has("nodeId")){const t=e.reduce(((e,t)=>CSSOverviewCompletedView.pushedNodes.has(t.nodeId)?e:(CSSOverviewCompletedView.pushedNodes.add(t.nodeId),e.add(t.nodeId))),new Set);s=await this._domModel.pushNodesByBackendIdsToFrontend(t)}for(const n of e){if(i.has("nodeId")){if(!s)continue;const e=s.get(n.nodeId);if(!e)continue;n.node=e}const e=new ElementNode(this._elementGrid,n,this._linkifier,this._cssModel);e.selectable=!1,this._elementGrid.insertChild(e)}this._elementGrid.setColumnsVisiblity(i),this._elementGrid.renderInline(),this._elementGrid.wasShown()}}export class ElementNode extends DataGrid.SortableDataGrid.SortableDataGridNode{constructor(e,t,i,s){super(e,t.hasChildren),this.data=t,this._linkifier=i,this._cssModel=s}createCell(e){if("nodeId"===e){const t=this.createTD(e);return t.textContent="...",Common.Linkifier.Linkifier.linkify(this.data.node).then((e=>{t.textContent="",e.dataset.backendNodeId=this.data.node.backendNodeId(),t.appendChild(e);const i=document.createElement("button");i.classList.add("show-element"),UI.Tooltip.Tooltip.install(i,i18nString(UIStrings.showElement)),i.tabIndex=0,i.onclick=()=>this.data.node.scrollIntoView(),t.appendChild(i)})),t}if("sourceURL"===e){const t=this.createTD(e);if(this.data.range){const e=this._linkifyRuleLocation(this._cssModel,this._linkifier,this.data.styleSheetId,TextUtils.TextRange.TextRange.fromObject(this.data.range));e&&""!==e.textContent?t.appendChild(e):t.textContent="(unable to link)"}else t.textContent="(unable to link to inlined styles)";return t}if("contrastRatio"===e){const t=this.createTD(e),i=Root.Runtime.experiments.isEnabled("APCA"),s=Platform.NumberUtilities.floor(this.data.contrastRatio,2),n=i?s+"%":s,r=getBorderString(this.data.backgroundcolor),a=UI.Fragment.Fragment.build`
        <div class="contrast-container-in-grid" $="container">
          <span class="contrast-preview" style="border: ${r};
          color: ${this.data.textcolor.asstring()};
          background-color: ${this.data.backgroundcolor.asstring()};">Aa</span>
          <span>${n}</span>
        </div>
      `,o=a.$("container");return i?(o.append(UI.Fragment.Fragment.build`<span>${i18nString(UIStrings.apca)}</span>`.element()),this.data.thresholdsViolated.apca?o.appendChild(UI.Icon.Icon.create("smallicon-no")):o.appendChild(UI.Icon.Icon.create("smallicon-checkmark-square"))):(o.append(UI.Fragment.Fragment.build`<span>${i18nString(UIStrings.aa)}</span>`.element()),this.data.thresholdsViolated.aa?o.appendChild(UI.Icon.Icon.create("smallicon-no")):o.appendChild(UI.Icon.Icon.create("smallicon-checkmark-square")),o.append(UI.Fragment.Fragment.build`<span>${i18nString(UIStrings.aaa)}</span>`.element()),this.data.thresholdsViolated.aaa?o.appendChild(UI.Icon.Icon.create("smallicon-no")):o.appendChild(UI.Icon.Icon.create("smallicon-checkmark-square"))),t.appendChild(a.element()),t}return super.createCell(e)}_linkifyRuleLocation(e,t,i,s){const n=e.styleSheetHeaderForId(i);if(!n)return;const r=n.lineNumberInSource(s.startLine),a=n.columnNumberInSource(s.startLine,s.startColumn),o=new SDK.CSSModel.CSSLocation(n,r,a);return t.linkifyCSSLocation(o)}}