import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import*as InlineEditor from"../inline_editor/inline_editor.js";import*as Platform from"../platform/platform.js";import*as UI from"../ui/ui.js";import{StepTimingFunction}from"./AnimationTimeline.js";const UIStrings={animationEndpointSlider:"Animation Endpoint slider",animationKeyframeSlider:"Animation Keyframe slider",sSlider:"{PH1} slider"},str_=i18n.i18n.registerUIStrings("animation/AnimationUI.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class AnimationUI{constructor(t,i,e){this._animation=t,this._timeline=i,this._parentElement=e;const n=this._animation.source().keyframesRule();n&&(this._keyframes=n.keyframes()),this._nameElement=e.createChild("div","animation-name"),this._nameElement.textContent=this._animation.name(),this._svg=UI.UIUtils.createSVGChild(e,"svg","animation-ui"),this._svg.setAttribute("height",Options.AnimationSVGHeight.toString()),this._svg.style.marginLeft="-"+Options.AnimationMargin+"px",this._svg.addEventListener("contextmenu",this._onContextMenu.bind(this)),this._activeIntervalGroup=UI.UIUtils.createSVGChild(this._svg,"g"),UI.UIUtils.installDragHandle(this._activeIntervalGroup,this._mouseDown.bind(this,"AnimationDrag",null),this._mouseMove.bind(this),this._mouseUp.bind(this),"-webkit-grabbing","-webkit-grab"),AnimationUI.installDragHandleKeyboard(this._activeIntervalGroup,this._keydownMove.bind(this,"AnimationDrag",null)),this._cachedElements=[],this._movementInMs=0,this._keyboardMovementRateMs=50,this._color=AnimationUI.colorForAnimation(this._animation)}static colorForAnimation(t){const i=Array.from(Colors.keys()),e=i[Platform.StringUtilities.hashCode(t.name()||t.id())%i.length],n=Colors.get(e);if(!n)throw new Error("Unable to locate color");return n.asString(Common.Color.Format.RGB)||""}static installDragHandleKeyboard(t,i){t.addEventListener("keydown",i,!1)}animation(){return this._animation}setNode(t){this._node=t}_createLine(t,i){const e=UI.UIUtils.createSVGChild(t,"line",i);return e.setAttribute("x1",Options.AnimationMargin.toString()),e.setAttribute("y1",Options.AnimationHeight.toString()),e.setAttribute("y2",Options.AnimationHeight.toString()),e.style.stroke=this._color,e}_drawAnimationLine(t,i){const e=this._cachedElements[t];e.animationLine||(e.animationLine=this._createLine(i,"animation-line")),e.animationLine&&e.animationLine.setAttribute("x2",(this._duration()*this._timeline.pixelMsRatio()+Options.AnimationMargin).toFixed(2))}_drawDelayLine(t){this._delayLine&&this._endDelayLine||(this._delayLine=this._createLine(t,"animation-delay-line"),this._endDelayLine=this._createLine(t,"animation-delay-line"));const i=this._animation.source().fill();this._delayLine.classList.toggle("animation-fill","backwards"===i||"both"===i);const e=Options.AnimationMargin;this._delayLine.setAttribute("x1",e.toString()),this._delayLine.setAttribute("x2",(this._delay()*this._timeline.pixelMsRatio()+e).toFixed(2));const n="forwards"===i||"both"===i;this._endDelayLine.classList.toggle("animation-fill",n);const s=Math.min(this._timeline.width(),(this._delay()+this._duration()*this._animation.source().iterations())*this._timeline.pixelMsRatio());this._endDelayLine.style.transform="translateX("+s.toFixed(2)+"px)",this._endDelayLine.setAttribute("x1",e.toString()),this._endDelayLine.setAttribute("x2",n?(this._timeline.width()-s+e).toFixed(2):(this._animation.source().endDelay()*this._timeline.pixelMsRatio()+e).toFixed(2))}_drawPoint(t,i,e,n,s){if(this._cachedElements[t].keyframePoints[n])return void this._cachedElements[t].keyframePoints[n].setAttribute("cx",e.toFixed(2));const o=UI.UIUtils.createSVGChild(i,"circle",n<=0?"animation-endpoint":"animation-keyframe-point");if(o.setAttribute("cx",e.toFixed(2)),o.setAttribute("cy",Options.AnimationHeight.toString()),o.style.stroke=this._color,o.setAttribute("r",(Options.AnimationMargin/2).toString()),o.tabIndex=0,UI.ARIAUtils.setAccessibleName(o,i18nString(n<=0?UIStrings.animationEndpointSlider:UIStrings.animationKeyframeSlider)),n<=0&&(o.style.fill=this._color),this._cachedElements[t].keyframePoints[n]=o,!s)return;let a;a=0===n?"StartEndpointMove":-1===n?"FinishEndpointMove":"KeyframeMove",UI.UIUtils.installDragHandle(o,this._mouseDown.bind(this,a,n),this._mouseMove.bind(this),this._mouseUp.bind(this),"ew-resize"),AnimationUI.installDragHandleKeyboard(o,this._keydownMove.bind(this,a,n))}_renderKeyframe(t,i,e,n,s,o){function a(t,i,e){const n=UI.UIUtils.createSVGChild(t,"line");n.setAttribute("x1",i.toString()),n.setAttribute("x2",i.toString()),n.setAttribute("y1",Options.AnimationMargin.toString()),n.setAttribute("y2",Options.AnimationHeight.toString()),n.style.stroke=e}const r=UI.Geometry.CubicBezier.parse(o),m=this._cachedElements[t].keyframeRender;if(!m[i]){const t=r?UI.UIUtils.createSVGChild(e,"path","animation-keyframe"):UI.UIUtils.createSVGChild(e,"g","animation-keyframe-step");m[i]=t}const l=m[i];if(l.tabIndex=0,UI.ARIAUtils.setAccessibleName(l,i18nString(UIStrings.sSlider,{PH1:this._animation.name()})),l.style.transform="translateX("+n.toFixed(2)+"px)","linear"===o){l.style.fill=this._color;const t=InlineEditor.BezierUI.Height;l.setAttribute("d",["M",0,t,"L",0,5,"L",s.toFixed(2),5,"L",s.toFixed(2),t,"Z"].join(" "))}else if(r)l.style.fill=this._color,InlineEditor.BezierUI.BezierUI.drawVelocityChart(r,l,s);else{const t=StepTimingFunction.parse(o);l.removeChildren();const i={start:0,middle:.5,end:1};if(t){const e=i[t.stepAtPosition];for(let i=0;i<t.steps;i++)a(l,(i+e)*s/t.steps,this._color)}}}redraw(){const t=this._timeline.width()-Options.AnimationMargin;if(this._svg.setAttribute("width",(t+2*Options.AnimationMargin).toFixed(2)),this._activeIntervalGroup.style.transform="translateX("+(this._delay()*this._timeline.pixelMsRatio()).toFixed(2)+"px)",this._nameElement.style.transform="translateX("+(this._delay()*this._timeline.pixelMsRatio()+Options.AnimationMargin).toFixed(2)+"px)",this._nameElement.style.width=(this._duration()*this._timeline.pixelMsRatio()).toFixed(2)+"px",this._drawDelayLine(this._svg),"CSSTransition"===this._animation.type())return void this._renderTransition();this._renderIteration(this._activeIntervalGroup,0),this._tailGroup||(this._tailGroup=UI.UIUtils.createSVGChild(this._activeIntervalGroup,"g","animation-tail-iterations"));const i=this._duration()*this._timeline.pixelMsRatio();let e;for(e=1;e<this._animation.source().iterations()&&i*(e-1)<this._timeline.width();e++)this._renderIteration(this._tailGroup,e);for(;e<this._cachedElements.length;){const t=this._cachedElements.pop();t&&t.group&&t.group.remove()}}_renderTransition(){const t=this._activeIntervalGroup;this._cachedElements[0]||(this._cachedElements[0]={animationLine:null,keyframePoints:{},keyframeRender:{},group:null}),this._drawAnimationLine(0,t),this._renderKeyframe(0,0,t,Options.AnimationMargin,this._duration()*this._timeline.pixelMsRatio(),this._animation.source().easing()),this._drawPoint(0,t,Options.AnimationMargin,0,!0),this._drawPoint(0,t,this._duration()*this._timeline.pixelMsRatio()+Options.AnimationMargin,-1,!0)}_renderIteration(t,i){this._cachedElements[i]||(this._cachedElements[i]={animationLine:null,keyframePoints:{},keyframeRender:{},group:UI.UIUtils.createSVGChild(t,"g")});const e=this._cachedElements[i].group;if(e){if(e.style.transform="translateX("+(i*this._duration()*this._timeline.pixelMsRatio()).toFixed(2)+"px)",this._drawAnimationLine(i,e),this._keyframes&&this._keyframes.length>1)for(let t=0;t<this._keyframes.length-1;t++){const n=this._offset(t)*this._duration()*this._timeline.pixelMsRatio()+Options.AnimationMargin,s=this._duration()*(this._offset(t+1)-this._offset(t))*this._timeline.pixelMsRatio();this._renderKeyframe(i,t,e,n,s,this._keyframes[t].easing()),(t||!t&&0===i)&&this._drawPoint(i,e,n,t,0===i)}this._drawPoint(i,e,this._duration()*this._timeline.pixelMsRatio()+Options.AnimationMargin,-1,0===i)}}_delay(){let t=this._animation.source().delay();return"AnimationDrag"!==this._mouseEventType&&"StartEndpointMove"!==this._mouseEventType||(t+=this._movementInMs),Math.max(0,t)}_duration(){let t=this._animation.source().duration();return"FinishEndpointMove"===this._mouseEventType?t+=this._movementInMs:"StartEndpointMove"===this._mouseEventType&&(t-=Math.max(this._movementInMs,-this._animation.source().delay())),Math.max(0,t)}_offset(t){if(!this._keyframes)throw new Error("Unable to calculate offset; keyframes do not exist");let i=this._keyframes[t].offsetAsNumber();return"KeyframeMove"===this._mouseEventType&&t===this._keyframeMoved&&(console.assert(t>0&&t<this._keyframes.length-1,"First and last keyframe cannot be moved"),i+=this._movementInMs/this._animation.source().duration(),i=Math.max(i,this._keyframes[t-1].offsetAsNumber()),i=Math.min(i,this._keyframes[t+1].offsetAsNumber())),i}_mouseDown(t,i,e){const n=e;return 2!==n.buttons&&(!this._svg.enclosingNodeOrSelfWithClass("animation-node-removed")&&(this._mouseEventType=t,this._keyframeMoved=i,this._downMouseX=n.clientX,e.consume(!0),this._node&&Common.Revealer.reveal(this._node),!0))}_mouseMove(t){const i=t;this._setMovementAndRedraw((i.clientX-(this._downMouseX||0))/this._timeline.pixelMsRatio())}_setMovementAndRedraw(t){this._movementInMs=t,this._delay()+this._duration()>.8*this._timeline.duration()&&this._timeline.setDuration(1.2*this._timeline.duration()),this.redraw()}_mouseUp(t){const i=t;this._movementInMs=(i.clientX-(this._downMouseX||0))/this._timeline.pixelMsRatio(),"KeyframeMove"===this._mouseEventType?this._keyframes&&null!==this._keyframeMoved&&"undefined"!==typeof this._keyframeMoved&&this._keyframes[this._keyframeMoved].setOffset(this._offset(this._keyframeMoved)):this._animation.setTiming(this._duration(),this._delay()),this._movementInMs=0,this.redraw(),delete this._mouseEventType,delete this._downMouseX,delete this._keyframeMoved}_keydownMove(t,i,e){const n=e;switch(this._mouseEventType=t,this._keyframeMoved=i,n.key){case"ArrowLeft":case"ArrowUp":this._movementInMs=-this._keyboardMovementRateMs;break;case"ArrowRight":case"ArrowDown":this._movementInMs=this._keyboardMovementRateMs;break;default:return}"KeyframeMove"===this._mouseEventType?this._keyframes&&null!==this._keyframeMoved&&this._keyframes[this._keyframeMoved].setOffset(this._offset(this._keyframeMoved)):this._animation.setTiming(this._duration(),this._delay()),this._setMovementAndRedraw(0),delete this._mouseEventType,delete this._keyframeMoved,e.consume(!0)}_onContextMenu(t){this._animation.remoteObjectPromise().then((function(i){if(!i)return;const e=new UI.ContextMenu.ContextMenu(t);e.appendApplicableItems(i),e.show()})),t.consume(!0)}}export const Options={AnimationHeight:26,AnimationSVGHeight:50,AnimationMargin:7,EndpointsClickRegionSize:10,GridCanvasHeight:40};export const Colors=new Map([["Purple",Common.Color.Color.parse("#9C27B0")],["Light Blue",Common.Color.Color.parse("#03A9F4")],["Deep Orange",Common.Color.Color.parse("#FF5722")],["Blue",Common.Color.Color.parse("#5677FC")],["Lime",Common.Color.Color.parse("#CDDC39")],["Blue Grey",Common.Color.Color.parse("#607D8B")],["Pink",Common.Color.Color.parse("#E91E63")],["Green",Common.Color.Color.parse("#0F9D58")],["Brown",Common.Color.Color.parse("#795548")],["Cyan",Common.Color.Color.parse("#00BCD4")]]);