import*as Common from"../common/common.js";import*as SDK from"../sdk/sdk.js";import*as Workspace from"../workspace/workspace.js";import{DebuggerWorkspaceBinding}from"./DebuggerWorkspaceBinding.js";import{LiveLocationPool}from"./LiveLocation.js";let breakpointManagerInstance;export class BreakpointManager extends Common.ObjectWrapper.ObjectWrapper{constructor(e,t,o){super(),this._storage=new Storage,this._workspace=t,this._targetManager=e,this._debuggerWorkspaceBinding=o,this._breakpointsForUISourceCode=new Map,this._breakpointByStorageId=new Map,this._workspace.addEventListener(Workspace.Workspace.Events.UISourceCodeAdded,this._uiSourceCodeAdded,this),this._workspace.addEventListener(Workspace.Workspace.Events.UISourceCodeRemoved,this._uiSourceCodeRemoved,this),this._workspace.addEventListener(Workspace.Workspace.Events.ProjectRemoved,this._projectRemoved,this)}static instance(e={forceNew:null,targetManager:null,workspace:null,debuggerWorkspaceBinding:null}){const{forceNew:t,targetManager:o,workspace:i,debuggerWorkspaceBinding:r}=e;if(!breakpointManagerInstance||t){if(!o||!i||!r)throw new Error(`Unable to create settings: targetManager, workspace, and debuggerWorkspaceBinding must be provided: ${(new Error).stack}`);breakpointManagerInstance=new BreakpointManager(o,i,r)}return breakpointManagerInstance}static _breakpointStorageId(e,t,o){return e?`${e}:${t}`+("number"===typeof o?`:${o}`:""):""}async copyBreakpoints(e,t){const o=this._storage.breakpointItems(e);for(const i of o)await this.setBreakpoint(t,i.lineNumber,i.columnNumber,i.condition,i.enabled)}_restoreBreakpoints(e){const t=e.url();if(!t)return;this._storage.mute();const o=this._storage.breakpointItems(t);for(const i of o)this._innerSetBreakpoint(e,i.lineNumber,i.columnNumber,i.condition,i.enabled);this._storage.unmute()}_uiSourceCodeAdded(e){const t=e.data;this._restoreBreakpoints(t)}_uiSourceCodeRemoved(e){const t=e.data;this._removeUISourceCode(t)}_projectRemoved(e){const t=e.data;for(const o of t.uiSourceCodes())this._removeUISourceCode(o)}_removeUISourceCode(e){this.breakpointLocationsForUISourceCode(e).forEach((t=>t.breakpoint.removeUISourceCode(e)))}async setBreakpoint(e,t,o,i,r){let n=new Workspace.UISourceCode.UILocation(e,t,o);const s=await this._debuggerWorkspaceBinding.normalizeUILocation(n);return s.id()!==n.id()&&(Common.Revealer.reveal(s),n=s),this._innerSetBreakpoint(n.uiSourceCode,n.lineNumber,n.columnNumber,i,r)}_innerSetBreakpoint(e,t,o,i,r){const n=BreakpointManager._breakpointStorageId(e.url(),t,o);let s=this._breakpointByStorageId.get(n);return s?(s._updateState(i,r),s.addUISourceCode(e),s._updateBreakpoint(),s):(s=new Breakpoint(this,e,e.url(),t,o,i,r),this._breakpointByStorageId.set(n,s),s)}findBreakpoint(e){const t=this._breakpointsForUISourceCode.get(e.uiSourceCode);return t&&t.get(e.id())||null}async possibleBreakpoints(e,t){const{pluginManager:o}=this._debuggerWorkspaceBinding;if(o){const i=await o.uiLocationToRawLocations(e,t.startLine);if(i){const e=[];for(const t of i){const o=await this._debuggerWorkspaceBinding.rawLocationToUILocation(t);o&&e.push(o)}return e}}const i=DebuggerWorkspaceBinding.instance().uiLocationToRawLocations(e,t.startLine,t.startColumn),r=DebuggerWorkspaceBinding.instance().uiLocationToRawLocations(e,t.endLine,t.endColumn),[n,s]=await Promise.all([i,r]),a=new Map;for(const c of s)a.set(c.debuggerModel,c);let d=null,u=null;for(const c of n){const e=a.get(c.debuggerModel);if(e){d=c,u=e;break}}return d&&u?d.debuggerModel.getPossibleBreakpoints(d,u,!1).then(async function(t){const o=t.map((e=>this._debuggerWorkspaceBinding.rawLocationToUILocation(e))),i=(await Promise.all(o)).filter((t=>t&&t.uiSourceCode===e));if(!i.length)return[];i.sort(Workspace.UISourceCode.UILocation.comparator);let r=i[0];const n=[r];for(const e of i)e.id()!==r.id()&&(n.push(e),r=e);return n}.bind(this)):[]}breakpointLocationsForUISourceCode(e){const t=this._breakpointsForUISourceCode.get(e);return t?Array.from(t.values()):[]}allBreakpointLocations(){const e=[];for(const t of this._breakpointsForUISourceCode.values())e.push(...t.values());return e}_removeBreakpoint(e,t){t&&this._storage._removeBreakpoint(e),this._breakpointByStorageId.delete(e._breakpointStorageId())}_uiLocationAdded(e,t){let o=this._breakpointsForUISourceCode.get(t.uiSourceCode);o||(o=new Map,this._breakpointsForUISourceCode.set(t.uiSourceCode,o));const i={breakpoint:e,uiLocation:t};o.set(t.id(),i),this.dispatchEventToListeners(Events.BreakpointAdded,i)}_uiLocationRemoved(e,t){const o=this._breakpointsForUISourceCode.get(t.uiSourceCode);if(!o)return;o.get(t.id())&&(o.delete(t.id()),0===o.size&&this._breakpointsForUISourceCode.delete(t.uiSourceCode),this.dispatchEventToListeners(Events.BreakpointRemoved,{breakpoint:e,uiLocation:t}))}}export var Events;!function(e){e.BreakpointAdded="breakpoint-added",e.BreakpointRemoved="breakpoint-removed"}(Events||(Events={}));export class Breakpoint{constructor(e,t,o,i,r,n,s){this._breakpointManager=e,this._url=o,this._lineNumber=i,this._columnNumber=r,this._uiLocations=new Set,this._uiSourceCodes=new Set,this._currentState=null,this._modelBreakpoints=new Map,this._updateState(n,s),this.addUISourceCode(t),this._breakpointManager._targetManager.observeModels(SDK.DebuggerModel.DebuggerModel,this)}async refreshInDebugger(){if(!this._isRemoved){const e=Array.from(this._modelBreakpoints.values());await Promise.all(e.map((e=>e._refreshBreakpoint())))}}modelAdded(e){const t=this._breakpointManager._debuggerWorkspaceBinding;this._modelBreakpoints.set(e,new ModelBreakpoint(e,this,t))}modelRemoved(e){const t=this._modelBreakpoints.get(e);this._modelBreakpoints.delete(e),t&&(t._cleanUpAfterDebuggerIsGone(),t._removeEventListeners())}addUISourceCode(e){this._uiSourceCodes.has(e)||(this._uiSourceCodes.add(e),this.bound()||this._breakpointManager._uiLocationAdded(this,this._defaultUILocation(e)))}clearUISourceCodes(){this.bound()||this._removeAllUnboundLocations(),this._uiSourceCodes.clear()}removeUISourceCode(e){if(this._uiSourceCodes.has(e)&&(this._uiSourceCodes.delete(e),this.bound()||this._breakpointManager._uiLocationRemoved(this,this._defaultUILocation(e))),this.bound()){for(const t of this._uiLocations)t.uiSourceCode===e&&(this._uiLocations.delete(t),this._breakpointManager._uiLocationRemoved(this,t));this.bound()||this._isRemoved||this._addAllUnboundLocations()}}url(){return this._url}lineNumber(){return this._lineNumber}columnNumber(){return this._columnNumber}_uiLocationAdded(e){this._isRemoved||(this.bound()||this._removeAllUnboundLocations(),this._uiLocations.add(e),this._breakpointManager._uiLocationAdded(this,e))}_uiLocationRemoved(e){this._uiLocations.has(e)&&(this._uiLocations.delete(e),this._breakpointManager._uiLocationRemoved(this,e),this.bound()||this._isRemoved||this._addAllUnboundLocations())}enabled(){return this._enabled}bound(){return 0!==this._uiLocations.size}hasBoundScript(){for(const e of this._uiSourceCodes)if(e.project().type()===Workspace.Workspace.projectTypes.Network)return!0;return!1}setEnabled(e){this._updateState(this._condition,e)}condition(){return this._condition}setCondition(e){this._updateState(e,this._enabled)}_updateState(e,t){this._enabled===t&&this._condition===e||(this._enabled=t,this._condition=e,this._breakpointManager._storage._updateBreakpoint(this),this._updateBreakpoint())}_updateBreakpoint(){this.bound()||(this._removeAllUnboundLocations(),this._isRemoved||this._addAllUnboundLocations());for(const e of this._modelBreakpoints.values())e._scheduleUpdateInDebugger()}remove(e){this._isRemoved=!0;const t=!e;for(const o of this._modelBreakpoints.values())o._scheduleUpdateInDebugger(),o._removeEventListeners();this._breakpointManager._removeBreakpoint(this,t),this._breakpointManager._targetManager.unobserveModels(SDK.DebuggerModel.DebuggerModel,this),this.clearUISourceCodes()}_breakpointStorageId(){return BreakpointManager._breakpointStorageId(this._url,this._lineNumber,this._columnNumber)}_resetLocations(){this.clearUISourceCodes();for(const e of this._modelBreakpoints.values())e._resetLocations()}_defaultUILocation(e){return e.uiLocation(this._lineNumber,this._columnNumber)}_removeAllUnboundLocations(){for(const e of this._uiSourceCodes)this._breakpointManager._uiLocationRemoved(this,this._defaultUILocation(e))}_addAllUnboundLocations(){for(const e of this._uiSourceCodes)this._breakpointManager._uiLocationAdded(this,this._defaultUILocation(e))}}export class ModelBreakpoint{constructor(e,t,o){this._debuggerModel=e,this._breakpoint=t,this._debuggerWorkspaceBinding=o,this._liveLocations=new LiveLocationPool,this._uiLocations=new Map,this._debuggerModel.addEventListener(SDK.DebuggerModel.Events.DebuggerWasDisabled,this._cleanUpAfterDebuggerIsGone,this),this._debuggerModel.addEventListener(SDK.DebuggerModel.Events.DebuggerWasEnabled,this._scheduleUpdateInDebugger,this),this._hasPendingUpdate=!1,this._isUpdating=!1,this._cancelCallback=!1,this._currentState=null,this._breakpointIds=[],this._debuggerModel.debuggerEnabled()&&this._scheduleUpdateInDebugger()}_resetLocations(){for(const e of this._uiLocations.values())this._breakpoint._uiLocationRemoved(e);this._uiLocations.clear(),this._liveLocations.disposeAll()}_scheduleUpdateInDebugger(){this._isUpdating?this._hasPendingUpdate=!0:(this._isUpdating=!0,this._updateInDebugger(this._didUpdateInDebugger.bind(this)))}_didUpdateInDebugger(){this._isUpdating=!1,this._hasPendingUpdate&&(this._hasPendingUpdate=!1,this._scheduleUpdateInDebugger())}_scriptDiverged(){for(const e of this._breakpoint._uiSourceCodes){const t=this._debuggerWorkspaceBinding.scriptFile(e,this._debuggerModel);if(t&&t.hasDivergedFromVM())return!0}return!1}async _updateInDebugger(e){if(this._debuggerModel.target().isDisposed())return this._cleanUpAfterDebuggerIsGone(),void e();const t=this._breakpoint.lineNumber(),o=this._breakpoint.columnNumber(),i=this._breakpoint.condition();let r=null;if(!this._breakpoint._isRemoved&&this._breakpoint.enabled()&&!this._scriptDiverged()){let e=[];for(const i of this._breakpoint._uiSourceCodes){if(e=(await DebuggerWorkspaceBinding.instance().uiLocationToRawLocations(i,t,o)).filter((e=>e.debuggerModel===this._debuggerModel)),e.length)break}if(e.length&&e.every((e=>e.script()))){const t=e.map((e=>{const t=e.script();return{url:t.sourceURL,scriptId:t.scriptId,scriptHash:t.hash,lineNumber:e.lineNumber,columnNumber:e.columnNumber}}));r=new Breakpoint.State(t,i)}else if(this._breakpoint._currentState)r=new Breakpoint.State(this._breakpoint._currentState.positions,i);else{const e={url:this._breakpoint.url(),scriptId:"",scriptHash:"",lineNumber:t,columnNumber:o};r=new Breakpoint.State([e],i)}}if(this._breakpointIds.length&&Breakpoint.State.equals(r,this._currentState))return void e();if(this._breakpoint._currentState=r,this._breakpointIds.length)return await this._refreshBreakpoint(),void e();if(!r)return void e();this._currentState=r;const n=await Promise.all(r.positions.map((e=>e.url?this._debuggerModel.setBreakpointByURL(e.url,e.lineNumber,e.columnNumber,i):this._debuggerModel.setBreakpointInAnonymousScript(e.scriptId,e.scriptHash,e.lineNumber,e.columnNumber,i)))),s=[];let a=[];for(const{breakpointId:d,locations:u}of n)d&&(s.push(d),a=a.concat(u));await this._didSetBreakpointInDebugger(e,s,a)}async _refreshBreakpoint(){this._breakpointIds.length&&(this._resetLocations(),await Promise.all(this._breakpointIds.map((e=>this._debuggerModel.removeBreakpoint(e)))),this._didRemoveFromDebugger(),this._currentState=null,this._scheduleUpdateInDebugger())}async _didSetBreakpointInDebugger(e,t,o){if(this._cancelCallback)return this._cancelCallback=!1,void e();if(!t.length)return this._breakpoint.remove(!0),void e();this._breakpointIds=t;for(const i of this._breakpointIds)this._debuggerModel.addBreakpointListener(i,(e=>this._breakpointResolved(e)),this);for(const i of o)if(!await this._addResolvedLocation(i))break;e()}_didRemoveFromDebugger(){if(this._cancelCallback)this._cancelCallback=!1;else{this._resetLocations();for(const e of this._breakpointIds)this._debuggerModel.removeBreakpointListener(e,(e=>this._breakpointResolved(e)),this);this._breakpointIds=[]}}async _breakpointResolved(e){await this._addResolvedLocation(e.data)}async _locationUpdated(e){const t=this._uiLocations.get(e),o=await e.uiLocation();t&&this._breakpoint._uiLocationRemoved(t),o?(this._uiLocations.set(e,o),this._breakpoint._uiLocationAdded(o)):this._uiLocations.delete(e)}async _addResolvedLocation(e){const t=await this._debuggerWorkspaceBinding.rawLocationToUILocation(e);if(!t)return!1;const o=this._breakpoint._breakpointManager.findBreakpoint(t);return o&&o.breakpoint!==this._breakpoint?(this._breakpoint.remove(!1),!1):(await this._debuggerWorkspaceBinding.createLiveLocation(e,this._locationUpdated.bind(this),this._liveLocations),!0)}_cleanUpAfterDebuggerIsGone(){this._isUpdating&&(this._cancelCallback=!0),this._resetLocations(),this._currentState=null,this._breakpointIds.length&&this._didRemoveFromDebugger()}_removeEventListeners(){this._debuggerModel.removeEventListener(SDK.DebuggerModel.Events.DebuggerWasDisabled,this._cleanUpAfterDebuggerIsGone,this),this._debuggerModel.removeEventListener(SDK.DebuggerModel.Events.DebuggerWasEnabled,this._scheduleUpdateInDebugger,this)}}!function(e){e.State=class{constructor(e,t){this.positions=e,this.condition=t}static equals(e,t){if(!e||!t)return!1;if(e.condition!==t.condition)return!1;if(e.positions.length!==t.positions.length)return!1;for(let o=0;o<e.positions.length;o++){const i=e.positions[o],r=t.positions[o];if(i.url!==r.url)return!1;if(i.scriptId!==r.scriptId)return!1;if(i.scriptHash!==r.scriptHash)return!1;if(i.lineNumber!==r.lineNumber)return!1;if(i.columnNumber!==r.columnNumber)return!1}return!0}}}(Breakpoint||(Breakpoint={}));class Storage{constructor(){this._setting=Common.Settings.Settings.instance().createLocalSetting("breakpoints",[]),this._breakpoints=new Map;const e=this._setting.get();for(const t of e)this._breakpoints.set(BreakpointManager._breakpointStorageId(t.url,t.lineNumber,t.columnNumber),t)}mute(){this._muted=!0}unmute(){delete this._muted}breakpointItems(e){return Array.from(this._breakpoints.values()).filter((t=>t.url===e))}_updateBreakpoint(e){!this._muted&&e._breakpointStorageId()&&(this._breakpoints.set(e._breakpointStorageId(),new Storage.Item(e)),this._save())}_removeBreakpoint(e){this._muted||(this._breakpoints.delete(e._breakpointStorageId()),this._save())}_save(){this._setting.set(Array.from(this._breakpoints.values()))}}!function(e){e.Item=class{constructor(e){this.url=e._url,this.lineNumber=e.lineNumber(),this.columnNumber=e.columnNumber(),this.condition=e.condition(),this.enabled=e.enabled()}}}(Storage||(Storage={}));