import*as Common from"../common/common.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as Platform from"../platform/platform.js";import*as Root from"../root/root.js";import*as UI from"../ui/ui.js";const UIStrings={noContrastInformationAvailable:"No contrast information available",contrastRatio:"Contrast ratio",showMore:"Show more",pickBackgroundColor:"Pick background color",toggleBackgroundColorPicker:"Toggle background color picker",useSuggestedColorStoFixLow:"Use suggested color {PH1}to fix low contrast",apca:"APCA",aa:"AA",placeholderWithColon:": {PH1}",aaa:"AAA",showLess:"Show less"},str_=i18n.i18n.registerUIStrings("color_picker/ContrastDetails.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class ContrastDetails extends Common.ObjectWrapper.ObjectWrapper{constructor(t,o,s,e,n){super(),this._contrastInfo=t,this._element=o.createChild("div","spectrum-contrast-details collapsed"),this._toggleMainColorPicker=s,this._expandedChangedCallback=e,this._colorSelectedCallback=n,this._expanded=!1,this._passesAA=!0,this._contrastUnknown=!1,this._visible=!1,this._noContrastInfoAvailable=o.createChild("div","no-contrast-info-available"),this._noContrastInfoAvailable.textContent=i18nString(UIStrings.noContrastInformationAvailable),this._noContrastInfoAvailable.classList.add("hidden");const a=this._element.createChild("div");a.addEventListener("click",this._topRowClicked.bind(this));const i=a.createChild("div","container");UI.UIUtils.createTextChild(i,i18nString(UIStrings.contrastRatio)),this._contrastValueBubble=i.createChild("span","contrast-details-value"),this._contrastValue=this._contrastValueBubble.createChild("span"),this._contrastValueBubbleIcons=[],this._contrastValueBubbleIcons.push(this._contrastValueBubble.appendChild(UI.Icon.Icon.create("smallicon-checkmark-square"))),this._contrastValueBubbleIcons.push(this._contrastValueBubble.appendChild(UI.Icon.Icon.create("smallicon-checkmark-behind"))),this._contrastValueBubbleIcons.push(this._contrastValueBubble.appendChild(UI.Icon.Icon.create("smallicon-no"))),this._contrastValueBubbleIcons.forEach((t=>t.addEventListener("click",(t=>{ContrastDetails._showHelp(),t.consume(!1)}))));const r=new UI.Toolbar.Toolbar("expand",i);this._expandButton=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.showMore),"smallicon-expand-more"),this._expandButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this._expandButtonClicked.bind(this)),UI.ARIAUtils.setExpanded(this._expandButton.element,!1),r.appendToolbarItem(this._expandButton),this._expandedDetails=this._element.createChild("div","expanded-details"),UI.ARIAUtils.setControls(this._expandButton.element,this._expandedDetails),this._contrastThresholds=this._expandedDetails.createChild("div","contrast-thresholds"),this._contrastAA=this._contrastThresholds.createChild("div","contrast-threshold"),this._contrastPassFailAA=this._contrastAA.createChild("div","contrast-pass-fail"),this._contrastAAA=this._contrastThresholds.createChild("div","contrast-threshold"),this._contrastPassFailAAA=this._contrastAAA.createChild("div","contrast-pass-fail"),this._contrastAPCA=this._contrastThresholds.createChild("div","contrast-threshold"),this._contrastPassFailAPCA=this._contrastAPCA.createChild("div","contrast-pass-fail"),this._chooseBgColor=this._expandedDetails.createChild("div","contrast-choose-bg-color"),this._chooseBgColor.textContent=i18nString(UIStrings.pickBackgroundColor);const l=this._expandedDetails.createChild("div","background-color"),c=new UI.Toolbar.Toolbar("spectrum-eye-dropper",l);this._bgColorPickerButton=new UI.Toolbar.ToolbarToggle(i18nString(UIStrings.toggleBackgroundColorPicker),"largeicon-eyedropper"),this._bgColorPickerButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this._toggleBackgroundColorPicker.bind(this,void 0,!0)),c.appendToolbarItem(this._bgColorPickerButton),this._bgColorPickedBound=this._bgColorPicked.bind(this),this._bgColorSwatch=new Swatch(l),this._contrastInfo.addEventListener("ContrastInfoUpdated",this._update.bind(this))}_showNoContrastInfoAvailableMessage(){this._noContrastInfoAvailable.classList.remove("hidden")}_hideNoContrastInfoAvailableMessage(){this._noContrastInfoAvailable.classList.add("hidden")}_computeSuggestedColor(t){const o=this._contrastInfo.color(),s=this._contrastInfo.bgColor();if(!o||!s)return;if("APCA"===t){const t=this._contrastInfo.contrastRatioAPCAThreshold();if(null===t)return;return Common.Color.Color.findFgColorForContrastAPCA(o,s,t+1)}const e=this._contrastInfo.contrastRatioThreshold(t);return e?Common.Color.Color.findFgColorForContrast(o,s,e+.1):void 0}_onSuggestColor(t){Host.userMetrics.colorFixed(t);const o=this._computeSuggestedColor(t);o&&this._colorSelectedCallback(o)}_createFixColorButton(t,o){const s=t.createChild("button","contrast-fix-button"),e=this._contrastInfo.colorFormat(),n=e&&e!==Common.Color.Format.Nickname&&e!==Common.Color.Format.Original?e:Common.Color.Format.HEXA,a=o.asString(n),i=a?a+" ":"",r=i18nString(UIStrings.useSuggestedColorStoFixLow,{PH1:i});return UI.ARIAUtils.setAccessibleName(s,r),UI.Tooltip.Tooltip.install(s,r),s.tabIndex=0,s.style.backgroundColor=i,s}_update(){if(this._contrastInfo.isNull())return this._showNoContrastInfoAvailableMessage(),void this.setVisible(!1);this.setVisible(!0),this._hideNoContrastInfoAvailableMessage();const t=Root.Runtime.experiments.isEnabled("APCA"),o=this._contrastInfo.color(),s=this._contrastInfo.bgColor();if(t){const t=this._contrastInfo.contrastRatioAPCA();if(null===t||!s||!o)return this._contrastUnknown=!0,this._contrastValue.textContent="",this._contrastValueBubble.classList.add("contrast-unknown"),this._chooseBgColor.classList.remove("hidden"),this._contrastThresholds.classList.add("hidden"),void this._showNoContrastInfoAvailableMessage();this._contrastUnknown=!1,this._chooseBgColor.classList.add("hidden"),this._contrastThresholds.classList.remove("hidden"),this._contrastValueBubble.classList.remove("contrast-unknown"),this._contrastValue.textContent=`${Platform.NumberUtilities.floor(t,2)}%`;const e=this._contrastInfo.contrastRatioAPCAThreshold(),n=!(!t||!e)&&Math.abs(t)>=e;this._contrastPassFailAPCA.removeChildren();const a=this._contrastPassFailAPCA.createChild("span","contrast-link-label");if(a.textContent=i18nString(UIStrings.apca),null!==e&&(this._contrastPassFailAPCA.createChild("span").textContent=`: ${e.toFixed(2)}%`),n)this._contrastPassFailAPCA.appendChild(UI.Icon.Icon.create("smallicon-checkmark-square"));else{this._contrastPassFailAPCA.appendChild(UI.Icon.Icon.create("smallicon-no"));const t=this._computeSuggestedColor("APCA");if(t){this._createFixColorButton(this._contrastPassFailAPCA,t).addEventListener("click",(()=>this._onSuggestColor("APCA")))}}return a.addEventListener("click",(t=>ContrastDetails._showHelp())),this._element.classList.toggle("contrast-fail",!n),void this._contrastValueBubble.classList.toggle("contrast-aa",n)}const e=this._contrastInfo.contrastRatio();if(!e||!s||!o)return this._contrastUnknown=!0,this._contrastValue.textContent="",this._contrastValueBubble.classList.add("contrast-unknown"),this._chooseBgColor.classList.remove("hidden"),this._contrastThresholds.classList.add("hidden"),void this._showNoContrastInfoAvailableMessage();this._contrastUnknown=!1,this._chooseBgColor.classList.add("hidden"),this._contrastThresholds.classList.remove("hidden"),this._contrastValueBubble.classList.remove("contrast-unknown"),this._contrastValue.textContent=String(Platform.NumberUtilities.floor(e,2)),this._bgColorSwatch.setColors(o,s);const n=this._contrastInfo.contrastRatioThreshold("aa")||0;this._passesAA=(this._contrastInfo.contrastRatio()||0)>=n,this._contrastPassFailAA.removeChildren();const a=this._contrastPassFailAA.createChild("span","contrast-link-label");if(a.textContent=i18nString(UIStrings.aa),this._contrastPassFailAA.createChild("span").textContent=i18nString(UIStrings.placeholderWithColon,{PH1:n.toFixed(1)}),this._passesAA)this._contrastPassFailAA.appendChild(UI.Icon.Icon.create("smallicon-checkmark-square"));else{this._contrastPassFailAA.appendChild(UI.Icon.Icon.create("smallicon-no"));const t=this._computeSuggestedColor("aa");if(t){this._createFixColorButton(this._contrastPassFailAA,t).addEventListener("click",(()=>this._onSuggestColor("aa")))}}const i=this._contrastInfo.contrastRatioThreshold("aaa")||0,r=(this._contrastInfo.contrastRatio()||0)>=i;this._contrastPassFailAAA.removeChildren();const l=this._contrastPassFailAAA.createChild("span","contrast-link-label");if(l.textContent=i18nString(UIStrings.aaa),this._contrastPassFailAAA.createChild("span").textContent=i18nString(UIStrings.placeholderWithColon,{PH1:i.toFixed(1)}),r)this._contrastPassFailAAA.appendChild(UI.Icon.Icon.create("smallicon-checkmark-square"));else{this._contrastPassFailAAA.appendChild(UI.Icon.Icon.create("smallicon-no"));const t=this._computeSuggestedColor("aaa");if(t){this._createFixColorButton(this._contrastPassFailAAA,t).addEventListener("click",(()=>this._onSuggestColor("aaa")))}}[a,l].forEach((t=>t.addEventListener("click",(()=>ContrastDetails._showHelp())))),this._element.classList.toggle("contrast-fail",!this._passesAA),this._contrastValueBubble.classList.toggle("contrast-aa",this._passesAA),this._contrastValueBubble.classList.toggle("contrast-aaa",r)}static _showHelp(){Host.InspectorFrontendHost.InspectorFrontendHostInstance.openInNewTab(UI.UIUtils.addReferrerToURL("https://web.dev/color-and-contrast-accessibility/"))}setVisible(t){this._visible=t,this._element.classList.toggle("hidden",!t)}visible(){return this._visible}element(){return this._element}_expandButtonClicked(t){const o=this._contrastValueBubble.getComponentSelection();o&&o.empty(),this._toggleExpanded()}_topRowClicked(t){const o=this._contrastValueBubble.getComponentSelection();o&&o.empty(),this._toggleExpanded(),t.consume(!0)}_toggleExpanded(){this._expanded=!this._expanded,UI.ARIAUtils.setExpanded(this._expandButton.element,this._expanded),this._element.classList.toggle("collapsed",!this._expanded),this._expanded?(this._toggleMainColorPicker(!1),this._expandButton.setGlyph("smallicon-expand-less"),this._expandButton.setTitle(i18nString(UIStrings.showLess)),this._contrastUnknown&&this._toggleBackgroundColorPicker(!0)):(this._toggleBackgroundColorPicker(!1),this._expandButton.setGlyph("smallicon-expand-more"),this._expandButton.setTitle(i18nString(UIStrings.showMore))),this._expandedChangedCallback()}collapse(){this._element.classList.remove("expanded"),this._toggleBackgroundColorPicker(!1),this._toggleMainColorPicker(!1)}expanded(){return this._expanded}backgroundColorPickerEnabled(){return this._bgColorPickerButton.toggled()}toggleBackgroundColorPicker(t){this._toggleBackgroundColorPicker(t,!1)}_toggleBackgroundColorPicker(t,o=!0){void 0===t&&(t=!this._bgColorPickerButton.toggled()),this._bgColorPickerButton.setToggled(t),o&&this.dispatchEventToListeners(Events.BackgroundColorPickerWillBeToggled,t),Host.InspectorFrontendHost.InspectorFrontendHostInstance.setEyeDropperActive(t),t?Host.InspectorFrontendHost.InspectorFrontendHostInstance.events.addEventListener(Host.InspectorFrontendHostAPI.Events.EyeDropperPickedColor,this._bgColorPickedBound):Host.InspectorFrontendHost.InspectorFrontendHostInstance.events.removeEventListener(Host.InspectorFrontendHostAPI.Events.EyeDropperPickedColor,this._bgColorPickedBound)}_bgColorPicked(t){const o=t.data,s=[o.r,o.g,o.b,(o.a/2.55|0)/100],e=Common.Color.Color.fromRGBA(s);this._contrastInfo.setBgColor(e),this._toggleBackgroundColorPicker(!1),Host.InspectorFrontendHost.InspectorFrontendHostInstance.bringToFront()}}export const Events={BackgroundColorPickerWillBeToggled:Symbol("BackgroundColorPickerWillBeToggled")};export class Swatch{constructor(t){this._parentElement=t,this._swatchElement=t.createChild("span","swatch contrast swatch-inner-white"),this._swatchInnerElement=this._swatchElement.createChild("span","swatch-inner"),this._textPreview=this._swatchElement.createChild("div","text-preview"),this._textPreview.textContent="Aa"}setColors(t,o){this._textPreview.style.color=t.asString(Common.Color.Format.RGBA),this._swatchInnerElement.style.backgroundColor=o.asString(Common.Color.Format.RGBA),this._swatchElement.classList.toggle("swatch-inner-white",o.hsla()[2]>.9)}}