import*as Common from"../common/common.js";import*as DataGrid from"../data_grid/data_grid.js";import*as Formatter from"../formatter/formatter.js";import*as i18n from"../i18n/i18n.js";import*as TextUtils from"../text_utils/text_utils.js";import*as UI from"../ui/ui.js";import*as Workspace from"../workspace/workspace.js";const UIStrings={css:"CSS",jsPerFunction:"JS (per function)",jsPerBlock:"JS (per block)",url:"URL",type:"Type",totalBytes:"Total Bytes",unusedBytes:"Unused Bytes",usageVisualization:"Usage Visualization",codeCoverage:"Code Coverage",jsCoverageWithPerFunction:"JS coverage with per function granularity: Once a function was executed, the whole function is marked as covered.",jsCoverageWithPerBlock:"JS coverage with per block granularity: Once a block of JavaScript was executed, that block is marked as covered.",Byte:"1 byte",sBytes:"{PH1} bytes",sPercent:"{PH1} %",ByteS:"1 byte, {PH1}",sBytesS:"{PH1} bytes, {PH2}",sBytesSBelongToFunctionsThatHave:"{PH1} bytes ({PH2} %) belong to functions that have not (yet) been executed.",sBytesSBelongToBlocksOf:"{PH1} bytes ({PH2} %) belong to blocks of JavaScript that have not (yet) been executed.",sBytesSBelongToFunctionsThatHaveExecuted:"{PH1} bytes ({PH2} %) belong to functions that have executed at least once.",sBytesSBelongToBlocksOfJavascript:"{PH1} bytes ({PH2} %) belong to blocks of JavaScript that have executed at least once.",sOfFileUnusedSOfFileUsed:"{PH1} % of file unused, {PH2} % of file used"},str_=i18n.i18n.registerUIStrings("coverage/CoverageListView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export function coverageTypeToString(e){const t=[];return 1&e&&t.push(i18nString(UIStrings.css)),4&e?t.push(i18nString(UIStrings.jsPerFunction)):2&e&&t.push(i18nString(UIStrings.jsPerBlock)),t.join("+")}export class CoverageListView extends UI.Widget.VBox{constructor(e){super(!0),this._nodeForCoverageInfo=new Map,this._isVisibleFilter=e,this._highlightRegExp=null,this.registerRequiredCSS("coverage/coverageListView.css",{enableLegacyPatching:!0});const t=[{id:"url",title:i18nString(UIStrings.url),width:"250px",fixedWidth:!1,sortable:!0},{id:"type",title:i18nString(UIStrings.type),width:"45px",fixedWidth:!0,sortable:!0},{id:"size",title:i18nString(UIStrings.totalBytes),width:"60px",fixedWidth:!0,sortable:!0,align:DataGrid.DataGrid.Align.Right},{id:"unusedSize",title:i18nString(UIStrings.unusedBytes),width:"100px",fixedWidth:!0,sortable:!0,align:DataGrid.DataGrid.Align.Right,sort:DataGrid.DataGrid.Order.Descending},{id:"bars",title:i18nString(UIStrings.usageVisualization),width:"250px",fixedWidth:!1,sortable:!0}];this._dataGrid=new DataGrid.SortableDataGrid.SortableDataGrid({displayName:i18nString(UIStrings.codeCoverage),columns:t,editCallback:void 0,refreshCallback:void 0,deleteCallback:void 0}),this._dataGrid.setResizeMethod(DataGrid.DataGrid.ResizeMethod.Last),this._dataGrid.element.classList.add("flex-auto"),this._dataGrid.element.addEventListener("keydown",this._onKeyDown.bind(this),!1),this._dataGrid.addEventListener(DataGrid.DataGrid.Events.OpenedNode,this._onOpenedNode,this),this._dataGrid.addEventListener(DataGrid.DataGrid.Events.SortingChanged,this._sortingChanged,this);const i=this._dataGrid.asWidget();i.show(this.contentElement),this.setDefaultFocusedChild(i)}update(e){let t=!1;const i=e.reduce(((e,t)=>Math.max(e,t.size())),0),s=this._dataGrid.rootNode();for(const r of e){let e=this._nodeForCoverageInfo.get(r);e?this._isVisibleFilter(e._coverageInfo)&&(t=e._refreshIfNeeded(i)||t):(e=new GridNode(r,i),this._nodeForCoverageInfo.set(r,e),this._isVisibleFilter(e._coverageInfo)&&(s.appendChild(e),t=!0))}t&&this._sortingChanged()}reset(){this._nodeForCoverageInfo.clear(),this._dataGrid.rootNode().removeChildren()}updateFilterAndHighlight(e){this._highlightRegExp=e;let t=!1;for(const i of this._nodeForCoverageInfo.values()){const e=this._isVisibleFilter(i._coverageInfo),s=Boolean(i.parent);e&&i._setHighlight(this._highlightRegExp),e!==s&&(t=!0,e?this._dataGrid.rootNode().appendChild(i):i.remove())}t&&this._sortingChanged()}selectByUrl(e){for(const[t,i]of this._nodeForCoverageInfo.entries())if(t.url()===e){i.revealAndSelect();break}}_onOpenedNode(){this._revealSourceForSelectedNode()}_onKeyDown(e){"Enter"===e.key&&(e.consume(!0),this._revealSourceForSelectedNode())}async _revealSourceForSelectedNode(){const e=this._dataGrid.selectedNode;if(!e)return;const t=e._coverageInfo;let i=Workspace.Workspace.WorkspaceImpl.instance().uiSourceCodeForURL(t.url());if(!i)return;i=(await Formatter.SourceFormatter.SourceFormatter.instance().format(i)).formattedSourceCode,this._dataGrid.selectedNode===e&&Common.Revealer.reveal(i)}_sortingChanged(){const e=this._dataGrid.sortColumnId();if(!e)return;const t=GridNode.sortFunctionForColumn(e);t&&this._dataGrid.sortNodes(t,!this._dataGrid.isSortOrderAscending())}}export class GridNode extends DataGrid.SortableDataGrid.SortableDataGridNode{constructor(e,t){super(),this._coverageInfo=e,this._url=e.url(),this._maxSize=t,this._highlightRegExp=null}_setHighlight(e){this._highlightRegExp!==e&&(this._highlightRegExp=e,this.refresh())}_refreshIfNeeded(e){return(this._lastUsedSize!==this._coverageInfo.usedSize()||e!==this._maxSize)&&(this._lastUsedSize=this._coverageInfo.usedSize(),this._maxSize=e,this.refresh(),!0)}createCell(e){const t=this.createTD(e);switch(e){case"url":{UI.Tooltip.Tooltip.install(t,this._url);const i=t.createChild("div","url-outer"),s=i.createChild("div","url-prefix"),r=i.createChild("div","url-suffix"),o=/^(.*)(\/[^/]*)$/.exec(this._url);s.textContent=o?o[1]:this._url,r.textContent=o?o[2]:"",this._highlightRegExp&&this._highlight(i,this._url),this.setCellAccessibleName(this._url,t,e);break}case"type":t.textContent=coverageTypeToString(this._coverageInfo.type()),4&this._coverageInfo.type()?UI.Tooltip.Tooltip.install(t,i18nString(UIStrings.jsCoverageWithPerFunction)):2&this._coverageInfo.type()&&UI.Tooltip.Tooltip.install(t,i18nString(UIStrings.jsCoverageWithPerBlock));break;case"size":{t.createChild("span").textContent=Number.withThousandsSeparator(this._coverageInfo.size()||0);const i=1===this._coverageInfo.size()?i18nString(UIStrings.Byte):i18nString(UIStrings.sBytes,{PH1:this._coverageInfo.size()||0});this.setCellAccessibleName(i,t,e);break}case"unusedSize":{const i=this._coverageInfo.unusedSize()||0,s=t.createChild("span"),r=t.createChild("span","percent-value");s.textContent=Number.withThousandsSeparator(i);const o=i18nString(UIStrings.sPercent,{PH1:this._percentageString(this._coverageInfo.unusedPercentage())});r.textContent=o;const n=1===i?i18nString(UIStrings.ByteS,{PH1:o}):i18nString(UIStrings.sBytesS,{PH1:i,PH2:o});this.setCellAccessibleName(n,t,e);break}case"bars":{const i=t.createChild("div","bar-container"),s=this._percentageString(this._coverageInfo.unusedPercentage()),r=this._percentageString(this._coverageInfo.usedPercentage());if(this._coverageInfo.unusedSize()>0){const e=i.createChild("div","bar bar-unused-size");e.style.width=(this._coverageInfo.unusedSize()/this._maxSize*100||0)+"%",4&this._coverageInfo.type()?UI.Tooltip.Tooltip.install(e,i18nString(UIStrings.sBytesSBelongToFunctionsThatHave,{PH1:this._coverageInfo.unusedSize(),PH2:s})):2&this._coverageInfo.type()&&UI.Tooltip.Tooltip.install(e,i18nString(UIStrings.sBytesSBelongToBlocksOf,{PH1:this._coverageInfo.unusedSize(),PH2:s}))}if(this._coverageInfo.usedSize()>0){const e=i.createChild("div","bar bar-used-size");e.style.width=(this._coverageInfo.usedSize()/this._maxSize*100||0)+"%",4&this._coverageInfo.type()?UI.Tooltip.Tooltip.install(e,i18nString(UIStrings.sBytesSBelongToFunctionsThatHaveExecuted,{PH1:this._coverageInfo.usedSize(),PH2:r})):2&this._coverageInfo.type()&&UI.Tooltip.Tooltip.install(e,i18nString(UIStrings.sBytesSBelongToBlocksOfJavascript,{PH1:this._coverageInfo.usedSize(),PH2:r}))}this.setCellAccessibleName(i18nString(UIStrings.sOfFileUnusedSOfFileUsed,{PH1:s,PH2:r}),t,e)}}return t}_percentageString(e){return e.toFixed(1)}_highlight(e,t){if(!this._highlightRegExp)return;const i=this._highlightRegExp.exec(t);if(!i||!i.length)return;const s=new TextUtils.TextRange.SourceRange(i.index,i[0].length);UI.UIUtils.highlightRangesWithStyleClass(e,[s],"filter-highlight")}static sortFunctionForColumn(e){const t=(e,t)=>e._url.localeCompare(t._url);switch(e){case"url":return t;case"type":return(e,i)=>{const s=coverageTypeToString(e._coverageInfo.type()),r=coverageTypeToString(i._coverageInfo.type());return s.localeCompare(r)||t(e,i)};case"size":return(e,i)=>e._coverageInfo.size()-i._coverageInfo.size()||t(e,i);case"bars":case"unusedSize":return(e,i)=>e._coverageInfo.unusedSize()-i._coverageInfo.unusedSize()||t(e,i);default:return console.assert(!1,"Unknown sort field: "+e),null}}}