import*as Common from"../common/common.js";import*as Components from"../components/components.js";import*as i18n from"../i18n/i18n.js";import*as InlineEditor from"../inline_editor/inline_editor.js";import*as Platform from"../platform/platform.js";import*as SDK from"../sdk/sdk.js";import*as UI from"../ui/ui.js";import{ComputedStyleModel,Events}from"./ComputedStyleModel.js";import{ComputedStyleProperty}from"./ComputedStyleProperty.js";import{ComputedStyleTrace}from"./ComputedStyleTrace.js";import{ImagePreviewPopover}from"./ImagePreviewPopover.js";import{PlatformFontsWidget}from"./PlatformFontsWidget.js";import{categorizePropertyName,DefaultCategoryOrder}from"./PropertyNameCategories.js";import{IdleCallbackManager,StylePropertiesSection,StylesSidebarPane,StylesSidebarPropertyRenderer}from"./StylesSidebarPane.js";const UIStrings={filter:"Filter",filterComputedStyles:"Filter Computed Styles",showAll:"Show all",group:"Group",noMatchingProperty:"No matching property",navigateToSelectorSource:"Navigate to selector source",navigateToStyle:"Navigate to style"},str_=i18n.i18n.registerUIStrings("elements/ComputedStyleWidget.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),createPropertyElement=(e,t,o)=>{const n=new ComputedStyleProperty,r=new StylesSidebarPropertyRenderer(null,e,t,o);r.setColorHandler(processComputedColor);const i=r.renderName();i.slot="property-name",n.appendChild(i);const s=r.renderValue();return s.slot="property-value",n.appendChild(s),n},createTraceElement=(e,t,o,n,r)=>{const i=new ComputedStyleTrace,s=new StylesSidebarPropertyRenderer(null,e,t.name,t.value);s.setColorHandler(processColor);const l=s.renderValue();l.slot="trace-value",i.appendChild(l);const a=t.ownerStyle.parentRule;if(a){const e=document.createElement("span");e.appendChild(StylePropertiesSection.createRuleOriginNode(n,r,a)),e.slot="trace-link",i.appendChild(e)}return i.data={selector:a?a.selectorText():"element.style",active:!o,onNavigateToSource:navigateToSource.bind(null,t)},i},processColor=e=>{const t=new InlineEditor.ColorSwatch.ColorSwatch;return t.renderColor(e,!0),t.createChild("span").textContent=e,t},processComputedColor=e=>{const t=new InlineEditor.ColorSwatch.ColorSwatch;return t.renderColor(e,Common.Color.Format.RGB),t.createChild("span").textContent=e,t},navigateToSource=(e,t)=>{Common.Revealer.reveal(e),t.consume(!0)},propertySorter=(e,t)=>{if(e.startsWith("--")!==t.startsWith("--"))return e.startsWith("--")?1:-1;if(e.startsWith("-webkit")!==t.startsWith("-webkit"))return e.startsWith("-webkit")?1:-1;const o=SDK.CSSMetadata.cssMetadata().canonicalPropertyName(e),n=SDK.CSSMetadata.cssMetadata().canonicalPropertyName(t);return Platform.StringUtilities.compare(o,n)};export class ComputedStyleWidget extends UI.ThrottledWidget.ThrottledWidget{constructor(){super(!0),this.registerRequiredCSS("elements/computedStyleSidebarPane.css",{enableLegacyPatching:!0}),this._computedStyleModel=new ComputedStyleModel,this._computedStyleModel.addEventListener(Events.ComputedStyleChanged,this.update,this),this._showInheritedComputedStylePropertiesSetting=Common.Settings.Settings.instance().createSetting("showInheritedComputedStyleProperties",!1),this._showInheritedComputedStylePropertiesSetting.addChangeListener(this.update.bind(this)),this._groupComputedStylesSetting=Common.Settings.Settings.instance().createSetting("groupComputedStyles",!1),this._groupComputedStylesSetting.addChangeListener((()=>{this.update()}));const e=this.contentElement.createChild("div","hbox styles-sidebar-pane-toolbar"),t=e.createChild("div","styles-sidebar-pane-filter-box"),o=StylesSidebarPane.createPropertyFilterElement(i18nString(UIStrings.filter),e,function(e){this._filterRegex=e,this._groupComputedStylesSetting.get()?this._filterGroupLists():this._filterAlphabeticalList()}.bind(this));UI.ARIAUtils.setAccessibleName(o,i18nString(UIStrings.filterComputedStyles)),t.appendChild(o),this._filterRegex=null;const n=new UI.Toolbar.Toolbar("styles-pane-toolbar",e);n.appendToolbarItem(new UI.Toolbar.ToolbarSettingCheckbox(this._showInheritedComputedStylePropertiesSetting,void 0,i18nString(UIStrings.showAll))),n.appendToolbarItem(new UI.Toolbar.ToolbarSettingCheckbox(this._groupComputedStylesSetting,void 0,i18nString(UIStrings.group))),this._noMatchesElement=this.contentElement.createChild("div","gray-info-message"),this._noMatchesElement.textContent=i18nString(UIStrings.noMatchingProperty),this._propertiesOutline=new UI.TreeOutline.TreeOutlineInShadow,this._propertiesOutline.hideOverflow(),this._propertiesOutline.setShowSelectionOnKeyboardFocus(!0),this._propertiesOutline.setFocusable(!0),this._propertiesOutline.registerRequiredCSS("elements/computedStyleWidgetTree.css",{enableLegacyPatching:!0}),this._propertiesOutline.element.classList.add("monospace","computed-properties"),this._propertiesOutline.addEventListener(UI.TreeOutline.Events.ElementExpanded,this._onTreeElementToggled,this),this._propertiesOutline.addEventListener(UI.TreeOutline.Events.ElementCollapsed,this._onTreeElementToggled,this),this.contentElement.appendChild(this._propertiesOutline.element),this._propertyByTreeElement=new WeakMap,this._categoryByTreeElement=new WeakMap,this._expandedProperties=new Set,this._expandedGroups=new Set(DefaultCategoryOrder),this._linkifier=new Components.Linkifier.Linkifier(_maxLinkLength),this._imagePreviewPopover=new ImagePreviewPopover(this.contentElement,(e=>{const t=e.composedPath()[0];return t instanceof Element?t:null}),(()=>this._computedStyleModel.node()));new PlatformFontsWidget(this._computedStyleModel).show(this.contentElement),this._idleCallbackManager=new IdleCallbackManager}onResize(){const e=this.contentElement.offsetWidth<260;this._propertiesOutline.contentElement.classList.toggle("computed-narrow",e)}_showInheritedComputedStyleChanged(){this.update()}update(){this._idleCallbackManager&&this._idleCallbackManager.discard(),this._idleCallbackManager=new IdleCallbackManager,super.update()}async doUpdate(){const[e,t]=await Promise.all([this._computedStyleModel.fetchComputedStyle(),this._fetchMatchedCascade()]),o=this._groupComputedStylesSetting.get();this._propertiesOutline.contentElement.classList.toggle("grouped-list",o),this._propertiesOutline.contentElement.classList.toggle("alphabetical-list",!o),o?await this._rebuildGroupedList(e,t):await this._rebuildAlphabeticalList(e,t)}async _fetchMatchedCascade(){const e=this._computedStyleModel.node();if(!e||!this._computedStyleModel.cssModel())return null;const t=this._computedStyleModel.cssModel();return t?t.cachedMatchedCascadeForNode(e).then(function(e){return e&&e.node()===this._computedStyleModel.node()?e:null}.bind(this)):null}async _rebuildAlphabeticalList(e,t){const o=this._propertiesOutline.element.hasFocus();this._imagePreviewPopover.hide(),this._propertiesOutline.removeChildren(),this._linkifier.reset();const n=this._computedStyleModel.cssModel();if(!e||!t||!n)return void this._noMatchesElement.classList.remove("hidden");const r=[...e.computedStyle.keys()];r.sort(propertySorter);const i=e.node,s=this._computePropertyTraces(t),l=this._computeNonInheritedProperties(t),a=this._showInheritedComputedStylePropertiesSetting.get(),d=[];for(const c of r){const t=e.computedStyle.get(c)||"",o=SDK.CSSMetadata.cssMetadata().canonicalPropertyName(c),n=!l.has(o);(a||!n||_alwaysShownComputedProperties.has(c))&&(!a&&c.startsWith("--")||c!==o&&t===e.computedStyle.get(o)||d.push({propertyName:c,propertyValue:t,isInherited:n}))}this._propertiesOutline.contentElement.classList.add("render-flash");let p=100;for(;d.length>0;){const e=d.splice(0,20);this._idleCallbackManager.schedule((()=>{for(const{propertyName:n,propertyValue:r,isInherited:l}of e){const e=this._buildPropertyTreeElement(s,i,t,n,r,l,o);this._propertiesOutline.appendChild(e)}this._filterAlphabeticalList()}),p),p+=100}await this._idleCallbackManager.awaitDone(),this._propertiesOutline.contentElement.classList.remove("render-flash")}async _rebuildGroupedList(e,t){const o=this._propertiesOutline.element.hasFocus();this._imagePreviewPopover.hide(),this._propertiesOutline.removeChildren(),this._linkifier.reset();const n=this._computedStyleModel.cssModel();if(!e||!t||!n)return void this._noMatchesElement.classList.remove("hidden");const r=e.node,i=this._computePropertyTraces(t),s=this._computeNonInheritedProperties(t),l=this._showInheritedComputedStylePropertiesSetting.get(),a=new Map;for(const[d,p]of e.computedStyle){const n=SDK.CSSMetadata.cssMetadata().canonicalPropertyName(d),c=!s.has(n);if(!l&&c&&!_alwaysShownComputedProperties.has(d))continue;if(!l&&d.startsWith("--"))continue;if(d!==n&&p===e.computedStyle.get(n))continue;const h=categorizePropertyName(d);for(const e of h){const n=this._buildPropertyTreeElement(i,r,t,d,p,c,o);a.has(e)||a.set(e,[]),a.get(e).push(n)}}for(const d of DefaultCategoryOrder){const e=a.get(d);if(e&&e.length>0){const t=document.createElement("h1");t.textContent=d;const o=new UI.TreeOutline.TreeElement(t);o.listItemElement.classList.add("group-title"),o.toggleOnClick=!0;for(const n of e)o.appendChild(n);this._propertiesOutline.appendChild(o),this._expandedGroups.has(d)&&o.expand(),this._categoryByTreeElement.set(o,d)}}this._filterGroupLists()}_onTreeElementToggled(e){const t=e.data,o=this._propertyByTreeElement.get(t);if(o)t.expanded?this._expandedProperties.add(o.name):this._expandedProperties.delete(o.name);else{const e=this._categoryByTreeElement.get(t);e&&(t.expanded?this._expandedGroups.add(e):this._expandedGroups.delete(e))}}_buildPropertyTreeElement(e,t,o,n,r,i,s){const l=new UI.TreeOutline.TreeElement,a=e.get(n);let d=()=>{};if(a){const e=this._renderPropertyTrace(o,t,l,a);l.setExpandable(!0),l.listItemElement.addEventListener("click",(e=>{l.expanded?l.collapse():l.expand(),e.consume()}),!1),d=navigateToSource.bind(this,e)}const p=createPropertyElement(t,n,r);return p.data={traceable:e.has(n),inherited:i,onNavigateToSource:d},l.title=p,this._propertyByTreeElement.set(l,{name:n,value:r}),this._propertiesOutline.selectedTreeElement||l.select(!s),this._expandedProperties.has(n)&&l.expand(),l}_renderPropertyTrace(e,t,o,n){let r=null;for(const i of n){const n=e.propertyState(i)===SDK.CSSMatchedStyles.PropertyState.Overloaded;n||(r=i,o.listItemElement.addEventListener("contextmenu",this._handleContextMenuEvent.bind(this,e,i)));const s=createTraceElement(t,i,n,e,this._linkifier),l=new UI.TreeOutline.TreeElement;l.title=s,l.listItemElement.addEventListener("contextmenu",this._handleContextMenuEvent.bind(this,e,i)),o.appendChild(l)}return r}_handleContextMenuEvent(e,t,o){const n=new UI.ContextMenu.ContextMenu(o),r=t.ownerStyle.parentRule;if(r){const t=r.styleSheetId?e.cssModel().styleSheetHeaderForId(r.styleSheetId):null;t&&!t.isAnonymousInlineStyleSheet()&&n.defaultSection().appendItem(i18nString(UIStrings.navigateToSelectorSource),(()=>{StylePropertiesSection.tryNavigateToRuleLocation(e,r)}))}n.defaultSection().appendItem(i18nString(UIStrings.navigateToStyle),(()=>Common.Revealer.reveal(t))),n.show()}_computePropertyTraces(e){const t=new Map;for(const o of e.nodeStyles()){const n=o.allProperties();for(const o of n)o.activeInStyle()&&e.propertyState(o)&&(t.has(o.name)||t.set(o.name,[]),t.get(o.name).push(o))}return t}_computeNonInheritedProperties(e){const t=new Set;for(const o of e.nodeStyles())for(const n of o.allProperties())e.propertyState(n)&&t.add(SDK.CSSMetadata.cssMetadata().canonicalPropertyName(n.name));return t}_filterAlphabeticalList(){const e=this._filterRegex,t=this._propertiesOutline.rootElement().children();let o=!1;for(const n of t){const t=this._propertyByTreeElement.get(n);if(!t)continue;const r=!e||e.test(t.name)||e.test(t.value);n.hidden=!r,o=o||r}this._noMatchesElement.classList.toggle("hidden",Boolean(o))}_filterGroupLists(){const e=this._filterRegex,t=this._propertiesOutline.rootElement().children();let o=!1,n=!1;for(const r of t){let t=!1;const i=r.children();for(const n of i){const r=this._propertyByTreeElement.get(n);if(!r)continue;const i=!e||e.test(r.name)||e.test(r.value);n.hidden=!i,o=o||i,t=t||i}r.hidden=!t,r.listItemElement.classList.toggle("first-group",t&&!n),n=n||t}this._noMatchesElement.classList.toggle("hidden",o)}}const _maxLinkLength=30,_alwaysShownComputedProperties=new Set(["display","height","width"]);