import*as Bindings from"../bindings/bindings.js";import*as Common from"../common/common.js";import*as Components from"../components/components.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as InlineEditor from"../inline_editor/inline_editor.js";import*as Platform from"../platform/platform.js";import*as Root from"../root/root.js";import*as SDK from"../sdk/sdk.js";import*as TextUtils from"../text_utils/text_utils.js";import*as WebComponents from"../ui/components/components.js";import*as UI from"../ui/ui.js";import{FontEditorSectionManager}from"./ColorSwatchPopoverIcon.js";import{ComputedStyleModel}from"./ComputedStyleModel.js";import{findIcon}from"./CSSPropertyIconResolver.js";import{linkifyDeferredNodeReference}from"./DOMLinkifier.js";import{ElementsSidebarPane}from"./ElementsSidebarPane.js";import{FlexboxEditorWidget}from"./FlexboxEditorWidget.js";import{ImagePreviewPopover}from"./ImagePreviewPopover.js";import{StylePropertyHighlighter}from"./StylePropertyHighlighter.js";import{StylePropertyTreeElement}from"./StylePropertyTreeElement.js";const UIStrings={noMatchingSelectorOrStyle:"No matching selector or style",invalidPropertyValue:"Invalid property value",unknownPropertyName:"Unknown property name",filter:"Filter",filterStyles:"Filter Styles",pseudoSElement:"Pseudo ::{PH1} element",inheritedFroms:"Inherited from ",insertStyleRuleBelow:"Insert Style Rule Below",constructedStylesheet:"constructed stylesheet",userAgentStylesheet:"user agent stylesheet",injectedStylesheet:"injected stylesheet",viaInspector:"via inspector",styleAttribute:"Style Attribute",sattributesStyle:"{PH1}[Attributes Style]",showAllPropertiesSMore:"Show All Properties ({PH1} more)",copySelector:"Copy `selector`",copyRule:"Copy rule",copyAllDeclarations:"Copy all declarations",incrementdecrementWithMousewheelOne:"Increment/decrement with mousewheel or up/down keys. {PH1}: R \xb11, Shift: G \xb11, Alt: B \xb11",incrementdecrementWithMousewheelHundred:"Increment/decrement with mousewheel or up/down keys. {PH1}: \xb1100, Shift: \xb110, Alt: \xb10.1",invalidString:"{PH1}, property name: {PH2}, property value: {PH3}",newStyleRule:"New Style Rule"},str_=i18n.i18n.registerUIStrings("elements/StylesSidebarPane.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),HIGHLIGHTABLE_PROPERTIES=[{mode:"padding",properties:["padding"]},{mode:"border",properties:["border"]},{mode:"margin",properties:["margin"]},{mode:"gap",properties:["gap","grid-gap"]},{mode:"column-gap",properties:["column-gap","grid-column-gap"]},{mode:"row-gap",properties:["row-gap","grid-row-gap"]},{mode:"grid-template-columns",properties:["grid-template-columns"]},{mode:"grid-template-rows",properties:["grid-template-rows"]},{mode:"grid-template-areas",properties:["grid-areas"]},{mode:"justify-content",properties:["justify-content"]},{mode:"align-content",properties:["align-content"]},{mode:"align-items",properties:["align-items"]}];let _stylesSidebarPaneInstance,buttonProviderInstance;export class StylesSidebarPane extends ElementsSidebarPane{static instance(){return _stylesSidebarPaneInstance||(_stylesSidebarPaneInstance=new StylesSidebarPane),_stylesSidebarPaneInstance}constructor(){super(!0),this.setMinimumSize(96,26),this.registerRequiredCSS("elements/stylesSidebarPane.css",{enableLegacyPatching:!0}),Common.Settings.Settings.instance().moduleSetting("colorFormat").addChangeListener(this.update.bind(this)),Common.Settings.Settings.instance().moduleSetting("textEditorIndent").addChangeListener(this.update.bind(this)),this._currentToolbarPane=null,this._animatedToolbarPane=null,this._pendingWidget=null,this._pendingWidgetToggle=null,this._toolbar=null,this._toolbarPaneElement=this._createStylesSidebarToolbar(),this._computedStyleModel=new ComputedStyleModel,this._noMatchesElement=this.contentElement.createChild("div","gray-info-message hidden"),this._noMatchesElement.textContent=i18nString(UIStrings.noMatchingSelectorOrStyle),this._sectionsContainer=this.contentElement.createChild("div"),UI.ARIAUtils.markAsTree(this._sectionsContainer),this._sectionsContainer.addEventListener("keydown",this._sectionsContainerKeyDown.bind(this),!1),this._sectionsContainer.addEventListener("focusin",this._sectionsContainerFocusChanged.bind(this),!1),this._sectionsContainer.addEventListener("focusout",this._sectionsContainerFocusChanged.bind(this),!1),this.sectionByElement=new WeakMap,this._swatchPopoverHelper=new InlineEditor.SwatchPopoverHelper.SwatchPopoverHelper,this._swatchPopoverHelper.addEventListener(InlineEditor.SwatchPopoverHelper.Events.WillShowPopover,this.hideAllPopovers,this),this._linkifier=new Components.Linkifier.Linkifier(_maxLinkLength,!0),this._decorator=new StylePropertyHighlighter(this),this._lastRevealedProperty=null,this._userOperation=!1,this._isEditingStyle=!1,this._filterRegex=null,this._isActivePropertyHighlighted=!1,this._initialUpdateCompleted=!1,this.hasMatchedStyles=!1,this.contentElement.classList.add("styles-pane"),this._sectionBlocks=[],this._idleCallbackManager=null,this._needsForceUpdate=!1,_stylesSidebarPaneInstance=this,UI.Context.Context.instance().addFlavorChangeListener(SDK.DOMModel.DOMNode,this.forceUpdate,this),this.contentElement.addEventListener("copy",this._clipboardCopy.bind(this)),this._resizeThrottler=new Common.Throttler.Throttler(100),this._imagePreviewPopover=new ImagePreviewPopover(this.contentElement,(e=>{const t=e.composedPath()[0];return t instanceof Element?t:null}),(()=>this.node())),this.activeCSSAngle=null}swatchPopoverHelper(){return this._swatchPopoverHelper}setUserOperation(e){this._userOperation=e}static createExclamationMark(e,t){const i=document.createElement("span",{is:"dt-icon-label"});let n;i.className="exclamation-mark",StylesSidebarPane.ignoreErrorsForProperty(e)||(i.type="smallicon-warning"),t?(UI.Tooltip.Tooltip.install(i,t),n=t):(n=SDK.CSSMetadata.cssMetadata().isCSSPropertyName(e.name)?i18nString(UIStrings.invalidPropertyValue):i18nString(UIStrings.unknownPropertyName),UI.Tooltip.Tooltip.install(i,n));const s=i18nString(UIStrings.invalidString,{PH1:n,PH2:e.name,PH3:e.value});return e.setDisplayedStringForInvalidProperty(s),i}static ignoreErrorsForProperty(e){function t(e){return!e.startsWith("-webkit-")&&/^[-_][\w\d]+-\w/.test(e)}const i=e.name.toLowerCase();if("_"===i.charAt(0))return!0;if("filter"===i)return!0;if(i.startsWith("scrollbar-"))return!0;if(t(i))return!0;const n=e.value.toLowerCase();return!!n.endsWith("\\9")||!!t(n)}static createPropertyFilterElement(e,t,i){const n=document.createElement("input");function s(){const e=n.value?new RegExp(Platform.StringUtilities.escapeForRegExp(n.value),"i"):null;i(e)}return n.type="search",n.classList.add("custom-search-input"),n.placeholder=e,n.addEventListener("input",s,!1),n.addEventListener("keydown",(function(e){const t=e;"Escape"===t.key&&n.value&&(t.consume(!0),n.value="",s())}),!1),n}static formatLeadingProperties(e){const t=e._headerText(),i=Common.Settings.Settings.instance().moduleSetting("textEditorIndent").get(),n=e._style,s=[];for(const r of n.leadingProperties())r.disabled?s.push(`${i}/* ${r.name}: ${r.value}; */`):s.push(`${i}${r.name}: ${r.value};`);const o=s.join("\n");return{allDeclarationText:o,ruleText:`${t} {\n${o}\n}`}}revealProperty(e){this._decorator.highlightProperty(e),this._lastRevealedProperty=e,this.update()}jumpToProperty(e){this._decorator.findAndHighlightPropertyName(e)}forceUpdate(){this._needsForceUpdate=!0,this._swatchPopoverHelper.hide(),this._resetCache(),this.update()}_sectionsContainerKeyDown(e){const t=this._sectionsContainer.ownerDocument.deepActiveElement();if(!t)return;const i=this.sectionByElement.get(t);if(!i)return;let n=null,s=!1;switch(e.key){case"ArrowUp":case"ArrowLeft":n=i.previousSibling()||i.lastSibling(),s=!1;break;case"ArrowDown":case"ArrowRight":n=i.nextSibling()||i.firstSibling(),s=!0;break;case"Home":n=i.firstSibling(),s=!0;break;case"End":n=i.lastSibling(),s=!1}n&&this._filterRegex&&(n=n.findCurrentOrNextVisible(s)),n&&(n.element.focus(),e.consume(!0))}_sectionsContainerFocusChanged(){this.resetFocus()}resetFocus(){if(this._noMatchesElement.classList.contains("hidden")&&this._sectionBlocks[0]&&this._sectionBlocks[0].sections[0]){const e=this._sectionBlocks[0].sections[0].findCurrentOrNextVisible(!0);e&&(e.element.tabIndex=this._sectionsContainer.hasFocus()?-1:0)}}_onAddButtonLongClick(e){const t=this.cssModel();if(!t)return;const i=t.styleSheetHeaders().filter((function(e){return!e.isViaInspector()&&!e.isInline&&Boolean(e.resourceURL())})),n=[];for(let o=0;o<i.length;++o){const e=i[o],t=this._createNewRuleInStyleSheet.bind(this,e);n.push({text:Bindings.ResourceUtils.displayNameForURL(e.resourceURL()),handler:t})}n.sort((function(e,t){return Platform.StringUtilities.naturalOrderComparator(e.text,t.text)}));const s=new UI.ContextMenu.ContextMenu(e);for(let o=0;o<n.length;++o){const e=n[o];s.defaultSection().appendItem(e.text,e.handler)}s.footerSection().appendItem("inspector-stylesheet",this._createNewRuleInViaInspectorStyleSheet.bind(this)),s.show()}_onFilterChanged(e){this._filterRegex=e,this._updateFilter(),this.resetFocus()}_refreshUpdate(e,t){if(t)for(const n of this.allSections())n instanceof BlankStylePropertiesSection&&n.isBlank||n._updateVarFunctions(t);if(this._isEditingStyle)return;const i=this.node();if(i){for(const t of this.allSections())t instanceof BlankStylePropertiesSection&&t.isBlank||t.update(t===e);this._filterRegex&&this._updateFilter(),this._nodeStylesUpdatedForTest(i,!1)}}async doUpdate(){this._initialUpdateCompleted||setTimeout((()=>{this._initialUpdateCompleted||this._sectionsContainer.createChild("span","spinner")}),200);const e=await this._fetchMatchedCascade();await this._innerRebuildUpdate(e),this._initialUpdateCompleted||(this._initialUpdateCompleted=!0,this.dispatchEventToListeners(Events.InitialUpdateCompleted)),this.dispatchEventToListeners(Events.StylesUpdateCompleted,{hasMatchedStyles:this.hasMatchedStyles})}onResize(){this._resizeThrottler.schedule(this._innerResize.bind(this))}_innerResize(){const e=this.contentElement.getBoundingClientRect().width+"px";return this.allSections().forEach((t=>{t.propertiesTreeOutline.element.style.width=e})),Promise.resolve()}_resetCache(){const e=this.cssModel();e&&e.discardCachedMatchedCascade()}_fetchMatchedCascade(){const e=this.node();if(!e||!this.cssModel())return Promise.resolve(null);const t=this.cssModel();return t?t.cachedMatchedCascadeForNode(e).then(function(e){return e&&e.node()===this.node()?e:null}.bind(this)):Promise.resolve(null)}setEditingStyle(e,t){this._isEditingStyle!==e&&(this.contentElement.classList.toggle("is-editing-style",e),this._isEditingStyle=e,this._setActiveProperty(null))}_setActiveProperty(e){if(this._isActivePropertyHighlighted&&SDK.OverlayModel.OverlayModel.hideDOMNodeHighlight(),this._isActivePropertyHighlighted=!1,!this.node())return;if(!e||e.overloaded()||e.inherited())return;const t=e.property.ownerStyle.parentRule,i=t instanceof SDK.CSSRule.CSSStyleRule?t.selectorText():void 0;for(const{properties:n,mode:s}of HIGHLIGHTABLE_PROPERTIES){if(!n.includes(e.name))continue;const t=this.node();if(t){t.domModel().overlayModel().highlightInOverlay({node:this.node(),selectorList:i},s),this._isActivePropertyHighlighted=!0;break}}}onCSSModelChanged(e){const t=e&&e.data?e.data.edit:null;if(t)for(const i of this.allSections())i._styleSheetEdited(t);else this._userOperation||this._isEditingStyle||(this._resetCache(),this.update())}focusedSectionIndex(){let e=0;for(const t of this._sectionBlocks)for(const i of t.sections){if(i.element.hasFocus())return e;e++}return-1}continueEditingElement(e,t){const i=this.allSections()[e];if(i){const e=i.closestPropertyForEditing(t);if(!e)return void i.element.focus();e.startEditing()}}async _innerRebuildUpdate(e){if(this._needsForceUpdate)this._needsForceUpdate=!1;else if(this._isEditingStyle||this._userOperation)return;const t=this.focusedSectionIndex();this._linkifier.reset();const i=this._sectionBlocks.map((e=>e.sections)).flat();this._sectionBlocks=[];const n=this.node();if(this.hasMatchedStyles=null!==e&&null!==n,!this.hasMatchedStyles)return this._sectionsContainer.removeChildren(),void this._noMatchesElement.classList.remove("hidden");this._sectionBlocks=await this._rebuildSectionsForMatchedStyleRules(e);const s=this._sectionBlocks.map((e=>e.sections)).flat(),o=FlexboxEditorWidget.instance(),r=o.getSection();if(r){o.unbindContext();for(const[e,t]of i.entries())r===t&&e<s.length&&o.bindContext(this,s[e])}this._sectionsContainer.removeChildren();const l=document.createDocumentFragment();let a=0,d=null;for(const c of this._sectionBlocks){const e=c.titleElement();e&&l.appendChild(e);for(const i of c.sections)l.appendChild(i.element),a===t&&(d=i.element),a++}this._sectionsContainer.appendChild(l),d&&d.focus(),t>=a&&this._sectionBlocks[0].sections[0].element.focus(),this._sectionsContainerFocusChanged(),this._filterRegex?this._updateFilter():this._noMatchesElement.classList.toggle("hidden",this._sectionBlocks.length>0),this._nodeStylesUpdatedForTest(n,!0),this._lastRevealedProperty&&(this._decorator.highlightProperty(this._lastRevealedProperty),this._lastRevealedProperty=null),Host.userMetrics.panelLoaded("elements","DevTools.Launch.Elements"),this.dispatchEventToListeners(Events.StylesUpdateCompleted,{hasStyle:!0})}_nodeStylesUpdatedForTest(e,t){}async _rebuildSectionsForMatchedStyleRules(e){this._idleCallbackManager&&this._idleCallbackManager.discard(),this._idleCallbackManager=new IdleCallbackManager;const t=[new SectionBlock(null)];let i=null;for(const o of e.nodeStyles()){const n=e.isInherited(o)?e.nodeForStyle(o):null;if(n&&n!==i){i=n;const e=await SectionBlock._createInheritedNodeBlock(i);t.push(e)}const s=t[t.length-1];s&&this._idleCallbackManager.schedule((()=>{const t=new StylePropertiesSection(this,e,o);s.sections.push(t)}))}let n=[];const s=e.pseudoTypes();s.delete(Protocol.DOM.PseudoType.Before)&&n.push(Protocol.DOM.PseudoType.Before),n=n.concat([...s].sort());for(const o of n){const i=SectionBlock.createPseudoTypeBlock(o);for(const t of e.pseudoStyles(o))this._idleCallbackManager.schedule((()=>{const n=new StylePropertiesSection(this,e,t);i.sections.push(n)}));t.push(i)}for(const o of e.keyframes()){const i=SectionBlock.createKeyframesBlock(o.name().text);for(const t of o.keyframes())this._idleCallbackManager.schedule((()=>{i.sections.push(new KeyframePropertiesSection(this,e,t.style))}));t.push(i)}return await this._idleCallbackManager.awaitDone(),t}async _createNewRuleInViaInspectorStyleSheet(){const e=this.cssModel(),t=this.node();if(!e||!t)return;this.setUserOperation(!0);const i=await e.requestViaInspectorStylesheet(t);this.setUserOperation(!1),await this._createNewRuleInStyleSheet(i)}async _createNewRuleInStyleSheet(e){if(!e)return;const t=((await e.requestContent()).content||"").split("\n"),i=TextUtils.TextRange.TextRange.createFromLocation(t.length-1,t[t.length-1].length);this._sectionBlocks&&this._sectionBlocks.length>0&&this._addBlankSection(this._sectionBlocks[0].sections[0],e.id,i)}_addBlankSection(e,t,i){const n=this.node(),s=new BlankStylePropertiesSection(this,e._matchedStyles,n?n.simpleSelector():"",t,i,e._style);this._sectionsContainer.insertBefore(s.element,e.element.nextSibling);for(const o of this._sectionBlocks){const t=o.sections.indexOf(e);-1!==t&&(o.sections.splice(t+1,0,s),s.startEditingSelector())}}removeSection(e){for(const t of this._sectionBlocks){const i=t.sections.indexOf(e);-1!==i&&(t.sections.splice(i,1),e.element.remove())}}filterRegex(){return this._filterRegex}_updateFilter(){let e=!1;for(const t of this._sectionBlocks)e=t.updateFilter()||e;this._noMatchesElement.classList.toggle("hidden",Boolean(e))}willHide(){this.hideAllPopovers(),super.willHide()}hideAllPopovers(){this._swatchPopoverHelper.hide(),this._imagePreviewPopover.hide(),this.activeCSSAngle&&(this.activeCSSAngle.minify(),this.activeCSSAngle=null)}allSections(){let e=[];for(const t of this._sectionBlocks)e=e.concat(t.sections);return e}_clipboardCopy(e){Host.userMetrics.actionTaken(Host.UserMetrics.Action.StyleRuleCopied)}_createStylesSidebarToolbar(){const e=this.contentElement.createChild("div","styles-sidebar-pane-toolbar-container"),t=e.createChild("div","hbox styles-sidebar-pane-toolbar"),i=t.createChild("div","styles-sidebar-pane-filter-box"),n=StylesSidebarPane.createPropertyFilterElement(i18nString(UIStrings.filter),t,this._onFilterChanged.bind(this));UI.ARIAUtils.setAccessibleName(n,i18nString(UIStrings.filterStyles)),i.appendChild(n);const s=new UI.Toolbar.Toolbar("styles-pane-toolbar",t);s.makeToggledGray(),s.appendItemsAtLocation("styles-sidebarpane-toolbar"),this._toolbar=s;return e.createChild("div","styles-sidebar-toolbar-pane-container").createChild("div","styles-sidebar-toolbar-pane")}showToolbarPane(e,t){this._pendingWidgetToggle&&this._pendingWidgetToggle.setToggled(!1),this._pendingWidgetToggle=t,this._animatedToolbarPane?this._pendingWidget=e:this._startToolbarPaneAnimation(e),e&&t&&t.setToggled(!0)}appendToolbarItem(e){this._toolbar&&this._toolbar.appendToolbarItem(e)}_startToolbarPaneAnimation(e){if(e===this._currentToolbarPane)return;if(e&&this._currentToolbarPane)return this._currentToolbarPane.detach(),e.show(this._toolbarPaneElement),this._currentToolbarPane=e,void this._currentToolbarPane.focus();this._animatedToolbarPane=e,this._currentToolbarPane?this._toolbarPaneElement.style.animationName="styles-element-state-pane-slideout":e&&(this._toolbarPaneElement.style.animationName="styles-element-state-pane-slidein"),e&&e.show(this._toolbarPaneElement);const t=function(){this._toolbarPaneElement.style.removeProperty("animation-name"),this._toolbarPaneElement.removeEventListener("animationend",t,!1),this._currentToolbarPane&&this._currentToolbarPane.detach();this._currentToolbarPane=this._animatedToolbarPane,this._currentToolbarPane&&this._currentToolbarPane.focus();this._animatedToolbarPane=null,this._pendingWidget&&(this._startToolbarPaneAnimation(this._pendingWidget),this._pendingWidget=null)}.bind(this);this._toolbarPaneElement.addEventListener("animationend",t,!1)}}export const Events={InitialUpdateCompleted:Symbol("InitialUpdateCompleted"),StylesUpdateCompleted:Symbol("StylesUpdateCompleted")};export const _maxLinkLength=23;export class SectionBlock{constructor(e){this._titleElement=e,this.sections=[]}static createPseudoTypeBlock(e){const t=document.createElement("div");return t.className="sidebar-separator",t.textContent=i18nString(UIStrings.pseudoSElement,{PH1:e}),new SectionBlock(t)}static createKeyframesBlock(e){const t=document.createElement("div");return t.className="sidebar-separator",t.textContent=`@keyframes ${e}`,new SectionBlock(t)}static async _createInheritedNodeBlock(e){const t=document.createElement("div");t.className="sidebar-separator",UI.UIUtils.createTextChild(t,i18nString(UIStrings.inheritedFroms));const i=await Common.Linkifier.Linkifier.linkify(e,{preventKeyboardFocus:!0,tooltip:void 0});return t.appendChild(i),new SectionBlock(t)}updateFilter(){let e=!1;for(const t of this.sections)e=t._updateFilter()||e;return this._titleElement&&this._titleElement.classList.toggle("hidden",!e),Boolean(e)}titleElement(){return this._titleElement}}export class IdleCallbackManager{constructor(){this._discarded=!1,this._promises=[]}discard(){this._discarded=!0}schedule(e,t=100){this._discarded||this._promises.push(new Promise(((i,n)=>{window.requestIdleCallback((()=>{if(this._discarded)return i();(()=>{try{e(),i()}catch(t){n(t)}})()}),{timeout:t})})))}awaitDone(){return Promise.all(this._promises)}}export class StylePropertiesSection{constructor(e,t,i){this._parentPane=e,this._style=i,this._matchedStyles=t,this.editable=Boolean(i.styleSheetId&&i.range),this._hoverTimer=null,this._willCauseCancelEditing=!1,this._forceShowAll=!1,this._originalPropertiesCount=i.leadingProperties().length;const n=i.parentRule;this.element=document.createElement("div"),this.element.classList.add("styles-section"),this.element.classList.add("matched-styles"),this.element.classList.add("monospace"),UI.ARIAUtils.setAccessibleName(this.element,`${this._headerText()}, css selector`),this.element.tabIndex=-1,UI.ARIAUtils.markAsTreeitem(this.element),this.element.addEventListener("keydown",this._onKeyDown.bind(this),!1),e.sectionByElement.set(this.element,this),this._innerElement=this.element.createChild("div"),this._titleElement=this._innerElement.createChild("div","styles-section-title "+(n?"styles-selector":"")),this.propertiesTreeOutline=new UI.TreeOutline.TreeOutlineInShadow,this.propertiesTreeOutline.setFocusable(!1),this.propertiesTreeOutline.registerRequiredCSS("elements/stylesSectionTree.css",{enableLegacyPatching:!0}),this.propertiesTreeOutline.element.classList.add("style-properties","matched-styles","monospace"),this.propertiesTreeOutline.section=this,this._innerElement.appendChild(this.propertiesTreeOutline.element),this._showAllButton=UI.UIUtils.createTextButton("",this._showAllItems.bind(this),"styles-show-all"),this._innerElement.appendChild(this._showAllButton);const s=document.createElement("div");this._selectorElement=document.createElement("span"),this._selectorElement.classList.add("selector"),this._selectorElement.textContent=this._headerText(),s.appendChild(this._selectorElement),this._selectorElement.addEventListener("mouseenter",this._onMouseEnterSelector.bind(this),!1),this._selectorElement.addEventListener("mousemove",(e=>e.consume()),!1),this._selectorElement.addEventListener("mouseleave",this._onMouseOutSelector.bind(this),!1);s.createChild("span","sidebar-pane-open-brace").textContent=" {",s.addEventListener("mousedown",this._handleEmptySpaceMouseDown.bind(this),!1),s.addEventListener("click",this._handleSelectorContainerClick.bind(this),!1);if(this._innerElement.createChild("div","sidebar-pane-closing-brace").textContent="}",this._style.parentRule){const e=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.insertStyleRuleBelow),"largeicon-add");e.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this._onNewRuleClick,this),e.element.tabIndex=-1,this._newStyleRuleToolbar||(this._newStyleRuleToolbar=new UI.Toolbar.Toolbar("sidebar-pane-section-toolbar new-rule-toolbar",this._innerElement)),this._newStyleRuleToolbar.appendToolbarItem(e),UI.ARIAUtils.markAsHidden(this._newStyleRuleToolbar.element)}if(Root.Runtime.experiments.isEnabled("fontEditor")&&this.editable&&(this._fontEditorToolbar=new UI.Toolbar.Toolbar("sidebar-pane-section-toolbar",this._innerElement),this._fontEditorSectionManager=new FontEditorSectionManager(this._parentPane.swatchPopoverHelper(),this),this._fontEditorButton=new UI.Toolbar.ToolbarButton("Font Editor","largeicon-font-editor"),this._fontEditorButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,(()=>{this._onFontEditorButtonClicked()}),this),this._fontEditorButton.element.addEventListener("keydown",(e=>{isEnterOrSpaceKey(e)&&(e.consume(!0),this._onFontEditorButtonClicked())}),!1),this._fontEditorToolbar.appendToolbarItem(this._fontEditorButton),this._style.type===SDK.CSSStyleDeclaration.Type.Inline?this._newStyleRuleToolbar&&this._newStyleRuleToolbar.element.classList.add("shifted-toolbar"):this._fontEditorToolbar.element.classList.add("font-toolbar-hidden")),this._selectorElement.addEventListener("click",this._handleSelectorClick.bind(this),!1),this.element.addEventListener("contextmenu",this._handleContextMenuEvent.bind(this),!1),this.element.addEventListener("mousedown",this._handleEmptySpaceMouseDown.bind(this),!1),this.element.addEventListener("click",this._handleEmptySpaceClick.bind(this),!1),this.element.addEventListener("mousemove",this._onMouseMove.bind(this),!1),this.element.addEventListener("mouseleave",this._onMouseLeave.bind(this),!1),this._selectedSinceMouseDown=!1,this._elementToSelectorIndex=new WeakMap,n)if(n.isUserAgent()||n.isInjected())this.editable=!1;else if(n.styleSheetId){const e=n.cssModel().styleSheetHeaderForId(n.styleSheetId);this.navigable=e&&!e.isAnonymousInlineStyleSheet()}this._mediaListElement=this._titleElement.createChild("div","media-list media-matches"),this._selectorRefElement=this._titleElement.createChild("div","styles-section-subtitle"),this._updateMediaList(),this._updateRuleOrigin(),this._titleElement.appendChild(s),this._selectorContainer=s,this.navigable&&this.element.classList.add("navigable"),this.editable||(this.element.classList.add("read-only"),this.propertiesTreeOutline.element.classList.add("read-only")),this._fontPopoverIcon=null,this._hoverableSelectorsMode=!1,this._isHidden=!1,this._markSelectorMatches(),this.onpopulate()}registerFontProperty(e){this._fontEditorSectionManager&&this._fontEditorSectionManager.registerFontProperty(e),this._fontEditorToolbar&&(this._fontEditorToolbar.element.classList.remove("font-toolbar-hidden"),this._newStyleRuleToolbar&&this._newStyleRuleToolbar.element.classList.add("shifted-toolbar"))}resetToolbars(){this._parentPane.swatchPopoverHelper().isShowing()||this._style.type===SDK.CSSStyleDeclaration.Type.Inline||(this._fontEditorToolbar&&this._fontEditorToolbar.element.classList.add("font-toolbar-hidden"),this._newStyleRuleToolbar&&this._newStyleRuleToolbar.element.classList.remove("shifted-toolbar"))}static createRuleOriginNode(e,t,i){if(!i)return document.createTextNode("");const n=this._getRuleLocationFromCSSRule(i),s=i.styleSheetId?e.cssModel().styleSheetHeaderForId(i.styleSheetId):null;if(s&&s.isMutable&&!s.isViaInspector()){const e=s.isConstructed?i18nString(UIStrings.constructedStylesheet):"<style>";if(s.ownerNode){const t=linkifyDeferredNodeReference(s.ownerNode,{preventKeyboardFocus:!1,tooltip:void 0});return t.textContent=e,t}return document.createTextNode(e)}if(n&&i.styleSheetId&&s&&!s.isAnonymousInlineStyleSheet())return StylePropertiesSection._linkifyRuleLocation(e.cssModel(),t,i.styleSheetId,n);if(i.isUserAgent())return document.createTextNode(i18nString(UIStrings.userAgentStylesheet));if(i.isInjected())return document.createTextNode(i18nString(UIStrings.injectedStylesheet));if(i.isViaInspector())return document.createTextNode(i18nString(UIStrings.viaInspector));if(s&&s.ownerNode){const e=linkifyDeferredNodeReference(s.ownerNode,{preventKeyboardFocus:!1,tooltip:void 0});return e.textContent="<style>",e}return document.createTextNode("")}static _getRuleLocationFromCSSRule(e){let t;return e instanceof SDK.CSSRule.CSSStyleRule?t=e.style.range:e instanceof SDK.CSSRule.CSSKeyframeRule&&(t=e.key().range),t}static tryNavigateToRuleLocation(e,t){if(!t)return;const i=this._getRuleLocationFromCSSRule(t),n=t.styleSheetId?e.cssModel().styleSheetHeaderForId(t.styleSheetId):null;if(i&&t.styleSheetId&&n&&!n.isAnonymousInlineStyleSheet()){const n=this._getCSSSelectorLocation(e.cssModel(),t.styleSheetId,i);this._revealSelectorSource(n,!0)}}static _linkifyRuleLocation(e,t,i,n){const s=this._getCSSSelectorLocation(e,i,n);return t.linkifyCSSLocation(s)}static _getCSSSelectorLocation(e,t,i){const n=e.styleSheetHeaderForId(t),s=n.lineNumberInSource(i.startLine),o=n.columnNumberInSource(i.startLine,i.startColumn);return new SDK.CSSModel.CSSLocation(n,s,o)}_onKeyDown(e){const t=e;if(!(UI.UIUtils.isEditing()||!this.editable||t.altKey||t.ctrlKey||t.metaKey))switch(t.key){case"Enter":case" ":this._startEditingAtFirstPosition(),t.consume(!0);break;default:1===t.key.length&&this.addNewBlankProperty(0).startEditing()}}_setSectionHovered(e){this.element.classList.toggle("styles-panel-hovered",e),this.propertiesTreeOutline.element.classList.toggle("styles-panel-hovered",e),this._hoverableSelectorsMode!==e&&(this._hoverableSelectorsMode=e,this._markSelectorMatches())}_onMouseLeave(e){this._setSectionHovered(!1),this._parentPane._setActiveProperty(null)}_onMouseMove(e){const t=UI.KeyboardShortcut.KeyboardShortcut.eventHasCtrlOrMeta(e);this._setSectionHovered(t);const i=this.propertiesTreeOutline.treeElementFromEvent(e);i instanceof StylePropertyTreeElement?this._parentPane._setActiveProperty(i):this._parentPane._setActiveProperty(null);const n=this.element.getComponentSelection();!this._selectedSinceMouseDown&&n&&n.toString()&&(this._selectedSinceMouseDown=!0)}_onFontEditorButtonClicked(){this._fontEditorSectionManager&&this._fontEditorButton&&(Host.userMetrics.cssEditorOpened("fontEditor"),this._fontEditorSectionManager.showPopover(this._fontEditorButton.element,this._parentPane))}style(){return this._style}_headerText(){const e=this._matchedStyles.nodeForStyle(this._style);return this._style.type===SDK.CSSStyleDeclaration.Type.Inline?this._matchedStyles.isInherited(this._style)?i18nString(UIStrings.styleAttribute):"element.style":e&&this._style.type===SDK.CSSStyleDeclaration.Type.Attributes?i18nString(UIStrings.sattributesStyle,{PH1:e.nodeNameInCorrectCase()}):this._style.parentRule instanceof SDK.CSSRule.CSSStyleRule?this._style.parentRule.selectorText():""}_onMouseOutSelector(){this._hoverTimer&&clearTimeout(this._hoverTimer),SDK.OverlayModel.OverlayModel.hideDOMNodeHighlight()}_onMouseEnterSelector(){this._hoverTimer&&clearTimeout(this._hoverTimer),this._hoverTimer=setTimeout(this._highlight.bind(this),300)}_highlight(e="all"){SDK.OverlayModel.OverlayModel.hideDOMNodeHighlight();const t=this._parentPane.node();if(!t)return;const i=this._style.parentRule&&this._style.parentRule instanceof SDK.CSSRule.CSSStyleRule?this._style.parentRule.selectorText():void 0;t.domModel().overlayModel().highlightInOverlay({node:t,selectorList:i},e)}firstSibling(){const e=this.element.parentElement;if(!e)return null;let t=e.firstChild;for(;t;){const e=this._parentPane.sectionByElement.get(t);if(e)return e;t=t.nextSibling}return null}findCurrentOrNextVisible(e,t){if(!this.isHidden())return this;if(this===t)return null;t||(t=this);let i=null;const n=e?this.nextSibling():this.previousSibling();if(n)i=n.findCurrentOrNextVisible(e,t);else{const n=e?this.firstSibling():this.lastSibling();n&&(i=n.findCurrentOrNextVisible(e,t))}return i}lastSibling(){const e=this.element.parentElement;if(!e)return null;let t=e.lastChild;for(;t;){const e=this._parentPane.sectionByElement.get(t);if(e)return e;t=t.previousSibling}return null}nextSibling(){let e=this.element;do{e=e.nextSibling}while(e&&!this._parentPane.sectionByElement.has(e));if(e)return this._parentPane.sectionByElement.get(e)}previousSibling(){let e=this.element;do{e=e.previousSibling}while(e&&!this._parentPane.sectionByElement.has(e));if(e)return this._parentPane.sectionByElement.get(e)}_onNewRuleClick(e){e.data.consume();const t=this._style.parentRule;if(!t||!t.style.range)return;const i=TextUtils.TextRange.TextRange.createFromLocation(t.style.range.endLine,t.style.range.endColumn+1);this._parentPane._addBlankSection(this,t.styleSheetId,i)}_styleSheetEdited(e){const t=this._style.parentRule;t?t.rebase(e):this._style.rebase(e),this._updateMediaList(),this._updateRuleOrigin()}_createMediaList(e){for(let t=e.length-1;t>=0;--t){const i=e[t];if(!i.text||!i.text.includes("(")&&"print"!==i.text)continue;const n=this._mediaListElement.createChild("div","media"),s=n.createChild("span"),o=s.createChild("span","media-text");switch(i.source){case SDK.CSSMedia.Source.LINKED_SHEET:case SDK.CSSMedia.Source.INLINE_SHEET:o.textContent=`media="${i.text}"`;break;case SDK.CSSMedia.Source.MEDIA_RULE:{const e=s.createChild("span");s.insertBefore(e,o),e.textContent="@media ",o.textContent=i.text,i.styleSheetId&&(n.classList.add("editable-media"),o.addEventListener("click",this._handleMediaRuleClick.bind(this,i,o),!1));break}case SDK.CSSMedia.Source.IMPORT_RULE:o.textContent=`@import ${i.text}`}}}_updateMediaList(){this._mediaListElement.removeChildren(),this._style.parentRule&&this._style.parentRule instanceof SDK.CSSRule.CSSStyleRule&&this._createMediaList(this._style.parentRule.media)}isPropertyInherited(e){return!!this._matchedStyles.isInherited(this._style)&&!SDK.CSSMetadata.cssMetadata().isPropertyInherited(e)}nextEditableSibling(){let e=this;do{e=e.nextSibling()}while(e&&!e.editable);if(!e)for(e=this.firstSibling();e&&!e.editable;)e=e.nextSibling();return e&&e.editable?e:null}previousEditableSibling(){let e=this;do{e=e.previousSibling()}while(e&&!e.editable);if(!e)for(e=this.lastSibling();e&&!e.editable;)e=e.previousSibling();return e&&e.editable?e:null}refreshUpdate(e){this._parentPane._refreshUpdate(this,e)}_updateVarFunctions(e){let t=this.propertiesTreeOutline.firstChild();for(;t;)t!==e&&t instanceof StylePropertyTreeElement&&t.updateTitleIfComputedValueChanged(),t=t.traverseNextTreeElement(!1,null,!0)}update(e){if(this._selectorElement.textContent=this._headerText(),this._markSelectorMatches(),e)this.onpopulate();else{let e=this.propertiesTreeOutline.firstChild();for(;e&&e instanceof StylePropertyTreeElement;)e.setOverloaded(this._isPropertyOverloaded(e.property)),e=e.traverseNextTreeElement(!1,null,!0)}}_showAllItems(e){e&&e.consume(),this._forceShowAll||(this._forceShowAll=!0,this.onpopulate())}onpopulate(){this._parentPane._setActiveProperty(null),this.propertiesTreeOutline.removeChildren();const e=this._style;let t=0;const i=e.leadingProperties(),n=StylePropertiesSection.MaxProperties+i.length-this._originalPropertiesCount;for(const s of i){if(!this._forceShowAll&&t>=n)break;t++;const i=Boolean(e.longhandProperties(s.name).length),o=this.isPropertyInherited(s.name),r=this._isPropertyOverloaded(s);if(e.parentRule&&e.parentRule.isUserAgent()&&o)continue;const l=new StylePropertyTreeElement(this._parentPane,this._matchedStyles,s,i,o,r,!1);this.propertiesTreeOutline.appendChild(l)}t<i.length?(this._showAllButton.classList.remove("hidden"),this._showAllButton.textContent=i18nString(UIStrings.showAllPropertiesSMore,{PH1:i.length-t})):this._showAllButton.classList.add("hidden")}_isPropertyOverloaded(e){return this._matchedStyles.propertyState(e)===SDK.CSSMatchedStyles.PropertyState.Overloaded}_updateFilter(){let e=!1;this._showAllItems();for(const n of this.propertiesTreeOutline.rootElement().children())if(n instanceof StylePropertyTreeElement){const t=n.updateFilter();e=e||t}const t=this._parentPane.filterRegex(),i=!e&&null!==t&&!t.test(this.element.deepTextContent());return this._isHidden=i,this.element.classList.toggle("hidden",i),!i&&this._style.parentRule&&this._markSelectorHighlights(),!i}isHidden(){return this._isHidden}_markSelectorMatches(){const e=this._style.parentRule;if(!e||!(e instanceof SDK.CSSRule.CSSStyleRule))return;this._mediaListElement.classList.toggle("media-matches",this._matchedStyles.mediaMatches(this._style));const t=e.selectors.map((e=>e.text)),i=this._matchedStyles.matchingSelectors(e),n=new Array(t.length).fill(!1);for(const o of i)n[o]=!0;if(this._parentPane._isEditingStyle)return;const s=this._hoverableSelectorsMode?this._renderHoverableSelectors(t,n):this._renderSimplifiedSelectors(t,n);this._selectorElement.removeChildren(),this._selectorElement.appendChild(s),this._markSelectorHighlights()}_renderHoverableSelectors(e,t){const i=document.createDocumentFragment();for(let n=0;n<e.length;++n)n&&UI.UIUtils.createTextChild(i,", "),i.appendChild(this._createSelectorElement(e[n],t[n],n));return i}_createSelectorElement(e,t,i){const n=document.createElement("span");return n.classList.add("simple-selector"),n.classList.toggle("selector-matches",t),"number"===typeof i&&this._elementToSelectorIndex.set(n,i),n.textContent=e,n}_renderSimplifiedSelectors(e,t){const i=document.createDocumentFragment();let n=!1,s="";for(let o=0;o<e.length;++o)n!==t[o]&&s&&(i.appendChild(this._createSelectorElement(s,n)),s=""),n=t[o],s+=e[o]+(o===e.length-1?"":", ");return s&&i.appendChild(this._createSelectorElement(s,n)),i}_markSelectorHighlights(){const e=this._selectorElement.getElementsByClassName("simple-selector"),t=this._parentPane.filterRegex();for(let i=0;i<e.length;++i){const n=null!==t&&t.test(e[i].textContent||"");e[i].classList.toggle("filter-match",n)}}_checkWillCancelEditing(){const e=this._willCauseCancelEditing;return this._willCauseCancelEditing=!1,e}_handleSelectorContainerClick(e){!this._checkWillCancelEditing()&&this.editable&&e.target===this._selectorContainer&&(this.addNewBlankProperty(0).startEditing(),e.consume(!0))}addNewBlankProperty(e=this.propertiesTreeOutline.rootElement().childCount()){const t=this._style.newBlankProperty(e),i=new StylePropertyTreeElement(this._parentPane,this._matchedStyles,t,!1,!1,!1,!0);return this.propertiesTreeOutline.insertChild(i,t.index),i}_handleEmptySpaceMouseDown(){this._willCauseCancelEditing=this._parentPane._isEditingStyle,this._selectedSinceMouseDown=!1}_handleEmptySpaceClick(e){if(!this.editable||this.element.hasSelection()||this._checkWillCancelEditing()||this._selectedSinceMouseDown)return;const t=e.target;if(t.classList.contains("header")||this.element.classList.contains("read-only")||t.enclosingNodeOrSelfWithClass("media"))return void e.consume();const i=UI.UIUtils.deepElementFromEvent(e),n=i&&UI.TreeOutline.TreeElement.getTreeElementBylistItemNode(i);n&&n instanceof StylePropertyTreeElement?this.addNewBlankProperty(n.property.index+1).startEditing():this.addNewBlankProperty().startEditing(),e.consume(!0)}_handleMediaRuleClick(e,t,i){if(UI.UIUtils.isBeingEdited(t))return;if(UI.KeyboardShortcut.KeyboardShortcut.eventHasCtrlOrMeta(i)&&this.navigable){const t=e.rawLocation();if(!t)return void i.consume(!0);const n=Bindings.CSSWorkspaceBinding.CSSWorkspaceBinding.instance().rawLocationToUILocation(t);return n&&Common.Revealer.reveal(n),void i.consume(!0)}if(!this.editable)return;const n=new UI.InplaceEditor.Config(this._editingMediaCommitted.bind(this,e),this._editingMediaCancelled.bind(this,t),void 0,this._editingMediaBlurHandler.bind(this));UI.InplaceEditor.InplaceEditor.startEditing(t,n);const s=t.getComponentSelection();s&&s.selectAllChildren(t),this._parentPane.setEditingStyle(!0);t.enclosingNodeOrSelfWithClass("media").classList.add("editing-media"),i.consume(!0)}_editingMediaFinished(e){this._parentPane.setEditingStyle(!1);e.enclosingNodeOrSelfWithClass("media").classList.remove("editing-media")}_editingMediaCancelled(e){this._editingMediaFinished(e),this._markSelectorMatches();const t=e.getComponentSelection();t&&t.collapse(e,0)}_editingMediaBlurHandler(){return!0}_editingMediaCommitted(e,t,i,n,s,o){this._parentPane.setEditingStyle(!1),this._editingMediaFinished(t),i&&(i=i.trim()),this._parentPane.setUserOperation(!0);const r=this._parentPane.cssModel();r&&e.styleSheetId&&r.setMediaText(e.styleSheetId,e.range,i).then(function(e){e&&(this._matchedStyles.resetActiveProperties(),this._parentPane._refreshUpdate(this)),this._parentPane.setUserOperation(!1),this._editingMediaTextCommittedForTest()}.bind(this))}_editingMediaTextCommittedForTest(){}_handleSelectorClick(e){const t=e.target;if(t){if(UI.KeyboardShortcut.KeyboardShortcut.eventHasCtrlOrMeta(e)&&this.navigable&&t.classList.contains("simple-selector")){const i=this._elementToSelectorIndex.get(t);return i&&this._navigateToSelectorSource(i,!0),void e.consume(!0)}this.element.hasSelection()||(this._startEditingAtFirstPosition(),e.consume(!0))}}_handleContextMenuEvent(e){if(!e.target)return;const t=new UI.ContextMenu.ContextMenu(e);t.clipboardSection().appendItem(i18nString(UIStrings.copySelector),(()=>{const e=this._headerText();Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(e)})),t.clipboardSection().appendItem(i18nString(UIStrings.copyRule),(()=>{const e=StylesSidebarPane.formatLeadingProperties(this).ruleText;Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(e)})),t.clipboardSection().appendItem(i18nString(UIStrings.copyAllDeclarations),(()=>{const e=StylesSidebarPane.formatLeadingProperties(this).allDeclarationText;Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(e)})),t.show()}_navigateToSelectorSource(e,t){const i=this._parentPane.cssModel();if(!i)return;const n=this._style.parentRule;if(!n)return;const s=i.styleSheetHeaderForId(n.styleSheetId);if(!s)return;const o=new SDK.CSSModel.CSSLocation(s,n.lineNumberInSource(e),n.columnNumberInSource(e));StylePropertiesSection._revealSelectorSource(o,t)}static _revealSelectorSource(e,t){const i=Bindings.CSSWorkspaceBinding.CSSWorkspaceBinding.instance().rawLocationToUILocation(e);i&&Common.Revealer.reveal(i,!t)}_startEditingAtFirstPosition(){this.editable&&(this._style.parentRule?this.startEditingSelector():this.moveEditorFromSelector("forward"))}startEditingSelector(){const e=this._selectorElement;if(UI.UIUtils.isBeingEdited(e))return;e.scrollIntoViewIfNeeded(!1);const t=e.textContent;null!==t&&(e.textContent=t.replace(/\s+/g," ").trim());const i=new UI.InplaceEditor.Config(this.editingSelectorCommitted.bind(this),this.editingSelectorCancelled.bind(this));UI.InplaceEditor.InplaceEditor.startEditing(this._selectorElement,i);const n=e.getComponentSelection();n&&n.selectAllChildren(e),this._parentPane.setEditingStyle(!0),e.classList.contains("simple-selector")&&this._navigateToSelectorSource(0,!1)}moveEditorFromSelector(e){if(this._markSelectorMatches(),e)if("forward"===e){let e=this.propertiesTreeOutline.firstChild();for(;e&&e.inherited();){const t=e.nextSibling;e=t instanceof StylePropertyTreeElement?t:null}e?e.startEditing(e.nameElement):this.addNewBlankProperty().startEditing()}else{const e=this.previousEditableSibling();if(!e)return;e.addNewBlankProperty().startEditing()}}editingSelectorCommitted(e,t,i,n,s){if(this._editingSelectorEnded(),t&&(t=t.trim()),t===i)return this._selectorElement.textContent=t,void this.moveEditorFromSelector(s);const o=this._style.parentRule;o&&(this._parentPane.setUserOperation(!0),this._setHeaderText(o,t).then(function(){this._parentPane.setUserOperation(!1),this.moveEditorFromSelector(s),this._editingSelectorCommittedForTest()}.bind(this)))}_setHeaderText(e,t){function i(e){const t=this._matchedStyles.matchingSelectors(e).length>0;this.propertiesTreeOutline.element.classList.toggle("no-affect",!t),this._matchedStyles.resetActiveProperties(),this._parentPane._refreshUpdate(this)}if(!(e instanceof SDK.CSSRule.CSSStyleRule))return Promise.resolve();const n=e.selectorRange();return n?e.setSelectorText(t).then(function(e,t){return t?this._matchedStyles.recomputeMatchingSelectors(e).then(i.bind(this,e)):Promise.resolve()}.bind(this,e,Boolean(n))):Promise.resolve()}_editingSelectorCommittedForTest(){}_updateRuleOrigin(){this._selectorRefElement.removeChildren(),this._selectorRefElement.appendChild(StylePropertiesSection.createRuleOriginNode(this._matchedStyles,this._parentPane._linkifier,this._style.parentRule))}_editingSelectorEnded(){this._parentPane.setEditingStyle(!1)}editingSelectorCancelled(){this._editingSelectorEnded(),this._markSelectorMatches()}closestPropertyForEditing(e){const t=this.propertiesTreeOutline.rootElement();return e>=t.childCount()?t.lastChild():t.childAt(e)}}StylePropertiesSection.MaxProperties=50;export class BlankStylePropertiesSection extends StylePropertiesSection{constructor(e,t,i,n,s,o){const r=e.cssModel();super(e,t,SDK.CSSRule.CSSStyleRule.createDummyRule(r,i).style),this._normal=!1,this._ruleLocation=s,this._styleSheetId=n,this._selectorRefElement.removeChildren(),this._selectorRefElement.appendChild(StylePropertiesSection._linkifyRuleLocation(r,this._parentPane._linkifier,n,this._actualRuleLocation())),o&&o.parentRule&&o.parentRule instanceof SDK.CSSRule.CSSStyleRule&&this._createMediaList(o.parentRule.media),this.element.classList.add("blank-section")}_actualRuleLocation(){const e=this._rulePrefix().split("\n"),t=e[e.length-1],i=new TextUtils.TextRange.TextRange(0,0,e.length-1,t?t.length:0);return this._ruleLocation.rebaseAfterTextEdit(TextUtils.TextRange.TextRange.createFromLocation(0,0),i)}_rulePrefix(){return 0===this._ruleLocation.startLine&&0===this._ruleLocation.startColumn?"":"\n\n"}get isBlank(){return!this._normal}editingSelectorCommitted(e,t,i,n,s){if(!this.isBlank)return void super.editingSelectorCommitted(e,t,i,n,s);function o(e){const t=this._matchedStyles.matchingSelectors(e).length>0;this._makeNormal(e),t||this.propertiesTreeOutline.element.classList.add("no-affect"),this._updateRuleOrigin(),this._parentPane.setUserOperation(!1),this._editingSelectorEnded(),this.element.parentElement&&this.moveEditorFromSelector(s),this._markSelectorMatches(),this._editingSelectorCommittedForTest()}t&&(t=t.trim()),this._parentPane.setUserOperation(!0);const r=this._parentPane.cssModel(),l=this._rulePrefix()+t+" {}";r&&r.addRule(this._styleSheetId,l,this._ruleLocation).then(function(e){return e?this._matchedStyles.addNewRule(e,this._matchedStyles.node()).then(o.bind(this,e)):(this.editingSelectorCancelled(),this._editingSelectorCommittedForTest(),Promise.resolve())}.bind(this))}editingSelectorCancelled(){this._parentPane.setUserOperation(!1),this.isBlank?(this._editingSelectorEnded(),this._parentPane.removeSection(this)):super.editingSelectorCancelled()}_makeNormal(e){this.element.classList.remove("blank-section"),this._style=e.style,this._normal=!0}}export class KeyframePropertiesSection extends StylePropertiesSection{constructor(e,t,i){super(e,t,i),this._selectorElement.className="keyframe-key"}_headerText(){return this._style.parentRule instanceof SDK.CSSRule.CSSKeyframeRule?this._style.parentRule.key().text:""}_setHeaderText(e,t){if(!(e instanceof SDK.CSSRule.CSSKeyframeRule))return Promise.resolve();return e.key().range?e.setKeyText(t).then(function(e){e&&this._parentPane._refreshUpdate(this)}.bind(this)):Promise.resolve()}isPropertyInherited(e){return!1}_isPropertyOverloaded(e){return!1}_markSelectorHighlights(){}_markSelectorMatches(){this._style.parentRule instanceof SDK.CSSRule.CSSKeyframeRule&&(this._selectorElement.textContent=this._style.parentRule.key().text)}_highlight(){}}export function quoteFamilyName(e){return`'${e.replaceAll("'","\\'")}'`}export class CSSPropertyPrompt extends UI.TextPrompt.TextPrompt{constructor(e,t){super(),this.initialize(this._buildPropertyCompletions.bind(this),UI.UIUtils.StyleValueDelimiters);const i=SDK.CSSMetadata.cssMetadata();this._isColorAware=SDK.CSSMetadata.cssMetadata().isColorAwareProperty(e.property.name),this._cssCompletions=[];const n=e.node();if(t)this._cssCompletions=i.allProperties(),n&&!n.isSVGNode()&&(this._cssCompletions=this._cssCompletions.filter((e=>!i.isSVGProperty(e))));else if(this._cssCompletions=i.propertyValues(e.property.name),n&&i.isFontFamilyProperty(e.property.name)){const e=n.domModel().cssModel().fontFaces().map((e=>quoteFamilyName(e.getFontFamily())));this._cssCompletions.unshift(...e)}if(this._selectedNodeComputedStyles=null,this._parentNodeComputedStyles=null,this._treeElement=e,this._isEditingName=t,this._cssVariables=e.matchedStyles().availableCSSVariables(e.property.ownerStyle),this._cssVariables.length<1e3?this._cssVariables.sort(Platform.StringUtilities.naturalOrderComparator):this._cssVariables.sort(),!t&&(this.disableDefaultSuggestionForEmptyInput(),e&&e.valueElement)){const t=e.valueElement.textContent,i=Host.Platform.isMac()?"Cmd":"Ctrl";null!==t&&(t.match(/#[\da-f]{3,6}$/i)?this.setTitle(i18nString(UIStrings.incrementdecrementWithMousewheelOne,{PH1:i})):t.match(/\d+/)&&this.setTitle(i18nString(UIStrings.incrementdecrementWithMousewheelHundred,{PH1:i})))}}onKeyDown(e){const t=e;switch(t.key){case"ArrowUp":case"ArrowDown":case"PageUp":case"PageDown":if(!this.isSuggestBoxVisible()&&this._handleNameOrValueUpDown(t))return void t.preventDefault();break;case"Enter":if(t.shiftKey)return;return this.tabKeyPressed(),void t.preventDefault()}super.onKeyDown(t)}onMouseWheel(e){this._handleNameOrValueUpDown(e)?e.consume(!0):super.onMouseWheel(e)}tabKeyPressed(){return this.acceptAutoComplete(),!1}_handleNameOrValueUpDown(e){return!(this._isEditingName||!this._treeElement.valueElement||!UI.UIUtils.handleElementValueModifications(e,this._treeElement.valueElement,function(e,t){this._treeElement.nameElement&&this._treeElement.valueElement&&this._treeElement.applyStyleText(this._treeElement.nameElement.textContent+": "+this._treeElement.valueElement.textContent,!1)}.bind(this),this._isValueSuggestion.bind(this),function(e,t,i){return 0===t||i.length||!SDK.CSSMetadata.cssMetadata().isLengthProperty(this._treeElement.property.name)||this._treeElement.property.value.toLowerCase().startsWith("calc(")||(i="px"),e+t+i}.bind(this)))}_isValueSuggestion(e){return!!e&&(e=e.toLowerCase(),-1!==this._cssCompletions.indexOf(e)||e.startsWith("--"))}async _buildPropertyCompletions(e,t,i){const n=t.toLowerCase(),s=!this._isEditingName&&e.trim().endsWith("var(");if(!t&&!i&&!s&&(this._isEditingName||e))return Promise.resolve([]);const o=[],r=[];s||this._cssCompletions.forEach((e=>c.call(this,e,!1)));const l=this._treeElement.node();if(this._isEditingName&&l){SDK.CSSMetadata.cssMetadata().nameValuePresets(l.isSVGNode()).forEach((e=>c.call(this,e,!1,!0)))}(this._isEditingName||s)&&this._cssVariables.forEach((e=>c.call(this,e,!0)));const a=o.concat(r);!this._isEditingName&&!a.length&&t.length>1&&"!important".startsWith(n)&&a.push({text:"!important",title:void 0,subtitle:void 0,iconType:void 0,priority:void 0,isSecondary:void 0,subtitleRenderer:void 0,selectionRange:void 0,hideGhostText:void 0,iconElement:void 0});const d=t.replace("-","");if(d&&d===d.toUpperCase())for(let p=0;p<a.length;++p)a[p].text.startsWith("--")||(a[p].text=a[p].text.toUpperCase());for(const p of a){if(s){p.title=p.text,p.text+=")";continue}const e=SDK.CSSMetadata.cssMetadata().getValuePreset(this._treeElement.name,p.text);!this._isEditingName&&e&&(p.title=p.text,p.text=e.text,p.selectionRange={startColumn:e.startColumn,endColumn:e.endColumn})}if(Root.Runtime.experiments.isEnabled("cssFlexboxFeatures")){const e=this._treeElement.node(),t=async()=>{if(!e||this._selectedNodeComputedStyles)return;this._selectedNodeComputedStyles=await e.domModel().cssModel().computedStylePromise(e.id);const t=e.parentNode;t&&(this._parentNodeComputedStyles=await t.domModel().cssModel().computedStylePromise(e.id))};for(const i of a){await t();const e=findIcon(this._isEditingName?i.text:`${this._treeElement.property.name}: ${i.text}`,this._selectedNodeComputedStyles,this._parentNodeComputedStyles);if(!e)continue;const n=new WebComponents.Icon.Icon,s="12.5px",o="12.5px";n.data={iconName:e.iconName,width:s,height:o,color:"black"},n.style.transform=`rotate(${e.rotate}deg) scale(${1.1*e.scaleX}, ${1.1*e.scaleY})`,n.style.maxHeight=o,n.style.maxWidth=s,i.iconElement=n}}return this._isColorAware&&!this._isEditingName&&a.sort(((e,t)=>Boolean(e.subtitleRenderer)===Boolean(t.subtitleRenderer)?0:e.subtitleRenderer?-1:1)),Promise.resolve(a);function c(e,t,i){const s=e.toLowerCase().indexOf(n),l={text:e,title:void 0,subtitle:void 0,iconType:void 0,priority:void 0,isSecondary:void 0,subtitleRenderer:void 0,selectionRange:void 0,hideGhostText:void 0,iconElement:void 0};if(t){const t=this._treeElement.matchedStyles().computeCSSVariable(this._treeElement.property.ownerStyle,e);if(t){const e=Common.Color.Color.parse(t);e&&(l.subtitleRenderer=h.bind(null,e))}}i&&(l.hideGhostText=!0),0===s?(l.priority=this._isEditingName?SDK.CSSMetadata.cssMetadata().propertyUsageWeight(e):1,o.push(l)):s>-1&&r.push(l)}function h(e){const t=new InlineEditor.ColorSwatch.ColorSwatch;return t.renderColor(e),t.style.pointerEvents="none",t}}}export function unescapeCssString(e){return e.replace(/(?<!\\)\\(?:([a-fA-F0-9]{1,6})|(.))[\n\t\x20]?/gs,((e,t,i)=>{if(i)return i;const n=parseInt(t,16);return 55296<=n&&n<=57343||0===n||n>1114111?"\ufffd":String.fromCodePoint(n)}))}export class StylesSidebarPropertyRenderer{constructor(e,t,i,n){this._rule=e,this._node=t,this._propertyName=i,this._propertyValue=n,this._colorHandler=null,this._bezierHandler=null,this._fontHandler=null,this._shadowHandler=null,this._gridHandler=null,this._varHandler=document.createTextNode.bind(document),this._angleHandler=null}setColorHandler(e){this._colorHandler=e}setBezierHandler(e){this._bezierHandler=e}setFontHandler(e){this._fontHandler=e}setShadowHandler(e){this._shadowHandler=e}setGridHandler(e){this._gridHandler=e}setVarHandler(e){this._varHandler=e}setAngleHandler(e){this._angleHandler=e}renderName(){const e=document.createElement("span");return e.className="webkit-css-property",e.textContent=this._propertyName,e.normalize(),e}renderValue(){const e=document.createElement("span");if(e.className="value",!this._propertyValue)return e;const t=SDK.CSSMetadata.cssMetadata();if(this._shadowHandler&&t.isShadowProperty(this._propertyName)&&!SDK.CSSMetadata.VariableRegex.test(this._propertyValue))return e.appendChild(this._shadowHandler(this._propertyValue,this._propertyName)),e.normalize(),e;if(this._gridHandler&&t.isGridAreaDefiningProperty(this._propertyName))return e.appendChild(this._gridHandler(this._propertyValue,this._propertyName)),e.normalize(),e;t.isStringProperty(this._propertyName)&&UI.Tooltip.Tooltip.install(e,unescapeCssString(this._propertyValue));const i=[SDK.CSSMetadata.VariableRegex,SDK.CSSMetadata.URLRegex],n=[this._varHandler,this._processURL.bind(this)];this._bezierHandler&&t.isBezierAwareProperty(this._propertyName)&&(i.push(UI.Geometry.CubicBezier.Regex),n.push(this._bezierHandler)),this._colorHandler&&t.isColorAwareProperty(this._propertyName)&&(i.push(Common.Color.Regex),n.push(this._colorHandler)),this._angleHandler&&t.isAngleAwareProperty(this._propertyName)&&(i.push(InlineEditor.CSSAngleUtils.CSSAngleRegex),n.push(this._angleHandler)),this._fontHandler&&t.isFontAwareProperty(this._propertyName)&&("font-family"===this._propertyName?i.push(InlineEditor.FontEditorUtils.FontFamilyRegex):i.push(InlineEditor.FontEditorUtils.FontPropertiesRegex),n.push(this._fontHandler));const s=TextUtils.TextUtils.Utils.splitStringByRegexes(this._propertyValue,i);for(let o=0;o<s.length;o++){const t=s[o],i=-1===t.regexIndex?document.createTextNode.bind(document):n[t.regexIndex];i&&e.appendChild(i(t.value))}return e.normalize(),e}_processURL(e){let t=e.substring(4,e.length-1).trim();(/^'.*'$/s.test(t)||/^".*"$/s.test(t))&&(t=t.substring(1,t.length-1));const i=document.createDocumentFragment();UI.UIUtils.createTextChild(i,"url(");let n=null;this._rule&&this._rule.resourceURL()?n=Common.ParsedURL.ParsedURL.completeURL(this._rule.resourceURL(),t):this._node&&(n=this._node.resolveURL(t));const s=ImagePreviewPopover.setImageUrl(Components.Linkifier.Linkifier.linkifyURL(n||t,{text:t,preventClick:!0,bypassURLTrimming:!0,className:void 0,lineNumber:void 0,columnNumber:void 0,maxLength:void 0,tabStop:void 0}),n||t);return i.appendChild(s),UI.UIUtils.createTextChild(i,")"),i}}export class ButtonProvider{constructor(){this._button=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.newStyleRule),"largeicon-add"),this._button.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this._clicked,this);const e=UI.Icon.Icon.create("largeicon-longclick-triangle","long-click-glyph");function t(){let e=UI.Context.Context.instance().flavor(SDK.DOMModel.DOMNode);e=e?e.enclosingElementOrSelf():null,this._button.setEnabled(Boolean(e))}this._button.element.appendChild(e),new UI.UIUtils.LongClickController(this._button.element,this._longClicked.bind(this)),UI.Context.Context.instance().addFlavorChangeListener(SDK.DOMModel.DOMNode,t.bind(this)),t.call(this)}static instance(e={forceNew:null}){const{forceNew:t}=e;return buttonProviderInstance&&!t||(buttonProviderInstance=new ButtonProvider),buttonProviderInstance}_clicked(e){StylesSidebarPane.instance()._createNewRuleInViaInspectorStyleSheet()}_longClicked(e){StylesSidebarPane.instance()._onAddButtonLongClick(e)}item(){return this._button}}