import*as Bindings from"../bindings/bindings.js";import*as Common from"../common/common.js";import*as SDK from"../sdk/sdk.js";import*as TextUtils from"../text_utils/text_utils.js";import*as Workspace from"../workspace/workspace.js";import{FormatterInterface}from"./ScriptFormatter.js";const objectToFormattingResult=new WeakMap;export class SourceFormatData{constructor(e,o,t){this.originalSourceCode=e,this.formattedSourceCode=o,this.mapping=t}originalPath(){return this.originalSourceCode.project().id()+":"+this.originalSourceCode.url()}static _for(e){return objectToFormattingResult.get(e)||null}}let sourceFormatterInstance=null;export class SourceFormatter{constructor(){this._projectId="formatter:",this._project=new Bindings.ContentProviderBasedProject.ContentProviderBasedProject(Workspace.Workspace.WorkspaceImpl.instance(),this._projectId,Workspace.Workspace.projectTypes.Formatter,"formatter",!0),this._formattedSourceCodes=new Map,this._scriptMapping=new ScriptMapping,this._styleMapping=new StyleMapping,Workspace.Workspace.WorkspaceImpl.instance().addEventListener(Workspace.Workspace.Events.UISourceCodeRemoved,(e=>{this._onUISourceCodeRemoved(e)}),this)}static instance(){return sourceFormatterInstance||(sourceFormatterInstance=new SourceFormatter),sourceFormatterInstance}async _onUISourceCodeRemoved(e){const o=e.data,t=this._formattedSourceCodes.get(o);t&&t.formatData&&await this._discardFormatData(t.formatData),this._formattedSourceCodes.delete(o)}async discardFormattedUISourceCode(e){const o=SourceFormatData._for(e);return o?(await this._discardFormatData(o),this._formattedSourceCodes.delete(o.originalSourceCode),o.originalSourceCode):null}async _discardFormatData(e){objectToFormattingResult.delete(e.formattedSourceCode),await this._scriptMapping._setSourceMappingEnabled(e,!1),this._styleMapping._setSourceMappingEnabled(e,!1),this._project.removeFile(e.formattedSourceCode.url())}hasFormatted(e){return this._formattedSourceCodes.has(e)}getOriginalUISourceCode(e){const o=objectToFormattingResult.get(e);return o?o.originalSourceCode:e}async format(e){const o=this._formattedSourceCodes.get(e);if(o)return o.promise;const t=new Promise((async o=>{const{content:r}=await e.requestContent();FormatterInterface.format(e.contentType(),e.mimeType(),r||"",(async(r,n)=>{const a=this._formattedSourceCodes.get(e);if(!a||a.promise!==t)return;let i,s=0,c="";do{i=`${e.url()}:formatted${c}`,c=":"+s++}while(this._project.uiSourceCodeForURL(i));const u=TextUtils.StaticContentProvider.StaticContentProvider.fromString(i,e.contentType(),r),d=this._project.createUISourceCode(i,u.contentType()),p=new SourceFormatData(e,d,n);objectToFormattingResult.set(d,p),this._project.addUISourceCodeWithProvider(d,u,null,e.mimeType()),await this._scriptMapping._setSourceMappingEnabled(p,!0),await this._styleMapping._setSourceMappingEnabled(p,!0),a.formatData=p;for(const o of e.allDecorations()){const e=o.range(),t=n.originalToFormatted(e.startLine,e.startColumn),r=n.originalToFormatted(e.endLine,e.endColumn);d.addDecoration(new TextUtils.TextRange.TextRange(t[0],t[1],r[0],r[1]),o.type(),o.data())}o(p)}))}));return this._formattedSourceCodes.set(e,{promise:t,formatData:null}),t}}class ScriptMapping{constructor(){Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().addSourceMapping(this)}rawLocationToUILocation(e){const o=e.script(),t=o&&SourceFormatData._for(o);if(!t||!o)return null;if(o.isInlineScriptWithSourceURL()){const[r,n]=o.toRelativeLocation(e),[a,i]=t.mapping.originalToFormatted(r,n);return t.formattedSourceCode.uiLocation(a,i)}const[r,n]=t.mapping.originalToFormatted(e.lineNumber,e.columnNumber||0);return t.formattedSourceCode.uiLocation(r,n)}uiLocationToRawLocations(e,o,t){const r=SourceFormatData._for(e);if(!r)return[];const[n,a]=r.mapping.formattedToOriginal(o,t);if(r.originalSourceCode.contentType().isScript()){const e=Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().uiLocationToRawLocationsForUnformattedJavaScript(r.originalSourceCode,n,a);return console.assert(e.every((e=>e&&Boolean(e.script())))),e}if(r.originalSourceCode.contentType()===Common.ResourceType.resourceTypes.Document){const e=Bindings.NetworkProject.NetworkProject.targetForUISourceCode(r.originalSourceCode),o=e&&e.model(SDK.DebuggerModel.DebuggerModel);if(o){const e=o.scriptsForSourceURL(r.originalSourceCode.url()).filter((e=>e.isInlineScript()&&!e.hasSourceURL)).map((e=>e.rawLocation(n,a))).filter((e=>Boolean(e)));return console.assert(e.every((e=>e&&Boolean(e.script())))),e}}return[]}async _setSourceMappingEnabled(e,o){const t=this._scriptsForUISourceCode(e.originalSourceCode);if(!t.length)return;if(o)for(const n of t)objectToFormattingResult.set(n,e);else for(const n of t)objectToFormattingResult.delete(n);const r=t.map((e=>Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().updateLocations(e)));await Promise.all(r)}_scriptsForUISourceCode(e){if(e.contentType()===Common.ResourceType.resourceTypes.Document){const o=Bindings.NetworkProject.NetworkProject.targetForUISourceCode(e),t=o&&o.model(SDK.DebuggerModel.DebuggerModel);if(t){return t.scriptsForSourceURL(e.url()).filter((e=>e.isInlineScript()&&!e.hasSourceURL))}}if(e.contentType().isScript()){console.assert(!objectToFormattingResult.has(e));return Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().uiLocationToRawLocationsForUnformattedJavaScript(e,0,0).map((e=>e.script())).filter((e=>Boolean(e)))}return[]}}const sourceCodeToHeaders=new WeakMap;class StyleMapping{constructor(){Bindings.CSSWorkspaceBinding.CSSWorkspaceBinding.instance().addSourceMapping(this),this._headersSymbol=Symbol("Formatter.SourceFormatter.StyleMapping._headersSymbol")}rawLocationToUILocation(e){const o=e.header(),t=o&&SourceFormatData._for(o);if(!t)return null;const r=t.mapping.originalToFormatted(e.lineNumber,e.columnNumber||0);return t.formattedSourceCode.uiLocation(r[0],r[1])}uiLocationToRawLocations(e){const o=SourceFormatData._for(e.uiSourceCode);if(!o)return[];const[t,r]=o.mapping.formattedToOriginal(e.lineNumber,e.columnNumber),n=sourceCodeToHeaders.get(o.originalSourceCode);if(!n)return[];return n.filter((e=>e.containsLocation(t,r))).map((e=>new SDK.CSSModel.CSSLocation(e,t,r)))}async _setSourceMappingEnabled(e,o){const t=e.originalSourceCode,r=this._headersForUISourceCode(t);o?(sourceCodeToHeaders.set(t,r),r.forEach((o=>{objectToFormattingResult.set(o,e)}))):(sourceCodeToHeaders.delete(t),r.forEach((e=>{objectToFormattingResult.delete(e)})));const n=r.map((e=>Bindings.CSSWorkspaceBinding.CSSWorkspaceBinding.instance().updateLocations(e)));await Promise.all(n)}_headersForUISourceCode(e){if(e.contentType()===Common.ResourceType.resourceTypes.Document){const o=Bindings.NetworkProject.NetworkProject.targetForUISourceCode(e),t=o&&o.model(SDK.CSSModel.CSSModel);if(t)return t.headersForSourceURL(e.url()).filter((e=>e.isInline&&!e.hasSourceURL))}else if(e.contentType().isStyleSheet()){return Bindings.CSSWorkspaceBinding.CSSWorkspaceBinding.instance().uiLocationToRawLocations(e.uiLocation(0,0)).map((e=>e.header())).filter((e=>Boolean(e)))}return[]}}