import*as Common from"../common/common.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as SDK from"../sdk/sdk.js";import*as UI from"../ui/ui.js";import{MobileThrottlingSelector}from"./MobileThrottlingSelector.js";import{NetworkThrottlingSelector}from"./NetworkThrottlingSelector.js";import{CPUThrottlingRates,ThrottlingPresets}from"./ThrottlingPresets.js";const UIStrings={sS:"{PH1}: {PH2}",add:"Add\u2026",addS:"Add {PH1}",offline:"Offline",forceDisconnectedFromNetwork:"Force disconnected from network",throttling:"Throttling",cpuThrottlingIsEnabled:"CPU throttling is enabled",cpuThrottling:"CPU throttling",noThrottling:"No throttling",dSlowdown:"{PH1}\xd7 slowdown"},str_=i18n.i18n.registerUIStrings("mobile_throttling/ThrottlingManager.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);let throttlingManagerInstance,actionDelegateInstance;export class ThrottlingManager extends Common.ObjectWrapper.ObjectWrapper{constructor(){super(),this._cpuThrottlingRate=CPUThrottlingRates.NoThrottling,this._cpuThrottlingControls=new Set,this._cpuThrottlingRates=ThrottlingPresets.cpuThrottlingPresets,this._customNetworkConditionsSetting=Common.Settings.Settings.instance().moduleSetting("customNetworkConditions"),this._currentNetworkThrottlingConditions=SDK.NetworkManager.NoThrottlingConditions,SDK.NetworkManager.MultitargetNetworkManager.instance().addEventListener(SDK.NetworkManager.MultitargetNetworkManager.Events.ConditionsChanged,(()=>{this._lastNetworkThrottlingConditions=this._currentNetworkThrottlingConditions,this._currentNetworkThrottlingConditions=SDK.NetworkManager.MultitargetNetworkManager.instance().networkConditions()})),SDK.SDKModel.TargetManager.instance().observeModels(SDK.EmulationModel.EmulationModel,this)}static instance(t={forceNew:null}){const{forceNew:e}=t;return throttlingManagerInstance&&!e||(throttlingManagerInstance=new ThrottlingManager),throttlingManagerInstance}decorateSelectWithNetworkThrottling(t){let e=[];const n=new NetworkThrottlingSelector((function(n){t.removeChildren(),e=[];for(let o=0;o<n.length;++o){const i=n[o],r=t.createChild("optgroup");r.label=i.title;for(const t of i.items){const n="function"===typeof t.title?t.title():t.title,o=new Option(n,n);UI.ARIAUtils.setAccessibleName(o,i18nString(UIStrings.sS,{PH1:i.title,PH2:n})),r.appendChild(o),e.push(t)}if(o===n.length-1){const t=new Option(i18nString(UIStrings.add),i18nString(UIStrings.add));UI.ARIAUtils.setAccessibleName(t,i18nString(UIStrings.addS,{PH1:i.title})),r.appendChild(t),e.push(null)}}return e}),(function(e){t.selectedIndex!==e&&(t.selectedIndex=e)}),this._customNetworkConditionsSetting);return t.addEventListener("change",(function(){if(t.selectedIndex===t.options.length-1)n.revealAndUpdate();else{const o=e[t.selectedIndex];o&&n.optionSelected(o)}}),!1),n}createOfflineToolbarCheckbox(){const t=new UI.Toolbar.ToolbarCheckbox(i18nString(UIStrings.offline),i18nString(UIStrings.forceDisconnectedFromNetwork),function(){t.checked()?SDK.NetworkManager.MultitargetNetworkManager.instance().setNetworkConditions(SDK.NetworkManager.OfflineConditions):SDK.NetworkManager.MultitargetNetworkManager.instance().setNetworkConditions(this._lastNetworkThrottlingConditions)}.bind(this));return SDK.NetworkManager.MultitargetNetworkManager.instance().addEventListener(SDK.NetworkManager.MultitargetNetworkManager.Events.ConditionsChanged,(function(){t.setChecked(SDK.NetworkManager.MultitargetNetworkManager.instance().networkConditions()===SDK.NetworkManager.OfflineConditions)})),t.setChecked(SDK.NetworkManager.MultitargetNetworkManager.instance().networkConditions()===SDK.NetworkManager.OfflineConditions),t}createMobileThrottlingButton(){const t=new UI.Toolbar.ToolbarMenuButton((function(t){for(let i=0;i<e.length;++i){const r=e[i];r&&(r.title===ThrottlingPresets.getCustomConditions().title&&r.description===ThrottlingPresets.getCustomConditions().description||t.defaultSection().appendCheckboxItem(i18nString(r.title),o.optionSelected.bind(o,r),n===i))}}));t.setTitle(i18nString(UIStrings.throttling)),t.setGlyph(""),t.turnIntoSelect(),t.setDarkText();let e=[],n=-1;const o=new MobileThrottlingSelector((function(t){e=[];for(const n of t){for(const t of n.items)e.push(t);e.push(null)}return e}),(function(o){n=o;const i=e[o];i&&(t.setText(i.title),t.setTitle(i.description))}));return t}cpuThrottlingRate(){return this._cpuThrottlingRate}setCPUThrottlingRate(t){this._cpuThrottlingRate=t;for(const o of SDK.SDKModel.TargetManager.instance().models(SDK.EmulationModel.EmulationModel))o.setCPUThrottlingRate(this._cpuThrottlingRate);let e=null;this._cpuThrottlingRate!==CPUThrottlingRates.NoThrottling&&(Host.userMetrics.actionTaken(Host.UserMetrics.Action.CpuThrottlingEnabled),e=UI.Icon.Icon.create("smallicon-warning"),UI.Tooltip.Tooltip.install(e,i18nString(UIStrings.cpuThrottlingIsEnabled)));const n=this._cpuThrottlingRates.indexOf(this._cpuThrottlingRate);for(const o of this._cpuThrottlingControls)o.setSelectedIndex(n);UI.InspectorView.InspectorView.instance().setPanelIcon("timeline",e),this.dispatchEventToListeners(Events.RateChanged,this._cpuThrottlingRate)}modelAdded(t){this._cpuThrottlingRate!==CPUThrottlingRates.NoThrottling&&t.setCPUThrottlingRate(this._cpuThrottlingRate)}modelRemoved(t){}createCPUThrottlingSelector(){const t=new UI.Toolbar.ToolbarComboBox((t=>this.setCPUThrottlingRate(this._cpuThrottlingRates[t.target.selectedIndex])),i18nString(UIStrings.cpuThrottling));this._cpuThrottlingControls.add(t);const e=this._cpuThrottlingRate;for(let n=0;n<this._cpuThrottlingRates.length;++n){const o=this._cpuThrottlingRates[n],i=1===o?i18nString(UIStrings.noThrottling):i18nString(UIStrings.dSlowdown,{PH1:o}),r=t.createOption(i);t.addOption(r),e===o&&t.setSelectedIndex(n)}return t}}export var Events;!function(t){t.RateChanged="RateChanged"}(Events||(Events={}));export class ActionDelegate{static instance(t={forceNew:null}){const{forceNew:e}=t;return actionDelegateInstance&&!e||(actionDelegateInstance=new ActionDelegate),actionDelegateInstance}handleAction(t,e){return"network-conditions.network-online"===e?(SDK.NetworkManager.MultitargetNetworkManager.instance().setNetworkConditions(SDK.NetworkManager.NoThrottlingConditions),!0):"network-conditions.network-low-end-mobile"===e?(SDK.NetworkManager.MultitargetNetworkManager.instance().setNetworkConditions(SDK.NetworkManager.Slow3GConditions),!0):"network-conditions.network-mid-tier-mobile"===e?(SDK.NetworkManager.MultitargetNetworkManager.instance().setNetworkConditions(SDK.NetworkManager.Fast3GConditions),!0):"network-conditions.network-offline"===e&&(SDK.NetworkManager.MultitargetNetworkManager.instance().setNetworkConditions(SDK.NetworkManager.OfflineConditions),!0)}}export function throttlingManager(){return ThrottlingManager.instance()}