import*as Bindings from"../bindings/bindings.js";import*as BrowserSDK from"../browser_sdk/browser_sdk.js";import*as Common from"../common/common.js";import*as Components from"../components/components.js";import*as DataGrid from"../data_grid/data_grid.js";import*as HARImporter from"../har_importer/har_importer.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as PerfUI from"../perf_ui/perf_ui.js";import*as Platform from"../platform/platform.js";import*as SDK from"../sdk/sdk.js";import*as TextUtils from"../text_utils/text_utils.js";import*as ThemeSupport from"../theme_support/theme_support.js";import*as UI from"../ui/ui.js";import{HARWriter}from"./HARWriter.js";import{Events,NetworkGroupNode,NetworkRequestNode}from"./NetworkDataGridNode.js";import{NetworkFrameGrouper}from"./NetworkFrameGrouper.js";import{NetworkLogViewColumns}from"./NetworkLogViewColumns.js";import{NetworkTimeBoundary,NetworkTransferDurationCalculator,NetworkTransferTimeCalculator}from"./NetworkTimeCalculator.js";const UIStrings={hideDataUrls:"Hide data URLs",hidesDataAndBlobUrls:"Hides data: and blob: URLs",resourceTypesToInclude:"Resource types to include",hasBlockedCookies:"Has blocked cookies",onlyShowRequestsWithBlocked:"Only show requests with blocked response cookies",blockedRequests:"Blocked Requests",onlyShowBlockedRequests:"Only show blocked requests",dropHarFilesHere:"Drop HAR files here",recordingNetworkActivity:"Recording network activity\u2026",performARequestOrHitSToRecordThe:"Perform a request or hit {PH1} to record the reload.",recordSToDisplayNetworkActivity:"Record ({PH1}) to display network activity.",learnMore:"Learn more",networkDataAvailable:"Network Data Available",sSRequests:"{PH1} / {PH2} requests",sSTransferred:"{PH1} / {PH2} transferred",sBSBTransferredOverNetwork:"{PH1} B / {PH2} B transferred over network",sSResources:"{PH1} / {PH2} resources",sBSBResourcesLoadedByThePage:"{PH1} B / {PH2} B resources loaded by the page",sRequests:"{PH1} requests",sTransferred:"{PH1} transferred",sBTransferredOverNetwork:"{PH1} B transferred over network",sResources:"{PH1} resources",sBResourcesLoadedByThePage:"{PH1} B resources loaded by the page",finishS:"Finish: {PH1}",domcontentloadedS:"DOMContentLoaded: {PH1}",loadS:"Load: {PH1}",copy:"Copy",copyRequestHeaders:"Copy request headers",copyResponseHeaders:"Copy response headers",copyResponse:"Copy response",copyStacktrace:"Copy stack trace",copyAsPowershell:"Copy as `PowerShell`",copyAsFetch:"Copy as `fetch`",copyAsNodejsFetch:"Copy as `Node.js` `fetch`",copyAsCurlCmd:"Copy as `cURL` (`cmd`)",copyAsCurlBash:"Copy as `cURL` (`bash`)",copyAllAsPowershell:"Copy all as `PowerShell`",copyAllAsFetch:"Copy all as `fetch`",copyAllAsNodejsFetch:"Copy all as `Node.js` `fetch`",copyAllAsCurlCmd:"Copy all as `cURL` (`cmd`)",copyAllAsCurlBash:"Copy all as `cURL` (`bash`)",copyAsCurl:"Copy as `cURL`",copyAllAsCurl:"Copy all as `cURL`",copyAllAsHar:"Copy all as `HAR`",saveAllAsHarWithContent:"Save all as `HAR` with content",clearBrowserCache:"Clear browser cache",clearBrowserCookies:"Clear browser cookies",blockRequestUrl:"Block request URL",unblockS:"Unblock {PH1}",blockRequestDomain:"Block request domain",replayXhr:"Replay XHR",areYouSureYouWantToClearBrowser:"Are you sure you want to clear browser cache?",areYouSureYouWantToClearBrowserCookies:"Are you sure you want to clear browser cookies?"},str_=i18n.i18n.registerUIStrings("network/NetworkLogView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class NetworkLogView extends UI.Widget.VBox{constructor(e,t,r){function i(){this._rawRowHeight=Boolean(this._networkLogLargeRowsSetting.get())?41:21,this._rowHeight=this._computeRowHeight()}super(),this.setMinimumSize(50,64),this.registerRequiredCSS("network/networkLogView.css",{enableLegacyPatching:!0}),this.element.id="network-container",this.element.classList.add("no-node-selected"),this._networkHideDataURLSetting=Common.Settings.Settings.instance().createSetting("networkHideDataURL",!1),this._networkShowIssuesOnlySetting=Common.Settings.Settings.instance().createSetting("networkShowIssuesOnly",!1),this._networkOnlyBlockedRequestsSetting=Common.Settings.Settings.instance().createSetting("networkOnlyBlockedRequests",!1),this._networkResourceTypeFiltersSetting=Common.Settings.Settings.instance().createSetting("networkResourceTypeFilters",{}),this._rawRowHeight=0,this._progressBarContainer=t,this._networkLogLargeRowsSetting=r,this._networkLogLargeRowsSetting.addChangeListener(i.bind(this),this),this._rawRowHeight=0,this._rowHeight=0,i.call(this),this._timeCalculator=new NetworkTransferTimeCalculator,this._durationCalculator=new NetworkTransferDurationCalculator,this._calculator=this._timeCalculator,this._columns=new NetworkLogViewColumns(this,this._timeCalculator,this._durationCalculator,r),this._columns.show(this.element),this._staleRequests=new Set,this._mainRequestLoadTime=-1,this._mainRequestDOMContentLoadedTime=-1,this._highlightedSubstringChanges=[],this._filters=[],this._timeFilter=null,this._hoveredNode=null,this._recordingHint=null,this._refreshRequestId=null,this._highlightedNode=null,this._linkifier=new Components.Linkifier.Linkifier,this._recording=!1,this._needsRefresh=!1,this._headerHeight=0,this._groupLookups=new Map,this._groupLookups.set("Frame",new NetworkFrameGrouper(this)),this._activeGroupLookup=null,this._textFilterUI=new UI.FilterBar.TextFilterUI,this._textFilterUI.addEventListener(UI.FilterBar.FilterUI.Events.FilterChanged,this._filterChanged,this),e.addFilter(this._textFilterUI),this._dataURLFilterUI=new UI.FilterBar.CheckboxFilterUI("hide-data-url",i18nString(UIStrings.hideDataUrls),!0,this._networkHideDataURLSetting),this._dataURLFilterUI.addEventListener(UI.FilterBar.FilterUI.Events.FilterChanged,this._filterChanged.bind(this),this),UI.Tooltip.Tooltip.install(this._dataURLFilterUI.element(),i18nString(UIStrings.hidesDataAndBlobUrls)),e.addFilter(this._dataURLFilterUI);const s=Object.values(Common.ResourceType.resourceCategories).map((e=>({name:e.title(),label:()=>e.shortTitle(),title:e.title()})));this._resourceCategoryFilterUI=new UI.FilterBar.NamedBitSetFilterUI(s,this._networkResourceTypeFiltersSetting),UI.ARIAUtils.setAccessibleName(this._resourceCategoryFilterUI.element(),i18nString(UIStrings.resourceTypesToInclude)),this._resourceCategoryFilterUI.addEventListener(UI.FilterBar.FilterUI.Events.FilterChanged,this._filterChanged.bind(this),this),e.addFilter(this._resourceCategoryFilterUI),this._onlyIssuesFilterUI=new UI.FilterBar.CheckboxFilterUI("only-show-issues",i18nString(UIStrings.hasBlockedCookies),!0,this._networkShowIssuesOnlySetting),this._onlyIssuesFilterUI.addEventListener(UI.FilterBar.FilterUI.Events.FilterChanged,this._filterChanged.bind(this),this),UI.Tooltip.Tooltip.install(this._onlyIssuesFilterUI.element(),i18nString(UIStrings.onlyShowRequestsWithBlocked)),e.addFilter(this._onlyIssuesFilterUI),this._onlyBlockedRequestsUI=new UI.FilterBar.CheckboxFilterUI("only-show-blocked-requests",i18nString(UIStrings.blockedRequests),!0,this._networkOnlyBlockedRequestsSetting),this._onlyBlockedRequestsUI.addEventListener(UI.FilterBar.FilterUI.Events.FilterChanged,this._filterChanged.bind(this),this),UI.Tooltip.Tooltip.install(this._onlyBlockedRequestsUI.element(),i18nString(UIStrings.onlyShowBlockedRequests)),e.addFilter(this._onlyBlockedRequestsUI),this._filterParser=new TextUtils.TextUtils.FilterParser(_searchKeys),this._suggestionBuilder=new UI.FilterSuggestionBuilder.FilterSuggestionBuilder(_searchKeys,NetworkLogView._sortSearchValues),this._resetSuggestionBuilder(),this._dataGrid=this._columns.dataGrid(),this._setupDataGrid(),this._columns.sortByCurrentColumn(),e.filterButton().addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this._dataGrid.scheduleUpdate.bind(this._dataGrid,!0)),this._summaryToolbar=new UI.Toolbar.Toolbar("network-summary-bar",this.element),new UI.DropTarget.DropTarget(this.element,[UI.DropTarget.Type.File],i18nString(UIStrings.dropHarFilesHere),this._handleDrop.bind(this)),Common.Settings.Settings.instance().moduleSetting("networkColorCodeResourceTypes").addChangeListener(this._invalidateAllItems.bind(this,!1),this),SDK.SDKModel.TargetManager.instance().observeModels(SDK.NetworkManager.NetworkManager,this),SDK.NetworkLog.NetworkLog.instance().addEventListener(SDK.NetworkLog.Events.RequestAdded,this._onRequestUpdated,this),SDK.NetworkLog.NetworkLog.instance().addEventListener(SDK.NetworkLog.Events.RequestUpdated,this._onRequestUpdated,this),SDK.NetworkLog.NetworkLog.instance().addEventListener(SDK.NetworkLog.Events.Reset,this._reset,this),this._updateGroupByFrame(),Common.Settings.Settings.instance().moduleSetting("network.group-by-frame").addChangeListener((()=>this._updateGroupByFrame())),this._filterBar=e,this._textFilterSetting=Common.Settings.Settings.instance().createSetting("networkTextFilter",""),this._textFilterSetting.get()&&this._textFilterUI.setValue(this._textFilterSetting.get())}_updateGroupByFrame(){const e=Common.Settings.Settings.instance().moduleSetting("network.group-by-frame").get();this._setGrouping(e?"Frame":null)}static _sortSearchValues(e,t){e===FilterType.Priority?t.sort(((e,t)=>{const r=PerfUI.NetworkPriorities.uiLabelToNetworkPriority(e),i=PerfUI.NetworkPriorities.uiLabelToNetworkPriority(t);return PerfUI.NetworkPriorities.networkPriorityWeight(r)-PerfUI.NetworkPriorities.networkPriorityWeight(i)})):t.sort()}static _negativeFilter(e,t){return!e(t)}static _requestPathFilter(e,t){return!!e&&e.test(t.path()+"/"+t.name())}static _subdomains(e){const t=[e];let r=e.indexOf(".");for(;-1!==r;)t.push("*"+e.substring(r)),r=e.indexOf(".",r+1);return t}static _createRequestDomainFilter(e){const t=e.split("*").map(Platform.StringUtilities.escapeForRegExp).join(".*");return NetworkLogView._requestDomainFilter.bind(null,new RegExp("^"+t+"$","i"))}static _requestDomainFilter(e,t){return e.test(t.domain)}static _runningRequestFilter(e){return!e.finished}static _fromCacheRequestFilter(e){return e.cached()}static _interceptedByServiceWorkerFilter(e){return e.fetchedViaServiceWorker}static _initiatedByServiceWorkerFilter(e){return e.initiatedByServiceWorker()}static _requestResponseHeaderFilter(e,t){return void 0!==t.responseHeaderValue(e)}static _requestMethodFilter(e,t){return t.requestMethod===e}static _requestPriorityFilter(e,t){return t.priority()===e}static _requestMimeTypeFilter(e,t){return t.mimeType===e}static _requestMixedContentFilter(e,t){return e===MixedContentFilterValues.Displayed?t.mixedContentType===Protocol.Security.MixedContentType.OptionallyBlockable:e===MixedContentFilterValues.Blocked?t.mixedContentType===Protocol.Security.MixedContentType.Blockable&&t.wasBlocked():e===MixedContentFilterValues.BlockOverridden?t.mixedContentType===Protocol.Security.MixedContentType.Blockable&&!t.wasBlocked():e===MixedContentFilterValues.All&&t.mixedContentType!==Protocol.Security.MixedContentType.None}static _requestSchemeFilter(e,t){return t.scheme===e}static _requestCookieDomainFilter(e,t){return t.allCookiesIncludingBlockedOnes().some((t=>t.domain()===e))}static _requestCookieNameFilter(e,t){return t.allCookiesIncludingBlockedOnes().some((t=>t.name()===e))}static _requestCookiePathFilter(e,t){return t.allCookiesIncludingBlockedOnes().some((t=>t.path()===e))}static _requestCookieValueFilter(e,t){return t.allCookiesIncludingBlockedOnes().some((t=>t.value()===e))}static _requestSetCookieDomainFilter(e,t){return t.responseCookies.some((t=>t.domain()===e))}static _requestSetCookieNameFilter(e,t){return t.responseCookies.some((t=>t.name()===e))}static _requestSetCookieValueFilter(e,t){return t.responseCookies.some((t=>t.value()===e))}static _requestSizeLargerThanFilter(e,t){return t.transferSize>=e}static _statusCodeFilter(e,t){return String(t.statusCode)===e}static HTTPRequestsFilter(e){return e.parsedURL.isValid&&e.scheme in HTTPSchemas}static _resourceTypeFilter(e,t){return t.resourceType().name()===e}static _requestUrlFilter(e,t){return new RegExp(Platform.StringUtilities.escapeForRegExp(e),"i").test(t.url())}static _requestTimeFilter(e,t,r){return!(r.issueTime()>t)&&!(-1!==r.endTime&&r.endTime<e)}static _copyRequestHeaders(e){Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(e.requestHeadersText())}static _copyResponseHeaders(e){Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(e.responseHeadersText)}static async _copyResponse(e){const t=await e.contentData();let r=t.content||"";e.contentType().isTextType()?t.encoded&&r&&(r=window.atob(r)):r=TextUtils.ContentProvider.contentAsDataURL(r,e.mimeType,t.encoded),Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(r)}_handleDrop(e){const t=e.items;if(!t.length)return;const r=t[0].webkitGetAsEntry();r.isDirectory||r.file(this.onLoadFromFile.bind(this))}async onLoadFromFile(e){const t=new Common.StringOutputStream.StringOutputStream,r=new Bindings.FileUtils.ChunkedFileReader(e,1e7);if(!await r.read(t)){const e=r.error();return void(e&&this._harLoadFailed(e.message))}let i;try{i=new HARImporter.HARFormat.HARRoot(JSON.parse(t.data()))}catch(s){return void this._harLoadFailed(s)}SDK.NetworkLog.NetworkLog.instance().importRequests(HARImporter.HARImporter.Importer.requestsFromHARLog(i.log))}_harLoadFailed(e){Common.Console.Console.instance().error("Failed to load HAR file with following error: "+e)}_setGrouping(e){this._activeGroupLookup&&this._activeGroupLookup.reset();const t=e&&this._groupLookups.get(e)||null;this._activeGroupLookup=t,this._invalidateAllItems()}_computeRowHeight(){return Math.round(this._rawRowHeight*window.devicePixelRatio)/window.devicePixelRatio}nodeForRequest(e){return networkRequestToNode.get(e)||null}headerHeight(){return this._headerHeight}setRecording(e){this._recording=e,this._updateSummaryBar()}modelAdded(e){if(e.target().parentTarget())return;const t=e.target().model(SDK.ResourceTreeModel.ResourceTreeModel);t&&(t.addEventListener(SDK.ResourceTreeModel.Events.Load,this._loadEventFired,this),t.addEventListener(SDK.ResourceTreeModel.Events.DOMContentLoaded,this._domContentLoadedEventFired,this))}modelRemoved(e){if(!e.target().parentTarget()){const t=e.target().model(SDK.ResourceTreeModel.ResourceTreeModel);t&&(t.removeEventListener(SDK.ResourceTreeModel.Events.Load,this._loadEventFired,this),t.removeEventListener(SDK.ResourceTreeModel.Events.DOMContentLoaded,this._domContentLoadedEventFired,this))}}linkifier(){return this._linkifier}setWindow(e,t){e||t?(this._timeFilter=NetworkLogView._requestTimeFilter.bind(null,e,t),this._timeCalculator.setWindow(new NetworkTimeBoundary(e,t))):(this._timeFilter=null,this._timeCalculator.setWindow(null)),this._filterRequests()}resetFocus(){this._dataGrid.element.focus()}_resetSuggestionBuilder(){this._suggestionBuilder.clear(),this._suggestionBuilder.addItem(FilterType.Is,IsFilterType.Running),this._suggestionBuilder.addItem(FilterType.Is,IsFilterType.FromCache),this._suggestionBuilder.addItem(FilterType.Is,IsFilterType.ServiceWorkerIntercepted),this._suggestionBuilder.addItem(FilterType.Is,IsFilterType.ServiceWorkerInitiated),this._suggestionBuilder.addItem(FilterType.LargerThan,"100"),this._suggestionBuilder.addItem(FilterType.LargerThan,"10k"),this._suggestionBuilder.addItem(FilterType.LargerThan,"1M"),this._textFilterUI.setSuggestionProvider(this._suggestionBuilder.completions.bind(this._suggestionBuilder))}_filterChanged(e){this.removeAllNodeHighlights(),this._parseFilterQuery(this._textFilterUI.value()),this._filterRequests(),this._textFilterSetting.set(this._textFilterUI.value())}async resetFilter(){this._textFilterUI.clear()}_showRecordingHint(){this._hideRecordingHint(),this._recordingHint=this.element.createChild("div","network-status-pane fill");const e=this._recordingHint.createChild("div","recording-hint");if(this._recording){let t=null;const r=UI.ShortcutRegistry.ShortcutRegistry.instance().shortcutsForAction("inspector_main.reload")[0];r&&(t=this._recordingHint.createChild("b"),t.textContent=r.title());e.createChild("span").textContent=i18nString(UIStrings.recordingNetworkActivity),t&&(e.createChild("br"),e.appendChild(i18n.i18n.getFormatLocalizedString(str_,UIStrings.performARequestOrHitSToRecordThe,{PH1:t})))}else{const t=e.createChild("b");t.textContent=UI.ShortcutRegistry.ShortcutRegistry.instance().shortcutTitleForAction("network.toggle-recording")||"",e.appendChild(i18n.i18n.getFormatLocalizedString(str_,UIStrings.recordSToDisplayNetworkActivity,{PH1:t}))}e.createChild("br"),e.appendChild(UI.XLink.XLink.create("https://developers.google.com/web/tools/chrome-devtools/network/?utm_source=devtools&utm_campaign=2019Q1",i18nString(UIStrings.learnMore))),this._setHidden(!0)}_hideRecordingHint(){this._setHidden(!1),this._recordingHint&&this._recordingHint.remove(),UI.ARIAUtils.alert(i18nString(UIStrings.networkDataAvailable),this._summaryToolbar.element),this._recordingHint=null}_setHidden(e){this._columns.setHidden(e),UI.ARIAUtils.setHidden(this._summaryToolbar.element,e)}elementsToRestoreScrollPositionsFor(){return this._dataGrid?[this._dataGrid.scrollContainer]:[]}columnExtensionResolved(){this._invalidateAllItems(!0)}_setupDataGrid(){return this._dataGrid.setRowContextMenuCallback(((e,t)=>{const r=t.request();r&&this.handleContextMenuForRequest(e,r)})),this._dataGrid.setStickToBottom(!0),this._dataGrid.setName("networkLog"),this._dataGrid.setResizeMethod(DataGrid.DataGrid.ResizeMethod.Last),this._dataGrid.element.classList.add("network-log-grid"),this._dataGrid.element.addEventListener("mousedown",this._dataGridMouseDown.bind(this),!0),this._dataGrid.element.addEventListener("mousemove",this._dataGridMouseMove.bind(this),!0),this._dataGrid.element.addEventListener("mouseleave",(()=>this._setHoveredNode(null)),!0),this._dataGrid.element.addEventListener("keydown",(e=>{isEnterOrSpaceKey(e)&&(this.dispatchEventToListeners(Events.RequestActivated,{showPanel:!0,takeFocus:!0}),e.consume(!0))})),this._dataGrid.element.addEventListener("focus",this._onDataGridFocus.bind(this),!0),this._dataGrid.element.addEventListener("blur",this._onDataGridBlur.bind(this),!0),this._dataGrid}_dataGridMouseMove(e){const t=e,r=this._dataGrid.dataGridNodeFromNode(t.target),i=t.shiftKey;this._setHoveredNode(r,i)}hoveredNode(){return this._hoveredNode}_setHoveredNode(e,t){this._hoveredNode&&this._hoveredNode.setHovered(!1,!1),this._hoveredNode=e,this._hoveredNode&&this._hoveredNode.setHovered(!0,Boolean(t))}_dataGridMouseDown(e){const t=e;!this._dataGrid.selectedNode&&t.button&&t.consume()}_updateSummaryBar(){this._hideRecordingHint();let e=0,t=0,r=0,i=0,s=0,o=-1,n=-1,a=0;for(const d of SDK.NetworkLog.NetworkLog.instance().requests()){const l=networkRequestToNode.get(d);if(!l)continue;a++;const c=d.transferSize;e+=c;const u=d.resourceSize;t+=u,filteredNetworkRequests.has(l)||(r++,i+=c,s+=u);const h=SDK.NetworkManager.NetworkManager.forRequest(d);h&&d.url()===h.target().inspectedURL()&&d.resourceType()===Common.ResourceType.resourceTypes.Document&&!h.target().parentTarget()&&(o=d.startTime),d.endTime>n&&(n=d.endTime)}if(!a)return void this._showRecordingHint();this._summaryToolbar.removeToolbarItems();const l=(e,t)=>{const r=new UI.Toolbar.ToolbarText(e);return r.setTitle(t||e),this._summaryToolbar.appendToolbarItem(r),r.element};if(r!==a?(l(i18nString(UIStrings.sSRequests,{PH1:r,PH2:a})),this._summaryToolbar.appendSeparator(),l(i18nString(UIStrings.sSTransferred,{PH1:Platform.NumberUtilities.bytesToString(i),PH2:Platform.NumberUtilities.bytesToString(e)}),i18nString(UIStrings.sBSBTransferredOverNetwork,{PH1:i,PH2:e})),this._summaryToolbar.appendSeparator(),l(i18nString(UIStrings.sSResources,{PH1:Platform.NumberUtilities.bytesToString(s),PH2:Platform.NumberUtilities.bytesToString(t)}),i18nString(UIStrings.sBSBResourcesLoadedByThePage,{PH1:s,PH2:t}))):(l(i18nString(UIStrings.sRequests,{PH1:a})),this._summaryToolbar.appendSeparator(),l(i18nString(UIStrings.sTransferred,{PH1:Platform.NumberUtilities.bytesToString(e)}),i18nString(UIStrings.sBTransferredOverNetwork,{PH1:e})),this._summaryToolbar.appendSeparator(),l(i18nString(UIStrings.sResources,{PH1:Platform.NumberUtilities.bytesToString(t)}),i18nString(UIStrings.sBResourcesLoadedByThePage,{PH1:t}))),-1!==o&&-1!==n){if(this._summaryToolbar.appendSeparator(),l(i18nString(UIStrings.finishS,{PH1:Number.secondsToString(n-o)})),-1!==this._mainRequestDOMContentLoadedTime&&this._mainRequestDOMContentLoadedTime>o){this._summaryToolbar.appendSeparator();l(i18nString(UIStrings.domcontentloadedS,{PH1:Number.secondsToString(this._mainRequestDOMContentLoadedTime-o)})).style.color=NetworkLogView.getDCLEventColor()}if(-1!==this._mainRequestLoadTime){this._summaryToolbar.appendSeparator();l(i18nString(UIStrings.loadS,{PH1:Number.secondsToString(this._mainRequestLoadTime-o)})).style.color=NetworkLogView.getLoadEventColor()}}}scheduleRefresh(){this._needsRefresh||(this._needsRefresh=!0,this.isShowing()&&!this._refreshRequestId&&(this._refreshRequestId=this.element.window().requestAnimationFrame(this._refresh.bind(this))))}addFilmStripFrames(e){this._columns.addEventDividers(e,"network-frame-divider")}selectFilmStripFrame(e){this._columns.selectFilmStripFrame(e)}clearFilmStripFrame(){this._columns.clearFilmStripFrame()}_refreshIfNeeded(){this._needsRefresh&&this._refresh()}_invalidateAllItems(e){this._staleRequests=new Set(SDK.NetworkLog.NetworkLog.instance().requests()),e?this.scheduleRefresh():this._refresh()}timeCalculator(){return this._timeCalculator}calculator(){return this._calculator}setCalculator(e){e&&this._calculator!==e&&(this._calculator!==e&&(this._calculator=e,this._columns.setCalculator(this._calculator)),this._calculator.reset(),this._calculator.startAtZero?this._columns.hideEventDividers():this._columns.showEventDividers(),this._invalidateAllItems())}_loadEventFired(e){if(!this._recording)return;const t=e.data.loadTime;t&&(this._mainRequestLoadTime=t,this._columns.addEventDividers([t],"network-load-divider"))}_domContentLoadedEventFired(e){if(!this._recording)return;const t=e.data;t&&(this._mainRequestDOMContentLoadedTime=t,this._columns.addEventDividers([t],"network-dcl-divider"))}wasShown(){this._refreshIfNeeded(),this._columns.wasShown()}willHide(){this._columns.willHide()}onResize(){this._rowHeight=this._computeRowHeight()}flatNodesList(){return this._dataGrid.rootNode().flatChildren()}_onDataGridFocus(){this._dataGrid.element.matches(":focus-visible")&&this.element.classList.add("grid-focused"),this.updateNodeBackground()}_onDataGridBlur(){this.element.classList.remove("grid-focused"),this.updateNodeBackground()}updateNodeBackground(){this._dataGrid.selectedNode&&this._dataGrid.selectedNode.updateBackgroundColor()}updateNodeSelectedClass(e){e?this.element.classList.remove("no-node-selected"):this.element.classList.add("no-node-selected")}stylesChanged(){this._columns.scheduleRefresh()}_refresh(){this._needsRefresh=!1,this._refreshRequestId&&(this.element.window().cancelAnimationFrame(this._refreshRequestId),this._refreshRequestId=null),this.removeAllNodeHighlights(),this._timeCalculator.updateBoundariesForEventTime(this._mainRequestLoadTime),this._durationCalculator.updateBoundariesForEventTime(this._mainRequestLoadTime),this._timeCalculator.updateBoundariesForEventTime(this._mainRequestDOMContentLoadedTime),this._durationCalculator.updateBoundariesForEventTime(this._mainRequestDOMContentLoadedTime);const e=new Map,t=[],r=new Set;for(;this._staleRequests.size;){const e=this._staleRequests.values().next().value;this._staleRequests.delete(e);let t=networkRequestToNode.get(e);t||(t=this._createNodeForRequest(e)),r.add(t)}for(const i of r){const r=!this._applyFilter(i);r&&i===this._hoveredNode&&this._setHoveredNode(null),r||t.push(i);const s=i.request();this._timeCalculator.updateBoundaries(s),this._durationCalculator.updateBoundaries(s);const o=this._parentNodeForInsert(i);if(filteredNetworkRequests.has(i)===r&&i.parent===o)continue;r?filteredNetworkRequests.add(i):filteredNetworkRequests.delete(i);if(i.parent&&(r||i.parent!==o)){let e=i.parent;if(!e)continue;for(e.removeChild(i);e&&!e.hasChildren()&&e.dataGrid&&e.dataGrid.rootNode()!==e;){const t=e.parent;t.removeChild(e),e=t}}o&&!r&&(o.dataGrid||e.has(o)||(e.set(o,this._dataGrid.rootNode()),t.push(o)),e.set(i,o))}for(const i of e.keys())e.get(i).appendChild(i);for(const i of t)i.refresh();this._updateSummaryBar(),e.size&&this._columns.sortByCurrentColumn(),this._dataGrid.updateInstantly(),this._didRefreshForTest()}_didRefreshForTest(){}_parentNodeForInsert(e){if(!this._activeGroupLookup)return this._dataGrid.rootNode();const t=this._activeGroupLookup.groupNodeForRequest(e.request());return t||this._dataGrid.rootNode()}_reset(){this.dispatchEventToListeners(Events.RequestActivated,{showPanel:!1}),this._setHoveredNode(null),this._columns.reset(),this._timeFilter=null,this._calculator.reset(),this._timeCalculator.setWindow(null),this._linkifier.reset(),this._activeGroupLookup&&this._activeGroupLookup.reset(),this._staleRequests.clear(),this._resetSuggestionBuilder(),this._mainRequestLoadTime=-1,this._mainRequestDOMContentLoadedTime=-1,this._dataGrid.rootNode().removeChildren(),this._updateSummaryBar(),this._dataGrid.setStickToBottom(!0),this.scheduleRefresh()}setTextFilterValue(e){this._textFilterUI.setValue(e),this._dataURLFilterUI.setChecked(!1),this._onlyIssuesFilterUI.setChecked(!1),this._onlyBlockedRequestsUI.setChecked(!1),this._resourceCategoryFilterUI.reset()}_createNodeForRequest(e){const t=new NetworkRequestNode(this,e);networkRequestToNode.set(e,t),filteredNetworkRequests.add(t);for(let r=e.redirectSource();r;r=r.redirectSource())this._refreshRequest(r);return t}_onRequestUpdated(e){const t=e.data;this._refreshRequest(t)}_refreshRequest(e){NetworkLogView._subdomains(e.domain).forEach(this._suggestionBuilder.addItem.bind(this._suggestionBuilder,FilterType.Domain)),this._suggestionBuilder.addItem(FilterType.Method,e.requestMethod),this._suggestionBuilder.addItem(FilterType.MimeType,e.mimeType),this._suggestionBuilder.addItem(FilterType.Scheme,String(e.scheme)),this._suggestionBuilder.addItem(FilterType.StatusCode,String(e.statusCode)),this._suggestionBuilder.addItem(FilterType.ResourceType,e.resourceType().name()),this._suggestionBuilder.addItem(FilterType.Url,e.securityOrigin());const t=e.priority();if(t&&this._suggestionBuilder.addItem(FilterType.Priority,PerfUI.NetworkPriorities.uiLabelForNetworkPriority(t)),e.mixedContentType!==Protocol.Security.MixedContentType.None&&this._suggestionBuilder.addItem(FilterType.MixedContent,MixedContentFilterValues.All),e.mixedContentType===Protocol.Security.MixedContentType.OptionallyBlockable&&this._suggestionBuilder.addItem(FilterType.MixedContent,MixedContentFilterValues.Displayed),e.mixedContentType===Protocol.Security.MixedContentType.Blockable){const t=e.wasBlocked()?MixedContentFilterValues.Blocked:MixedContentFilterValues.BlockOverridden;this._suggestionBuilder.addItem(FilterType.MixedContent,t)}const r=e.responseHeaders;for(let i=0,s=r.length;i<s;++i)this._suggestionBuilder.addItem(FilterType.HasResponseHeader,r[i].name);for(const i of e.responseCookies)this._suggestionBuilder.addItem(FilterType.SetCookieDomain,i.domain()),this._suggestionBuilder.addItem(FilterType.SetCookieName,i.name()),this._suggestionBuilder.addItem(FilterType.SetCookieValue,i.value());for(const i of e.allCookiesIncludingBlockedOnes())this._suggestionBuilder.addItem(FilterType.CookieDomain,i.domain()),this._suggestionBuilder.addItem(FilterType.CookieName,i.name()),this._suggestionBuilder.addItem(FilterType.CookiePath,i.path()),this._suggestionBuilder.addItem(FilterType.CookieValue,i.value());this._staleRequests.add(e),this.scheduleRefresh()}rowHeight(){return this._rowHeight}switchViewMode(e){this._columns.switchViewMode(e)}handleContextMenuForRequest(e,t){e.appendApplicableItems(t);let r=e.clipboardSection().appendSubMenuItem(i18nString(UIStrings.copy));const i=r.footerSection();if(t){r.defaultSection().appendItem(UI.UIUtils.copyLinkAddressLabel(),Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText.bind(Host.InspectorFrontendHost.InspectorFrontendHostInstance,t.contentURL())),t.requestHeadersText()&&r.defaultSection().appendItem(i18nString(UIStrings.copyRequestHeaders),NetworkLogView._copyRequestHeaders.bind(null,t)),t.responseHeadersText&&r.defaultSection().appendItem(i18nString(UIStrings.copyResponseHeaders),NetworkLogView._copyResponseHeaders.bind(null,t)),t.finished&&r.defaultSection().appendItem(i18nString(UIStrings.copyResponse),NetworkLogView._copyResponse.bind(null,t));const e=t.initiator();if(e){const t=e.stack;if(t){const e=computeStackTraceText(t);""!==e&&r.defaultSection().appendItem(i18nString(UIStrings.copyStacktrace),(()=>{Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(e)}))}}const s=t.isBlobRequest();Host.Platform.isWin()?(i.appendItem(i18nString(UIStrings.copyAsPowershell),this._copyPowerShellCommand.bind(this,t),s),i.appendItem(i18nString(UIStrings.copyAsFetch),this._copyFetchCall.bind(this,t,!1),s),i.appendItem(i18nString(UIStrings.copyAsNodejsFetch),this._copyFetchCall.bind(this,t,!0),s),i.appendItem(i18nString(UIStrings.copyAsCurlCmd),this._copyCurlCommand.bind(this,t,"win"),s),i.appendItem(i18nString(UIStrings.copyAsCurlBash),this._copyCurlCommand.bind(this,t,"unix"),s),i.appendItem(i18nString(UIStrings.copyAllAsPowershell),this._copyAllPowerShellCommand.bind(this)),i.appendItem(i18nString(UIStrings.copyAllAsFetch),this._copyAllFetchCall.bind(this,!1)),i.appendItem(i18nString(UIStrings.copyAllAsNodejsFetch),this._copyAllFetchCall.bind(this,!0)),i.appendItem(i18nString(UIStrings.copyAllAsCurlCmd),this._copyAllCurlCommand.bind(this,"win")),i.appendItem(i18nString(UIStrings.copyAllAsCurlBash),this._copyAllCurlCommand.bind(this,"unix"))):(i.appendItem(i18nString(UIStrings.copyAsFetch),this._copyFetchCall.bind(this,t,!1),s),i.appendItem(i18nString(UIStrings.copyAsNodejsFetch),this._copyFetchCall.bind(this,t,!0),s),i.appendItem(i18nString(UIStrings.copyAsCurl),this._copyCurlCommand.bind(this,t,"unix"),s),i.appendItem(i18nString(UIStrings.copyAllAsFetch),this._copyAllFetchCall.bind(this,!1)),i.appendItem(i18nString(UIStrings.copyAllAsNodejsFetch),this._copyAllFetchCall.bind(this,!0)),i.appendItem(i18nString(UIStrings.copyAllAsCurl),this._copyAllCurlCommand.bind(this,"unix")))}else r=e.clipboardSection().appendSubMenuItem(i18nString(UIStrings.copy));if(i.appendItem(i18nString(UIStrings.copyAllAsHar),this._copyAll.bind(this)),e.saveSection().appendItem(i18nString(UIStrings.saveAllAsHarWithContent),this.exportAll.bind(this)),e.editSection().appendItem(i18nString(UIStrings.clearBrowserCache),this._clearBrowserCache.bind(this)),e.editSection().appendItem(i18nString(UIStrings.clearBrowserCookies),this._clearBrowserCookies.bind(this)),t){const r=20,i=SDK.NetworkManager.MultitargetNetworkManager.instance();let s=i.blockedPatterns();function o(e){s.push({enabled:!0,url:e}),i.setBlockedPatterns(s),i.setBlockingEnabled(!0),UI.ViewManager.ViewManager.instance().showView("network.blocked-urls")}function n(e){s=s.filter((t=>t.url!==e)),i.setBlockedPatterns(s),UI.ViewManager.ViewManager.instance().showView("network.blocked-urls")}const a=t.parsedURL.urlWithoutScheme();if(a&&!s.find((e=>e.url===a)))e.debugSection().appendItem(i18nString(UIStrings.blockRequestUrl),o.bind(null,a));else if(a){const t=Platform.StringUtilities.trimMiddle(a,r);e.debugSection().appendItem(i18nString(UIStrings.unblockS,{PH1:t}),n.bind(null,a))}const l=t.parsedURL.domain();if(l&&!s.find((e=>e.url===l)))e.debugSection().appendItem(i18nString(UIStrings.blockRequestDomain),o.bind(null,l));else if(l){const t=Platform.StringUtilities.trimMiddle(l,r);e.debugSection().appendItem(i18nString(UIStrings.unblockS,{PH1:t}),n.bind(null,l))}SDK.NetworkManager.NetworkManager.canReplayRequest(t)&&e.debugSection().appendItem(i18nString(UIStrings.replayXhr),SDK.NetworkManager.NetworkManager.replayRequest.bind(null,t))}}_harRequests(){return SDK.NetworkLog.NetworkLog.instance().requests().filter(NetworkLogView.HTTPRequestsFilter).filter((e=>e.finished||e.resourceType()===Common.ResourceType.resourceTypes.WebSocket&&e.responseReceivedTime))}async _copyAll(){const e={log:await SDK.HARLog.HARLog.build(this._harRequests())};Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(JSON.stringify(e,null,2))}async _copyCurlCommand(e,t){const r=await this._generateCurlCommand(e,t);Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(r)}async _copyAllCurlCommand(e){const t=await this._generateAllCurlCommand(SDK.NetworkLog.NetworkLog.instance().requests(),e);Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(t)}async _copyFetchCall(e,t){const r=await this._generateFetchCall(e,t);Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(r)}async _copyAllFetchCall(e){const t=await this._generateAllFetchCall(SDK.NetworkLog.NetworkLog.instance().requests(),e);Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(t)}async _copyPowerShellCommand(e){const t=await this._generatePowerShellCommand(e);Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(t)}async _copyAllPowerShellCommand(){const e=await this._generateAllPowerShellCommand(SDK.NetworkLog.NetworkLog.instance().requests());Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(e)}async exportAll(){const e=SDK.SDKModel.TargetManager.instance().mainTarget();if(!e)return;const t=e.inspectedURL(),r=Common.ParsedURL.ParsedURL.fromString(t),i=r?r.host:"network-log",s=new Bindings.FileUtils.FileOutputStream;if(!await s.open(i+".har"))return;const o=new UI.ProgressIndicator.ProgressIndicator;this._progressBarContainer.appendChild(o.element),await HARWriter.write(s,this._harRequests(),o),o.done(),s.close()}_clearBrowserCache(){confirm(i18nString(UIStrings.areYouSureYouWantToClearBrowser))&&SDK.NetworkManager.MultitargetNetworkManager.instance().clearBrowserCache()}_clearBrowserCookies(){confirm(i18nString(UIStrings.areYouSureYouWantToClearBrowserCookies))&&SDK.NetworkManager.MultitargetNetworkManager.instance().clearBrowserCookies()}_removeAllHighlights(){this.removeAllNodeHighlights();for(let e=0;e<this._highlightedSubstringChanges.length;++e)UI.UIUtils.revertDomChanges(this._highlightedSubstringChanges[e]);this._highlightedSubstringChanges=[]}_applyFilter(e){const t=e.request();if(this._timeFilter&&!this._timeFilter(t))return!1;const r=t.resourceType().category().title();if(!this._resourceCategoryFilterUI.accept(r))return!1;if(this._dataURLFilterUI.checked()&&(t.parsedURL.isDataURL()||t.parsedURL.isBlobURL()))return!1;if(this._onlyIssuesFilterUI.checked()&&!BrowserSDK.RelatedIssue.hasIssueOfCategory(t,SDK.Issue.IssueCategory.SameSiteCookie))return!1;if(this._onlyBlockedRequestsUI.checked()&&!t.wasBlocked()&&!t.corsErrorStatus())return!1;if("Service Worker Fallback Required"===t.statusText)return!1;for(let i=0;i<this._filters.length;++i)if(!this._filters[i](t))return!1;return!0}_parseFilterQuery(e){const t=this._filterParser.parse(e);this._filters=t.map((e=>{const t=e.key,r=e.text||"",i=e.regex;let s;if(t){const e=Platform.StringUtilities.escapeForRegExp(t+":"+r);s=this._createSpecialFilter(t,r)||NetworkLogView._requestPathFilter.bind(null,new RegExp(e,"i"))}else s=e.regex?NetworkLogView._requestPathFilter.bind(null,i):NetworkLogView._requestPathFilter.bind(null,new RegExp(Platform.StringUtilities.escapeForRegExp(r),"i"));return e.negative?NetworkLogView._negativeFilter.bind(null,s):s}))}_createSpecialFilter(e,t){switch(e){case FilterType.Domain:return NetworkLogView._createRequestDomainFilter(t);case FilterType.HasResponseHeader:return NetworkLogView._requestResponseHeaderFilter.bind(null,t);case FilterType.Is:if(t.toLowerCase()===IsFilterType.Running)return NetworkLogView._runningRequestFilter;if(t.toLowerCase()===IsFilterType.FromCache)return NetworkLogView._fromCacheRequestFilter;if(t.toLowerCase()===IsFilterType.ServiceWorkerIntercepted)return NetworkLogView._interceptedByServiceWorkerFilter;if(t.toLowerCase()===IsFilterType.ServiceWorkerInitiated)return NetworkLogView._initiatedByServiceWorkerFilter;break;case FilterType.LargerThan:return this._createSizeFilter(t.toLowerCase());case FilterType.Method:return NetworkLogView._requestMethodFilter.bind(null,t);case FilterType.MimeType:return NetworkLogView._requestMimeTypeFilter.bind(null,t);case FilterType.MixedContent:return NetworkLogView._requestMixedContentFilter.bind(null,t);case FilterType.Scheme:return NetworkLogView._requestSchemeFilter.bind(null,t);case FilterType.SetCookieDomain:return NetworkLogView._requestSetCookieDomainFilter.bind(null,t);case FilterType.SetCookieName:return NetworkLogView._requestSetCookieNameFilter.bind(null,t);case FilterType.SetCookieValue:return NetworkLogView._requestSetCookieValueFilter.bind(null,t);case FilterType.CookieDomain:return NetworkLogView._requestCookieDomainFilter.bind(null,t);case FilterType.CookieName:return NetworkLogView._requestCookieNameFilter.bind(null,t);case FilterType.CookiePath:return NetworkLogView._requestCookiePathFilter.bind(null,t);case FilterType.CookieValue:return NetworkLogView._requestCookieValueFilter.bind(null,t);case FilterType.Priority:return NetworkLogView._requestPriorityFilter.bind(null,PerfUI.NetworkPriorities.uiLabelToNetworkPriority(t));case FilterType.StatusCode:return NetworkLogView._statusCodeFilter.bind(null,t);case FilterType.ResourceType:return NetworkLogView._resourceTypeFilter.bind(null,t);case FilterType.Url:return NetworkLogView._requestUrlFilter.bind(null,t)}return null}_createSizeFilter(e){let t=1;e.endsWith("k")?(t=1e3,e=e.substring(0,e.length-1)):e.endsWith("m")&&(t=1e6,e=e.substring(0,e.length-1));const r=Number(e);return isNaN(r)?null:NetworkLogView._requestSizeLargerThanFilter.bind(null,r*t)}_filterRequests(){this._removeAllHighlights(),this._invalidateAllItems()}_reveal(e){this.removeAllNodeHighlights();const t=networkRequestToNode.get(e);return t&&t.dataGrid?(t.parent&&t.parent instanceof NetworkGroupNode&&(t.parent.reveal(),t.parent.expand()),t.reveal(),t):null}revealAndHighlightRequest(e){const t=this._reveal(e);t&&this._highlightNode(t)}selectRequest(e,t){const{clearFilter:r}=t||{clearFilter:!0};r&&this.setTextFilterValue("");const i=this._reveal(e);i&&i.select()}removeAllNodeHighlights(){this._highlightedNode&&(this._highlightedNode.element().classList.remove("highlighted-row"),this._highlightedNode=null)}_highlightNode(e){UI.UIUtils.runCSSAnimationOnce(e.element(),"highlighted-row"),this._highlightedNode=e}_filterOutBlobRequests(e){return e.filter((e=>!e.isBlobRequest()))}async _generateFetchCall(e,t){const r=new Set(["method","path","scheme","version","accept-charset","accept-encoding","access-control-request-headers","access-control-request-method","connection","content-length","cookie","cookie2","date","dnt","expect","host","keep-alive","origin","referer","te","trailer","transfer-encoding","upgrade","via","user-agent"]),i=new Set(["cookie","authorization"]),s=JSON.stringify(e.url()),o=e.requestHeaders(),n=o.reduce(((e,t)=>{const i=t.name;return r.has(i.toLowerCase())||i.includes(":")||e.append(i,t.value),e}),new Headers),a={};for(const g of n)a[g[0]]=g[1];const l=e.includedRequestCookies().length||o.some((({name:e})=>i.has(e.toLowerCase())))?"include":"omit",d=o.find((({name:e})=>"referer"===e.toLowerCase())),c=d?d.value:void 0,u=e.referrerPolicy()||void 0,h=await e.requestFormData(),p={headers:Object.keys(a).length?a:void 0,referrer:c,referrerPolicy:u,body:h,method:e.requestMethod,mode:"cors"};if(t){const e=o.find((e=>"cookie"===e.name.toLowerCase()));e&&(p.headers={...a,cookie:e.value})}else p.credentials=l;return`fetch(${s}, ${JSON.stringify(p,null,2)});`}async _generateAllFetchCall(e,t){const r=this._filterOutBlobRequests(e);return(await Promise.all(r.map((e=>this._generateFetchCall(e,t))))).join(" ;\n")}async _generateCurlCommand(e,t){let r=[];const i=new Set(["accept-encoding","host","method","path","scheme","version"]);const s="win"===t?function(e){const t=/[\r\n]/.test(e)?'^"':'"';return t+e.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/[^a-zA-Z0-9\s_\-:=+~'\/.',?;()*`&]/g,"^$&").replace(/%(?=[a-zA-Z0-9_])/g,"%^").replace(/\r?\n/g,"^\n\n")+t}:function(e){return/[\0-\x1F\x7F-\x9F!]|\'/.test(e)?"$'"+e.replace(/\\/g,"\\\\").replace(/\'/g,"\\'").replace(/\n/g,"\\n").replace(/\r/g,"\\r").replace(/[\0-\x1F\x7F-\x9F!]/g,(function(e){let t=e.charCodeAt(0).toString(16);for(;t.length<4;)t="0"+t;return"\\u"+t}))+"'":"'"+e+"'"};r.push(s(e.url()).replace(/[[{}\]]/g,"\\$&"));let o="GET";const n=[],a=e.requestContentType(),l=await e.requestFormData();(a&&a.startsWith("application/x-www-form-urlencoded")&&l||l)&&(n.push("--data-raw "+s(l)),i.add("content-length"),o="POST"),e.requestMethod!==o&&r.push("-X "+s(e.requestMethod));const d=e.requestHeaders();for(let c=0;c<d.length;c++){const e=d[c],t=e.name.replace(/^:/,"");i.has(t.toLowerCase())||r.push("-H "+s(t+": "+e.value))}return r=r.concat(n),r.push("--compressed"),e.securityState()===Protocol.Security.SecurityState.Insecure&&r.push("--insecure"),"curl "+r.join(r.length>=3?"win"===t?" ^\n  ":" \\\n  ":" ")}async _generateAllCurlCommand(e,t){const r=this._filterOutBlobRequests(e),i=await Promise.all(r.map((e=>this._generateCurlCommand(e,t))));return"win"===t?i.join(" &\r\n"):i.join(" ;\n")}async _generatePowerShellCommand(e){const t=[],r=new Set(["host","connection","proxy-connection","content-length","expect","range","content-type"]);function i(e){return'"'+e.replace(/[`\$"]/g,"`$&").replace(/[^\x20-\x7E]/g,(e=>"$([char]"+e.charCodeAt(0)+")"))+'"'}t.push("-Uri "+i(e.url())),"GET"!==e.requestMethod&&t.push("-Method "+i(e.requestMethod));const s=e.requestHeaders(),o=[];for(const l of s){const e=l.name.replace(/^:/,"");r.has(e.toLowerCase())||o.push(i(e)+"="+i(l.value))}o.length&&t.push("-Headers @{\n"+o.join("\n  ")+"\n}");const n=s.find((({name:e})=>"content-type"===e.toLowerCase()));n&&t.push("-ContentType "+i(n.value));const a=await e.requestFormData();if(a){const e=i(a);/[^\x20-\x7E]/.test(a)?t.push("-Body ([System.Text.Encoding]::UTF8.GetBytes("+e+"))"):t.push("-Body "+e)}return"Invoke-WebRequest "+t.join(t.length>=3?" `\n":" ")}async _generateAllPowerShellCommand(e){const t=this._filterOutBlobRequests(e);return(await Promise.all(t.map((e=>this._generatePowerShellCommand(e))))).join(";\r\n")}static getDCLEventColor(){return"dark"===ThemeSupport.ThemeSupport.instance().themeName()?"#03A9F4":"#0867CB"}static getLoadEventColor(){return ThemeSupport.ThemeSupport.instance().patchColorText("#B31412",ThemeSupport.ThemeSupport.ColorUsage.Foreground)}}export function computeStackTraceText(e){let t="";for(const r of e.callFrames){t+=`${UI.UIUtils.beautifyFunctionName(r.functionName)} @ ${r.url}:${r.lineNumber+1}\n`}return e.parent&&(t+=computeStackTraceText(e.parent)),t}const filteredNetworkRequests=new WeakSet,networkRequestToNode=new WeakMap;export function isRequestFilteredOut(e){return filteredNetworkRequests.has(e)}export const HTTPSchemas={http:!0,https:!0,ws:!0,wss:!0};export var FilterType;!function(e){e.Domain="domain",e.HasResponseHeader="has-response-header",e.Is="is",e.LargerThan="larger-than",e.Method="method",e.MimeType="mime-type",e.MixedContent="mixed-content",e.Priority="priority",e.Scheme="scheme",e.SetCookieDomain="set-cookie-domain",e.SetCookieName="set-cookie-name",e.SetCookieValue="set-cookie-value",e.ResourceType="resource-type",e.CookieDomain="cookie-domain",e.CookieName="cookie-name",e.CookiePath="cookie-path",e.CookieValue="cookie-value",e.StatusCode="status-code",e.Url="url"}(FilterType||(FilterType={}));export var MixedContentFilterValues;!function(e){e.All="all",e.Displayed="displayed",e.Blocked="blocked",e.BlockOverridden="block-overridden"}(MixedContentFilterValues||(MixedContentFilterValues={}));export var IsFilterType;!function(e){e.Running="running",e.FromCache="from-cache",e.ServiceWorkerIntercepted="service-worker-intercepted",e.ServiceWorkerInitiated="service-worker-initiated"}(IsFilterType||(IsFilterType={}));export const _searchKeys=Object.values(FilterType);