import*as Common from"../common/common.js";import*as Components from"../components/components.js";import*as DataGrid from"../data_grid/data_grid.js";import*as i18n from"../i18n/i18n.js";import*as UI from"../ui/ui.js";import{NetworkRequestNode}from"./NetworkDataGridNode.js";import{NetworkManageCustomHeadersView}from"./NetworkManageCustomHeadersView.js";import{NetworkWaterfallColumn}from"./NetworkWaterfallColumn.js";import{RequestInitiatorView}from"./RequestInitiatorView.js";const UIStrings={networkLog:"Network Log",waterfall:"Waterfall",responseHeaders:"Response Headers",manageHeaderColumns:"Manage Header Columns\u2026",startTime:"Start Time",responseTime:"Response Time",endTime:"End Time",totalDuration:"Total Duration",latency:"Latency",name:"Name",path:"Path",url:"Url",method:"Method",status:"Status",text:"Text",protocol:"Protocol",scheme:"Scheme",domain:"Domain",remoteAddress:"Remote Address",type:"Type",initiator:"Initiator",initiatorAddressSpace:"Initiator Address Space",cookies:"Cookies",setCookies:"Set Cookies",size:"Size",content:"Content",time:"Time",priority:"Priority",connectionId:"Connection ID",cachecontrol:"`Cache-Control`",s:"{PH1}",contentencoding:"`Content-Encoding`",contentlength:"`Content-Length`",etag:"`ETag`",keepalive:"`Keep-Alive`",lastmodified:"`Last-Modified`",server:"`Server`",vary:"`Vary`",remoteAddressSpace:"Remote Address Space"},str_=i18n.i18n.registerUIStrings("network/NetworkLogViewColumns.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),i18nLazyString=i18n.i18n.getLazilyComputedLocalizedString.bind(void 0,str_);export class NetworkLogViewColumns{constructor(t,e,i,o){this._networkLogView=t,this._persistantSettings=Common.Settings.Settings.instance().createSetting("networkLogColumns",{}),this._networkLogLargeRowsSetting=o,this._networkLogLargeRowsSetting.addChangeListener(this._updateRowsSize,this),this._eventDividers=new Map,this._eventDividersShown=!1,this._gridMode=!0,this._columns=[],this._waterfallRequestsAreStale=!1,this._waterfallScrollerWidthIsStale=!0,this._popupLinkifier=new Components.Linkifier.Linkifier,this._calculatorsMap=new Map,this._calculatorsMap.set(_calculatorTypes.Time,e),this._calculatorsMap.set(_calculatorTypes.Duration,i),this._lastWheelTime=0,this._setupDataGrid(),this._setupWaterfall()}static _convertToDataGridDescriptor(t){const e=t.title instanceof Function?t.title():t.title;return{id:t.id,title:e,sortable:t.sortable,align:t.align,nonSelectable:t.nonSelectable,weight:t.weight,allowInSortByEvenWhenHidden:t.allowInSortByEvenWhenHidden}}wasShown(){this._updateRowsSize()}willHide(){this._popoverHelper&&this._popoverHelper.hidePopover()}reset(){this._popoverHelper&&this._popoverHelper.hidePopover(),this._eventDividers.clear()}_setupDataGrid(){const t=_defaultColumns,e=_defaultColumnConfig;this._columns=[];for(const o of t){const t=Object.assign({},e,o);if(t.id=t.id,t.subtitle){const e=t.title instanceof Function?t.title():t.title,i=t.subtitle instanceof Function?t.subtitle():t.subtitle;t.titleDOMFragment=this._makeHeaderFragment(e,i)}this._columns.push(t)}this._loadCustomColumnsAndSettings(),this._popoverHelper=new UI.PopoverHelper.PopoverHelper(this._networkLogView.element,this._getPopoverRequest.bind(this)),this._popoverHelper.setHasPadding(!0),this._popoverHelper.setTimeout(300,300),this._dataGrid=new DataGrid.SortableDataGrid.SortableDataGrid({displayName:i18nString(UIStrings.networkLog),columns:this._columns.map(NetworkLogViewColumns._convertToDataGridDescriptor),editCallback:void 0,deleteCallback:void 0,refreshCallback:void 0}),this._dataGrid.element.addEventListener("mousedown",(t=>{!this._dataGrid.selectedNode&&t.button&&t.consume()}),!0),this._dataGridScroller=this._dataGrid.scrollContainer,this._updateColumns(),this._dataGrid.addEventListener(DataGrid.DataGrid.Events.SortingChanged,this._sortHandler,this),this._dataGrid.setHeaderContextMenuCallback(this._innerHeaderContextMenu.bind(this)),this._activeWaterfallSortId=WaterfallSortIds.StartTime,this._dataGrid.markColumnAsSortedBy(_initialSortColumn,DataGrid.DataGrid.Order.Ascending),this._splitWidget=new UI.SplitWidget.SplitWidget(!0,!0,"networkPanelSplitViewWaterfall",200);const i=this._dataGrid.asWidget();i.setMinimumSize(150,0),this._splitWidget.setMainWidget(i)}_setupWaterfall(){this._waterfallColumn=new NetworkWaterfallColumn(this._networkLogView.calculator()),this._waterfallColumn.element.addEventListener("contextmenu",function(t){const e=t,i=this._waterfallColumn.getNodeFromPoint(e.offsetX,e.offsetY);if(!i)return;const o=i.request();if(!o)return;const r=new UI.ContextMenu.ContextMenu(e);this._networkLogView.handleContextMenuForRequest(r,o),r.show()}.bind(this)),this._waterfallColumn.element.addEventListener("wheel",this._onMouseWheel.bind(this,!1),{passive:!0}),this._waterfallColumn.element.addEventListener("touchstart",this._onTouchStart.bind(this)),this._waterfallColumn.element.addEventListener("touchmove",this._onTouchMove.bind(this)),this._waterfallColumn.element.addEventListener("touchend",this._onTouchEnd.bind(this)),this._dataGridScroller.addEventListener("wheel",this._onMouseWheel.bind(this,!0),!0),this._dataGridScroller.addEventListener("touchstart",this._onTouchStart.bind(this)),this._dataGridScroller.addEventListener("touchmove",this._onTouchMove.bind(this)),this._dataGridScroller.addEventListener("touchend",this._onTouchEnd.bind(this)),this._waterfallScroller=this._waterfallColumn.contentElement.createChild("div","network-waterfall-v-scroll"),this._waterfallScrollerContent=this._waterfallScroller.createChild("div","network-waterfall-v-scroll-content"),this._dataGrid.addEventListener(DataGrid.DataGrid.Events.PaddingChanged,(()=>{this._waterfallScrollerWidthIsStale=!0,this._syncScrollers()})),this._dataGrid.addEventListener(DataGrid.ViewportDataGrid.Events.ViewportCalculated,this._redrawWaterfallColumn.bind(this)),this._createWaterfallHeader(),this._waterfallColumn.contentElement.classList.add("network-waterfall-view"),this._waterfallColumn.setMinimumSize(100,0),this._splitWidget.setSidebarWidget(this._waterfallColumn),this.switchViewMode(!1)}_onMouseWheel(t,e){t&&e.consume(!0);const i=e,o=Date.now()-this._lastWheelTime<80;this._activeScroller.scrollBy({top:i.deltaY,behavior:o?"auto":"smooth"}),this._syncScrollers(),this._lastWheelTime=Date.now()}_onTouchStart(t){const e=t;this._hasScrollerTouchStarted=!0,this._scrollerTouchStartPos=e.changedTouches[0].pageY}_onTouchMove(t){if(!this._hasScrollerTouchStarted)return;const e=t.changedTouches[0].pageY,i=this._scrollerTouchStartPos-e;this._activeScroller.scrollBy({top:i,behavior:"auto"}),this._syncScrollers(),this._scrollerTouchStartPos=e}_onTouchEnd(){this._hasScrollerTouchStarted=!1}_syncScrollers(){this._waterfallColumn.isShowing()&&(this._waterfallScrollerContent.style.height=this._dataGridScroller.scrollHeight+"px",this._updateScrollerWidthIfNeeded(),this._dataGridScroller.scrollTop=this._waterfallScroller.scrollTop)}_updateScrollerWidthIfNeeded(){this._waterfallScrollerWidthIsStale&&(this._waterfallScrollerWidthIsStale=!1,this._waterfallColumn.setRightPadding(this._waterfallScroller.offsetWidth-this._waterfallScrollerContent.offsetWidth))}_redrawWaterfallColumn(){if(!this._waterfallRequestsAreStale)return this._updateScrollerWidthIfNeeded(),void this._waterfallColumn.update(this._activeScroller.scrollTop,this._eventDividersShown?this._eventDividers:void 0);this._syncScrollers();const t=this._networkLogView.flatNodesList();this._waterfallColumn.update(this._activeScroller.scrollTop,this._eventDividers,t)}_createWaterfallHeader(){this._waterfallHeaderElement=this._waterfallColumn.contentElement.createChild("div","network-waterfall-header"),this._waterfallHeaderElement.addEventListener("click",function(){const t=DataGrid.DataGrid.Order,e="waterfall"===this._dataGrid.sortColumnId(),i=this._dataGrid.isSortOrderAscending(),o=e&&i?t.Descending:t.Ascending;this._dataGrid.markColumnAsSortedBy("waterfall",o),this._sortHandler()}.bind(this)),this._waterfallHeaderElement.addEventListener("contextmenu",(t=>this._innerHeaderContextMenu(new UI.ContextMenu.ContextMenu(t))));this._waterfallHeaderElement.createChild("div").textContent=i18nString(UIStrings.waterfall),this._waterfallColumnSortIcon=UI.Icon.Icon.create("","sort-order-icon"),this._waterfallHeaderElement.createChild("div","sort-order-icon-container").appendChild(this._waterfallColumnSortIcon)}setCalculator(t){this._waterfallColumn.setCalculator(t)}scheduleRefresh(){this._waterfallColumn.scheduleDraw()}_updateRowsSize(){const t=Boolean(this._networkLogLargeRowsSetting.get());this._dataGrid.element.classList.toggle("small",!t),this._dataGrid.scheduleUpdate(),this._waterfallScrollerWidthIsStale=!0,this._waterfallColumn.setRowHeight(t?41:21),this._waterfallScroller.classList.toggle("small",!t),this._waterfallHeaderElement.classList.toggle("small",!t),window.requestAnimationFrame((()=>{this._waterfallColumn.setHeaderHeight(this._waterfallScroller.offsetTop)}))}show(t){this._splitWidget.show(t)}setHidden(t){UI.ARIAUtils.setHidden(this._splitWidget.element,t)}dataGrid(){return this._dataGrid}sortByCurrentColumn(){this._sortHandler()}_sortHandler(){const t=this._dataGrid.sortColumnId();if(this._networkLogView.removeAllNodeHighlights(),this._waterfallRequestsAreStale=!0,"waterfall"===t){this._dataGrid.sortOrder()===DataGrid.DataGrid.Order.Ascending?this._waterfallColumnSortIcon.setIconType("smallicon-triangle-up"):this._waterfallColumnSortIcon.setIconType("smallicon-triangle-down");const t=NetworkRequestNode.RequestPropertyComparator.bind(null,this._activeWaterfallSortId);return this._dataGrid.sortNodes(t,!this._dataGrid.isSortOrderAscending()),void this._dataGridSortedForTest()}this._waterfallColumnSortIcon.setIconType("");const e=this._columns.find((e=>e.id===t));if(!e||!e.sortingFunction)return;const i=e.sortingFunction;i&&(this._dataGrid.sortNodes(i,!this._dataGrid.isSortOrderAscending()),this._dataGridSortedForTest())}_dataGridSortedForTest(){}_updateColumns(){if(!this._dataGrid)return;const t=new Set;if(this._gridMode)for(const e of this._columns)e.visible&&t.add(e.id);else{const e=this._columns.find((t=>"path"===t.hideableGroup&&t.visible));e?t.add(e.id):t.add("name")}this._dataGrid.setColumnsVisiblity(t)}switchViewMode(t){this._gridMode!==t&&(this._gridMode=t,t?(this._splitWidget.showBoth(),this._activeScroller=this._waterfallScroller,this._waterfallScroller.scrollTop=this._dataGridScroller.scrollTop,this._dataGrid.setScrollContainer(this._waterfallScroller)):(this._networkLogView.removeAllNodeHighlights(),this._splitWidget.hideSidebar(),this._activeScroller=this._dataGridScroller,this._dataGrid.setScrollContainer(this._dataGridScroller)),this._networkLogView.element.classList.toggle("brief-mode",!t),this._updateColumns(),this._updateRowsSize())}_toggleColumnVisibility(t){this._loadCustomColumnsAndSettings(),t.visible=!t.visible,this._saveColumnsSettings(),this._updateColumns()}_saveColumnsSettings(){const t={};for(const e of this._columns)t[e.id]={visible:e.visible,title:e.title};this._persistantSettings.set(t)}_loadCustomColumnsAndSettings(){const t=this._persistantSettings.get(),e=Object.keys(t);for(const i of e){const e=t[i];let o=this._columns.find((t=>t.id===i));o||(o=this._addCustomHeader(e.title,i)||void 0),o&&o.hideable&&"boolean"===typeof e.visible&&(o.visible=Boolean(e.visible)),o&&"string"===typeof e.title&&(o.title=e.title)}}_makeHeaderFragment(t,e){const i=document.createDocumentFragment();UI.UIUtils.createTextChild(i,t);const o=i.createChild("div","network-header-subtitle");return UI.UIUtils.createTextChild(o,e),i}_innerHeaderContextMenu(t){const e=this._columns.filter((t=>t.hideable)),i=e.filter((t=>!t.isResponseHeader)),o=new Map,r=[];for(const c of i)if(c.hideableGroup){const t=c.hideableGroup;let e=o.get(t);e||(e=[],o.set(t,e)),e.push(c)}else r.push(c);for(const c of o.values()){const e=c.filter((t=>t.visible));for(const i of c){const o=1===e.length&&e[0]===i,r=i.title instanceof Function?i.title():i.title;t.headerSection().appendCheckboxItem(r,this._toggleColumnVisibility.bind(this,i),i.visible,o)}t.headerSection().appendSeparator()}for(const c of r){const e=c.title instanceof Function?c.title():c.title;t.headerSection().appendCheckboxItem(e,this._toggleColumnVisibility.bind(this,c),c.visible)}const n=t.footerSection().appendSubMenuItem(i18nString(UIStrings.responseHeaders)),s=e.filter((t=>t.isResponseHeader));for(const c of s){const t=c.title instanceof Function?c.title():c.title;n.defaultSection().appendCheckboxItem(t,this._toggleColumnVisibility.bind(this,c),c.visible)}n.footerSection().appendItem(i18nString(UIStrings.manageHeaderColumns),this._manageCustomHeaderDialog.bind(this));const a=WaterfallSortIds,l=t.footerSection().appendSubMenuItem(i18nString(UIStrings.waterfall));function d(t){let e=this._calculatorsMap.get(_calculatorTypes.Time);const i=WaterfallSortIds;t!==i.Duration&&t!==i.Latency||(e=this._calculatorsMap.get(_calculatorTypes.Duration)),this._networkLogView.setCalculator(e),this._activeWaterfallSortId=t,this._dataGrid.markColumnAsSortedBy("waterfall",DataGrid.DataGrid.Order.Ascending),this._sortHandler()}l.defaultSection().appendCheckboxItem(i18nString(UIStrings.startTime),d.bind(this,a.StartTime),this._activeWaterfallSortId===a.StartTime),l.defaultSection().appendCheckboxItem(i18nString(UIStrings.responseTime),d.bind(this,a.ResponseTime),this._activeWaterfallSortId===a.ResponseTime),l.defaultSection().appendCheckboxItem(i18nString(UIStrings.endTime),d.bind(this,a.EndTime),this._activeWaterfallSortId===a.EndTime),l.defaultSection().appendCheckboxItem(i18nString(UIStrings.totalDuration),d.bind(this,a.Duration),this._activeWaterfallSortId===a.Duration),l.defaultSection().appendCheckboxItem(i18nString(UIStrings.latency),d.bind(this,a.Latency),this._activeWaterfallSortId===a.Latency)}_manageCustomHeaderDialog(){const t=[];for(const o of this._columns){const e=o.title instanceof Function?o.title():o.title;o.isResponseHeader&&t.push({title:e,editable:o.isCustomHeader})}const e=new NetworkManageCustomHeadersView(t,(t=>Boolean(this._addCustomHeader(t))),this._changeCustomHeader.bind(this),this._removeCustomHeader.bind(this)),i=new UI.Dialog.Dialog;e.show(i.contentElement),i.setSizeBehavior(UI.GlassPane.SizeBehavior.MeasureContent),i.show(this._networkLogView.element)}_removeCustomHeader(t){t=t.toLowerCase();const e=this._columns.findIndex((e=>e.id===t));return-1!==e&&(this._columns.splice(e,1),this._dataGrid.removeColumn(t),this._saveColumnsSettings(),this._updateColumns(),!0)}_addCustomHeader(t,e,i){e||(e=t.toLowerCase()),void 0===i&&(i=this._columns.length-1);const o=this._columns.find((t=>t.id===e));if(o)return null;const r=Object.assign({},_defaultColumnConfig,{id:e,title:t,isResponseHeader:!0,isCustomHeader:!0,visible:!0,sortingFunction:NetworkRequestNode.ResponseHeaderStringComparator.bind(null,e)});return this._columns.splice(i,0,r),this._dataGrid&&this._dataGrid.addColumn(NetworkLogViewColumns._convertToDataGridDescriptor(r),i),this._saveColumnsSettings(),this._updateColumns(),r}_changeCustomHeader(t,e,i){i||(i=e.toLowerCase()),t=t.toLowerCase();const o=this._columns.findIndex((e=>e.id===t)),r=this._columns[o],n=this._columns.find((t=>t.id===i));return!(!r||n&&t!==i)&&(this._removeCustomHeader(t),this._addCustomHeader(e,i,o),!0)}_getPopoverRequest(t){if(!this._gridMode)return null;const e=this._networkLogView.hoveredNode();if(!e||!t.target)return null;const i=t.target.enclosingNodeOrSelfWithClass("network-script-initiated");if(!i)return null;const o=e.request();return o?{box:i.boxInWindow(),show:async t=>{this._popupLinkifier.setLiveLocationUpdateCallback((()=>{t.setSizeBehavior(UI.GlassPane.SizeBehavior.MeasureContent)}));const e=RequestInitiatorView.createStackTracePreview(o,this._popupLinkifier,!1);return!!e&&(t.contentElement.appendChild(e.element),!0)},hide:this._popupLinkifier.reset.bind(this._popupLinkifier)}:null}addEventDividers(t,e){let i="transparent";switch(e){case"network-dcl-divider":i="#0867CB";break;case"network-load-divider":i="#B31412";break;default:return}const o=this._eventDividers.get(i)||[];this._eventDividers.set(i,o.concat(t)),this._networkLogView.scheduleRefresh()}hideEventDividers(){this._eventDividersShown=!0,this._redrawWaterfallColumn()}showEventDividers(){this._eventDividersShown=!1,this._redrawWaterfallColumn()}selectFilmStripFrame(t){this._eventDividers.set(_filmStripDividerColor,[t]),this._redrawWaterfallColumn()}clearFilmStripFrame(){this._eventDividers.delete(_filmStripDividerColor),this._redrawWaterfallColumn()}}export const _initialSortColumn="waterfall";export var _calculatorTypes;!function(t){t.Duration="Duration",t.Time="Time"}(_calculatorTypes||(_calculatorTypes={}));export const _defaultColumnConfig={subtitle:null,visible:!1,weight:6,sortable:!0,hideable:!0,hideableGroup:null,nonSelectable:!1,isResponseHeader:!1,isCustomHeader:!1,allowInSortByEvenWhenHidden:!1};const _temporaryDefaultColumns=[{id:"name",title:i18nLazyString(UIStrings.name),subtitle:i18nLazyString(UIStrings.path),visible:!0,weight:20,hideable:!0,hideableGroup:"path",sortingFunction:NetworkRequestNode.NameComparator},{id:"path",title:i18nLazyString(UIStrings.path),hideable:!0,hideableGroup:"path",sortingFunction:NetworkRequestNode.RequestPropertyComparator.bind(null,"pathname")},{id:"url",title:i18nLazyString(UIStrings.url),hideable:!0,hideableGroup:"path",sortingFunction:NetworkRequestNode.RequestURLComparator},{id:"method",title:i18nLazyString(UIStrings.method),sortingFunction:NetworkRequestNode.RequestPropertyComparator.bind(null,"requestMethod")},{id:"status",title:i18nLazyString(UIStrings.status),visible:!0,subtitle:i18nLazyString(UIStrings.text),sortingFunction:NetworkRequestNode.RequestPropertyComparator.bind(null,"statusCode")},{id:"protocol",title:i18nLazyString(UIStrings.protocol),sortingFunction:NetworkRequestNode.RequestPropertyComparator.bind(null,"protocol")},{id:"scheme",title:i18nLazyString(UIStrings.scheme),sortingFunction:NetworkRequestNode.RequestPropertyComparator.bind(null,"scheme")},{id:"domain",title:i18nLazyString(UIStrings.domain),sortingFunction:NetworkRequestNode.RequestPropertyComparator.bind(null,"domain")},{id:"remoteaddress",title:i18nLazyString(UIStrings.remoteAddress),weight:10,align:DataGrid.DataGrid.Align.Right,sortingFunction:NetworkRequestNode.RemoteAddressComparator},{id:"remoteaddress-space",title:i18nLazyString(UIStrings.remoteAddressSpace),visible:!1,weight:10,sortingFunction:NetworkRequestNode.RemoteAddressSpaceComparator},{id:"type",title:i18nLazyString(UIStrings.type),visible:!0,sortingFunction:NetworkRequestNode.TypeComparator},{id:"initiator",title:i18nLazyString(UIStrings.initiator),visible:!0,weight:10,sortingFunction:NetworkRequestNode.InitiatorComparator},{id:"initiator-address-space",title:i18nLazyString(UIStrings.initiatorAddressSpace),visible:!1,weight:10,sortingFunction:NetworkRequestNode.InitiatorAddressSpaceComparator},{id:"cookies",title:i18nLazyString(UIStrings.cookies),align:DataGrid.DataGrid.Align.Right,sortingFunction:NetworkRequestNode.RequestCookiesCountComparator},{id:"setcookies",title:i18nLazyString(UIStrings.setCookies),align:DataGrid.DataGrid.Align.Right,sortingFunction:NetworkRequestNode.ResponseCookiesCountComparator},{id:"size",title:i18nLazyString(UIStrings.size),visible:!0,subtitle:i18nLazyString(UIStrings.content),align:DataGrid.DataGrid.Align.Right,sortingFunction:NetworkRequestNode.SizeComparator},{id:"time",title:i18nLazyString(UIStrings.time),visible:!0,subtitle:i18nLazyString(UIStrings.latency),align:DataGrid.DataGrid.Align.Right,sortingFunction:NetworkRequestNode.RequestPropertyComparator.bind(null,"duration")},{id:"priority",title:i18nLazyString(UIStrings.priority),sortingFunction:NetworkRequestNode.PriorityComparator},{id:"connectionid",title:i18nLazyString(UIStrings.connectionId),sortingFunction:NetworkRequestNode.RequestPropertyComparator.bind(null,"connectionId")},{id:"cache-control",isResponseHeader:!0,title:i18nLazyString(UIStrings.cachecontrol),sortingFunction:NetworkRequestNode.ResponseHeaderStringComparator.bind(null,"cache-control")},{id:"connection",isResponseHeader:!0,title:i18nLazyString(UIStrings.s,{PH1:"Connection"}),sortingFunction:NetworkRequestNode.ResponseHeaderStringComparator.bind(null,"connection")},{id:"content-encoding",isResponseHeader:!0,title:i18nLazyString(UIStrings.contentencoding),sortingFunction:NetworkRequestNode.ResponseHeaderStringComparator.bind(null,"content-encoding")},{id:"content-length",isResponseHeader:!0,title:i18nLazyString(UIStrings.contentlength),align:DataGrid.DataGrid.Align.Right,sortingFunction:NetworkRequestNode.ResponseHeaderNumberComparator.bind(null,"content-length")},{id:"etag",isResponseHeader:!0,title:i18nLazyString(UIStrings.etag),sortingFunction:NetworkRequestNode.ResponseHeaderStringComparator.bind(null,"etag")},{id:"keep-alive",isResponseHeader:!0,title:i18nLazyString(UIStrings.keepalive),sortingFunction:NetworkRequestNode.ResponseHeaderStringComparator.bind(null,"keep-alive")},{id:"last-modified",isResponseHeader:!0,title:i18nLazyString(UIStrings.lastmodified),sortingFunction:NetworkRequestNode.ResponseHeaderDateComparator.bind(null,"last-modified")},{id:"server",isResponseHeader:!0,title:i18nLazyString(UIStrings.server),sortingFunction:NetworkRequestNode.ResponseHeaderStringComparator.bind(null,"server")},{id:"vary",isResponseHeader:!0,title:i18nLazyString(UIStrings.vary),sortingFunction:NetworkRequestNode.ResponseHeaderStringComparator.bind(null,"vary")},{id:"waterfall",title:i18nLazyString(UIStrings.waterfall),visible:!1,hideable:!1,allowInSortByEvenWhenHidden:!0}],_defaultColumns=_temporaryDefaultColumns;export const _filmStripDividerColor="#fccc49";export var WaterfallSortIds;!function(t){t.StartTime="startTime",t.ResponseTime="responseReceivedTime",t.EndTime="endTime",t.Duration="duration",t.Latency="latency"}(WaterfallSortIds||(WaterfallSortIds={}));