import*as Common from"../common/common.js";import*as CookieTable from"../cookie_table/cookie_table.js";import*as i18n from"../i18n/i18n.js";import*as SDK from"../sdk/sdk.js";import*as UI from"../ui/ui.js";const UIStrings={thisRequestHasNoCookies:"This request has no cookies.",requestCookies:"Request Cookies",cookiesThatWereSentToTheServerIn:"Cookies that were sent to the server in the 'cookie' header of the request",showFilteredOutRequestCookies:"show filtered out request cookies",noRequestCookiesWereSent:"No request cookies were sent.",responseCookies:"Response Cookies",cookiesThatWereReceivedFromThe:"Cookies that were received from the server in the '`set-cookie`' header of the response",malformedResponseCookies:"Malformed Response Cookies",cookiesThatWereReceivedFromTheServer:"Cookies that were received from the server in the '`set-cookie`' header of the response but were malformed"},str_=i18n.i18n.registerUIStrings("network/RequestCookiesView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class RequestCookiesView extends UI.Widget.Widget{constructor(e){super(),this.registerRequiredCSS("network/requestCookiesView.css",{enableLegacyPatching:!1}),this.element.classList.add("request-cookies-view"),this._request=e,this._showFilteredOutCookiesSetting=Common.Settings.Settings.instance().createSetting("show-filtered-out-request-cookies",!1),this._emptyWidget=new UI.EmptyWidget.EmptyWidget(i18nString(UIStrings.thisRequestHasNoCookies)),this._emptyWidget.show(this.element),this._requestCookiesTitle=this.element.createChild("div");const s=this._requestCookiesTitle.createChild("span","request-cookies-title");s.textContent=i18nString(UIStrings.requestCookies),UI.Tooltip.Tooltip.install(s,i18nString(UIStrings.cookiesThatWereSentToTheServerIn));const o=UI.SettingsUI.createSettingCheckbox(i18nString(UIStrings.showFilteredOutRequestCookies),this._showFilteredOutCookiesSetting,!0);o.checkboxElement.addEventListener("change",(()=>{this._refreshRequestCookiesView()})),this._requestCookiesTitle.appendChild(o),this._requestCookiesEmpty=this.element.createChild("div","cookies-panel-item"),this._requestCookiesEmpty.textContent=i18nString(UIStrings.noRequestCookiesWereSent),this._requestCookiesTable=new CookieTable.CookiesTable.CookiesTable(!0),this._requestCookiesTable.contentElement.classList.add("cookie-table","cookies-panel-item"),this._requestCookiesTable.show(this.element),this._responseCookiesTitle=this.element.createChild("div","request-cookies-title"),this._responseCookiesTitle.textContent=i18nString(UIStrings.responseCookies),this._responseCookiesTitle.title=i18nString(UIStrings.cookiesThatWereReceivedFromThe),this._responseCookiesTable=new CookieTable.CookiesTable.CookiesTable(!0),this._responseCookiesTable.contentElement.classList.add("cookie-table","cookies-panel-item"),this._responseCookiesTable.show(this.element),this._malformedResponseCookiesTitle=this.element.createChild("div","request-cookies-title"),this._malformedResponseCookiesTitle.textContent=i18nString(UIStrings.malformedResponseCookies),UI.Tooltip.Tooltip.install(this._malformedResponseCookiesTitle,i18nString(UIStrings.cookiesThatWereReceivedFromTheServer)),this._malformedResponseCookiesList=this.element.createChild("div")}_getRequestCookies(){const e=new Map,s=this._request.includedRequestCookies().slice();if(this._showFilteredOutCookiesSetting.get())for(const o of this._request.blockedRequestCookies())e.set(o.cookie,o.blockedReasons.map((e=>({attribute:SDK.NetworkRequest.cookieBlockedReasonToAttribute(e),uiString:SDK.NetworkRequest.cookieBlockedReasonToUiString(e)})))),s.push(o.cookie);return{requestCookies:s,requestCookieToBlockedReasons:e}}_getResponseCookies(){let e=[];const s=new Map,o=[];if(this._request.responseCookies.length){const t=this._request.blockedResponseCookies().map((e=>e.cookieLine));e=this._request.responseCookies.filter((e=>{const s=t.indexOf(e.getCookieLine());return-1===s||(t[s]=null,!1)}));for(const i of this._request.blockedResponseCookies()){const t=SDK.CookieParser.CookieParser.parseSetCookie(i.cookieLine);if(t&&!t.length||i.blockedReasons.includes(Protocol.Network.SetCookieBlockedReason.SyntaxError)){o.push(i);continue}let r=i.cookie;!r&&t&&(r=t[0]),r&&(s.set(r,i.blockedReasons.map((e=>({attribute:SDK.NetworkRequest.setCookieBlockedReasonToAttribute(e),uiString:SDK.NetworkRequest.setCookieBlockedReasonToUiString(e)})))),e.push(r))}}return{responseCookies:e,responseCookieToBlockedReasons:s,malformedResponseCookies:o}}_refreshRequestCookiesView(){if(!this.isShowing())return;this._request.hasRequestCookies()||this._request.responseCookies.length?this._emptyWidget.hideWidget():this._emptyWidget.showWidget();const{requestCookies:e,requestCookieToBlockedReasons:s}=this._getRequestCookies(),{responseCookies:o,responseCookieToBlockedReasons:t,malformedResponseCookies:i}=this._getResponseCookies();if(e.length?(this._requestCookiesTitle.classList.remove("hidden"),this._requestCookiesEmpty.classList.add("hidden"),this._requestCookiesTable.showWidget(),this._requestCookiesTable.setCookies(e,s)):this._request.blockedRequestCookies().length?(this._requestCookiesTitle.classList.remove("hidden"),this._requestCookiesEmpty.classList.remove("hidden"),this._requestCookiesTable.hideWidget()):(this._requestCookiesTitle.classList.add("hidden"),this._requestCookiesEmpty.classList.add("hidden"),this._requestCookiesTable.hideWidget()),o.length?(this._responseCookiesTitle.classList.remove("hidden"),this._responseCookiesTable.showWidget(),this._responseCookiesTable.setCookies(o,t)):(this._responseCookiesTitle.classList.add("hidden"),this._responseCookiesTable.hideWidget()),i.length){this._malformedResponseCookiesTitle.classList.remove("hidden"),this._malformedResponseCookiesList.classList.remove("hidden"),this._malformedResponseCookiesList.removeChildren();for(const e of i){const s=this._malformedResponseCookiesList.createChild("span","cookie-line source-code"),o=UI.Icon.Icon.create("smallicon-error","cookie-warning-icon");s.appendChild(o),UI.UIUtils.createTextChild(s,e.cookieLine),s.title=SDK.NetworkRequest.setCookieBlockedReasonToUiString(Protocol.Network.SetCookieBlockedReason.SyntaxError)}}else this._malformedResponseCookiesTitle.classList.add("hidden"),this._malformedResponseCookiesList.classList.add("hidden")}wasShown(){this._request.addEventListener(SDK.NetworkRequest.Events.RequestHeadersChanged,this._refreshRequestCookiesView,this),this._request.addEventListener(SDK.NetworkRequest.Events.ResponseHeadersChanged,this._refreshRequestCookiesView,this),this._refreshRequestCookiesView()}willHide(){this._request.removeEventListener(SDK.NetworkRequest.Events.RequestHeadersChanged,this._refreshRequestCookiesView,this),this._request.removeEventListener(SDK.NetworkRequest.Events.ResponseHeadersChanged,this._refreshRequestCookiesView,this)}}