import*as Common from"../common/common.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as ObjectUI from"../object_ui/object_ui.js";import*as SDK from"../sdk/sdk.js";import*as UI from"../ui/ui.js";import{Events}from"./NetworkTimeCalculator.js";const UIStrings={receivingPush:"Receiving `Push`",queueing:"Queueing",stalled:"Stalled",initialConnection:"Initial connection",dnsLookup:"DNS Lookup",proxyNegotiation:"Proxy negotiation",readingPush:"Reading `Push`",contentDownload:"Content Download",requestSent:"Request sent",requestToServiceworker:"Request to `ServiceWorker`",startup:"Startup",respondwith:"respondWith",ssl:"SSL",total:"Total",waitingTtfb:"Waiting (TTFB)",label:"Label",waterfall:"Waterfall",duration:"Duration",queuedAtS:"Queued at {PH1}",startedAtS:"Started at {PH1}",serverPush:"Server Push",resourceScheduling:"Resource Scheduling",connectionStart:"Connection Start",requestresponse:"Request/Response",cautionRequestIsNotFinishedYet:"CAUTION: request is not finished yet!",explanation:"Explanation",serverTiming:"Server Timing",time:"TIME",theServerTimingApi:"the Server Timing API",duringDevelopmentYouCanUseSToAdd:"During development, you can use {PH1} to add insights into the server-side timing of this request.",durationC:"DURATION",originalRequest:"Original Request",responseReceived:"Response Received",unknown:"Unknown",sourceOfResponseS:"Source of response: {PH1}",cacheStorageCacheNameS:"Cache storage cache name: {PH1}",cacheStorageCacheNameUnknown:"Cache storage cache name: Unknown",retrievalTimeS:"Retrieval Time: {PH1}",serviceworkerCacheStorage:"`ServiceWorker` cache storage",fromHttpCache:"From HTTP cache",networkFetch:"Network fetch",fallbackCode:"Fallback code"},str_=i18n.i18n.registerUIStrings("network/RequestTimingView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class RequestTimingView extends UI.Widget.VBox{constructor(e,t){super(),this.element.classList.add("resource-timing-view"),this._request=e,this._calculator=t}static _timeRangeTitle(e){switch(e){case RequestTimeRangeNames.Push:return i18nString(UIStrings.receivingPush);case RequestTimeRangeNames.Queueing:return i18nString(UIStrings.queueing);case RequestTimeRangeNames.Blocking:return i18nString(UIStrings.stalled);case RequestTimeRangeNames.Connecting:return i18nString(UIStrings.initialConnection);case RequestTimeRangeNames.DNS:return i18nString(UIStrings.dnsLookup);case RequestTimeRangeNames.Proxy:return i18nString(UIStrings.proxyNegotiation);case RequestTimeRangeNames.ReceivingPush:return i18nString(UIStrings.readingPush);case RequestTimeRangeNames.Receiving:return i18nString(UIStrings.contentDownload);case RequestTimeRangeNames.Sending:return i18nString(UIStrings.requestSent);case RequestTimeRangeNames.ServiceWorker:return i18nString(UIStrings.requestToServiceworker);case RequestTimeRangeNames.ServiceWorkerPreparation:return i18nString(UIStrings.startup);case RequestTimeRangeNames.ServiceWorkerRespondWith:return i18nString(UIStrings.respondwith);case RequestTimeRangeNames.SSL:return i18nString(UIStrings.ssl);case RequestTimeRangeNames.Total:return i18nString(UIStrings.total);case RequestTimeRangeNames.Waiting:return i18nString(UIStrings.waitingTtfb);default:return e}}static calculateRequestTimeRanges(e,t){const i=[];function n(e,t,n){t<Number.MAX_VALUE&&t<=n&&i.push({name:e,start:t,end:n})}function r(e){for(let t=0;t<e.length;++t)if(e[t]>0)return e[t]}function s(e,t,i){t>=0&&i>=0&&n(e,c+t/1e3,c+i/1e3)}const a=e.timing;if(!a){const t=-1!==e.issueTime()?e.issueTime():-1!==e.startTime?e.startTime:0,r=-1===e.responseReceivedTime?Number.MAX_VALUE:e.responseReceivedTime,s=-1===e.endTime?Number.MAX_VALUE:e.endTime;return n(RequestTimeRangeNames.Total,t,s),n(RequestTimeRangeNames.Blocking,t,r),n(RequestTimeRangeNames.Receiving,r,s),i}const o=e.issueTime(),c=a.requestTime,l=r([e.endTime,e.responseReceivedTime])||c;if(n(RequestTimeRangeNames.Total,o<c?o:c,l),a.pushStart){const e=a.pushEnd||l;e>t&&n(RequestTimeRangeNames.Push,Math.max(a.pushStart,t),e)}o<c&&n(RequestTimeRangeNames.Queueing,o,c);const g=1e3*(e.responseReceivedTime-c);if(e.fetchedViaServiceWorker)s(RequestTimeRangeNames.Blocking,0,a.workerStart),s(RequestTimeRangeNames.ServiceWorkerPreparation,a.workerStart,a.workerReady),s(RequestTimeRangeNames.ServiceWorkerRespondWith,a.workerFetchStart,a.workerRespondWithSettled),s(RequestTimeRangeNames.ServiceWorker,a.workerReady,a.sendEnd),s(RequestTimeRangeNames.Waiting,a.sendEnd,g);else if(!a.pushStart){const e=r([a.dnsStart,a.connectStart,a.sendStart,g])||0;s(RequestTimeRangeNames.Blocking,0,e),s(RequestTimeRangeNames.Proxy,a.proxyStart,a.proxyEnd),s(RequestTimeRangeNames.DNS,a.dnsStart,a.dnsEnd),s(RequestTimeRangeNames.Connecting,a.connectStart,a.connectEnd),s(RequestTimeRangeNames.SSL,a.sslStart,a.sslEnd),s(RequestTimeRangeNames.Sending,a.sendStart,a.sendEnd),s(RequestTimeRangeNames.Waiting,Math.max(a.sendEnd,a.connectEnd,a.dnsEnd,a.proxyEnd,e),g)}return-1!==e.endTime&&n(a.pushStart?RequestTimeRangeNames.ReceivingPush:RequestTimeRangeNames.Receiving,e.responseReceivedTime,l),i}static createTimingTable(e,t){const i=document.createElement("table");i.classList.add("network-timing-table"),UI.Utils.appendStyle(i,"network/networkTimingTable.css",{enableLegacyPatching:!0});const n=i.createChild("colgroup");n.createChild("col","labels"),n.createChild("col","bars"),n.createChild("col","duration");const r=RequestTimingView.calculateRequestTimeRanges(e,t.minimumBoundary()),s=r.map((e=>e.start)).reduce(((e,t)=>Math.min(e,t))),a=r.map((e=>e.end)).reduce(((e,t)=>Math.max(e,t))),o=100/(a-s);let c,l,g,d,m=0;const u=i.createChild("thead","network-timing-start"),h=u.createChild("tr"),S=h.createChild("th");S.createChild("span","network-timing-hidden-header").textContent=i18nString(UIStrings.label),S.scope="col";const R=h.createChild("th");R.createChild("span","network-timing-hidden-header").textContent=i18nString(UIStrings.waterfall),R.scope="col";const T=h.createChild("th");T.createChild("span","network-timing-hidden-header").textContent=i18nString(UIStrings.duration),T.scope="col";const p=u.createChild("tr").createChild("td"),C=u.createChild("tr").createChild("td");let k;p.colSpan=C.colSpan=3,UI.UIUtils.createTextChild(p,i18nString(UIStrings.queuedAtS,{PH1:t.formatValue(e.issueTime(),2)})),UI.UIUtils.createTextChild(C,i18nString(UIStrings.startedAtS,{PH1:t.formatValue(e.startTime,2)}));for(let E=0;E<r.length;++E){const e=r[E],n=e.name;if(n===RequestTimeRangeNames.Total){m=e.end-e.start;continue}n===RequestTimeRangeNames.Push?b(i18nString(UIStrings.serverPush)):n===RequestTimeRangeNames.Queueing?d||(d=b(i18nString(UIStrings.resourceScheduling))):ConnectionSetupRangeNames.has(n)?c||(c=b(i18nString(UIStrings.connectionStart))):ServiceWorkerRangeNames.has(n)?l||(l=b("Service Worker")):g||(g=b(i18nString(UIStrings.requestresponse)));const u=o*(e.start-s);k=o*(a-e.end);const h=e.end-e.start,S=i.createChild("tr"),R=S.createChild("td");UI.UIUtils.createTextChild(R,RequestTimingView._timeRangeTitle(n));const T=S.createChild("td").createChild("div","network-timing-row"),p=T.createChild("span","network-timing-bar "+n);p.style.left=u+"%",p.style.right=k+"%",p.textContent="\u200b",UI.ARIAUtils.setAccessibleName(T,i18nString(UIStrings.startedAtS,{PH1:t.formatValue(e.start,2)}));S.createChild("td").createChild("div","network-timing-bar-title").textContent=Number.secondsToString(h,!0),"serviceworker-respondwith"===e.name&&(R.classList.add("network-fetch-timing-bar-clickable"),i.createChild("tr","network-fetch-timing-bar-details"),R.setAttribute("tabindex","0"),R.setAttribute("role","switch"),UI.ARIAUtils.setChecked(R,!1))}if(!e.finished){const e=i.createChild("tr").createChild("td","caution");e.colSpan=3,UI.UIUtils.createTextChild(e,i18nString(UIStrings.cautionRequestIsNotFinishedYet))}const w=i.createChild("tr","network-timing-footer"),U=w.createChild("td");U.colSpan=1,U.appendChild(UI.XLink.XLink.create("https://developers.google.com/web/tools/chrome-devtools/network/reference#timing-explanation",i18nString(UIStrings.explanation))),w.createChild("td"),UI.UIUtils.createTextChild(w.createChild("td"),Number.secondsToString(m,!0));const v=e.serverTimings,q=void 0===k?100:k,I=i.createChild("tr","network-timing-table-header").createChild("td");I.colSpan=3,I.createChild("hr","break");const N=i.createChild("tr","network-timing-table-header");if(UI.UIUtils.createTextChild(N.createChild("td"),i18nString(UIStrings.serverTiming)),N.createChild("td"),UI.UIUtils.createTextChild(N.createChild("td"),i18nString(UIStrings.time)),!v){const e=i.createChild("tr").createChild("td");e.colSpan=3;const t=UI.XLink.XLink.create("https://web.dev/custom-metrics/#server-timing-api",i18nString(UIStrings.theServerTimingApi));return e.appendChild(i18n.i18n.getFormatLocalizedString(str_,UIStrings.duringDevelopmentYouCanUseSToAdd,{PH1:t})),i}return v.filter((e=>"total"!==e.metric.toLowerCase())).forEach((e=>f(e,q))),v.filter((e=>"total"===e.metric.toLowerCase())).forEach((e=>f(e,q))),i;function f(e,t){const n=new Common.Color.Generator({min:0,max:360,count:36},{min:50,max:80,count:void 0},80),r="total"===e.metric.toLowerCase(),c=i.createChild("tr",r?"network-timing-footer":""),l=c.createChild("td","network-timing-metric"),g=e.description||e.metric;UI.UIUtils.createTextChild(l,g),UI.Tooltip.Tooltip.install(l,g);const d=c.createChild("td").createChild("div","network-timing-row");if(null===e.value)return;const m=o*(a-s-e.value/1e3);if(m>=0){const i=d.createChild("span","network-timing-bar server-timing");i.style.left=m+"%",i.style.right=t+"%",i.textContent="\u200b",r||(i.style.backgroundColor=n.colorForID(e.metric))}c.createChild("td").createChild("div","network-timing-bar-title").textContent=Number.millisToString(e.value,!0)}function b(e){const t=i.createChild("tr","network-timing-table-header"),n=t.createChild("td");return UI.UIUtils.createTextChild(n,e),UI.ARIAUtils.markAsHeading(n,2),UI.UIUtils.createTextChild(t.createChild("td"),""),UI.UIUtils.createTextChild(t.createChild("td"),i18nString(UIStrings.durationC)),t}}_constructFetchDetailsView(){if(!this._tableElement)return;const e=this._tableElement.ownerDocument,t=e.querySelector(".network-fetch-timing-bar-details");if(!t)return;t.classList.add("network-fetch-timing-bar-details-collapsed"),self.onInvokeElement(this._tableElement,this._onToggleFetchDetails.bind(this,t));const i=new UI.TreeOutline.TreeOutlineInShadow;t.appendChild(i.element);const n=SDK.NetworkLog.NetworkLog.instance().originalRequestForURL(this._request.url());if(n){const e=SDK.RemoteObject.RemoteObject.fromLocalObject(n),t=new ObjectUI.ObjectPropertiesSection.RootElement(e);t.title=i18nString(UIStrings.originalRequest),i.appendChild(t)}const r=SDK.NetworkLog.NetworkLog.instance().originalResponseForURL(this._request.url());if(r){const e=SDK.RemoteObject.RemoteObject.fromLocalObject(r),t=new ObjectUI.ObjectPropertiesSection.RootElement(e);t.title=i18nString(UIStrings.responseReceived),i.appendChild(t)}const s=e.createElementWithClass("div","network-fetch-details-treeitem");let a=i18nString(UIStrings.unknown);const o=this._request.serviceWorkerResponseSource();o&&(a=this._getLocalizedResponseSourceForCode(o)),s.textContent=i18nString(UIStrings.sourceOfResponseS,{PH1:a});const c=new UI.TreeOutline.TreeElement(s);i.appendChild(c);const l=e.createElementWithClass("div","network-fetch-details-treeitem"),g=this._request.getResponseCacheStorageCacheName();l.textContent=g?i18nString(UIStrings.cacheStorageCacheNameS,{PH1:g}):i18nString(UIStrings.cacheStorageCacheNameUnknown);const d=new UI.TreeOutline.TreeElement(l);i.appendChild(d);const m=this._request.getResponseRetrievalTime();if(m){const t=e.createElementWithClass("div","network-fetch-details-treeitem");t.textContent=i18nString(UIStrings.retrievalTimeS,{PH1:m});const n=new UI.TreeOutline.TreeElement(t);i.appendChild(n)}}_getLocalizedResponseSourceForCode(e){switch(e){case Protocol.Network.ServiceWorkerResponseSource.CacheStorage:return i18nString(UIStrings.serviceworkerCacheStorage);case Protocol.Network.ServiceWorkerResponseSource.HttpCache:return i18nString(UIStrings.fromHttpCache);case Protocol.Network.ServiceWorkerResponseSource.Network:return i18nString(UIStrings.networkFetch);default:return i18nString(UIStrings.fallbackCode)}}_onToggleFetchDetails(e,t){if(!t.target)return;const i=t.target;if(i.classList.contains("network-fetch-timing-bar-clickable")){e.classList.contains("network-fetch-timing-bar-details-collapsed")&&Host.userMetrics.actionTaken(Host.UserMetrics.Action.NetworkPanelServiceWorkerRespondWith);const t="true"===i.getAttribute("aria-checked");i.setAttribute("aria-checked",String(!t)),e.classList.toggle("network-fetch-timing-bar-details-collapsed"),e.classList.toggle("network-fetch-timing-bar-details-expanded")}}wasShown(){this._request.addEventListener(SDK.NetworkRequest.Events.TimingChanged,this._refresh,this),this._request.addEventListener(SDK.NetworkRequest.Events.FinishedLoading,this._refresh,this),this._calculator.addEventListener(Events.BoundariesChanged,this._refresh,this),this._refresh()}willHide(){this._request.removeEventListener(SDK.NetworkRequest.Events.TimingChanged,this._refresh,this),this._request.removeEventListener(SDK.NetworkRequest.Events.FinishedLoading,this._refresh,this),this._calculator.removeEventListener(Events.BoundariesChanged,this._refresh,this)}_refresh(){this._tableElement&&this._tableElement.remove(),this._tableElement=RequestTimingView.createTimingTable(this._request,this._calculator),this._tableElement.classList.add("resource-timing-table"),this.element.appendChild(this._tableElement),this._request.fetchedViaServiceWorker&&this._constructFetchDetailsView()}}export var RequestTimeRangeNames;!function(e){e.Push="push",e.Queueing="queueing",e.Blocking="blocking",e.Connecting="connecting",e.DNS="dns",e.Proxy="proxy",e.Receiving="receiving",e.ReceivingPush="receiving-push",e.Sending="sending",e.ServiceWorker="serviceworker",e.ServiceWorkerPreparation="serviceworker-preparation",e.ServiceWorkerRespondWith="serviceworker-respondwith",e.SSL="ssl",e.Total="total",e.Waiting="waiting"}(RequestTimeRangeNames||(RequestTimeRangeNames={}));export const ServiceWorkerRangeNames=new Set([RequestTimeRangeNames.ServiceWorker,RequestTimeRangeNames.ServiceWorkerPreparation,RequestTimeRangeNames.ServiceWorkerRespondWith]);export const ConnectionSetupRangeNames=new Set([RequestTimeRangeNames.Queueing,RequestTimeRangeNames.Blocking,RequestTimeRangeNames.Connecting,RequestTimeRangeNames.DNS,RequestTimeRangeNames.Proxy,RequestTimeRangeNames.SSL]);