import*as Common from"../common/common.js";import*as Components from"../components/components.js";import*as i18n from"../i18n/i18n.js";import*as PerfUI from"../perf_ui/perf_ui.js";import*as Platform from"../platform/platform.js";import*as Root from"../root/root.js";import*as SDK from"../sdk/sdk.js";import*as UI from"../ui/ui.js";import{ProfileFlameChartDataProvider}from"./CPUProfileFlameChart.js";import{HeapTimelineOverview,IdsRangeChanged}from"./HeapTimelineOverview.js";import{ProfileType,ProfileEvents}from"./ProfileHeader.js";import{ProfileView,WritableProfileHeader}from"./ProfileView.js";const UIStrings={selectedSizeS:"Selected size: {PH1}",selfSizeBytes:"Self Size (bytes)",totalSizeBytes:"Total Size (bytes)",stopHeapProfiling:"Stop heap profiling",startHeapProfiling:"Start heap profiling",recording:"Recording\u2026",heapProfilerIsRecording:"Heap profiler is recording",stopping:"Stopping\u2026",allocationSampling:"Allocation sampling",samplingProfiles:"SAMPLING PROFILES",recordMemoryAllocations:"Record memory allocations using sampling method.",thisProfileTypeHasMinimal:"This profile type has minimal performance overhead and can be used for long running operations.",itProvidesGoodApproximation:"It provides good approximation of allocations broken down by `JavaScript` execution stack.",profileD:"Profile {PH1}",sBytes:"{PH1} bytes",formatPercent:"{PH1}\xa0%",skb:"{PH1}\xa0kB",name:"Name",selfSize:"Self size",totalSize:"Total size",url:"URL"},str_=i18n.i18n.registerUIStrings("profiler/HeapProfileView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);function convertToSamplingHeapProfile(e){return e._profile||e.protocolProfile()}export class HeapProfileView extends ProfileView{constructor(e){super(),this.profileHeader=e,this._profileType=e.profileType(),this.initialize(new NodeFormatter(this));const i=new SamplingHeapProfileModel(convertToSamplingHeapProfile(e));this.adjustedTotal=i.total,this.setProfile(i),this._selectedSizeText=new UI.Toolbar.ToolbarText,this._timestamps=[],this._sizes=[],this._max=[],this._ordinals=[],this._totalTime=0,this._lastOrdinal=0,this._timelineOverview=new HeapTimelineOverview,Root.Runtime.experiments.isEnabled("samplingHeapProfilerTimeline")&&(this._timelineOverview.addEventListener(IdsRangeChanged,this._onIdsRangeChanged.bind(this)),this._timelineOverview.show(this.element,this.element.firstChild),this._timelineOverview.start(),this._profileType.addEventListener("StatsUpdate",this._onStatsUpdate,this),this._profileType.once(ProfileEvents.ProfileComplete).then((()=>{this._profileType.removeEventListener("StatsUpdate",this._onStatsUpdate,this),this._timelineOverview.stop(),this._timelineOverview.updateGrid()})))}async toolbarItems(){return[...await super.toolbarItems(),this._selectedSizeText]}_onIdsRangeChanged(e){const i=e.data.minId,t=e.data.maxId;this._selectedSizeText.setText(i18nString(UIStrings.selectedSizeS,{PH1:Platform.NumberUtilities.bytesToString(e.data.size)})),this._setSelectionRange(i,t)}_setSelectionRange(e,i){const t=convertToSamplingHeapProfile(this.profileHeader),r=new SamplingHeapProfileModel(t,e,i);this.adjustedTotal=r.total,this.setProfile(r)}_onStatsUpdate(e){const i=e.data;this._totalTime||(this._timestamps=[],this._sizes=[],this._max=[],this._ordinals=[],this._totalTime=3e4,this._lastOrdinal=0),this._sizes.fill(0),this._sizes.push(0),this._timestamps.push(Date.now()),this._ordinals.push(this._lastOrdinal+1);for(const r of i.samples){this._lastOrdinal=Math.max(this._lastOrdinal,r.ordinal);const e=Platform.ArrayUtilities.upperBound(this._ordinals,r.ordinal,Platform.ArrayUtilities.DEFAULT_COMPARATOR)-1;this._sizes[e]+=r.size}this._max.push(this._sizes[this._sizes.length-1]);this._timestamps[this._timestamps.length-1]-this._timestamps[0]>this._totalTime&&(this._totalTime*=2);const t={sizes:this._sizes,max:this._max,ids:this._ordinals,timestamps:this._timestamps,totalTime:this._totalTime};this._timelineOverview.setSamples(t)}columnHeader(e){switch(e){case"self":return i18nString(UIStrings.selfSizeBytes);case"total":return i18nString(UIStrings.totalSizeBytes)}return Common.UIString.LocalizedEmptyString}createFlameChartDataProvider(){return new HeapFlameChartDataProvider(this.profile(),this.profileHeader.heapProfilerModel())}}export class SamplingHeapProfileTypeBase extends ProfileType{constructor(e,i){super(e,i),this._recording=!1}profileBeingRecorded(){return super.profileBeingRecorded()}typeName(){return"Heap"}fileExtension(){return".heapprofile"}get buttonTooltip(){return this._recording?i18nString(UIStrings.stopHeapProfiling):i18nString(UIStrings.startHeapProfiling)}buttonClicked(){return this._recording?this._stopRecordingProfile():this._startRecordingProfile(),this._recording}_startRecordingProfile(){const e=UI.Context.Context.instance().flavor(SDK.HeapProfilerModel.HeapProfilerModel);if(this.profileBeingRecorded()||!e)return;const i=new SamplingHeapProfileHeader(e,this);this.setProfileBeingRecorded(i),this.addProfile(i),i.updateStatus(i18nString(UIStrings.recording));const t=UI.Icon.Icon.create("smallicon-warning");UI.Tooltip.Tooltip.install(t,i18nString(UIStrings.heapProfilerIsRecording)),UI.InspectorView.InspectorView.instance().setPanelIcon("heap_profiler",t),this._recording=!0,this._startSampling()}async _stopRecordingProfile(){this._recording=!1;const e=this.profileBeingRecorded();if(!e||!e.heapProfilerModel())return;e.updateStatus(i18nString(UIStrings.stopping));const i=await this._stopSampling();e&&(console.assert(void 0!==i),e.setProtocolProfile(i),e.updateStatus(""),this.setProfileBeingRecorded(null)),UI.InspectorView.InspectorView.instance().setPanelIcon("heap_profiler",null),this.dispatchEventToListeners(ProfileEvents.ProfileComplete,e)}createProfileLoadedFromFile(e){return new SamplingHeapProfileHeader(null,this,e)}profileBeingRecordedRemoved(){this._stopRecordingProfile()}_startSampling(){throw"Not implemented"}_stopSampling(){throw"Not implemented"}}let samplingHeapProfileTypeInstance;export class SamplingHeapProfileType extends SamplingHeapProfileTypeBase{constructor(){super(SamplingHeapProfileType.TypeId,i18nString(UIStrings.allocationSampling)),samplingHeapProfileTypeInstance||(samplingHeapProfileTypeInstance=this),this._updateTimer=0,this._updateIntervalMs=200}static get instance(){return samplingHeapProfileTypeInstance}get treeItemTitle(){return i18nString(UIStrings.samplingProfiles)}get description(){return[i18nString(UIStrings.recordMemoryAllocations),i18nString(UIStrings.thisProfileTypeHasMinimal),i18nString(UIStrings.itProvidesGoodApproximation)].join("\n")}hasTemporaryView(){return Root.Runtime.experiments.isEnabled("samplingHeapProfilerTimeline")}_startSampling(){const e=this._obtainRecordingProfile();e&&(e.startSampling(),Root.Runtime.experiments.isEnabled("samplingHeapProfilerTimeline")&&(this._updateTimer=window.setTimeout((()=>{this._updateStats()}),this._updateIntervalMs)))}_obtainRecordingProfile(){const e=this.profileBeingRecorded();if(e){return e.heapProfilerModel()}return null}async _stopSampling(){window.clearTimeout(this._updateTimer),this._updateTimer=0,this.dispatchEventToListeners("RecordingStopped");const e=this._obtainRecordingProfile();if(!e)throw new Error("No heap profiler model");const i=await e.stopSampling();if(!i)throw new Error("No sampling profile found");return i}async _updateStats(){const e=this._obtainRecordingProfile();if(!e)return;const i=await e.getSamplingProfile();this._updateTimer&&(this.dispatchEventToListeners("StatsUpdate",i),this._updateTimer=window.setTimeout((()=>{this._updateStats()}),this._updateIntervalMs))}}SamplingHeapProfileType.TypeId="SamplingHeap";export class SamplingHeapProfileHeader extends WritableProfileHeader{constructor(e,i,t){super(e&&e.debuggerModel(),i,t||i18nString(UIStrings.profileD,{PH1:i.nextProfileUid()})),this._heapProfilerModel=e,this._protocolProfile={head:{callFrame:{functionName:"",scriptId:"",url:"",lineNumber:0,columnNumber:0},children:[],selfSize:0,id:0},samples:[],startTime:0,endTime:0,nodes:[]}}createView(){return new HeapProfileView(this)}protocolProfile(){return this._protocolProfile}heapProfilerModel(){return this._heapProfilerModel}}export class SamplingHeapProfileNode extends SDK.ProfileTreeModel.ProfileNode{constructor(e){super(e.callFrame||{functionName:e.functionName,scriptId:e.scriptId,url:e.url,lineNumber:e.lineNumber-1,columnNumber:e.columnNumber-1}),this.self=e.selfSize}}export class SamplingHeapProfileModel extends SDK.ProfileTreeModel.ProfileTreeModel{constructor(e,i,t){super(),this.modules=e.modules||[];let r=null;if(i||t){r=new Map,i=i||0,t=t||1/0;for(const o of e.samples){if(o.ordinal<i||o.ordinal>t)continue;const e=r.get(o.nodeId)||0;r.set(o.nodeId,e+o.size)}}function o(e){return e.children=e.children.filter(o),Boolean(e.children.length||e.self)}this.initialize(function(e){const i=new SamplingHeapProfileNode(e),t=[e],n=[i];for(;t.length;){const e=t.pop(),i=n.pop();i.children=e.children.map((e=>{const i=new SamplingHeapProfileNode(e);return r&&(i.self=r.get(e.id)||0),i})),t.push(...e.children),n.push(...i.children)}return o(i),i}(e.head))}}export class NodeFormatter{constructor(e){this._profileView=e}formatValue(e){return Number.withThousandsSeparator(e)}formatValueAccessibleText(e){return i18nString(UIStrings.sBytes,{PH1:e})}formatPercent(e,i){return i18nString(UIStrings.formatPercent,{PH1:e.toFixed(2)})}linkifyNode(e){const i=this._profileView.profileHeader.heapProfilerModel(),t=i?i.target():null,r={className:"profile-node-file",columnNumber:void 0,tabStop:void 0};return this._profileView.linkifier().maybeLinkifyConsoleCallFrame(t,e.profileNode.callFrame,r)}}export class HeapFlameChartDataProvider extends ProfileFlameChartDataProvider{constructor(e,i){super(),this._profile=e,this._heapProfilerModel=i,this._entryNodes=[]}minimumBoundary(){return 0}totalTime(){return this._profile.root.total}entryHasDeoptReason(e){return!1}formatValue(e,i){return i18nString(UIStrings.skb,{PH1:Number.withThousandsSeparator(e/1e3)})}_calculateTimelineData(){const e=function e(i){return i.children.reduce(((i,t)=>i+e(t)),1)}(this._profile.root),i=new Array(e),t=new Uint16Array(e),r=new Float32Array(e),o=new Float64Array(e);let n=0,s=0,a=0,l=0;return function e(p){const m=a;i[l]=p,t[l]=n,r[l]=p.total,o[l]=a,++l,++n,p.children.forEach(e),--n,s=Math.max(s,n),a=m+p.total}(this._profile.root),this._maxStackDepth=s+1,this._entryNodes=i,this._timelineData=new PerfUI.FlameChart.TimelineData(t,r,o,null),this._timelineData}prepareHighlightedEntryInfo(e){const i=this._entryNodes[e];if(!i)return null;const t=[];function r(e,i){t.push({title:e,value:i})}r(i18nString(UIStrings.name),UI.UIUtils.beautifyFunctionName(i.functionName)),r(i18nString(UIStrings.selfSize),Platform.NumberUtilities.bytesToString(i.self)),r(i18nString(UIStrings.totalSize),Platform.NumberUtilities.bytesToString(i.total));const o=new Components.Linkifier.Linkifier,n=o.maybeLinkifyConsoleCallFrame(this._heapProfilerModel?this._heapProfilerModel.target():null,i.callFrame);return n&&r(i18nString(UIStrings.url),n.textContent),o.dispose(),ProfileView.buildPopoverTable(t)}}