import*as Components from"../components/components.js";import*as DataGrid from"../data_grid/data_grid.js";import*as HeapSnapshotModel from"../heap_snapshot_model/heap_snapshot_model.js";import*as i18n from"../i18n/i18n.js";import*as UI from"../ui/ui.js";import{AllocationGridNode,HeapSnapshotConstructorNode,HeapSnapshotGenericObjectNode,HeapSnapshotRetainingObjectNode,HeapSnapshotObjectNode,HeapSnapshotDiffNode}from"./HeapSnapshotGridNodes.js";const UIStrings={distanceFromWindowObject:"Distance from window object",sizeOfTheObjectItselfInBytes:"Size of the object itself in bytes",sizeOfTheObjectPlusTheGraphIt:"Size of the object plus the graph it retains in bytes",object:"Object",distance:"Distance",shallowSize:"Shallow Size",retainedSize:"Retained Size",heapSnapshotRetainment:"Heap Snapshot Retainment",constructorString:"Constructor",heapSnapshotConstructors:"Heap Snapshot Constructors",New:"# New",Deleted:"# Deleted",Delta:"# Delta",allocSize:"Alloc. Size",freedSize:"Freed Size",sizeDelta:"Size Delta",heapSnapshotDiff:"Heap Snapshot Diff",liveCount:"Live Count",count:"Count",liveSize:"Live Size",size:"Size",function:"Function",allocation:"Allocation"},str_=i18n.i18n.registerUIStrings("profiler/HeapSnapshotDataGrids.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),adjacencyMap=new WeakMap;export class HeapSnapshotSortableDataGrid extends DataGrid.DataGrid.DataGridImpl{constructor(e,t,i){super(i),this.snapshot=null,this.selectedNode=null,this._heapProfilerModel=e,this._dataDisplayDelegate=t;const o=[["distance",i18nString(UIStrings.distanceFromWindowObject)],["shallowSize",i18nString(UIStrings.sizeOfTheObjectItselfInBytes)],["retainedSize",i18nString(UIStrings.sizeOfTheObjectPlusTheGraphIt)]];for(const s of o){const e=this.headerTableHeader(s[0]);e&&e.setAttribute("title",s[1])}this._recursiveSortingDepth=0,this._highlightedNode=null,this._populatedAndSorted=!1,this._nameFilter=null,this._nodeFilter=new HeapSnapshotModel.HeapSnapshotModel.NodeFilter,this.addEventListener(HeapSnapshotSortableDataGridEvents.SortingComplete,this._sortingComplete,this),this.addEventListener(DataGrid.DataGrid.Events.SortingChanged,this.sortingChanged,this),this.setRowContextMenuCallback(this._populateContextMenu.bind(this))}async setDataSource(e,t){}_isFilteredOut(e){const t=this._nameFilter?this._nameFilter.value().toLowerCase():"";return!!(t&&(e instanceof HeapSnapshotDiffNode||e instanceof HeapSnapshotConstructorNode)&&e.filteredOut(t))}heapProfilerModel(){return this._heapProfilerModel}dataDisplayDelegate(){return this._dataDisplayDelegate}nodeFilter(){return this._nodeFilter}setNameFilter(e){this._nameFilter=e}defaultPopulateCount(){return 100}_disposeAllNodes(){const e=this.topLevelNodes();for(let t=0,i=e.length;t<i;++t)e[t].dispose()}wasShown(){this._nameFilter&&(this._nameFilter.addEventListener(UI.Toolbar.ToolbarInput.Event.TextChanged,this._onNameFilterChanged,this),this.updateVisibleNodes(!0)),this._populatedAndSorted&&this.dispatchEventToListeners(HeapSnapshotSortableDataGridEvents.ContentShown,this)}_sortingComplete(){this.removeEventListener(HeapSnapshotSortableDataGridEvents.SortingComplete,this._sortingComplete,this),this._populatedAndSorted=!0,this.dispatchEventToListeners(HeapSnapshotSortableDataGridEvents.ContentShown,this)}willHide(){this._nameFilter&&this._nameFilter.removeEventListener(UI.Toolbar.ToolbarInput.Event.TextChanged,this._onNameFilterChanged,this),this._clearCurrentHighlight()}_populateContextMenu(e,t){const i=t;i.populateContextMenu(e,this._dataDisplayDelegate,this.heapProfilerModel()),i instanceof HeapSnapshotGenericObjectNode&&i.linkElement&&!e.containsTarget(i.linkElement)&&e.appendApplicableItems(i.linkElement)}resetSortingCache(){delete this._lastSortColumnId,delete this._lastSortAscending}topLevelNodes(){return this.rootNode().children}revealObjectByHeapSnapshotId(e){return Promise.resolve(null)}highlightNode(e){this._clearCurrentHighlight(),this._highlightedNode=e,UI.UIUtils.runCSSAnimationOnce(this._highlightedNode.element(),"highlighted-row")}_clearCurrentHighlight(){this._highlightedNode&&(this._highlightedNode.element().classList.remove("highlighted-row"),this._highlightedNode=null)}resetNameFilter(){this._nameFilter&&this._nameFilter.setValue("")}_onNameFilterChanged(){this.updateVisibleNodes(!0),this._deselectFilteredNodes()}_deselectFilteredNodes(){let e=this.selectedNode;for(;e;){if(this.selectedNode&&this._isFilteredOut(e))return this.selectedNode.deselect(),void(this.selectedNode=null);e=e.parent}}_sortFields(e,t){throw new Error("Not implemented")}sortingChanged(){const e=this.isSortOrderAscending(),t=this.sortColumnId();if(this._lastSortColumnId===t&&this._lastSortAscending===e)return;this._lastSortColumnId=t,this._lastSortAscending=e;const i=this._sortFields(t||"",e);this._performSorting((function(e,t){let o=e[i.fieldName1],s=t[i.fieldName1],n=o<s?-1:o>s?1:0;return i.ascending1||(n=-n),0!==n||(o=e[i.fieldName2],s=t[i.fieldName2],n=o<s?-1:o>s?1:0,i.ascending2||(n=-n)),n}))}_performSorting(e){this.recursiveSortingEnter();const t=this.allChildren(this.rootNode());this.rootNode().removeChildren(),t.sort(e);for(let i=0,o=t.length;i<o;++i){const e=t[i];this.appendChildAfterSorting(e),e.expanded&&e.sort()}this.recursiveSortingLeave()}appendChildAfterSorting(e){const t=e.revealed;this.rootNode().appendChild(e),e.revealed=t}recursiveSortingEnter(){++this._recursiveSortingDepth}recursiveSortingLeave(){this._recursiveSortingDepth&&(--this._recursiveSortingDepth||(this.updateVisibleNodes(!0),this.dispatchEventToListeners(HeapSnapshotSortableDataGridEvents.SortingComplete)))}updateVisibleNodes(e){}allChildren(e){return e.children}insertChild(e,t,i){e.insertChild(t,i)}removeChildByIndex(e,t){e.removeChild(e.children[t])}removeAllChildren(e){e.removeChildren()}}export var HeapSnapshotSortableDataGridEvents;!function(e){e.ContentShown="ContentShown",e.SortingComplete="SortingComplete"}(HeapSnapshotSortableDataGridEvents||(HeapSnapshotSortableDataGridEvents={}));export class HeapSnapshotViewportDataGrid extends HeapSnapshotSortableDataGrid{constructor(e,t,i){super(e,t,i),this.scrollContainer.addEventListener("scroll",this._onScroll.bind(this),!0),this._topPaddingHeight=0,this._bottomPaddingHeight=0,this.selectedNode=null}topLevelNodes(){return this.allChildren(this.rootNode())}appendChildAfterSorting(e){}updateVisibleNodes(e){const t=this.scrollContainer.scrollHeight;let i=this.scrollContainer.scrollTop,o=t-i-this.scrollContainer.offsetHeight;i=Math.max(0,i-40),o=Math.max(0,o-40);let s=t-i-o;if(!e&&i>=this._topPaddingHeight&&o>=this._bottomPaddingHeight)return;i-=500,s+=1e3;const n=this.selectedNode;this.rootNode().removeChildren(),this._topPaddingHeight=0,this._bottomPaddingHeight=0,this._addVisibleNodes(this.rootNode(),i,i+s),this.setVerticalPadding(this._topPaddingHeight,this._bottomPaddingHeight),n&&(n.parent?n.select(!0):this.selectedNode=n)}_addVisibleNodes(e,t,i){if(!e.expanded)return 0;const o=this.allChildren(e);let s=0,n=0;for(;n<o.length;++n){const e=o[n];if(this._isFilteredOut(e))continue;const i=s+this._nodeHeight(e);if(i>t)break;s=i}let a=s;for(;n<o.length&&a<i;++n){const s=o[n];if(this._isFilteredOut(s))continue;const r=s.hasChildren();s.removeChildren(),s.setHasChildren(r),e.appendChild(s),a+=s.nodeSelfHeight(),a+=this._addVisibleNodes(s,t-a,i-a)}let r=0;for(;n<o.length;++n){const e=o[n];this._isFilteredOut(e)||(r+=this._nodeHeight(e))}return this._topPaddingHeight+=s,this._bottomPaddingHeight+=r,a+r}_nodeHeight(e){let t=e.nodeSelfHeight();if(!e.expanded)return t;const i=this.allChildren(e);for(let o=0;o<i.length;o++)t+=this._nodeHeight(i[o]);return t}revealTreeNode(e){const t=this._calculateOffset(e),i=e[e.length-1],o=this.scrollContainer.scrollTop,s=o+this.scrollContainer.offsetHeight;if(t>=o&&t<s)return Promise.resolve(i);return this.scrollContainer.scrollTop=Math.max(0,t-40),new Promise((e=>{console.assert(!this._scrollToResolveCallback),this._scrollToResolveCallback=e.bind(null,i),this.scrollContainer.window().requestAnimationFrame((()=>{this._scrollToResolveCallback&&(this._scrollToResolveCallback(),this._scrollToResolveCallback=null)}))}))}_calculateOffset(e){let t=this.rootNode(),i=0;if(0===e.length)return 0;for(let o=0;o<e.length;++o){const s=e[o],n=this.allChildren(t);for(let e=0;e<n.length;++e){const t=n[e];if(s===t){i+=s.nodeSelfHeight();break}i+=this._nodeHeight(t)}t=s}return i-e[e.length-1].nodeSelfHeight()}allChildren(e){const t=adjacencyMap.get(e)||[];return adjacencyMap.has(e)||adjacencyMap.set(e,t),t}appendNode(e,t){this.allChildren(e).push(t)}insertChild(e,t,i){this.allChildren(e).splice(i,0,t)}removeChildByIndex(e,t){this.allChildren(e).splice(t,1)}removeAllChildren(e){adjacencyMap.delete(e)}removeTopLevelNodes(){this._disposeAllNodes(),this.rootNode().removeChildren(),this.removeAllChildren(this.rootNode())}_isScrolledIntoView(e){const t=this.scrollContainer.scrollTop,i=t+this.scrollContainer.clientHeight,o=e.offsetTop;return o+e.offsetHeight<=i&&o>=t}onResize(){super.onResize(),this.updateVisibleNodes(!1)}_onScroll(e){this.updateVisibleNodes(!1),this._scrollToResolveCallback&&(this._scrollToResolveCallback(),this._scrollToResolveCallback=null)}}export class HeapSnapshotContainmentDataGrid extends HeapSnapshotSortableDataGrid{constructor(e,t,i,o){super(e,t,{displayName:i,columns:o=o||[{id:"object",title:i18nString(UIStrings.object),disclosure:!0,sortable:!0},{id:"distance",title:i18nString(UIStrings.distance),width:"70px",sortable:!0,fixedWidth:!0},{id:"shallowSize",title:i18nString(UIStrings.shallowSize),width:"110px",sortable:!0,fixedWidth:!0},{id:"retainedSize",title:i18nString(UIStrings.retainedSize),width:"110px",sortable:!0,fixedWidth:!0,sort:DataGrid.DataGrid.Order.Descending}]})}async setDataSource(e,t){this.snapshot=e;const i=new HeapSnapshotModel.HeapSnapshotModel.Node(-1,"root",0,t||e.rootNodeIndex,0,0,"");this.setRootNode(this._createRootNode(e,i)),this.rootNode().sort()}_createRootNode(e,t){const i=new HeapSnapshotModel.HeapSnapshotModel.Edge("",t,"",-1);return new HeapSnapshotObjectNode(this,e,i,null)}sortingChanged(){const e=this.rootNode();e.hasChildren()&&e.sort()}}export class HeapSnapshotRetainmentDataGrid extends HeapSnapshotContainmentDataGrid{constructor(e,t){const i=[{id:"object",title:i18nString(UIStrings.object),disclosure:!0,sortable:!0},{id:"distance",title:i18nString(UIStrings.distance),width:"70px",sortable:!0,fixedWidth:!0,sort:DataGrid.DataGrid.Order.Ascending},{id:"shallowSize",title:i18nString(UIStrings.shallowSize),width:"110px",sortable:!0,fixedWidth:!0},{id:"retainedSize",title:i18nString(UIStrings.retainedSize),width:"110px",sortable:!0,fixedWidth:!0}];super(e,t,i18nString(UIStrings.heapSnapshotRetainment),i)}_createRootNode(e,t){const i=new HeapSnapshotModel.HeapSnapshotModel.Edge("",t,"",-1);return new HeapSnapshotRetainingObjectNode(this,e,i,null)}_sortFields(e,t){switch(e){case"object":return new HeapSnapshotModel.HeapSnapshotModel.ComparatorConfig("_name",t,"_count",!1);case"count":return new HeapSnapshotModel.HeapSnapshotModel.ComparatorConfig("_count",t,"_name",!0);case"shallowSize":return new HeapSnapshotModel.HeapSnapshotModel.ComparatorConfig("_shallowSize",t,"_name",!0);case"retainedSize":return new HeapSnapshotModel.HeapSnapshotModel.ComparatorConfig("_retainedSize",t,"_name",!0);case"distance":return new HeapSnapshotModel.HeapSnapshotModel.ComparatorConfig("_distance",t,"_name",!0);default:throw new Error(`Unknown column ${e}`)}}reset(){this.rootNode().removeChildren(),this.resetSortingCache()}async setDataSource(e,t){await super.setDataSource(e,t),this.rootNode().expand()}}export var HeapSnapshotRetainmentDataGridEvents;!function(e){e.ExpandRetainersComplete="ExpandRetainersComplete"}(HeapSnapshotRetainmentDataGridEvents||(HeapSnapshotRetainmentDataGridEvents={}));export class HeapSnapshotConstructorsDataGrid extends HeapSnapshotViewportDataGrid{constructor(e,t){const i=[{id:"object",title:i18nString(UIStrings.constructorString),disclosure:!0,sortable:!0},{id:"distance",title:i18nString(UIStrings.distance),width:"70px",sortable:!0,fixedWidth:!0},{id:"shallowSize",title:i18nString(UIStrings.shallowSize),width:"110px",sortable:!0,fixedWidth:!0},{id:"retainedSize",title:i18nString(UIStrings.retainedSize),width:"110px",sort:DataGrid.DataGrid.Order.Descending,sortable:!0,fixedWidth:!0}];super(e,t,{displayName:i18nString(UIStrings.heapSnapshotConstructors).toString(),columns:i}),this._profileIndex=-1,this._objectIdToSelect=null,this._nextRequestedFilter=null}_sortFields(e,t){switch(e){case"object":return new HeapSnapshotModel.HeapSnapshotModel.ComparatorConfig("_name",t,"_retainedSize",!1);case"distance":return new HeapSnapshotModel.HeapSnapshotModel.ComparatorConfig("_distance",t,"_retainedSize",!1);case"shallowSize":return new HeapSnapshotModel.HeapSnapshotModel.ComparatorConfig("_shallowSize",t,"_name",!0);case"retainedSize":return new HeapSnapshotModel.HeapSnapshotModel.ComparatorConfig("_retainedSize",t,"_name",!0);default:throw new Error(`Unknown column ${e}`)}}async revealObjectByHeapSnapshotId(e){if(!this.snapshot)return this._objectIdToSelect=e,null;const t=await this.snapshot.nodeClassName(parseInt(e,10));if(!t)return null;const i=this.topLevelNodes().find((e=>e.name===t));if(!i)return null;const o=await i.populateNodeBySnapshotObjectId(parseInt(e,10));return o.length?this.revealTreeNode(o):null}clear(){this._nextRequestedFilter=null,this._lastFilter=null,this.removeTopLevelNodes()}async setDataSource(e,t){this.snapshot=e,-1===this._profileIndex&&this._populateChildren(),this._objectIdToSelect&&(this.revealObjectByHeapSnapshotId(this._objectIdToSelect),this._objectIdToSelect=null)}setSelectionRange(e,t){this._nodeFilter=new HeapSnapshotModel.HeapSnapshotModel.NodeFilter(e,t),this._populateChildren(this._nodeFilter)}setAllocationNodeId(e){this._nodeFilter=new HeapSnapshotModel.HeapSnapshotModel.NodeFilter,this._nodeFilter.allocationNodeId=e,this._populateChildren(this._nodeFilter)}_aggregatesReceived(e,t){this._filterInProgress=null,this._nextRequestedFilter&&this.snapshot&&(this.snapshot.aggregatesWithFilter(this._nextRequestedFilter).then(this._aggregatesReceived.bind(this,this._nextRequestedFilter)),this._filterInProgress=this._nextRequestedFilter,this._nextRequestedFilter=null),this.removeTopLevelNodes(),this.resetSortingCache();for(const i in t)this.appendNode(this.rootNode(),new HeapSnapshotConstructorNode(this,i,t[i],e));this.sortingChanged(),this._lastFilter=e}async _populateChildren(e){const t=e||new HeapSnapshotModel.HeapSnapshotModel.NodeFilter;if(this._filterInProgress)this._nextRequestedFilter=this._filterInProgress.equals(t)?null:t;else if((!this._lastFilter||!this._lastFilter.equals(t))&&(this._filterInProgress=t,this.snapshot)){const e=await this.snapshot.aggregatesWithFilter(t);this._aggregatesReceived(t,e)}}filterSelectIndexChanged(e,t){if(this._profileIndex=t,this._nodeFilter=void 0,-1!==t){const i=t>0?e[t-1].maxJSObjectId:0,o=e[t].maxJSObjectId;this._nodeFilter=new HeapSnapshotModel.HeapSnapshotModel.NodeFilter(i,o)}this._populateChildren(this._nodeFilter)}}export class HeapSnapshotDiffDataGrid extends HeapSnapshotViewportDataGrid{constructor(e,t){const i=[{id:"object",title:i18nString(UIStrings.constructorString),disclosure:!0,sortable:!0},{id:"addedCount",title:i18nString(UIStrings.New),width:"75px",sortable:!0,fixedWidth:!0},{id:"removedCount",title:i18nString(UIStrings.Deleted),width:"75px",sortable:!0,fixedWidth:!0},{id:"countDelta",title:i18nString(UIStrings.Delta),width:"65px",sortable:!0,fixedWidth:!0},{id:"addedSize",title:i18nString(UIStrings.allocSize),width:"75px",sortable:!0,fixedWidth:!0,sort:DataGrid.DataGrid.Order.Descending},{id:"removedSize",title:i18nString(UIStrings.freedSize),width:"75px",sortable:!0,fixedWidth:!0},{id:"sizeDelta",title:i18nString(UIStrings.sizeDelta),width:"75px",sortable:!0,fixedWidth:!0}];super(e,t,{displayName:i18nString(UIStrings.heapSnapshotDiff).toString(),columns:i})}defaultPopulateCount(){return 50}_sortFields(e,t){switch(e){case"object":return new HeapSnapshotModel.HeapSnapshotModel.ComparatorConfig("_name",t,"_count",!1);case"addedCount":return new HeapSnapshotModel.HeapSnapshotModel.ComparatorConfig("_addedCount",t,"_name",!0);case"removedCount":return new HeapSnapshotModel.HeapSnapshotModel.ComparatorConfig("_removedCount",t,"_name",!0);case"countDelta":return new HeapSnapshotModel.HeapSnapshotModel.ComparatorConfig("_countDelta",t,"_name",!0);case"addedSize":return new HeapSnapshotModel.HeapSnapshotModel.ComparatorConfig("_addedSize",t,"_name",!0);case"removedSize":return new HeapSnapshotModel.HeapSnapshotModel.ComparatorConfig("_removedSize",t,"_name",!0);case"sizeDelta":return new HeapSnapshotModel.HeapSnapshotModel.ComparatorConfig("_sizeDelta",t,"_name",!0);default:throw new Error(`Unknown column ${e}`)}}async setDataSource(e,t){this.snapshot=e}setBaseDataSource(e){this.baseSnapshot=e,this.removeTopLevelNodes(),this.resetSortingCache(),this.baseSnapshot!==this.snapshot?this._populateChildren():this.dispatchEventToListeners(HeapSnapshotSortableDataGridEvents.SortingComplete)}async _populateChildren(){if(null===this.snapshot||void 0===this.baseSnapshot||void 0===this.baseSnapshot.uid)throw new Error("Data sources have not been set correctly");const e=await this.baseSnapshot.aggregatesForDiff(),t=await this.snapshot.calculateSnapshotDiff(this.baseSnapshot.uid,e);for(const i in t){const e=t[i];this.appendNode(this.rootNode(),new HeapSnapshotDiffNode(this,i,e))}this.sortingChanged()}}export class AllocationDataGrid extends HeapSnapshotViewportDataGrid{constructor(e,t){const i=[{id:"liveCount",title:i18nString(UIStrings.liveCount),width:"75px",sortable:!0,fixedWidth:!0},{id:"count",title:i18nString(UIStrings.count),width:"65px",sortable:!0,fixedWidth:!0},{id:"liveSize",title:i18nString(UIStrings.liveSize),width:"75px",sortable:!0,fixedWidth:!0},{id:"size",title:i18nString(UIStrings.size),width:"75px",sortable:!0,fixedWidth:!0,sort:DataGrid.DataGrid.Order.Descending},{id:"name",title:i18nString(UIStrings.function),disclosure:!0,sortable:!0}];super(e,t,{displayName:i18nString(UIStrings.allocation).toString(),columns:i}),this._linkifier=new Components.Linkifier.Linkifier}get linkifier(){return this._linkifier}dispose(){this._linkifier.reset()}async setDataSource(e,t){this.snapshot=e,this._topNodes=await this.snapshot.allocationTracesTops(),this._populateChildren()}_populateChildren(){this.removeTopLevelNodes();const e=this.rootNode(),t=this._topNodes||[];for(const i of t)this.appendNode(e,new AllocationGridNode(this,i));this.updateVisibleNodes(!0)}sortingChanged(){void 0!==this._topNodes&&(this._topNodes.sort(this.createComparator()),this.rootNode().removeChildren(),this._populateChildren())}createComparator(){const e=this.sortColumnId(),t=this.sortOrder()===DataGrid.DataGrid.Order.Ascending?1:-1;return function(i,o){return i[e]>o[e]?t:i[e]<o[e]?-t:0}}}