import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import*as Platform from"../platform/platform.js";import*as SDK from"../sdk/sdk.js";import*as UI from"../ui/ui.js";const UIStrings={javascriptVmInstances:"JavaScript VM instances",totalJsHeapSize:"Total JS heap size",totalPageJsHeapSizeChangeTrend:"Total page JS heap size change trend over the last {PH1} minutes.",totalPageJsHeapSizeAcrossAllVm:"Total page JS heap size across all VM instances.",changeRate:"{PH1}/s",increasingBySPerSecond:"increasing by {PH1} per second",decreasingBySPerSecond:"decreasing by {PH1} per second",heapSizeInUseByLiveJsObjects:"Heap size in use by live JS objects.",heapSizeChangeTrendOverTheLastS:"Heap size change trend over the last {PH1} minutes.",empty:"(empty)"},str_=i18n.i18n.registerUIStrings("profiler/IsolateSelector.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class IsolateSelector extends UI.Widget.VBox{constructor(){super(!1),this._items=new UI.ListModel.ListModel,this._list=new UI.ListControl.ListControl(this._items,this,UI.ListControl.ListMode.NonViewport),this._list.element.classList.add("javascript-vm-instances-list"),UI.ARIAUtils.setAccessibleName(this._list.element,i18nString(UIStrings.javascriptVmInstances)),this.contentElement.appendChild(this._list.element),this._itemByIsolate=new Map,this._totalElement=document.createElement("div"),this._totalElement.classList.add("profile-memory-usage-item"),this._totalElement.classList.add("hbox"),this._totalValueDiv=this._totalElement.createChild("div","profile-memory-usage-item-size"),this._totalTrendDiv=this._totalElement.createChild("div","profile-memory-usage-item-trend"),this._totalElement.createChild("div").textContent=i18nString(UIStrings.totalJsHeapSize);const e=Math.round(SDK.IsolateManager.MemoryTrendWindowMs/6e4);UI.Tooltip.Tooltip.install(this._totalTrendDiv,i18nString(UIStrings.totalPageJsHeapSizeChangeTrend,{PH1:e})),UI.Tooltip.Tooltip.install(this._totalValueDiv,i18nString(UIStrings.totalPageJsHeapSizeAcrossAllVm)),SDK.IsolateManager.IsolateManager.instance().observeIsolates(this),SDK.SDKModel.TargetManager.instance().addEventListener(SDK.SDKModel.Events.NameChanged,this._targetChanged,this),SDK.SDKModel.TargetManager.instance().addEventListener(SDK.SDKModel.Events.InspectedURLChanged,this._targetChanged,this)}wasShown(){SDK.IsolateManager.IsolateManager.instance().addEventListener(SDK.IsolateManager.Events.MemoryChanged,this._heapStatsChanged,this)}willHide(){SDK.IsolateManager.IsolateManager.instance().removeEventListener(SDK.IsolateManager.Events.MemoryChanged,this._heapStatsChanged,this)}isolateAdded(e){this._list.element.tabIndex=0;const t=new ListItem(e),s=t.model().target()===SDK.SDKModel.TargetManager.instance().mainTarget()?0:this._items.length;this._items.insert(s,t),this._itemByIsolate.set(e,t),(1===this._items.length||e.isMainThread())&&this._list.selectItem(t),this._update()}isolateChanged(e){const t=this._itemByIsolate.get(e);t&&t.updateTitle(),this._update()}isolateRemoved(e){const t=this._itemByIsolate.get(e);t&&this._items.remove(this._items.indexOf(t)),this._itemByIsolate.delete(e),0===this._items.length&&(this._list.element.tabIndex=-1),this._update()}_targetChanged(e){const t=e.data.model(SDK.RuntimeModel.RuntimeModel);if(!t)return;const s=SDK.IsolateManager.IsolateManager.instance().isolateByModel(t),i=s&&this._itemByIsolate.get(s);i&&i.updateTitle()}_heapStatsChanged(e){const t=e.data,s=this._itemByIsolate.get(t);s&&s.updateStats(),this._updateTotal()}_updateTotal(){let e=0,t=0;for(const s of SDK.IsolateManager.IsolateManager.instance().isolates())e+=s.usedHeapSize(),t+=s.usedHeapSizeGrowRate();this._totalValueDiv.textContent=Platform.NumberUtilities.bytesToString(e),IsolateSelector._formatTrendElement(t,this._totalTrendDiv)}static _formatTrendElement(e,t){const s=1e3*e;if(Math.abs(s)<1e3)return;const i=Platform.NumberUtilities.bytesToString(Math.abs(s));let a,n;s>0?(a="\u2b06"+i18nString(UIStrings.changeRate,{PH1:i}),t.classList.toggle("increasing",!0),n=i18nString(UIStrings.increasingBySPerSecond,{PH1:i})):(a="\u2b07"+i18nString(UIStrings.changeRate,{PH1:i}),t.classList.toggle("increasing",!1),n=i18nString(UIStrings.decreasingBySPerSecond,{PH1:i})),t.textContent=a,UI.ARIAUtils.setAccessibleName(t,n)}totalMemoryElement(){return this._totalElement}createElementForItem(e){return e.element}heightForItem(e){return console.assert(!1,"should not be called"),0}updateSelectedItemARIA(e,t){return!1}isItemSelectable(e){return!0}selectedItemChanged(e,t,s,i){s&&s.classList.remove("selected"),i&&i.classList.add("selected");const a=t&&t.model();UI.Context.Context.instance().setFlavor(SDK.HeapProfilerModel.HeapProfilerModel,a&&a.heapProfilerModel()),UI.Context.Context.instance().setFlavor(SDK.CPUProfilerModel.CPUProfilerModel,a&&a.target().model(SDK.CPUProfilerModel.CPUProfilerModel))}_update(){this._updateTotal(),this._list.invalidateRange(0,this._items.length)}}export class ListItem{constructor(e){this._isolate=e;const t=Math.round(SDK.IsolateManager.MemoryTrendWindowMs/6e4);this.element=document.createElement("div"),this.element.classList.add("profile-memory-usage-item"),this.element.classList.add("hbox"),UI.ARIAUtils.markAsOption(this.element),this._heapDiv=this.element.createChild("div","profile-memory-usage-item-size"),UI.Tooltip.Tooltip.install(this._heapDiv,i18nString(UIStrings.heapSizeInUseByLiveJsObjects)),this._trendDiv=this.element.createChild("div","profile-memory-usage-item-trend"),UI.Tooltip.Tooltip.install(this._trendDiv,i18nString(UIStrings.heapSizeChangeTrendOverTheLastS,{PH1:t})),this._nameDiv=this.element.createChild("div","profile-memory-usage-item-name"),this.updateTitle()}model(){return this._isolate.runtimeModel()}updateStats(){this._heapDiv.textContent=Platform.NumberUtilities.bytesToString(this._isolate.usedHeapSize()),IsolateSelector._formatTrendElement(this._isolate.usedHeapSizeGrowRate(),this._trendDiv)}updateTitle(){const e=new Map;for(const s of this._isolate.models()){const t=s.target(),i=SDK.SDKModel.TargetManager.instance().mainTarget()!==t?t.name():"",a=new Common.ParsedURL.ParsedURL(t.inspectedURL()),n=a.isValid?a.domain():"",o=t.decorateLabel(n&&i?`${n}: ${i}`:i||n||i18nString(UIStrings.empty));e.set(o,(e.get(o)||0)+1)}this._nameDiv.removeChildren();const t=[];for(const[s,i]of e){const e=i>1?`${s} (${i})`:s;t.push(e);const a=this._nameDiv.createChild("div");a.textContent=e,UI.Tooltip.Tooltip.install(a,String(e))}}}