import*as Common from"../common/common.js";import*as Diff from"../diff/diff.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as Platform from"../platform/platform.js";import*as UI from"../ui/ui.js";import{FilteredListWidget,Provider,registerProvider}from"./FilteredListWidget.js";import{QuickOpenImpl}from"./QuickOpen.js";const UIStrings={oneOrMoreSettingsHaveChanged:"One or more settings have changed which requires a reload to take effect.",noCommandsFound:"No commands found",runCommand:"Run Command"},str_=i18n.i18n.registerUIStrings("quick_open/CommandMenu.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);let commandMenuInstance,commandMenuProviderInstance,showActionDelegateInstance;export class CommandMenu{constructor(){this._commands=[],this._loadCommands()}static instance(e={forceNew:null}){const{forceNew:t}=e;return commandMenuInstance&&!t||(commandMenuInstance=new CommandMenu),commandMenuInstance}static createCommand(e){const{category:t,keys:n,title:o,shortcut:r,executeHandler:a,availableHandler:s,userActionCode:i}=e;let c=a;if(i){const e=i;c=()=>{Host.userMetrics.actionTaken(e),a()}}if("Show Issues"===o){const e=c;c=()=>{Host.userMetrics.issuesPanelOpenedFrom(Host.UserMetrics.IssueOpener.CommandMenu),e()}}return new Command(t,o,n,r,c,s)}static createSettingCommand(e,t,n){const o=e.category();if(!o)throw new Error(`Creating '${t}' setting command failed. Setting has no category.`);const r=e.tags()||"",a=Boolean(e.reloadRequired());return CommandMenu.createCommand({category:Common.Settings.getLocalizedSettingsCategory(o),keys:r,title:t,shortcut:"",executeHandler:()=>{e.set(n),a&&UI.InspectorView.InspectorView.instance().displayReloadRequiredWarning(i18nString(UIStrings.oneOrMoreSettingsHaveChanged))},availableHandler:function(){return e.get()!==n},userActionCode:void 0})}static createActionCommand(e){const{action:t,userActionCode:n}=e,o=UI.ShortcutRegistry.ShortcutRegistry.instance().shortcutTitleForAction(t.id())||"";return CommandMenu.createCommand({category:t.category(),keys:t.tags()||"",title:t.title()||"",shortcut:o,executeHandler:t.execute.bind(t),userActionCode:n,availableHandler:void 0})}static createRevealViewCommand(e){const{title:t,tags:n,category:o,userActionCode:r,id:a}=e;return CommandMenu.createCommand({category:o,keys:n,title:t,shortcut:"",executeHandler:UI.ViewManager.ViewManager.instance().showView.bind(UI.ViewManager.ViewManager.instance(),a,!0),userActionCode:r,availableHandler:void 0})}_loadCommands(){const e=new Map;for(const{category:o,name:r}of UI.ViewManager.getRegisteredLocationResolvers())o&&r&&e.set(r,o);const t=UI.ViewManager.getRegisteredViewExtensions();for(const o of t){const t=o.location(),n=t&&e.get(t);if(!n)continue;const r={title:o.commandPrompt(),tags:o.tags()||"",category:n,userActionCode:void 0,id:o.viewId()};this._commands.push(CommandMenu.createRevealViewCommand(r))}const n=Common.Settings.getRegisteredSettings();for(const o of n){const e=o.options;if(e&&o.category)for(const t of e){const e=Common.Settings.Settings.instance().moduleSetting(o.settingName);this._commands.push(CommandMenu.createSettingCommand(e,t.title(),t.value))}}}commands(){return this._commands}}export class CommandMenuProvider extends Provider{constructor(){super(),this._commands=[]}static instance(e={forceNew:null}){const{forceNew:t}=e;return commandMenuProviderInstance&&!t||(commandMenuProviderInstance=new CommandMenuProvider),commandMenuProviderInstance}attach(){const e=CommandMenu.instance().commands(),t=UI.ActionRegistry.ActionRegistry.instance().availableActions();for(const n of t){if(!n.category())continue;const e={action:n,userActionCode:void 0};this._commands.push(CommandMenu.createActionCommand(e))}for(const n of e)n.available()&&this._commands.push(n);this._commands=this._commands.sort((function(e,t){const n=Platform.StringUtilities.compare(e.category(),t.category());return n||Platform.StringUtilities.compare(e.title(),t.title())}))}detach(){this._commands=[]}itemCount(){return this._commands.length}itemKeyAt(e){return this._commands[e].key()}itemScoreAt(e,t){const n=this._commands[e];let o=Diff.Diff.DiffWrapper.characterScore(t.toLowerCase(),n.title().toLowerCase());return n.category().startsWith("Panel")?o+=2:n.category().startsWith("Drawer")&&(o+=1),o}renderItem(e,t,n,o){const r=this._commands[e];n.removeChildren();const a=n.createChild("span","tag"),s=Platform.StringUtilities.hashCode(r.category())%MaterialPaletteColors.length;a.style.backgroundColor=MaterialPaletteColors[s],a.textContent=r.category(),UI.UIUtils.createTextChild(n,r.title()),FilteredListWidget.highlightRanges(n,t,!0),o.textContent=r.shortcut()}selectItem(e,t){null!==e&&(this._commands[e].execute(),Host.userMetrics.actionTaken(Host.UserMetrics.Action.SelectCommandFromCommandMenu))}notFoundText(){return i18nString(UIStrings.noCommandsFound)}}export const MaterialPaletteColors=["#F44336","#E91E63","#9C27B0","#673AB7","#3F51B5","#03A9F4","#00BCD4","#009688","#4CAF50","#8BC34A","#CDDC39","#FFC107","#FF9800","#FF5722","#795548","#9E9E9E","#607D8B"];export class Command{constructor(e,t,n,o,r,a){this._category=e,this._title=t,this._key=e+"\0"+t+"\0"+n,this._shortcut=o,this._executeHandler=r,this._availableHandler=a}category(){return this._category}title(){return this._title}key(){return this._key}shortcut(){return this._shortcut}available(){return!this._availableHandler||this._availableHandler()}execute(){this._executeHandler()}}export class ShowActionDelegate{static instance(e={forceNew:null}){const{forceNew:t}=e;return showActionDelegateInstance&&!t||(showActionDelegateInstance=new ShowActionDelegate),showActionDelegateInstance}handleAction(e,t){return Host.InspectorFrontendHost.InspectorFrontendHostInstance.bringToFront(),QuickOpenImpl.show(">"),!0}}registerProvider({prefix:">",title:()=>i18nString(UIStrings.runCommand),provider:CommandMenuProvider.instance});