import*as DataGrid from"../data_grid/data_grid.js";import*as i18n from"../i18n/i18n.js";import*as ObjectUI from"../object_ui/object_ui.js";import*as UI from"../ui/ui.js";const UIStrings={loading:"Loading\u2026",securityOrigin:"Security origin",version:"Version",objectStores:"Object stores",deleteDatabase:"Delete database",refreshDatabase:"Refresh database",pleaseConfirmDeleteOfSDatabase:'Please confirm delete of "{PH1}" database.',idb:"IDB",refresh:"Refresh",deleteSelected:"Delete selected",clearObjectStore:"Clear object store",dataMayBeStale:"Data may be stale",someEntriesMayHaveBeenModified:"Some entries may have been modified",keyString:"Key",primaryKey:"Primary key",valueString:"Value",indexedDb:"Indexed DB",keyPath:"Key path: ",showPreviousPage:"Show previous page",showNextPage:"Show next page",startFromKey:"Start from key",expandRecursively:"Expand Recursively",collapse:"Collapse",totalEntriesS:"Total entries: {PH1}",keyGeneratorValueS:"Key generator value: {PH1}"},str_=i18n.i18n.registerUIStrings("resources/IndexedDBViews.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class IDBDatabaseView extends UI.Widget.VBox{constructor(e,t){super(),this._model=e;const a=t?t.databaseId.name:i18nString(UIStrings.loading);this.registerRequiredCSS("resources/indexedDBViews.css",{enableLegacyPatching:!1}),this.contentElement.classList.add("indexed-db-container"),this._reportView=new UI.ReportView.ReportView(a),this._reportView.show(this.contentElement),this._reportView.registerRequiredCSS("resources/indexedDBViews.css",{enableLegacyPatching:!1}),this._reportView.element.classList.add("indexed-db-header");const i=this._reportView.appendSection("");this._securityOriginElement=i.appendField(i18nString(UIStrings.securityOrigin)),this._versionElement=i.appendField(i18nString(UIStrings.version)),this._objectStoreCountElement=i.appendField(i18nString(UIStrings.objectStores));const s=this._reportView.appendSection("").appendRow();this._clearButton=UI.UIUtils.createTextButton(i18nString(UIStrings.deleteDatabase),(()=>this._deleteDatabase()),i18nString(UIStrings.deleteDatabase)),s.appendChild(this._clearButton),this._refreshButton=UI.UIUtils.createTextButton(i18nString(UIStrings.refreshDatabase),(()=>this._refreshDatabaseButtonClicked()),i18nString(UIStrings.refreshDatabase)),s.appendChild(this._refreshButton),t&&this.update(t)}_refreshDatabase(){this._securityOriginElement.textContent=this._database.databaseId.securityOrigin,this._versionElement&&(this._versionElement.textContent=this._database.version.toString()),this._objectStoreCountElement.textContent=this._database.objectStores.size.toString()}_refreshDatabaseButtonClicked(){this._model.refreshDatabase(this._database.databaseId)}update(e){this._database=e,this._reportView.setTitle(this._database.databaseId.name),this._refreshDatabase(),this._updatedForTests()}_updatedForTests(){}async _deleteDatabase(){await UI.UIUtils.ConfirmDialog.show(i18nString(UIStrings.pleaseConfirmDeleteOfSDatabase,{PH1:this._database.databaseId.name}),this.element)&&this._model.deleteDatabase(this._database.databaseId)}}export class IDBDataView extends UI.View.SimpleView{constructor(e,t,a,i,s){super(i18nString(UIStrings.idb)),this.registerRequiredCSS("resources/indexedDBViews.css",{enableLegacyPatching:!1}),this._model=e,this._databaseId=t,this._isIndex=Boolean(i),this._refreshObjectStoreCallback=s,this.element.classList.add("indexed-db-data-view","storage-view"),this._refreshButton=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.refresh),"largeicon-refresh"),this._refreshButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this._refreshButtonClicked,this),this._deleteSelectedButton=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.deleteSelected),"largeicon-delete"),this._deleteSelectedButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,(e=>{this._deleteButtonClicked(null)})),this._clearButton=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.clearObjectStore),"largeicon-clear"),this._clearButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,(e=>{this._clearButtonClicked(e)}),this),this._needsRefresh=new UI.Toolbar.ToolbarItem(UI.UIUtils.createIconLabel(i18nString(UIStrings.dataMayBeStale),"smallicon-warning")),this._needsRefresh.setVisible(!1),this._needsRefresh.setTitle(i18nString(UIStrings.someEntriesMayHaveBeenModified)),this._clearingObjectStore=!1,this._createEditorToolbar(),this._pageSize=50,this._skipCount=0,this.update(a,i),this._entries=[]}_createDataGrid(){const e=this._isIndex&&this._index?this._index.keyPath:this._objectStore.keyPath,t=[],a={title:void 0,titleDOMFragment:void 0,sortable:!1,sort:void 0,align:void 0,width:void 0,fixedWidth:void 0,editable:void 0,nonSelectable:void 0,longText:void 0,disclosure:void 0,weight:void 0,allowInSortByEvenWhenHidden:void 0,dataType:void 0,defaultWeight:void 0};t.push({...a,id:"number",title:"#",sortable:!1,width:"50px"}),t.push({...a,id:"key",titleDOMFragment:this._keyColumnHeaderFragment(i18nString(UIStrings.keyString),e),sortable:!1}),this._isIndex&&t.push({...a,id:"primaryKey",titleDOMFragment:this._keyColumnHeaderFragment(i18nString(UIStrings.primaryKey),this._objectStore.keyPath),sortable:!1});const i=i18nString(UIStrings.valueString);t.push({...a,id:"value",title:i,sortable:!1});const s=new DataGrid.DataGrid.DataGridImpl({displayName:i18nString(UIStrings.indexedDb),columns:t,deleteCallback:this._deleteButtonClicked.bind(this),refreshCallback:this._updateData.bind(this,!0),editCallback:void 0});return s.setStriped(!0),s.addEventListener(DataGrid.DataGrid.Events.SelectedNode,(e=>this._updateToolbarEnablement()),this),s}_keyColumnHeaderFragment(e,t){const a=document.createDocumentFragment();if(UI.UIUtils.createTextChild(a,e),null===t)return a;if(UI.UIUtils.createTextChild(a," ("+i18nString(UIStrings.keyPath)),Array.isArray(t)){UI.UIUtils.createTextChild(a,"[");for(let e=0;e<t.length;++e)0!==e&&UI.UIUtils.createTextChild(a,", "),a.appendChild(this._keyPathStringFragment(t[e]));UI.UIUtils.createTextChild(a,"]")}else{const e=t;a.appendChild(this._keyPathStringFragment(e))}return UI.UIUtils.createTextChild(a,")"),a}_keyPathStringFragment(e){const t=document.createDocumentFragment();UI.UIUtils.createTextChild(t,'"');return t.createChild("span","source-code indexed-db-key-path").textContent=e,UI.UIUtils.createTextChild(t,'"'),t}_createEditorToolbar(){const e=new UI.Toolbar.Toolbar("data-view-toolbar",this.element);e.appendToolbarItem(this._refreshButton),e.appendToolbarItem(new UI.Toolbar.ToolbarSeparator),this._pageBackButton=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.showPreviousPage),"largeicon-play-back"),this._pageBackButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this._pageBackButtonClicked,this),e.appendToolbarItem(this._pageBackButton),this._pageForwardButton=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.showNextPage),"largeicon-play"),this._pageForwardButton.setEnabled(!1),this._pageForwardButton.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,this._pageForwardButtonClicked,this),e.appendToolbarItem(this._pageForwardButton),this._keyInput=new UI.Toolbar.ToolbarInput(i18nString(UIStrings.startFromKey),"",.5),this._keyInput.addEventListener(UI.Toolbar.ToolbarInput.Event.TextChanged,this._updateData.bind(this,!1)),e.appendToolbarItem(this._keyInput),e.appendToolbarItem(new UI.Toolbar.ToolbarSeparator),e.appendToolbarItem(this._clearButton),e.appendToolbarItem(this._deleteSelectedButton),e.appendToolbarItem(this._needsRefresh)}_pageBackButtonClicked(e){this._skipCount=Math.max(0,this._skipCount-this._pageSize),this._updateData(!1)}_pageForwardButtonClicked(e){this._skipCount=this._skipCount+this._pageSize,this._updateData(!1)}_populateContextMenu(e,t){const a=t;a.valueObjectPresentation&&(e.revealSection().appendItem(i18nString(UIStrings.expandRecursively),(()=>{a.valueObjectPresentation&&a.valueObjectPresentation.objectTreeElement().expandRecursively()})),e.revealSection().appendItem(i18nString(UIStrings.collapse),(()=>{a.valueObjectPresentation&&a.valueObjectPresentation.objectTreeElement().collapse()})))}refreshData(){this._updateData(!0)}update(e,t){this._objectStore=e,this._index=t,this._dataGrid&&this._dataGrid.asWidget().detach(),this._dataGrid=this._createDataGrid(),this._dataGrid.setRowContextMenuCallback(this._populateContextMenu.bind(this)),this._dataGrid.asWidget().show(this.element),this._skipCount=0,this._updateData(!0)}_parseKey(e){let t;try{t=JSON.parse(e)}catch(a){t=e}return t}_updateData(e){const t=this._parseKey(this._keyInput.value()),a=this._pageSize;let i=this._skipCount,s=this._dataGrid.selectedNode?this._dataGrid.selectedNode.data.number:0;if(s=Math.max(s,this._skipCount),this._clearButton.setEnabled(!this._isIndex),!e&&this._lastKey===t&&this._lastPageSize===a&&this._lastSkipCount===i)return;function r(e,t){this.clear(),this._entries=e;let a=null;for(let r=0;r<e.length;++r){const t={};t.number=r+i,t.key=e[r].key,t.primaryKey=e[r].primaryKey,t.value=e[r].value;const n=new IDBDataGridNode(t);this._dataGrid.rootNode().appendChild(n),t.number<=s&&(a=n)}a&&a.select(),this._pageBackButton.setEnabled(Boolean(i)),this._pageForwardButton.setEnabled(t),this._needsRefresh.setVisible(!1),this._updateToolbarEnablement(),this._updatedDataForTests()}this._lastKey===t&&this._lastPageSize===a||(i=0,this._skipCount=0),this._lastKey=t,this._lastPageSize=a,this._lastSkipCount=i;const n=t?window.IDBKeyRange.lowerBound(t):null;this._isIndex&&this._index?this._model.loadIndexData(this._databaseId,this._objectStore.name,this._index.name,n,i,a,r.bind(this)):this._model.loadObjectStoreData(this._databaseId,this._objectStore.name,n,i,a,r.bind(this)),this._model.getMetadata(this._databaseId,this._objectStore).then(this._updateSummaryBar.bind(this))}_updateSummaryBar(e){if(this._summaryBarElement||(this._summaryBarElement=this.element.createChild("div","object-store-summary-bar")),this._summaryBarElement.removeChildren(),!e)return;const t=this._summaryBarElement.createChild("span");t.textContent=i18nString(UIStrings.totalEntriesS,{PH1:String(e.entriesCount)}),this._objectStore.autoIncrement&&(t.textContent+="\u2002\u2758\u2002",t.textContent+=i18nString(UIStrings.keyGeneratorValueS,{PH1:String(e.keyGeneratorValue)}))}_updatedDataForTests(){}_refreshButtonClicked(e){this._updateData(!0)}async _clearButtonClicked(e){this._clearButton.setEnabled(!1),this._clearingObjectStore=!0,await this._model.clearObjectStore(this._databaseId,this._objectStore.name),this._clearingObjectStore=!1,this._clearButton.setEnabled(!0),this._updateData(!0)}markNeedsRefresh(){this._clearingObjectStore||this._needsRefresh.setVisible(!0)}async _deleteButtonClicked(e){if(!e&&!(e=this._dataGrid.selectedNode))return;const t=(this._isIndex?e.data.primaryKey:e.data.key).value;await this._model.deleteEntries(this._databaseId,this._objectStore.name,window.IDBKeyRange.only(t)),this._refreshObjectStoreCallback()}clear(){this._dataGrid.rootNode().removeChildren(),this._entries=[]}_updateToolbarEnablement(){const e=!this._dataGrid||0===this._dataGrid.rootNode().children.length;this._deleteSelectedButton.setEnabled(!e&&null!==this._dataGrid.selectedNode)}}export class IDBDataGridNode extends DataGrid.DataGrid.DataGridNode{constructor(e){super(e,!1),this.selectable=!0,this.valueObjectPresentation=null}createCell(e){const t=super.createCell(e),a=this.data[e];switch(e){case"value":{t.removeChildren();const e=ObjectUI.ObjectPropertiesSection.ObjectPropertiesSection.defaultObjectPropertiesSection(a,void 0,!0,!0);t.appendChild(e.element),this.valueObjectPresentation=e;break}case"key":case"primaryKey":{t.removeChildren();const e=ObjectUI.ObjectPropertiesSection.ObjectPropertiesSection.defaultObjectPresentation(a,void 0,!0,!0);t.appendChild(e);break}}return t}}