import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import{DOMModel,Events as DOMModelEvents}from"./DOMModel.js";import{RemoteObject}from"./RemoteObject.js";import{RuntimeModel}from"./RuntimeModel.js";import{Capability,SDKModel,TargetManager}from"./SDKModel.js";const UIStrings={trustedTypeViolations:"Trusted Type Violations",sinkViolations:"Sink Violations",policyViolations:"Policy Violations",animation:"Animation",canvas:"Canvas",geolocation:"Geolocation",notification:"Notification",parse:"Parse",script:"Script",timer:"Timer",window:"Window",webaudio:"WebAudio",media:"Media",pictureinpicture:"Picture-in-Picture",clipboard:"Clipboard",control:"Control",device:"Device",domMutation:"DOM Mutation",dragDrop:"Drag / drop",keyboard:"Keyboard",load:"Load",mouse:"Mouse",pointer:"Pointer",touch:"Touch",xhr:"XHR",settimeoutFired:"setTimeout fired",setintervalFired:"setInterval fired",scriptFirstStatement:"Script First Statement",scriptBlockedByContentSecurity:"Script Blocked by Content Security Policy",requestAnimationFrame:"Request Animation Frame",cancelAnimationFrame:"Cancel Animation Frame",animationFrameFired:"Animation Frame Fired",webglErrorFired:"WebGL Error Fired",webglWarningFired:"WebGL Warning Fired",setInnerhtml:"Set innerHTML",createCanvasContext:"Create canvas context",createAudiocontext:"Create AudioContext",closeAudiocontext:"Close AudioContext",resumeAudiocontext:"Resume AudioContext",suspendAudiocontext:"Suspend AudioContext",webglErrorFiredS:"WebGL Error Fired ({PH1})",scriptBlockedDueToContent:"Script blocked due to Content Security Policy directive: {PH1}"},str_=i18n.i18n.registerUIStrings("sdk/DOMDebuggerModel.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class DOMDebuggerModel extends SDKModel{constructor(e){super(e),this._agent=e.domdebuggerAgent(),this._runtimeModel=e.model(RuntimeModel),this._domModel=e.model(DOMModel),this._domModel.addEventListener(DOMModelEvents.DocumentUpdated,this._documentUpdated,this),this._domModel.addEventListener(DOMModelEvents.NodeRemoved,this._nodeRemoved,this),this._domBreakpoints=[],this._domBreakpointsSetting=Common.Settings.Settings.instance().createLocalSetting("domBreakpoints",[]),this._domModel.existingDocument()&&this._documentUpdated()}runtimeModel(){return this._runtimeModel}async eventListeners(e){if(console.assert(e.runtimeModel()===this._runtimeModel),!e.objectId)return[];const t=await this._agent.invoke_getEventListeners({objectId:e.objectId}),n=[];for(const i of t.listeners||[]){const t=this._runtimeModel.debuggerModel().createRawLocationByScriptId(i.scriptId,i.lineNumber,i.columnNumber);t&&n.push(new EventListener(this,e,i.type,i.useCapture,i.passive,i.once,i.handler?this._runtimeModel.createRemoteObject(i.handler):null,i.originalHandler?this._runtimeModel.createRemoteObject(i.originalHandler):null,t,null))}return n}retrieveDOMBreakpoints(){this._domModel.requestDocument()}domBreakpoints(){return this._domBreakpoints.slice()}hasDOMBreakpoint(e,t){return this._domBreakpoints.some((n=>n.node===e&&n.type===t))}setDOMBreakpoint(e,t){for(const i of this._domBreakpoints)if(i.node===e&&i.type===t)return this.toggleDOMBreakpoint(i,!0),i;const n=new DOMBreakpoint(this,e,t,!0);return this._domBreakpoints.push(n),this._saveDOMBreakpoints(),this._enableDOMBreakpoint(n),this.dispatchEventToListeners(Events.DOMBreakpointAdded,n),n}removeDOMBreakpoint(e,t){this._removeDOMBreakpoints((n=>n.node===e&&n.type===t))}removeAllDOMBreakpoints(){this._removeDOMBreakpoints((e=>!0))}toggleDOMBreakpoint(e,t){t!==e.enabled&&(e.enabled=t,t?this._enableDOMBreakpoint(e):this._disableDOMBreakpoint(e),this.dispatchEventToListeners(Events.DOMBreakpointToggled,e))}_enableDOMBreakpoint(e){e.node.id&&(this._agent.invoke_setDOMBreakpoint({nodeId:e.node.id,type:e.type}),e.node.setMarker(Marker,!0))}_disableDOMBreakpoint(e){e.node.id&&(this._agent.invoke_removeDOMBreakpoint({nodeId:e.node.id,type:e.type}),e.node.setMarker(Marker,!!this._nodeHasBreakpoints(e.node)||null))}_nodeHasBreakpoints(e){for(const t of this._domBreakpoints)if(t.node===e&&t.enabled)return!0;return!1}resolveDOMBreakpointData(e){const t=e.type,n=this._domModel.nodeForId(e.nodeId);if(!t||!n)return null;let i=null,r=!1;return t===Protocol.DOMDebugger.DOMBreakpointType.SubtreeModified&&(r=e.insertion||!1,i=this._domModel.nodeForId(e.targetNodeId)),{type:t,node:n,targetNode:i,insertion:r}}_currentURL(){const e=this._domModel.existingDocument();return e?e.documentURL:""}_documentUpdated(){const e=this._domBreakpoints;this._domBreakpoints=[],this.dispatchEventToListeners(Events.DOMBreakpointsRemoved,e);const t=this._currentURL();for(const i of this._domBreakpointsSetting.get())i.url===t&&this._domModel.pushNodeByPathToFrontend(i.path).then(n.bind(this,i));function n(e,t){const n=t?this._domModel.nodeForId(t):null;if(!n)return;const i=new DOMBreakpoint(this,n,e.type,e.enabled);this._domBreakpoints.push(i),e.enabled&&this._enableDOMBreakpoint(i),this.dispatchEventToListeners(Events.DOMBreakpointAdded,i)}}_removeDOMBreakpoints(e){const t=[],n=[];for(const i of this._domBreakpoints)e(i)?(t.push(i),i.enabled&&(i.enabled=!1,this._disableDOMBreakpoint(i))):n.push(i);t.length&&(this._domBreakpoints=n,this._saveDOMBreakpoints(),this.dispatchEventToListeners(Events.DOMBreakpointsRemoved,t))}_nodeRemoved(e){const t=e.data.node,n=t.children()||[];this._removeDOMBreakpoints((e=>e.node===t||-1!==n.indexOf(e.node)))}_saveDOMBreakpoints(){const e=this._currentURL(),t=this._domBreakpointsSetting.get().filter((t=>t.url!==e));for(const n of this._domBreakpoints)t.push({url:e,path:n.node.path(),type:n.type,enabled:n.enabled});this._domBreakpointsSetting.set(t)}}export const Events={DOMBreakpointAdded:Symbol("DOMBreakpointAdded"),DOMBreakpointToggled:Symbol("DOMBreakpointToggled"),DOMBreakpointsRemoved:Symbol("DOMBreakpointsRemoved")};const Marker="breakpoint-marker";export class DOMBreakpoint{constructor(e,t,n,i){this.domDebuggerModel=e,this.node=t,this.type=n,this.enabled=i}}export class EventListener{constructor(e,t,n,i,r,o,s,a,l,d,c){this._domDebuggerModel=e,this._eventTarget=t,this._type=n,this._useCapture=i,this._passive=r,this._once=o,this._handler=s,this._originalHandler=a||s,this._location=l;const u=l.script();this._sourceURL=u?u.contentURL():"",this._customRemoveFunction=d,this._origin=c||EventListener.Origin.Raw}domDebuggerModel(){return this._domDebuggerModel}type(){return this._type}useCapture(){return this._useCapture}passive(){return this._passive}once(){return this._once}handler(){return this._handler}location(){return this._location}sourceURL(){return this._sourceURL}originalHandler(){return this._originalHandler}canRemove(){return Boolean(this._customRemoveFunction)||this._origin!==EventListener.Origin.FrameworkUser}remove(){if(!this.canRemove())return Promise.resolve(void 0);if(this._origin!==EventListener.Origin.FrameworkUser){function e(e,t,n){this.removeEventListener(e,t,n),this["on"+e]&&(this["on"+e]=void 0)}return this._eventTarget.callFunction(e,[RemoteObject.toCallArgument(this._type),RemoteObject.toCallArgument(this._originalHandler),RemoteObject.toCallArgument(this._useCapture)]).then((()=>{}))}if(this._customRemoveFunction){function e(e,t,n,i){this.call(null,e,t,n,i)}return this._customRemoveFunction.callFunction(e,[RemoteObject.toCallArgument(this._type),RemoteObject.toCallArgument(this._originalHandler),RemoteObject.toCallArgument(this._useCapture),RemoteObject.toCallArgument(this._passive)]).then((()=>{}))}return Promise.resolve(void 0)}canTogglePassive(){return this._origin!==EventListener.Origin.FrameworkUser}togglePassive(){return this._eventTarget.callFunction((function(e,t,n,i){this.removeEventListener(e,t,{capture:n}),this.addEventListener(e,t,{capture:n,passive:!i})}),[RemoteObject.toCallArgument(this._type),RemoteObject.toCallArgument(this._originalHandler),RemoteObject.toCallArgument(this._useCapture),RemoteObject.toCallArgument(this._passive)]).then((()=>{}))}origin(){return this._origin}markAsFramework(){this._origin=EventListener.Origin.Framework}isScrollBlockingType(){return"touchstart"===this._type||"touchmove"===this._type||"mousewheel"===this._type||"wheel"===this._type}}EventListener.Origin={Raw:"Raw",Framework:"Framework",FrameworkUser:"FrameworkUser"};export class CategorizedBreakpoint{constructor(e,t){this._category=e,this._title=t,this._enabled=!1}category(){return this._category}enabled(){return this._enabled}setEnabled(e){this._enabled=e}title(){return this._title}}export class CSPViolationBreakpoint extends CategorizedBreakpoint{constructor(e,t,n){super(e,t),this._type=n}type(){return this._type}}export class EventListenerBreakpoint extends CategorizedBreakpoint{constructor(e,t,n,i,r){super(i,r),this._instrumentationName=e,this._eventName=t,this._eventTargetNames=n}setEnabled(e){if(this._enabled!==e){super.setEnabled(e);for(const e of TargetManager.instance().models(DOMDebuggerModel))this._updateOnModel(e)}}_updateOnModel(e){if(this._instrumentationName)this._enabled?e._agent.invoke_setInstrumentationBreakpoint({eventName:this._instrumentationName}):e._agent.invoke_removeInstrumentationBreakpoint({eventName:this._instrumentationName});else for(const t of this._eventTargetNames)this._enabled?e._agent.invoke_setEventListenerBreakpoint({eventName:this._eventName,targetName:t}):e._agent.invoke_removeEventListenerBreakpoint({eventName:this._eventName,targetName:t})}}let domDebuggerManagerInstance;EventListenerBreakpoint._listener="listener:",EventListenerBreakpoint._instrumentation="instrumentation:";export class DOMDebuggerManager{constructor(){this._xhrBreakpointsSetting=Common.Settings.Settings.instance().createLocalSetting("xhrBreakpoints",[]),this._xhrBreakpoints=new Map;for(const t of this._xhrBreakpointsSetting.get())this._xhrBreakpoints.set(t.url,t.enabled);let e;this._cspViolationsToBreakOn=[],this._cspViolationsToBreakOn.push(new CSPViolationBreakpoint(i18nString(UIStrings.trustedTypeViolations),i18nString(UIStrings.sinkViolations),Protocol.DOMDebugger.CSPViolationType.TrustedtypeSinkViolation)),this._cspViolationsToBreakOn.push(new CSPViolationBreakpoint(i18nString(UIStrings.trustedTypeViolations),i18nString(UIStrings.policyViolations),Protocol.DOMDebugger.CSPViolationType.TrustedtypePolicyViolation)),this._eventListenerBreakpoints=[],this._createInstrumentationBreakpoints(i18nString(UIStrings.animation),["requestAnimationFrame","cancelAnimationFrame","requestAnimationFrame.callback"]),this._createInstrumentationBreakpoints(i18nString(UIStrings.canvas),["canvasContextCreated","webglErrorFired","webglWarningFired"]),this._createInstrumentationBreakpoints(i18nString(UIStrings.geolocation),["Geolocation.getCurrentPosition","Geolocation.watchPosition"]),this._createInstrumentationBreakpoints(i18nString(UIStrings.notification),["Notification.requestPermission"]),this._createInstrumentationBreakpoints(i18nString(UIStrings.parse),["Element.setInnerHTML","Document.write"]),this._createInstrumentationBreakpoints(i18nString(UIStrings.script),["scriptFirstStatement","scriptBlockedByCSP"]),this._createInstrumentationBreakpoints(i18nString(UIStrings.timer),["setTimeout","clearTimeout","setInterval","clearInterval","setTimeout.callback","setInterval.callback"]),this._createInstrumentationBreakpoints(i18nString(UIStrings.window),["DOMWindow.close"]),this._createInstrumentationBreakpoints(i18nString(UIStrings.webaudio),["audioContextCreated","audioContextClosed","audioContextResumed","audioContextSuspended"]),this._createEventListenerBreakpoints(i18nString(UIStrings.media),["play","pause","playing","canplay","canplaythrough","seeking","seeked","timeupdate","ended","ratechange","durationchange","volumechange","loadstart","progress","suspend","abort","error","emptied","stalled","loadedmetadata","loadeddata","waiting"],["audio","video"]),this._createEventListenerBreakpoints(i18nString(UIStrings.pictureinpicture),["enterpictureinpicture","leavepictureinpicture"],["video"]),this._createEventListenerBreakpoints(i18nString(UIStrings.pictureinpicture),["resize"],["PictureInPictureWindow"]),this._createEventListenerBreakpoints(i18nString(UIStrings.clipboard),["copy","cut","paste","beforecopy","beforecut","beforepaste"],["*"]),this._createEventListenerBreakpoints(i18nString(UIStrings.control),["resize","scroll","zoom","focus","blur","select","change","submit","reset"],["*"]),this._createEventListenerBreakpoints(i18nString(UIStrings.device),["deviceorientation","devicemotion"],["*"]),this._createEventListenerBreakpoints(i18nString(UIStrings.domMutation),["DOMActivate","DOMFocusIn","DOMFocusOut","DOMAttrModified","DOMCharacterDataModified","DOMNodeInserted","DOMNodeInsertedIntoDocument","DOMNodeRemoved","DOMNodeRemovedFromDocument","DOMSubtreeModified","DOMContentLoaded"],["*"]),this._createEventListenerBreakpoints(i18nString(UIStrings.dragDrop),["drag","dragstart","dragend","dragenter","dragover","dragleave","drop"],["*"]),this._createEventListenerBreakpoints(i18nString(UIStrings.keyboard),["keydown","keyup","keypress","input"],["*"]),this._createEventListenerBreakpoints(i18nString(UIStrings.load),["load","beforeunload","unload","abort","error","hashchange","popstate"],["*"]),this._createEventListenerBreakpoints(i18nString(UIStrings.mouse),["auxclick","click","dblclick","mousedown","mouseup","mouseover","mousemove","mouseout","mouseenter","mouseleave","mousewheel","wheel","contextmenu"],["*"]),this._createEventListenerBreakpoints(i18nString(UIStrings.pointer),["pointerover","pointerout","pointerenter","pointerleave","pointerdown","pointerup","pointermove","pointercancel","gotpointercapture","lostpointercapture","pointerrawupdate"],["*"]),this._createEventListenerBreakpoints(i18nString(UIStrings.touch),["touchstart","touchmove","touchend","touchcancel"],["*"]),this._createEventListenerBreakpoints(i18nString("Worker"),["message","messageerror"],["*"]),this._createEventListenerBreakpoints(i18nString(UIStrings.xhr),["readystatechange","load","loadstart","loadend","abort","error","progress","timeout"],["xmlhttprequest","xmlhttprequestupload"]),e=this._resolveEventListenerBreakpoint("instrumentation:setTimeout.callback"),e&&(e._title=i18nString(UIStrings.settimeoutFired)),e=this._resolveEventListenerBreakpoint("instrumentation:setInterval.callback"),e&&(e._title=i18nString(UIStrings.setintervalFired)),e=this._resolveEventListenerBreakpoint("instrumentation:scriptFirstStatement"),e&&(e._title=i18nString(UIStrings.scriptFirstStatement)),e=this._resolveEventListenerBreakpoint("instrumentation:scriptBlockedByCSP"),e&&(e._title=i18nString(UIStrings.scriptBlockedByContentSecurity)),e=this._resolveEventListenerBreakpoint("instrumentation:requestAnimationFrame"),e&&(e._title=i18nString(UIStrings.requestAnimationFrame)),e=this._resolveEventListenerBreakpoint("instrumentation:cancelAnimationFrame"),e&&(e._title=i18nString(UIStrings.cancelAnimationFrame)),e=this._resolveEventListenerBreakpoint("instrumentation:requestAnimationFrame.callback"),e&&(e._title=i18nString(UIStrings.animationFrameFired)),e=this._resolveEventListenerBreakpoint("instrumentation:webglErrorFired"),e&&(e._title=i18nString(UIStrings.webglErrorFired)),e=this._resolveEventListenerBreakpoint("instrumentation:webglWarningFired"),e&&(e._title=i18nString(UIStrings.webglWarningFired)),e=this._resolveEventListenerBreakpoint("instrumentation:Element.setInnerHTML"),e&&(e._title=i18nString(UIStrings.setInnerhtml)),e=this._resolveEventListenerBreakpoint("instrumentation:canvasContextCreated"),e&&(e._title=i18nString(UIStrings.createCanvasContext)),e=this._resolveEventListenerBreakpoint("instrumentation:Geolocation.getCurrentPosition"),e&&(e._title="getCurrentPosition"),e=this._resolveEventListenerBreakpoint("instrumentation:Geolocation.watchPosition"),e&&(e._title="watchPosition"),e=this._resolveEventListenerBreakpoint("instrumentation:Notification.requestPermission"),e&&(e._title="requestPermission"),e=this._resolveEventListenerBreakpoint("instrumentation:DOMWindow.close"),e&&(e._title="window.close"),e=this._resolveEventListenerBreakpoint("instrumentation:Document.write"),e&&(e._title="document.write"),e=this._resolveEventListenerBreakpoint("instrumentation:audioContextCreated"),e&&(e._title=i18nString(UIStrings.createAudiocontext)),e=this._resolveEventListenerBreakpoint("instrumentation:audioContextClosed"),e&&(e._title=i18nString(UIStrings.closeAudiocontext)),e=this._resolveEventListenerBreakpoint("instrumentation:audioContextResumed"),e&&(e._title=i18nString(UIStrings.resumeAudiocontext)),e=this._resolveEventListenerBreakpoint("instrumentation:audioContextSuspended"),e&&(e._title=i18nString(UIStrings.suspendAudiocontext)),TargetManager.instance().observeModels(DOMDebuggerModel,this)}static instance(e={forceNew:null}){const{forceNew:t}=e;return domDebuggerManagerInstance&&!t||(domDebuggerManagerInstance=new DOMDebuggerManager),domDebuggerManagerInstance}cspViolationBreakpoints(){return this._cspViolationsToBreakOn.slice()}_createInstrumentationBreakpoints(e,t){for(const n of t)this._eventListenerBreakpoints.push(new EventListenerBreakpoint(n,"",[],e,n))}_createEventListenerBreakpoints(e,t,n){for(const i of t)this._eventListenerBreakpoints.push(new EventListenerBreakpoint("",i,n,e,i))}_resolveEventListenerBreakpoint(e,t){const n="instrumentation:",i="listener:";let r="";if(e.startsWith(n))r=e.substring(n.length),e="";else{if(!e.startsWith(i))return null;e=e.substring(i.length)}t=(t||"*").toLowerCase();let o=null;for(const s of this._eventListenerBreakpoints)r&&s._instrumentationName===r&&(o=s),e&&s._eventName===e&&-1!==s._eventTargetNames.indexOf(t)&&(o=s),!o&&e&&s._eventName===e&&-1!==s._eventTargetNames.indexOf("*")&&(o=s);return o}eventListenerBreakpoints(){return this._eventListenerBreakpoints.slice()}resolveEventListenerBreakpointTitle(e){const t=e.eventName;if("instrumentation:webglErrorFired"===t&&e.webglErrorName){let t=e.webglErrorName;return t=t.replace(/^.*(0x[0-9a-f]+).*$/i,"$1"),i18nString(UIStrings.webglErrorFiredS,{PH1:t})}if("instrumentation:scriptBlockedByCSP"===t&&e.directiveText)return i18nString(UIStrings.scriptBlockedDueToContent,{PH1:e.directiveText});const n=this._resolveEventListenerBreakpoint(t,e.targetName);return n?e.targetName?e.targetName+"."+n._title:n._title:""}resolveEventListenerBreakpoint(e){return this._resolveEventListenerBreakpoint(e.eventName,e.targetName)}updateCSPViolationBreakpoints(){const e=this._cspViolationsToBreakOn.filter((e=>e.enabled())).map((e=>e.type()));for(const t of TargetManager.instance().models(DOMDebuggerModel))this._updateCSPViolationBreakpointsForModel(t,e)}_updateCSPViolationBreakpointsForModel(e,t){e._agent.invoke_setBreakOnCSPViolation({violationTypes:t})}xhrBreakpoints(){return this._xhrBreakpoints}_saveXHRBreakpoints(){const e=[];for(const t of this._xhrBreakpoints.keys())e.push({url:t,enabled:this._xhrBreakpoints.get(t)});this._xhrBreakpointsSetting.set(e)}addXHRBreakpoint(e,t){if(this._xhrBreakpoints.set(e,t),t)for(const n of TargetManager.instance().models(DOMDebuggerModel))n._agent.invoke_setXHRBreakpoint({url:e});this._saveXHRBreakpoints()}removeXHRBreakpoint(e){const t=this._xhrBreakpoints.get(e);if(this._xhrBreakpoints.delete(e),t)for(const n of TargetManager.instance().models(DOMDebuggerModel))n._agent.invoke_removeXHRBreakpoint({url:e});this._saveXHRBreakpoints()}toggleXHRBreakpoint(e,t){this._xhrBreakpoints.set(e,t);for(const n of TargetManager.instance().models(DOMDebuggerModel))t?n._agent.invoke_setXHRBreakpoint({url:e}):n._agent.invoke_removeXHRBreakpoint({url:e});this._saveXHRBreakpoints()}modelAdded(e){for(const n of this._xhrBreakpoints.keys())this._xhrBreakpoints.get(n)&&e._agent.invoke_setXHRBreakpoint({url:n});for(const n of this._eventListenerBreakpoints)n._enabled&&n._updateOnModel(e);const t=this._cspViolationsToBreakOn.filter((e=>e.enabled())).map((e=>e.type()));this._updateCSPViolationBreakpointsForModel(e,t)}modelRemoved(e){}}SDKModel.register(DOMDebuggerModel,Capability.DOM,!1);