import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import*as Platform from"../platform/platform.js";import*as TextUtils from"../text_utils/text_utils.js";import{Attributes}from"./Cookie.js";import{CookieParser}from"./CookieParser.js";import{NetworkManager}from"./NetworkManager.js";import{Type}from"./SDKModel.js";import{ServerTiming}from"./ServerTiming.js";const UIStrings={binary:"(binary)",secureOnly:'This cookie was blocked because it had the "Secure" attribute and the connection was not secure.',notOnPath:"This cookie was blocked because its path was not an exact match for or a superdirectory of the request url's path.",domainMismatch:"This cookie was blocked because neither did the request URL's domain exactly match the cookie's domain, nor was the request URL's domain a subdomain of the cookie's Domain attribute value.",sameSiteStrict:'This cookie was blocked because it had the "SameSite=Strict" attribute and the request was made from a different site. This includes top-level navigation requests initiated by other sites.',sameSiteLax:'This cookie was blocked because it had the "SameSite=Lax" attribute and the request was made from a different site and was not initiated by a top-level navigation.',sameSiteUnspecifiedTreatedAsLax:'This cookie didn\'t specify a "SameSite" attribute when it was stored and was defaulted to "SameSite=Lax," and was blocked because the request was made from a different site and was not initiated by a top-level navigation. The cookie had to have been set with "SameSite=None" to enable cross-site usage.',sameSiteNoneInsecure:'This cookie was blocked because it had the "SameSite=None" attribute but was not marked "Secure". Cookies without SameSite restrictions must be marked "Secure" and sent over a secure connection.',userPreferences:"This cookie was blocked due to user preferences.",unknownError:"An unknown error was encountered when trying to send this cookie.",schemefulSameSiteStrict:'This cookie was blocked because it had the "SameSite=Strict" attribute but the request was cross-site. This includes top-level navigation requests initiated by other sites. This request is considered cross-site because the URL has a different scheme than the current site.',schemefulSameSiteLax:'This cookie was blocked because it had the "SameSite=Lax" attribute but the request was cross-site and was not initiated by a top-level navigation. This request is considered cross-site because the URL has a different scheme than the current site.',schemefulSameSiteUnspecifiedTreatedAsLax:'This cookie didn\'t specify a "SameSite" attribute when it was stored, was defaulted to "SameSite=Lax", and was blocked because the request was cross-site and was not initiated by a top-level navigation. This request is considered cross-site because the URL has a different scheme than the current site.',samePartyFromCrossPartyContext:"This cookie was blocked because it had the \"SameParty\" attribute but the request was cross-party. The request was considered cross-party because the domain of the resource's URL and the domains of the resource's enclosing frames/documents are neither owners nor members in the same First-Party Set.",thisSetcookieWasBlockedDueToUser:"This Set-Cookie was blocked due to user preferences.",thisSetcookieHadInvalidSyntax:"This Set-Cookie had invalid syntax.",theSchemeOfThisConnectionIsNot:"The scheme of this connection is not allowed to store cookies.",anUnknownErrorWasEncounteredWhenTrying:"An unknown error was encountered when trying to store this cookie.",thisSetcookieWasBlockedBecauseItHadTheSamesitestrict:'This Set-Cookie was blocked because it had the "SameSite=Strict" attribute but came from a cross-site response which was not the response to a top-level navigation. This response is considered cross-site because the URL has a different scheme than the current site.',thisSetcookieWasBlockedBecauseItHadTheSamesitelax:'This Set-Cookie was blocked because it had the "SameSite=Lax" attribute but came from a cross-site response which was not the response to a top-level navigation. This response is considered cross-site because the URL has a different scheme than the current site.',thisSetcookieDidntSpecifyASamesite:'This Set-Cookie didn\'t specify a "SameSite" attribute, was defaulted to "SameSite=Lax", and was blocked because it came from a cross-site response which was not the response to a top-level navigation. This response is considered cross-site because the URL has a different scheme than the current site.',thisSetcookieWasBlockedBecauseItHadTheSameparty:"This Set-Cookie was blocked because it had the \"SameParty\" attribute but the request was cross-party. The request was considered cross-party because the domain of the resource's URL and the domains of the resource's enclosing frames/documents are neither owners nor members in the same First-Party Set.",thisSetcookieWasBlockedBecauseItHadTheSamepartyAttribute:'This Set-Cookie was blocked because it had the "SameParty" attribute but also had other conflicting attributes. Chrome requires cookies that use the "SameParty" attribute to also have the "Secure" attribute, and to not be restricted to "SameSite=Strict".',blockedReasonSecureOnly:'This Set-Cookie was blocked because it had the "Secure" attribute but was not received over a secure connection.',blockedReasonSameSiteStrict:'This Set-Cookie was blocked because it had the "SameSite=Strict" attribute but came from a cross-site response which was not the response to a top-level navigation.',blockedReasonSameSiteLax:'This Set-Cookie was blocked because it had the "SameSite=Lax" attribute but came from a cross-site response which was not the response to a top-level navigation.',blockedReasonSameSiteUnspecifiedTreatedAsLax:'This Set-Cookie didn\'t specify a "SameSite" attribute and was defaulted to "SameSite=Lax," and was blocked because it came from a cross-site response which was not the response to a top-level navigation. The Set-Cookie had to have been set with "SameSite=None" to enable cross-site usage.',blockedReasonSameSiteNoneInsecure:'This Set-Cookie was blocked because it had the "SameSite=None" attribute but did not have the "Secure" attribute, which is required in order to use "SameSite=None".',blockedReasonOverwriteSecure:"This Set-Cookie was blocked because it was not sent over a secure connection and would have overwritten a cookie with the Secure attribute.",blockedReasonInvalidDomain:"This Set-Cookie was blocked because its Domain attribute was invalid with regards to the current host url.",blockedReasonInvalidPrefix:'This Set-Cookie was blocked because it used the "__Secure-" or "__Host-" prefix in its name and broke the additional rules applied to cookies with these prefixes as defined in https://tools.ietf.org/html/draft-west-cookie-prefixes-05.'},str_=i18n.i18n.registerUIStrings("sdk/NetworkRequest.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export const MIME_TYPE={HTML:"text/html",XML:"text/xml",PLAIN:"text/plain",XHTML:"application/xhtml+xml",SVG:"image/svg+xml",CSS:"text/css",XSL:"text/xsl",VTT:"text/vtt",PDF:"application/pdf"};export const MIME_TYPE_TO_RESOURCE_TYPE=new Map([[MIME_TYPE.HTML,{document:!0}],[MIME_TYPE.XML,{document:!0}],[MIME_TYPE.PLAIN,{document:!0}],[MIME_TYPE.XHTML,{document:!0}],[MIME_TYPE.SVG,{document:!0}],[MIME_TYPE.CSS,{stylesheet:!0}],[MIME_TYPE.XSL,{stylesheet:!0}],[MIME_TYPE.VTT,{texttrack:!0}],[MIME_TYPE.PDF,{document:!0}]]);export class NetworkRequest extends Common.ObjectWrapper.ObjectWrapper{constructor(e,t,s,r,o,i){super(),this._requestId=e,this._backendRequestId=e,this.setUrl(t),this._documentURL=s,this._frameId=r,this._loaderId=o,this._initiator=i,this._redirectSource=null,this._preflightRequest=null,this._preflightInitiatorRequest=null,this._isRedirect=!1,this._redirectDestination=null,this._issueTime=-1,this._startTime=-1,this._endTime=-1,this._blockedReason=void 0,this._corsErrorStatus=void 0,this.statusCode=0,this.statusText="",this.requestMethod="",this.requestTime=0,this.protocol="",this.mixedContentType=Protocol.Security.MixedContentType.None,this._initialPriority=null,this._currentPriority=null,this._signedExchangeInfo=null,this._resourceType=Common.ResourceType.resourceTypes.Other,this._contentData=null,this._frames=[],this._eventSourceMessages=[],this._responseHeaderValues={},this._responseHeadersText="",this._requestHeaders=[],this._requestHeaderValues={},this._remoteAddress="",this._remoteAddressSpace=Protocol.Network.IPAddressSpace.Unknown,this._referrerPolicy=null,this._securityState=Protocol.Security.SecurityState.Unknown,this._securityDetails=null,this.connectionId="0",this.connectionReused=!1,this.hasNetworkData=!1,this._formParametersPromise=null,this._requestFormDataPromise=Promise.resolve(null),this._hasExtraRequestInfo=!1,this._hasExtraResponseInfo=!1,this._blockedRequestCookies=[],this._includedRequestCookies=[],this._blockedResponseCookies=[],this.localizedFailDescription=null,this._url,this._responseReceivedTime,this._transferSize,this._finished,this._failed,this._canceled,this._mimeType,this._parsedURL,this._name,this._path,this._clientSecurityState,this._trustTokenParams,this._trustTokenOperationDoneEvent}identityCompare(e){const t=this.requestId(),s=e.requestId();return t>s?1:t<s?-1:0}requestId(){return this._requestId}backendRequestId(){return this._backendRequestId}url(){return this._url}isBlobRequest(){return this._url.startsWith("blob:")}setUrl(e){this._url!==e&&(this._url=e,this._parsedURL=new Common.ParsedURL.ParsedURL(e),delete this._queryString,delete this._parsedQueryParameters,delete this._name,delete this._path)}get documentURL(){return this._documentURL}get parsedURL(){return this._parsedURL}get frameId(){return this._frameId}get loaderId(){return this._loaderId}setRemoteAddress(e,t){this._remoteAddress=e+":"+t,this.dispatchEventToListeners(Events.RemoteAddressChanged,this)}remoteAddress(){return this._remoteAddress}remoteAddressSpace(){return this._remoteAddressSpace}getResponseCacheStorageCacheName(){return this._responseCacheStorageCacheName}setResponseCacheStorageCacheName(e){this._responseCacheStorageCacheName=e}serviceWorkerResponseSource(){return this._serviceWorkerResponseSource}setServiceWorkerResponseSource(e){this._serviceWorkerResponseSource=e}setReferrerPolicy(e){this._referrerPolicy=e}referrerPolicy(){return this._referrerPolicy}securityState(){return this._securityState}setSecurityState(e){this._securityState=e}securityDetails(){return this._securityDetails}securityOrigin(){return this._parsedURL.securityOrigin()}setSecurityDetails(e){this._securityDetails=e}get startTime(){return this._startTime||-1}setIssueTime(e,t){this._issueTime=e,this._wallIssueTime=t,this._startTime=e}issueTime(){return this._issueTime}pseudoWallTime(e){return this._wallIssueTime?this._wallIssueTime-this._issueTime+e:e}get responseReceivedTime(){return this._responseReceivedTime||-1}set responseReceivedTime(e){this._responseReceivedTime=e}getResponseRetrievalTime(){return this._responseRetrievalTime}setResponseRetrievalTime(e){this._responseRetrievalTime=e}get endTime(){return this._endTime||-1}set endTime(e){this.timing&&this.timing.requestTime?this._endTime=Math.max(e,this.responseReceivedTime):(this._endTime=e,this._responseReceivedTime>e&&(this._responseReceivedTime=e)),this.dispatchEventToListeners(Events.TimingChanged,this)}get duration(){return-1===this._endTime||-1===this._startTime?-1:this._endTime-this._startTime}get latency(){return-1===this._responseReceivedTime||-1===this._startTime?-1:this._responseReceivedTime-this._startTime}get resourceSize(){return this._resourceSize||0}set resourceSize(e){this._resourceSize=e}get transferSize(){return this._transferSize||0}increaseTransferSize(e){this._transferSize=(this._transferSize||0)+e}setTransferSize(e){this._transferSize=e}get finished(){return this._finished}set finished(e){this._finished!==e&&(this._finished=e,e&&this.dispatchEventToListeners(Events.FinishedLoading,this))}get failed(){return this._failed}set failed(e){this._failed=e}get canceled(){return this._canceled}set canceled(e){this._canceled=e}blockedReason(){return this._blockedReason}setBlockedReason(e){this._blockedReason=e}corsErrorStatus(){return this._corsErrorStatus}setCorsErrorStatus(e){this._corsErrorStatus=e}wasBlocked(){return Boolean(this._blockedReason)}cached(){return(Boolean(this._fromMemoryCache)||Boolean(this._fromDiskCache))&&!this._transferSize}cachedInMemory(){return Boolean(this._fromMemoryCache)&&!this._transferSize}fromPrefetchCache(){return Boolean(this._fromPrefetchCache)}setFromMemoryCache(){this._fromMemoryCache=!0,delete this._timing}setFromDiskCache(){this._fromDiskCache=!0}setFromPrefetchCache(){this._fromPrefetchCache=!0}get fetchedViaServiceWorker(){return Boolean(this._fetchedViaServiceWorker)}set fetchedViaServiceWorker(e){this._fetchedViaServiceWorker=e}initiatedByServiceWorker(){const e=NetworkManager.forRequest(this);return!!e&&e.target().type()===Type.ServiceWorker}get timing(){return this._timing}set timing(e){if(!e||this._fromMemoryCache)return;this._startTime=e.requestTime;const t=e.requestTime+e.receiveHeadersEnd/1e3;((this._responseReceivedTime||-1)<0||this._responseReceivedTime>t)&&(this._responseReceivedTime=t),this._startTime>this._responseReceivedTime&&(this._responseReceivedTime=this._startTime),this._timing=e,this.dispatchEventToListeners(Events.TimingChanged,this)}get mimeType(){return this._mimeType}set mimeType(e){this._mimeType=e}get displayName(){return this._parsedURL.displayName}name(){return this._name||this._parseNameAndPathFromURL(),this._name}path(){return this._path||this._parseNameAndPathFromURL(),this._path}_parseNameAndPathFromURL(){if(this._parsedURL.isDataURL())this._name=this._parsedURL.dataURLDisplayName(),this._path="";else if(this._parsedURL.isBlobURL())this._name=this._parsedURL.url,this._path="";else if(this._parsedURL.isAboutBlank())this._name=this._parsedURL.url,this._path="";else{this._path=this._parsedURL.host+this._parsedURL.folderPathComponents;const e=NetworkManager.forRequest(this),t=e?Common.ParsedURL.ParsedURL.fromString(e.target().inspectedURL()):null;this._path=Platform.StringUtilities.trimURL(this._path,t?t.host:""),this._parsedURL.lastPathComponent||this._parsedURL.queryParams?this._name=this._parsedURL.lastPathComponent+(this._parsedURL.queryParams?"?"+this._parsedURL.queryParams:""):this._parsedURL.folderPathComponents?(this._name=this._parsedURL.folderPathComponents.substring(this._parsedURL.folderPathComponents.lastIndexOf("/")+1)+"/",this._path=this._path.substring(0,this._path.lastIndexOf("/"))):(this._name=this._parsedURL.host,this._path="")}}get folder(){let e=this._parsedURL.path;const t=e.indexOf("?");-1!==t&&(e=e.substring(0,t));const s=e.lastIndexOf("/");return-1!==s?e.substring(0,s):""}get pathname(){return this._parsedURL.path}resourceType(){return this._resourceType}setResourceType(e){this._resourceType=e}get domain(){return this._parsedURL.host}get scheme(){return this._parsedURL.scheme}redirectSource(){return this._redirectSource}setRedirectSource(e){this._redirectSource=e}preflightRequest(){return this._preflightRequest}setPreflightRequest(e){this._preflightRequest=e}preflightInitiatorRequest(){return this._preflightInitiatorRequest}setPreflightInitiatorRequest(e){this._preflightInitiatorRequest=e}isPreflightRequest(){return null!==this._initiator&&void 0!==this._initiator&&this._initiator.type===Protocol.Network.InitiatorType.Preflight}redirectDestination(){return this._redirectDestination}setRedirectDestination(e){this._redirectDestination=e}requestHeaders(){return this._requestHeaders}setRequestHeaders(e){this._requestHeaders=e,delete this._requestCookies,this.dispatchEventToListeners(Events.RequestHeadersChanged)}requestHeadersText(){return this._requestHeadersText}setRequestHeadersText(e){this._requestHeadersText=e,this.dispatchEventToListeners(Events.RequestHeadersChanged)}requestHeaderValue(e){return this._requestHeaderValues[e]||(this._requestHeaderValues[e]=this._computeHeaderValue(this.requestHeaders(),e)),this._requestHeaderValues[e]}get requestCookies(){return this._requestCookies||(this._requestCookies=CookieParser.parseCookie(this.requestHeaderValue("Cookie"))||[]),this._requestCookies}requestFormData(){return this._requestFormDataPromise||(this._requestFormDataPromise=NetworkManager.requestPostData(this)),this._requestFormDataPromise}setRequestFormData(e,t){this._requestFormDataPromise=e&&null===t?null:Promise.resolve(t),this._formParametersPromise=null}_filteredProtocolName(){const e=this.protocol.toLowerCase();return"h2"===e?"http/2.0":e.replace(/^http\/2(\.0)?\+/,"http/2.0+")}requestHttpVersion(){const e=this.requestHeadersText();if(!e){const e=this.requestHeaderValue("version")||this.requestHeaderValue(":version");return e||this._filteredProtocolName()}const t=e.split(/\r\n/)[0].match(/(HTTP\/\d+\.\d+)$/);return t?t[1]:"HTTP/0.9"}get responseHeaders(){return this._responseHeaders||[]}set responseHeaders(e){this._responseHeaders=e,delete this._sortedResponseHeaders,delete this._serverTimings,delete this._responseCookies,this._responseHeaderValues={},this.dispatchEventToListeners(Events.ResponseHeadersChanged)}get responseHeadersText(){return this._responseHeadersText}set responseHeadersText(e){this._responseHeadersText=e,this.dispatchEventToListeners(Events.ResponseHeadersChanged)}get sortedResponseHeaders(){return void 0!==this._sortedResponseHeaders||(this._sortedResponseHeaders=this.responseHeaders.slice(),this._sortedResponseHeaders.sort((function(e,t){return Platform.StringUtilities.compare(e.name.toLowerCase(),t.name.toLowerCase())}))),this._sortedResponseHeaders}responseHeaderValue(e){return e in this._responseHeaderValues||(this._responseHeaderValues[e]=this._computeHeaderValue(this.responseHeaders,e)),this._responseHeaderValues[e]}get responseCookies(){return this._responseCookies||(this._responseCookies=CookieParser.parseSetCookie(this.responseHeaderValue("Set-Cookie"),this.domain)||[]),this._responseCookies}responseLastModified(){return this.responseHeaderValue("last-modified")}allCookiesIncludingBlockedOnes(){return[...this.includedRequestCookies(),...this.responseCookies,...this.blockedRequestCookies().map((e=>e.cookie)),...this.blockedResponseCookies().map((e=>e.cookie))].filter((e=>Boolean(e)))}get serverTimings(){return"undefined"===typeof this._serverTimings&&(this._serverTimings=ServerTiming.parseHeaders(this.responseHeaders)),this._serverTimings}queryString(){if(void 0!==this._queryString)return this._queryString;let e=null;const t=this.url(),s=t.indexOf("?");if(-1!==s){e=t.substring(s+1);const r=e.indexOf("#");-1!==r&&(e=e.substring(0,r))}return this._queryString=e,this._queryString}get queryParameters(){if(this._parsedQueryParameters)return this._parsedQueryParameters;const e=this.queryString();return e?(this._parsedQueryParameters=this._parseParameters(e),this._parsedQueryParameters):null}async _parseFormParameters(){const e=this.requestContentType();if(!e)return null;if(e.match(/^application\/x-www-form-urlencoded\s*(;.*)?$/i)){const e=await this.requestFormData();return e?this._parseParameters(e):null}const t=e.match(/^multipart\/form-data\s*;\s*boundary\s*=\s*(\S+)\s*$/);if(!t)return null;const s=t[1];if(!s)return null;const r=await this.requestFormData();return r?this._parseMultipartFormDataParameters(r,s):null}formParameters(){return this._formParametersPromise||(this._formParametersPromise=this._parseFormParameters()),this._formParametersPromise}responseHttpVersion(){const e=this._responseHeadersText;if(!e){const e=this.responseHeaderValue("version")||this.responseHeaderValue(":version");return e||this._filteredProtocolName()}const t=e.split(/\r\n/)[0].match(/^(HTTP\/\d+\.\d+)/);return t?t[1]:"HTTP/0.9"}_parseParameters(e){return e.split("&").map((function(e){const t=e.indexOf("=");return-1===t?{name:e,value:""}:{name:e.substring(0,t),value:e.substring(t+1)}}))}_parseMultipartFormDataParameters(e,t){const s=Platform.StringUtilities.escapeForRegExp(t),r=new RegExp('^\\r\\ncontent-disposition\\s*:\\s*form-data\\s*;\\s*name="([^"]*)"(?:\\s*;\\s*filename="([^"]*)")?(?:\\r\\ncontent-type\\s*:\\s*([^\\r\\n]*))?\\r\\n\\r\\n(.*)\\r\\n$',"is");return e.split(new RegExp(`--${s}(?:--s*$)?`,"g")).reduce((function(e,t){const[s,o,i,a,n]=t.match(r)||[];if(!s)return e;const c=i||a?i18nString(UIStrings.binary):n;return e.push({name:o,value:c}),e}),[])}_computeHeaderValue(e,t){t=t.toLowerCase();const s=[];for(let r=0;r<e.length;++r)e[r].name.toLowerCase()===t&&s.push(e[r].value);if(s.length)return"set-cookie"===t?s.join("\n"):s.join(", ")}contentData(){return this._contentData||(this._contentDataProvider?this._contentData=this._contentDataProvider():this._contentData=NetworkManager.requestContentData(this)),this._contentData}setContentDataProvider(e){console.assert(!this._contentData,"contentData can only be set once."),this._contentDataProvider=e}contentURL(){return this._url}contentType(){return this._resourceType}async contentEncoded(){return(await this.contentData()).encoded}async requestContent(){const{content:e,error:t,encoded:s}=await this.contentData();return{content:e,error:t,isEncoded:s}}async searchInContent(e,t,s){if(!this._contentDataProvider)return NetworkManager.searchInRequest(this,e,t,s);const r=await this.contentData();let o=r.content;return o?(r.encoded&&(o=window.atob(o)),TextUtils.TextUtils.performSearchInContent(o,e,t,s)):[]}isHttpFamily(){return Boolean(this.url().match(/^https?:/i))}requestContentType(){return this.requestHeaderValue("Content-Type")}hasErrorStatusCode(){return this.statusCode>=400}setInitialPriority(e){this._initialPriority=e}initialPriority(){return this._initialPriority}setPriority(e){this._currentPriority=e}priority(){return this._currentPriority||this._initialPriority||null}setSignedExchangeInfo(e){this._signedExchangeInfo=e}signedExchangeInfo(){return this._signedExchangeInfo}async populateImageSource(e){const{content:t,encoded:s}=await this.contentData();let r=TextUtils.ContentProvider.contentAsDataURL(t,this._mimeType,s);if(null===r&&!this._failed){(this.responseHeaderValue("cache-control")||"").includes("no-cache")||(r=this._url)}null!==r&&(e.src=r)}initiator(){return this._initiator||null}frames(){return this._frames}addProtocolFrameError(e,t){this.addFrame({type:WebSocketFrameType.Error,text:e,time:this.pseudoWallTime(t),opCode:-1,mask:!1})}addProtocolFrame(e,t,s){const r=s?WebSocketFrameType.Send:WebSocketFrameType.Receive;this.addFrame({type:r,text:e.payloadData,time:this.pseudoWallTime(t),opCode:e.opcode,mask:e.mask})}addFrame(e){this._frames.push(e),this.dispatchEventToListeners(Events.WebsocketFrameAdded,e)}eventSourceMessages(){return this._eventSourceMessages}addEventSourceMessage(e,t,s,r){const o={time:this.pseudoWallTime(e),eventName:t,eventId:s,data:r};this._eventSourceMessages.push(o),this.dispatchEventToListeners(Events.EventSourceMessageAdded,o)}markAsRedirect(e){this._isRedirect=!0,this._requestId=`${this._backendRequestId}:redirected.${e}`}isRedirect(){return this._isRedirect}setRequestIdForTest(e){this._backendRequestId=e,this._requestId=e}charset(){const e=this.responseHeaderValue("content-type");if(!e)return null;const t=e.replace(/ /g,"").split(";").filter((e=>e.toLowerCase().startsWith("charset="))).map((e=>e.slice("charset=".length)));return t.length?t[0]:null}addExtraRequestInfo(e){this._blockedRequestCookies=e.blockedRequestCookies,this._includedRequestCookies=e.includedRequestCookies,this.setRequestHeaders(e.requestHeaders),this._hasExtraRequestInfo=!0,this.setRequestHeadersText(""),this._clientSecurityState=e.clientSecurityState}hasExtraRequestInfo(){return this._hasExtraRequestInfo}blockedRequestCookies(){return this._blockedRequestCookies}includedRequestCookies(){return this._includedRequestCookies}hasRequestCookies(){return this._includedRequestCookies.length>0||this._blockedRequestCookies.length>0}addExtraResponseInfo(e){if(this._blockedResponseCookies=e.blockedResponseCookies,this.responseHeaders=e.responseHeaders,e.responseHeadersText&&(this.responseHeadersText=e.responseHeadersText,!this.requestHeadersText())){let e=`${this.requestMethod} ${this.parsedURL.path}`;this.parsedURL.queryParams&&(e+=`?${this.parsedURL.queryParams}`),e+=" HTTP/1.1\r\n";for(const{name:t,value:s}of this.requestHeaders())e+=`${t}: ${s}\r\n`;this.setRequestHeadersText(e)}this._remoteAddressSpace=e.resourceIPAddressSpace,this._hasExtraResponseInfo=!0}hasExtraResponseInfo(){return this._hasExtraResponseInfo}blockedResponseCookies(){return this._blockedResponseCookies}redirectSourceSignedExchangeInfoHasNoErrors(){return null!==this._redirectSource&&null!==this._redirectSource._signedExchangeInfo&&!this._redirectSource._signedExchangeInfo.errors}clientSecurityState(){return this._clientSecurityState}setTrustTokenParams(e){this._trustTokenParams=e}trustTokenParams(){return this._trustTokenParams}setTrustTokenOperationDoneEvent(e){this._trustTokenOperationDoneEvent=e,this.dispatchEventToListeners(Events.TrustTokenResultAdded)}trustTokenOperationDoneEvent(){return this._trustTokenOperationDoneEvent}}export const Events={FinishedLoading:Symbol("FinishedLoading"),TimingChanged:Symbol("TimingChanged"),RemoteAddressChanged:Symbol("RemoteAddressChanged"),RequestHeadersChanged:Symbol("RequestHeadersChanged"),ResponseHeadersChanged:Symbol("ResponseHeadersChanged"),WebsocketFrameAdded:Symbol("WebsocketFrameAdded"),EventSourceMessageAdded:Symbol("EventSourceMessageAdded"),TrustTokenResultAdded:Symbol("TrustTokenResultAdded")};export const InitiatorType={Other:"other",Parser:"parser",Redirect:"redirect",Script:"script",Preload:"preload",SignedExchange:"signedExchange",Preflight:"preflight"};export const WebSocketFrameType={Send:"send",Receive:"receive",Error:"error"};export const cookieBlockedReasonToUiString=function(e){switch(e){case Protocol.Network.CookieBlockedReason.SecureOnly:return i18nString(UIStrings.secureOnly);case Protocol.Network.CookieBlockedReason.NotOnPath:return i18nString(UIStrings.notOnPath);case Protocol.Network.CookieBlockedReason.DomainMismatch:return i18nString(UIStrings.domainMismatch);case Protocol.Network.CookieBlockedReason.SameSiteStrict:return i18nString(UIStrings.sameSiteStrict);case Protocol.Network.CookieBlockedReason.SameSiteLax:return i18nString(UIStrings.sameSiteLax);case Protocol.Network.CookieBlockedReason.SameSiteUnspecifiedTreatedAsLax:return i18nString(UIStrings.sameSiteUnspecifiedTreatedAsLax);case Protocol.Network.CookieBlockedReason.SameSiteNoneInsecure:return i18nString(UIStrings.sameSiteNoneInsecure);case Protocol.Network.CookieBlockedReason.UserPreferences:return i18nString(UIStrings.userPreferences);case Protocol.Network.CookieBlockedReason.UnknownError:return i18nString(UIStrings.unknownError);case Protocol.Network.CookieBlockedReason.SchemefulSameSiteStrict:return i18nString(UIStrings.schemefulSameSiteStrict);case Protocol.Network.CookieBlockedReason.SchemefulSameSiteLax:return i18nString(UIStrings.schemefulSameSiteLax);case Protocol.Network.CookieBlockedReason.SchemefulSameSiteUnspecifiedTreatedAsLax:return i18nString(UIStrings.schemefulSameSiteUnspecifiedTreatedAsLax);case Protocol.Network.CookieBlockedReason.SamePartyFromCrossPartyContext:return i18nString(UIStrings.samePartyFromCrossPartyContext)}return""};export const setCookieBlockedReasonToUiString=function(e){switch(e){case Protocol.Network.SetCookieBlockedReason.SecureOnly:return i18nString(UIStrings.blockedReasonSecureOnly);case Protocol.Network.SetCookieBlockedReason.SameSiteStrict:return i18nString(UIStrings.blockedReasonSameSiteStrict);case Protocol.Network.SetCookieBlockedReason.SameSiteLax:return i18nString(UIStrings.blockedReasonSameSiteLax);case Protocol.Network.SetCookieBlockedReason.SameSiteUnspecifiedTreatedAsLax:return i18nString(UIStrings.blockedReasonSameSiteUnspecifiedTreatedAsLax);case Protocol.Network.SetCookieBlockedReason.SameSiteNoneInsecure:return i18nString(UIStrings.blockedReasonSameSiteNoneInsecure);case Protocol.Network.SetCookieBlockedReason.UserPreferences:return i18nString(UIStrings.thisSetcookieWasBlockedDueToUser);case Protocol.Network.SetCookieBlockedReason.SyntaxError:return i18nString(UIStrings.thisSetcookieHadInvalidSyntax);case Protocol.Network.SetCookieBlockedReason.SchemeNotSupported:return i18nString(UIStrings.theSchemeOfThisConnectionIsNot);case Protocol.Network.SetCookieBlockedReason.OverwriteSecure:return i18nString(UIStrings.blockedReasonOverwriteSecure);case Protocol.Network.SetCookieBlockedReason.InvalidDomain:return i18nString(UIStrings.blockedReasonInvalidDomain);case Protocol.Network.SetCookieBlockedReason.InvalidPrefix:return i18nString(UIStrings.blockedReasonInvalidPrefix);case Protocol.Network.SetCookieBlockedReason.UnknownError:return i18nString(UIStrings.anUnknownErrorWasEncounteredWhenTrying);case Protocol.Network.SetCookieBlockedReason.SchemefulSameSiteStrict:return i18nString(UIStrings.thisSetcookieWasBlockedBecauseItHadTheSamesitestrict);case Protocol.Network.SetCookieBlockedReason.SchemefulSameSiteLax:return i18nString(UIStrings.thisSetcookieWasBlockedBecauseItHadTheSamesitelax);case Protocol.Network.SetCookieBlockedReason.SchemefulSameSiteUnspecifiedTreatedAsLax:return i18nString(UIStrings.thisSetcookieDidntSpecifyASamesite);case Protocol.Network.SetCookieBlockedReason.SamePartyFromCrossPartyContext:return i18nString(UIStrings.thisSetcookieWasBlockedBecauseItHadTheSameparty);case Protocol.Network.SetCookieBlockedReason.SamePartyConflictsWithOtherAttributes:return i18nString(UIStrings.thisSetcookieWasBlockedBecauseItHadTheSamepartyAttribute)}return""};export const cookieBlockedReasonToAttribute=function(e){switch(e){case Protocol.Network.CookieBlockedReason.SecureOnly:return Attributes.Secure;case Protocol.Network.CookieBlockedReason.NotOnPath:return Attributes.Path;case Protocol.Network.CookieBlockedReason.DomainMismatch:return Attributes.Domain;case Protocol.Network.CookieBlockedReason.SameSiteStrict:case Protocol.Network.CookieBlockedReason.SameSiteLax:case Protocol.Network.CookieBlockedReason.SameSiteUnspecifiedTreatedAsLax:case Protocol.Network.CookieBlockedReason.SameSiteNoneInsecure:case Protocol.Network.CookieBlockedReason.SchemefulSameSiteStrict:case Protocol.Network.CookieBlockedReason.SchemefulSameSiteLax:case Protocol.Network.CookieBlockedReason.SchemefulSameSiteUnspecifiedTreatedAsLax:return Attributes.SameSite;case Protocol.Network.CookieBlockedReason.SamePartyFromCrossPartyContext:return Attributes.SameParty;case Protocol.Network.CookieBlockedReason.UserPreferences:case Protocol.Network.CookieBlockedReason.UnknownError:return null}return null};export const setCookieBlockedReasonToAttribute=function(e){switch(e){case Protocol.Network.SetCookieBlockedReason.SecureOnly:case Protocol.Network.SetCookieBlockedReason.OverwriteSecure:return Attributes.Secure;case Protocol.Network.SetCookieBlockedReason.SameSiteStrict:case Protocol.Network.SetCookieBlockedReason.SameSiteLax:case Protocol.Network.SetCookieBlockedReason.SameSiteUnspecifiedTreatedAsLax:case Protocol.Network.SetCookieBlockedReason.SameSiteNoneInsecure:case Protocol.Network.SetCookieBlockedReason.SchemefulSameSiteStrict:case Protocol.Network.SetCookieBlockedReason.SchemefulSameSiteLax:case Protocol.Network.SetCookieBlockedReason.SchemefulSameSiteUnspecifiedTreatedAsLax:return Attributes.SameSite;case Protocol.Network.SetCookieBlockedReason.InvalidDomain:return Attributes.Domain;case Protocol.Network.SetCookieBlockedReason.InvalidPrefix:return Attributes.Name;case Protocol.Network.SetCookieBlockedReason.SamePartyConflictsWithOtherAttributes:case Protocol.Network.SetCookieBlockedReason.SamePartyFromCrossPartyContext:return Attributes.SameParty;case Protocol.Network.SetCookieBlockedReason.UserPreferences:case Protocol.Network.SetCookieBlockedReason.SyntaxError:case Protocol.Network.SetCookieBlockedReason.SchemeNotSupported:case Protocol.Network.SetCookieBlockedReason.UnknownError:return null}return null};export let NameValue;export let WebSocketFrame;export let BlockedSetCookieWithReason;export let BlockedCookieWithReason;export let ContentData;export let EventSourceMessage;export let ExtraRequestInfo;export let ExtraResponseInfo;