import*as Common from"../common/common.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import{FrameManager}from"./FrameManager.js";import{IOModel}from"./IOModel.js";import{MultitargetNetworkManager}from"./NetworkManager.js";import{NetworkManager}from"./NetworkManager.js";import{Events as ResourceTreeModelEvents,ResourceTreeModel}from"./ResourceTreeModel.js";import{TargetManager}from"./SDKModel.js";const UIStrings={loadCanceledDueToReloadOf:"Load canceled due to reload of inspected page",loadCanceledDueToLoadTimeout:"Load canceled due to load timeout"},str_=i18n.i18n.registerUIStrings("sdk/PageResourceLoader.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export let PageResourceLoadInitiator;export let PageResource;let pageResourceLoader=null;export class PageResourceLoader extends Common.ObjectWrapper.ObjectWrapper{constructor(e,r,o){super(),this._currentlyLoading=0,this._maxConcurrentLoads=r,this._pageResources=new Map,this._queuedLoads=[],TargetManager.instance().addModelListener(ResourceTreeModel,ResourceTreeModelEvents.MainFrameNavigated,this._onMainFrameNavigated,this),this._loadOverride=e,this._loadTimeout=o}static instance({forceNew:e,loadOverride:r,maxConcurrentLoads:o,loadTimeout:t}={forceNew:!1,loadOverride:null,maxConcurrentLoads:500,loadTimeout:3e4}){return pageResourceLoader&&!e||(pageResourceLoader=new PageResourceLoader(r,o,t)),pageResourceLoader}_onMainFrameNavigated(e){if(e.data.isTopFrame()){for(const{reject:e}of this._queuedLoads)e(new Error(i18nString(UIStrings.loadCanceledDueToReloadOf)));this._queuedLoads=[],this._pageResources.clear(),this.dispatchEventToListeners(Events.Update)}}getResourcesLoaded(){return this._pageResources}getNumberOfResources(){return{loading:this._currentlyLoading,queued:this._queuedLoads.length,resources:this._pageResources.size}}async _acquireLoadSlot(){if(this._currentlyLoading++,this._currentlyLoading>this._maxConcurrentLoads){const e={resolve:()=>{},reject:()=>{}},r=new Promise(((r,o)=>{e.resolve=r,e.reject=o}));this._queuedLoads.push(e),await r}}_releaseLoadSlot(){this._currentlyLoading--;const e=this._queuedLoads.shift();e&&e.resolve(void 0)}static async _withTimeout(e,r){const o=new Promise(((e,o)=>setTimeout(o,r,new Error(i18nString(UIStrings.loadCanceledDueToLoadTimeout)))));return Promise.race([e,o])}static makeKey(e,r){if(r.frameId)return`${e}-${r.frameId}`;if(r.target)return`${e}-${r.target.id()}`;throw new Error("Invalid initiator")}async loadResource(e,r){const o=PageResourceLoader.makeKey(e,r),t={success:null,size:null,errorMessage:void 0,url:e,initiator:r};this._pageResources.set(o,t),this.dispatchEventToListeners(Events.Update);try{await this._acquireLoadSlot();const o=this._dispatchLoad(e,r),s=await PageResourceLoader._withTimeout(o,this._loadTimeout);if(t.errorMessage=s.errorDescription.message,t.success=s.success,s.success)return t.size=s.content.length,{content:s.content};throw new Error(s.errorDescription.message)}catch(s){throw void 0===t.errorMessage&&(t.errorMessage=s.message),null===t.success&&(t.success=!1),s}finally{this._releaseLoadSlot(),this.dispatchEventToListeners(Events.Update)}}async _dispatchLoad(e,r){let o=null;if(this._loadOverride)return this._loadOverride(e);const t=new Common.ParsedURL.ParsedURL(e),s=getLoadThroughTargetSetting().get()&&t&&t.isHttpOrHttps();if(Host.userMetrics.developerResourceScheme(this._getDeveloperResourceScheme(t)),s){try{if(r.target){Host.userMetrics.developerResourceLoaded(Host.UserMetrics.DeveloperResourceLoaded.LoadThroughPageViaTarget);return await this._loadFromTarget(r.target,r.frameId,e)}const o=FrameManager.instance().getFrame(r.frameId||"");if(o){Host.userMetrics.developerResourceLoaded(Host.UserMetrics.DeveloperResourceLoaded.LoadThroughPageViaFrame);return await this._loadFromTarget(o.resourceTreeModel().target(),r.frameId,e)}}catch(c){c instanceof Error&&(Host.userMetrics.developerResourceLoaded(Host.UserMetrics.DeveloperResourceLoaded.LoadThroughPageFailure),o=c.message)}Host.userMetrics.developerResourceLoaded(Host.UserMetrics.DeveloperResourceLoaded.LoadThroughPageFallback),console.warn("Fallback triggered",e,r)}else{const e=getLoadThroughTargetSetting().get()?Host.UserMetrics.DeveloperResourceLoaded.FallbackPerProtocol:Host.UserMetrics.DeveloperResourceLoaded.FallbackPerOverride;Host.userMetrics.developerResourceLoaded(e)}const a=await MultitargetNetworkManager.instance().loadResource(e);return s&&!a.success&&Host.userMetrics.developerResourceLoaded(Host.UserMetrics.DeveloperResourceLoaded.FallbackFailure),o&&(a.errorDescription.message=`Fetch through target failed: ${o}; Fallback: ${a.errorDescription.message}`),a}_getDeveloperResourceScheme(e){if(!e||""===e.scheme)return Host.UserMetrics.DeveloperResourceScheme.SchemeUnknown;const r="localhost"===e.host||e.host.endsWith(".localhost");switch(e.scheme){case"file":return Host.UserMetrics.DeveloperResourceScheme.SchemeFile;case"data":return Host.UserMetrics.DeveloperResourceScheme.SchemeData;case"blob":return Host.UserMetrics.DeveloperResourceScheme.SchemeBlob;case"http":return r?Host.UserMetrics.DeveloperResourceScheme.SchemeHttpLocalhost:Host.UserMetrics.DeveloperResourceScheme.SchemeHttp;case"https":return r?Host.UserMetrics.DeveloperResourceScheme.SchemeHttpsLocalhost:Host.UserMetrics.DeveloperResourceScheme.SchemeHttps}return Host.UserMetrics.DeveloperResourceScheme.SchemeOther}async _loadFromTarget(e,r,o){const t=e.model(NetworkManager),s=e.model(IOModel),a=await t.loadNetworkResource(r||"",o,{disableCache:!0,includeCredentials:!0});try{const e=a.stream?await s.readToString(a.stream):"";return{success:a.success,content:e,errorDescription:{statusCode:a.httpStatusCode||0,netError:a.netError,netErrorName:a.netErrorName,message:Host.ResourceLoader.netErrorToMessage(a.netError,a.httpStatusCode,a.netErrorName)||"",urlValid:void 0}}}finally{a.stream&&s.close(a.stream)}}}export function getLoadThroughTargetSetting(){return Common.Settings.Settings.instance().createSetting("loadThroughTarget",!0)}export const Events={Update:Symbol("Update")};