import*as Common from"../common/common.js";import*as Host from"../host/host.js";import{DebuggerModel}from"./DebuggerModel.js";import{HeapProfilerModel}from"./HeapProfilerModel.js";import{RemoteFunction,RemoteObject,RemoteObjectImpl,RemoteObjectProperty,ScopeRemoteObject}from"./RemoteObject.js";import{Capability,SDKModel,Type}from"./SDKModel.js";export class RuntimeModel extends SDKModel{constructor(e){super(e),this._agent=e.runtimeAgent(),this.target().registerRuntimeDispatcher(new RuntimeDispatcher(this)),this._agent.invoke_enable(),this._executionContextById=new Map,this._executionContextComparator=ExecutionContext.comparator,this._hasSideEffectSupport=null,Common.Settings.Settings.instance().moduleSetting("customFormatters").get()&&this._agent.invoke_setCustomObjectFormatterEnabled({enabled:!0}),Common.Settings.Settings.instance().moduleSetting("customFormatters").addChangeListener(this._customFormattersStateChanged.bind(this))}static isSideEffectFailure(e){const t="exceptionDetails"in e&&e.exceptionDetails;return Boolean(t&&t.exception&&t.exception.description&&t.exception.description.startsWith("EvalError: Possible side-effect in debug-evaluate"))}debuggerModel(){return this.target().model(DebuggerModel)}heapProfilerModel(){return this.target().model(HeapProfilerModel)}executionContexts(){return[...this._executionContextById.values()].sort(this.executionContextComparator())}setExecutionContextComparator(e){this._executionContextComparator=e}executionContextComparator(){return this._executionContextComparator}defaultExecutionContext(){for(const e of this.executionContexts())if(e.isDefault)return e;return null}executionContext(e){return this._executionContextById.get(e)||null}_executionContextCreated(e){const t=e.auxData||{isDefault:!0},o=new ExecutionContext(this,e.id,e.uniqueId,e.name,e.origin,t.isDefault,t.frameId);this._executionContextById.set(o.id,o),this.dispatchEventToListeners(Events.ExecutionContextCreated,o)}_executionContextDestroyed(e){const t=this._executionContextById.get(e);t&&(this.debuggerModel().executionContextDestroyed(t),this._executionContextById.delete(e),this.dispatchEventToListeners(Events.ExecutionContextDestroyed,t))}fireExecutionContextOrderChanged(){this.dispatchEventToListeners(Events.ExecutionContextOrderChanged,this)}_executionContextsCleared(){this.debuggerModel().globalObjectCleared();const e=this.executionContexts();this._executionContextById.clear();for(let t=0;t<e.length;++t)this.dispatchEventToListeners(Events.ExecutionContextDestroyed,e[t])}createRemoteObject(e){return console.assert("object"===typeof e,"Remote object payload should only be an object"),new RemoteObjectImpl(this,e.objectId,e.type,e.subtype,e.value,e.unserializableValue,e.description,e.preview,e.customPreview,e.className)}createScopeRemoteObject(e,t){return new ScopeRemoteObject(this,e.objectId,t,e.type,e.subtype,e.value,e.unserializableValue,e.description,e.preview)}createRemoteObjectFromPrimitiveValue(e){const t=typeof e;let o;const n=RemoteObject.unserializableDescription(e);return null!==n&&(o=n),"undefined"!==typeof o&&(e=void 0),new RemoteObjectImpl(this,void 0,t,void 0,e,o)}createRemotePropertyFromPrimitiveValue(e,t){return new RemoteObjectProperty(e,this.createRemoteObjectFromPrimitiveValue(t))}discardConsoleEntries(){this._agent.invoke_discardConsoleEntries()}releaseObjectGroup(e){this._agent.invoke_releaseObjectGroup({objectGroup:e})}releaseEvaluationResult(e){if("object"in e&&e.object&&e.object.release(),"exceptionDetails"in e&&e.exceptionDetails&&e.exceptionDetails.exception){const t=e.exceptionDetails.exception;this.createRemoteObject({type:t.type,objectId:t.objectId}).release()}}runIfWaitingForDebugger(){this._agent.invoke_runIfWaitingForDebugger()}_customFormattersStateChanged(e){const t=e.data;this._agent.invoke_setCustomObjectFormatterEnabled({enabled:t})}async compileScript(e,t,o,n){const i=await this._agent.invoke_compileScript({expression:e,sourceURL:t,persistScript:o,executionContextId:n});return i.getError()?(console.error(i.getError()),null):{scriptId:i.scriptId,exceptionDetails:i.exceptionDetails}}async runScript(e,t,o,n,i,r,s,a){const c=await this._agent.invoke_runScript({scriptId:e,executionContextId:t,objectGroup:o,silent:n,includeCommandLineAPI:i,returnByValue:r,generatePreview:s,awaitPromise:a}),l=c.getError();return l?(console.error(l),{error:l}):{object:this.createRemoteObject(c.result),exceptionDetails:c.exceptionDetails}}async queryObjects(e){if(!e.objectId)return{error:"Prototype should be an Object."};const t=await this._agent.invoke_queryObjects({prototypeObjectId:e.objectId,objectGroup:"console"}),o=t.getError();return o?(console.error(o),{error:o}):{objects:this.createRemoteObject(t.objects)}}async isolateId(){const e=await this._agent.invoke_getIsolateId();return e.getError()||!e.id?this.target().id():e.id}async heapUsage(){const e=await this._agent.invoke_getHeapUsage();return e.getError()?null:e}_inspectRequested(e,t){const o=this.createRemoteObject(e);t&&"copyToClipboard"in t&&Boolean(t.copyToClipboard)?this._copyRequested(o):t&&"queryObjects"in t&&t.queryObjects?this._queryObjectsRequested(o):o.isNode()?Common.Revealer.reveal(o).then(o.release.bind(o)):"function"!==o.type?o.release():RemoteFunction.objectAsFunction(o).targetFunctionDetails().then((function(e){if(o.release(),!e||!e.location)return;Common.Revealer.reveal(e.location)}))}_copyRequested(e){if(!e.objectId)return void Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(e.unserializableValue()||e.value);const t=Common.Settings.Settings.instance().moduleSetting("textEditorIndent").get();e.callFunctionJSON((function(e){const t=e.subtype,o=e.indent;if("node"===t)return this instanceof Element?this.outerHTML:void 0;if(t&&"undefined"===typeof this)return String(t);try{return JSON.stringify(this,null,o)}catch(n){return String(this)}}),[{value:{subtype:e.subtype,indent:t}}]).then(Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText.bind(Host.InspectorFrontendHost.InspectorFrontendHostInstance))}async _queryObjectsRequested(e){const t=await this.queryObjects(e);e.release(),"error"in t?Common.Console.Console.instance().error(t.error):this.dispatchEventToListeners(Events.QueryObjectRequested,{objects:t.objects})}static simpleTextFromException(e){let t=e.text;if(e.exception&&e.exception.description){let o=e.exception.description;-1!==o.indexOf("\n")&&(o=o.substring(0,o.indexOf("\n"))),t+=" "+o}return t}exceptionThrown(e,t){const o={timestamp:e,details:t};this.dispatchEventToListeners(Events.ExceptionThrown,o)}_exceptionRevoked(e){this.dispatchEventToListeners(Events.ExceptionRevoked,e)}_consoleAPICalled(e,t,o,n,i,r){const s={type:e,args:t,executionContextId:o,timestamp:n,stackTrace:i,context:r};this.dispatchEventToListeners(Events.ConsoleAPICalled,s)}executionContextIdForScriptId(e){const t=this.debuggerModel().scriptForId(e);return t?t.executionContextId:0}executionContextForStackTrace(e){let t=e;for(;t&&!t.callFrames.length;)t=t.parent||null;return t&&t.callFrames.length?this.executionContextIdForScriptId(t.callFrames[0].scriptId):0}hasSideEffectSupport(){return this._hasSideEffectSupport}async checkSideEffectSupport(){const e=this.executionContexts(),t=e[e.length-1];if(!t)return!1;const o=await this._agent.invoke_evaluate({expression:_sideEffectTestExpression,contextId:t.id,throwOnSideEffect:!0});return this._hasSideEffectSupport=!o.getError()&&RuntimeModel.isSideEffectFailure(o),this._hasSideEffectSupport}terminateExecution(){return this._agent.invoke_terminateExecution()}}const _sideEffectTestExpression="(async function(){ await 1; })()";export const Events={ExecutionContextCreated:Symbol("ExecutionContextCreated"),ExecutionContextDestroyed:Symbol("ExecutionContextDestroyed"),ExecutionContextChanged:Symbol("ExecutionContextChanged"),ExecutionContextOrderChanged:Symbol("ExecutionContextOrderChanged"),ExceptionThrown:Symbol("ExceptionThrown"),ExceptionRevoked:Symbol("ExceptionRevoked"),ConsoleAPICalled:Symbol("ConsoleAPICalled"),QueryObjectRequested:Symbol("QueryObjectRequested")};class RuntimeDispatcher{constructor(e){this._runtimeModel=e}executionContextCreated({context:e}){this._runtimeModel._executionContextCreated(e)}executionContextDestroyed({executionContextId:e}){this._runtimeModel._executionContextDestroyed(e)}executionContextsCleared(){this._runtimeModel._executionContextsCleared()}exceptionThrown({timestamp:e,exceptionDetails:t}){this._runtimeModel.exceptionThrown(e,t)}exceptionRevoked({reason:e,exceptionId:t}){this._runtimeModel._exceptionRevoked(t)}consoleAPICalled({type:e,args:t,executionContextId:o,timestamp:n,stackTrace:i,context:r}){this._runtimeModel._consoleAPICalled(e,t,o,n,i,r)}inspectRequested({object:e,hints:t}){this._runtimeModel._inspectRequested(e,t)}bindingCalled(e){}}export class ExecutionContext{constructor(e,t,o,n,i,r,s){this.id=t,this.uniqueId=o,this.name=n,this._label=null,this.origin=i,this.isDefault=r,this.runtimeModel=e,this.debuggerModel=e.debuggerModel(),this.frameId=s,this._setLabel("")}target(){return this.runtimeModel.target()}static comparator(e,t){function o(e){return e.parentTarget()?e.type()===Type.Frame?4:e.type()===Type.ServiceWorker?3:e.type()===Type.Worker?2:1:5}function n(e){let t=e;const o=[];for(;t;)o.push(t),t=t.parentTarget();return o.reverse()}const i=n(e.target()),r=n(t.target());let s,a;for(let c=0;;c++)if(!i[c]||!r[c]||i[c]!==r[c]){s=i[c],a=r[c];break}if(!s&&a)return-1;if(!a&&s)return 1;if(s&&a){const e=o(s)-o(a);return e?-e:s.id().localeCompare(a.id())}return e.isDefault?-1:t.isDefault?1:e.name.localeCompare(t.name)}async evaluate(e,t,o){if(this.debuggerModel.selectedCallFrame())return this.debuggerModel.evaluateOnSelectedCallFrame(e);return!(Boolean(e.throwOnSideEffect)||void 0!==e.timeout)||this.runtimeModel.hasSideEffectSupport()||!1!==this.runtimeModel.hasSideEffectSupport()&&(await this.runtimeModel.checkSideEffectSupport(),this.runtimeModel.hasSideEffectSupport())?this._evaluateGlobal(e,t,o):{error:"Side-effect checks not supported by backend."}}globalObject(e,t){const o={expression:"this",objectGroup:e,includeCommandLineAPI:!1,silent:!0,returnByValue:!1,generatePreview:t};return this._evaluateGlobal(o,!1,!1)}async _evaluateGlobal(e,t,o){e.expression||(e.expression="this");const n=await this.runtimeModel._agent.invoke_evaluate({expression:e.expression,objectGroup:e.objectGroup,includeCommandLineAPI:e.includeCommandLineAPI,silent:e.silent,uniqueContextId:this.uniqueId,returnByValue:e.returnByValue,generatePreview:e.generatePreview,userGesture:t,awaitPromise:o,throwOnSideEffect:e.throwOnSideEffect,timeout:e.timeout,disableBreaks:e.disableBreaks,replMode:e.replMode,allowUnsafeEvalBlockedByCSP:e.allowUnsafeEvalBlockedByCSP}),i=n.getError();return i?(console.error(i),{error:i}):{object:this.runtimeModel.createRemoteObject(n.result),exceptionDetails:n.exceptionDetails}}async globalLexicalScopeNames(){const e=await this.runtimeModel._agent.invoke_globalLexicalScopeNames({executionContextId:this.id});return e.getError()?[]:e.names}label(){return this._label}setLabel(e){this._setLabel(e),this.runtimeModel.dispatchEventToListeners(Events.ExecutionContextChanged,this)}_setLabel(e){if(e)return void(this._label=e);if(this.name)return void(this._label=this.name);const t=Common.ParsedURL.ParsedURL.fromString(this.origin);this._label=t?t.lastPathComponentWithFragment():""}}SDKModel.register(RuntimeModel,Capability.JS,!0);export let EvaluationResult;export let CompileScriptResult;export let EvaluationOptions;export let QueryObjectResult;