import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import{FrameManager}from"./FrameManager.js";import{Issue,IssueCategory,resolveLazyDescription}from"./Issue.js";const UIStrings={samesiteCookiesExplained:"SameSite cookies explained",howSchemefulSamesiteWorks:"How Schemeful Same-Site Works",aSecure:"a secure",anInsecure:"an insecure"},str_=i18n.i18n.registerUIStrings("sdk/SameSiteCookieIssue.js",UIStrings),i18nLazyString=i18n.i18n.getLazilyComputedLocalizedString.bind(void 0,str_);export class SameSiteCookieIssue extends Issue{constructor(e,i,s){super(e,s),this._issueDetails=i}primaryKey(){const{domain:e,path:i,name:s}=this._issueDetails.cookie,t=`${e};${i};${s}`,n=this._issueDetails.request?this._issueDetails.request.requestId:"no-request";return`${this.code()}-(${t})-(${n})`}static createIssuesFromSameSiteDetails(e,i){const s=[];if(e.cookieExclusionReasons&&e.cookieExclusionReasons.length>0){for(const t of e.cookieExclusionReasons){const n=SameSiteCookieIssue.codeForSameSiteDetails(t,e.cookieWarningReasons,e.operation,e.cookieUrl);n&&s.push(new SameSiteCookieIssue(n,e,i))}return s}if(e.cookieWarningReasons)for(const t of e.cookieWarningReasons){const n=SameSiteCookieIssue.codeForSameSiteDetails(t,[],e.operation,e.cookieUrl);n&&s.push(new SameSiteCookieIssue(n,e,i))}return s}static codeForSameSiteDetails(e,i,s,t){const n=t&&(t.startsWith("https://")||t.startsWith("wss://"))?"Secure":"Insecure";if(e===Protocol.Audits.SameSiteCookieExclusionReason.ExcludeSameSiteStrict||e===Protocol.Audits.SameSiteCookieExclusionReason.ExcludeSameSiteLax||e===Protocol.Audits.SameSiteCookieExclusionReason.ExcludeSameSiteUnspecifiedTreatedAsLax){if(i&&i.length>0){if(i.includes(Protocol.Audits.SameSiteCookieWarningReason.WarnSameSiteStrictLaxDowngradeStrict))return[Protocol.Audits.InspectorIssueCode.SameSiteCookieIssue,"ExcludeNavigationContextDowngrade",n].join("::");if(i.includes(Protocol.Audits.SameSiteCookieWarningReason.WarnSameSiteStrictCrossDowngradeStrict)||i.includes(Protocol.Audits.SameSiteCookieWarningReason.WarnSameSiteStrictCrossDowngradeLax)||i.includes(Protocol.Audits.SameSiteCookieWarningReason.WarnSameSiteLaxCrossDowngradeStrict)||i.includes(Protocol.Audits.SameSiteCookieWarningReason.WarnSameSiteLaxCrossDowngradeLax))return[Protocol.Audits.InspectorIssueCode.SameSiteCookieIssue,"ExcludeContextDowngrade",s,n].join("::")}return e===Protocol.Audits.SameSiteCookieExclusionReason.ExcludeSameSiteUnspecifiedTreatedAsLax?[Protocol.Audits.InspectorIssueCode.SameSiteCookieIssue,e,s].join("::"):null}return e===Protocol.Audits.SameSiteCookieWarningReason.WarnSameSiteStrictLaxDowngradeStrict?[Protocol.Audits.InspectorIssueCode.SameSiteCookieIssue,e,n].join("::"):e===Protocol.Audits.SameSiteCookieWarningReason.WarnSameSiteStrictCrossDowngradeStrict||e===Protocol.Audits.SameSiteCookieWarningReason.WarnSameSiteStrictCrossDowngradeLax||e===Protocol.Audits.SameSiteCookieWarningReason.WarnSameSiteLaxCrossDowngradeLax||e===Protocol.Audits.SameSiteCookieWarningReason.WarnSameSiteLaxCrossDowngradeStrict?[Protocol.Audits.InspectorIssueCode.SameSiteCookieIssue,"WarnCrossDowngrade",s,n].join("::"):[Protocol.Audits.InspectorIssueCode.SameSiteCookieIssue,e,s].join("::")}cookies(){return[this._issueDetails.cookie]}requests(){return this._issueDetails.request?[this._issueDetails.request]:[]}getCategory(){return IssueCategory.SameSiteCookie}getDescription(){return resolveLazyDescription(issueDescriptions.get(this.code()))}isCausedByThirdParty(){return isCausedByThirdParty(FrameManager.instance().getTopFrame(),this._issueDetails.cookieUrl)}}export function isCausedByThirdParty(e,i){if(!e)return!0;if(!i||""===e.domainAndRegistry())return!1;const s=Common.ParsedURL.ParsedURL.fromString(i);return!!s&&!IsSubdomainOf(s.domain(),e.domainAndRegistry())}function IsSubdomainOf(e,i){if(e.length<=i.length)return e===i;if(!e.endsWith(i))return!1;return e.substr(0,e.length-i.length).endsWith(".")}const sameSiteUnspecifiedErrorRead={file:"issues/descriptions/SameSiteUnspecifiedTreatedAsLaxRead.md",substitutions:void 0,links:[{link:"https://web.dev/samesite-cookies-explained/",linkTitle:i18nLazyString(UIStrings.samesiteCookiesExplained)}]},sameSiteUnspecifiedErrorSet={file:"issues/descriptions/SameSiteUnspecifiedTreatedAsLaxSet.md",substitutions:void 0,links:[{link:"https://web.dev/samesite-cookies-explained/",linkTitle:i18nLazyString(UIStrings.samesiteCookiesExplained)}]},sameSiteUnspecifiedWarnRead={file:"issues/descriptions/SameSiteUnspecifiedLaxAllowUnsafeRead.md",substitutions:void 0,links:[{link:"https://web.dev/samesite-cookies-explained/",linkTitle:i18nLazyString(UIStrings.samesiteCookiesExplained)}]},sameSiteUnspecifiedWarnSet={file:"issues/descriptions/SameSiteUnspecifiedLaxAllowUnsafeSet.md",substitutions:void 0,links:[{link:"https://web.dev/samesite-cookies-explained/",linkTitle:i18nLazyString(UIStrings.samesiteCookiesExplained)}]},sameSiteNoneInsecureErrorRead={file:"issues/descriptions/SameSiteNoneInsecureErrorRead.md",substitutions:void 0,links:[{link:"https://web.dev/samesite-cookies-explained/",linkTitle:i18nLazyString(UIStrings.samesiteCookiesExplained)}]},sameSiteNoneInsecureErrorSet={file:"issues/descriptions/SameSiteNoneInsecureErrorSet.md",substitutions:void 0,links:[{link:"https://web.dev/samesite-cookies-explained/",linkTitle:i18nLazyString(UIStrings.samesiteCookiesExplained)}]},sameSiteNoneInsecureWarnRead={file:"issues/descriptions/SameSiteNoneInsecureWarnRead.md",substitutions:void 0,links:[{link:"https://web.dev/samesite-cookies-explained/",linkTitle:i18nLazyString(UIStrings.samesiteCookiesExplained)}]},sameSiteNoneInsecureWarnSet={file:"issues/descriptions/SameSiteNoneInsecureWarnSet.md",substitutions:void 0,links:[{link:"https://web.dev/samesite-cookies-explained/",linkTitle:i18nLazyString(UIStrings.samesiteCookiesExplained)}]},schemefulSameSiteArticles=[{link:"https://web.dev/schemeful-samesite/",linkTitle:i18nLazyString(UIStrings.howSchemefulSamesiteWorks)}];function sameSiteWarnStrictLaxDowngradeStrict(e){return{file:"issues/descriptions/SameSiteWarnStrictLaxDowngradeStrict.md",substitutions:new Map([["PLACEHOLDER_destination",i18nLazyString(e?UIStrings.aSecure:UIStrings.anInsecure)],["PLACEHOLDER_origin",i18nLazyString(e?UIStrings.anInsecure:UIStrings.aSecure)]]),links:schemefulSameSiteArticles}}function sameSiteExcludeNavigationContextDowngrade(e){return{file:"issues/descriptions/SameSiteExcludeNavigationContextDowngrade.md",substitutions:new Map([["PLACEHOLDER_destination",i18nLazyString(e?UIStrings.aSecure:UIStrings.anInsecure)],["PLACEHOLDER_origin",i18nLazyString(e?UIStrings.anInsecure:UIStrings.aSecure)]]),links:schemefulSameSiteArticles}}function sameSiteWarnCrossDowngradeRead(e){return{file:"issues/descriptions/SameSiteWarnCrossDowngradeRead.md",substitutions:new Map([["PLACEHOLDER_destination",i18nLazyString(e?UIStrings.aSecure:UIStrings.anInsecure)],["PLACEHOLDER_origin",i18nLazyString(e?UIStrings.anInsecure:UIStrings.aSecure)]]),links:schemefulSameSiteArticles}}function sameSiteExcludeContextDowngradeRead(e){return{file:"issues/descriptions/SameSiteExcludeContextDowngradeRead.md",substitutions:new Map([["PLACEHOLDER_destination",i18nLazyString(e?UIStrings.aSecure:UIStrings.anInsecure)],["PLACEHOLDER_origin",i18nLazyString(e?UIStrings.anInsecure:UIStrings.aSecure)]]),links:schemefulSameSiteArticles}}function sameSiteWarnCrossDowngradeSet(e){return{file:"issues/descriptions/SameSiteWarnCrossDowngradeSet.md",substitutions:new Map([["PLACEHOLDER_ORIGIN",i18nLazyString(e?UIStrings.aSecure:UIStrings.anInsecure)],["PLACEHOLDER_DESTINATION",i18nLazyString(e?UIStrings.anInsecure:UIStrings.aSecure)]]),links:schemefulSameSiteArticles}}function sameSiteExcludeContextDowngradeSet(e){return{file:"issues/descriptions/SameSiteExcludeContextDowngradeSet.md",substitutions:new Map([["PLACEHOLDER_destination",i18nLazyString(e?UIStrings.aSecure:UIStrings.anInsecure)],["PLACEHOLDER_origin",i18nLazyString(e?UIStrings.anInsecure:UIStrings.aSecure)]]),links:schemefulSameSiteArticles}}const issueDescriptions=new Map([["SameSiteCookieIssue::ExcludeSameSiteUnspecifiedTreatedAsLax::ReadCookie",sameSiteUnspecifiedErrorRead],["SameSiteCookieIssue::ExcludeSameSiteUnspecifiedTreatedAsLax::SetCookie",sameSiteUnspecifiedErrorSet],["SameSiteCookieIssue::WarnSameSiteUnspecifiedLaxAllowUnsafe::ReadCookie",sameSiteUnspecifiedWarnRead],["SameSiteCookieIssue::WarnSameSiteUnspecifiedLaxAllowUnsafe::SetCookie",sameSiteUnspecifiedWarnSet],["SameSiteCookieIssue::WarnSameSiteUnspecifiedCrossSiteContext::ReadCookie",sameSiteUnspecifiedWarnRead],["SameSiteCookieIssue::WarnSameSiteUnspecifiedCrossSiteContext::SetCookie",sameSiteUnspecifiedWarnSet],["SameSiteCookieIssue::ExcludeSameSiteNoneInsecure::ReadCookie",sameSiteNoneInsecureErrorRead],["SameSiteCookieIssue::ExcludeSameSiteNoneInsecure::SetCookie",sameSiteNoneInsecureErrorSet],["SameSiteCookieIssue::WarnSameSiteNoneInsecure::ReadCookie",sameSiteNoneInsecureWarnRead],["SameSiteCookieIssue::WarnSameSiteNoneInsecure::SetCookie",sameSiteNoneInsecureWarnSet],["SameSiteCookieIssue::WarnSameSiteStrictLaxDowngradeStrict::Secure",sameSiteWarnStrictLaxDowngradeStrict(!0)],["SameSiteCookieIssue::WarnSameSiteStrictLaxDowngradeStrict::Insecure",sameSiteWarnStrictLaxDowngradeStrict(!1)],["SameSiteCookieIssue::WarnCrossDowngrade::ReadCookie::Secure",sameSiteWarnCrossDowngradeRead(!0)],["SameSiteCookieIssue::WarnCrossDowngrade::ReadCookie::Insecure",sameSiteWarnCrossDowngradeRead(!1)],["SameSiteCookieIssue::WarnCrossDowngrade::SetCookie::Secure",sameSiteWarnCrossDowngradeSet(!0)],["SameSiteCookieIssue::WarnCrossDowngrade::SetCookie::Insecure",sameSiteWarnCrossDowngradeSet(!1)],["SameSiteCookieIssue::ExcludeNavigationContextDowngrade::Secure",sameSiteExcludeNavigationContextDowngrade(!0)],["SameSiteCookieIssue::ExcludeNavigationContextDowngrade::Insecure",sameSiteExcludeNavigationContextDowngrade(!1)],["SameSiteCookieIssue::ExcludeContextDowngrade::ReadCookie::Secure",sameSiteExcludeContextDowngradeRead(!0)],["SameSiteCookieIssue::ExcludeContextDowngrade::ReadCookie::Insecure",sameSiteExcludeContextDowngradeRead(!1)],["SameSiteCookieIssue::ExcludeContextDowngrade::SetCookie::Secure",sameSiteExcludeContextDowngradeSet(!0)],["SameSiteCookieIssue::ExcludeContextDowngrade::SetCookie::Insecure",sameSiteExcludeContextDowngradeSet(!1)]]);