import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import*as Platform from"../platform/platform.js";import*as TextUtils from"../text_utils/text_utils.js";import{CompilerSourceMappingContentProvider}from"./CompilerSourceMappingContentProvider.js";import{PageResourceLoader}from"./PageResourceLoader.js";const UIStrings={couldNotLoadContentForSS:"Could not load content for {PH1}: {PH2}",couldNotParseContentForSS:"Could not parse content for {PH1}: {PH2}"},str_=i18n.i18n.registerUIStrings("sdk/SourceMap.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class SourceMap{compiledURL(){throw new Error("Not implemented")}url(){throw new Error("Not implemented")}sourceURLs(){throw new Error("Not implemented")}sourceContentProvider(e,t){throw new Error("Not implemented")}embeddedContentByURL(e){throw new Error("Not implemented")}findEntry(e,t){throw new Error("Not implemented")}sourceLineMapping(e,t,r){throw new Error("Not implemented")}mappings(){throw new Error("Not implemented")}}class SourceMapV3{constructor(){this.version,this.file,this.sources,this.sections,this.mappings,this.sourceRoot,this.names,this.sourcesContent}}class Section{constructor(){this.map,this.offset,this.url}}class Offset{constructor(){this.line,this.column}}export class SourceMapEntry{constructor(e,t,r,o,s,n){this.lineNumber=e,this.columnNumber=t,this.sourceURL=r,this.sourceLineNumber=o,this.sourceColumnNumber=s,this.name=n}static compare(e,t){return e.lineNumber!==t.lineNumber?e.lineNumber-t.lineNumber:e.columnNumber-t.columnNumber}}export class EditResult{constructor(e,t,r){this.map=e,this.compiledEdits=t,this.newSources=r}}const base64Digits="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",base64Map=new Map;for(let e=0;e<base64Digits.length;++e)base64Map.set(base64Digits.charAt(e),e);const sourceMapToSourceList=new WeakMap;export class TextSourceMap{constructor(e,t,r,o){if(this._initiator=o,this._json=r,this._compiledURL=e,this._sourceMappingURL=t,this._baseURL=t.startsWith("data:")?e:t,this._mappings=null,this._sourceInfos=new Map,this._json.sections){Boolean(this._json.sections.find((e=>Boolean(e.url))))&&Common.Console.Console.instance().warn(`SourceMap "${t}" contains unsupported "URL" field in one of its sections.`)}this._eachSection(this._parseSources.bind(this))}static async load(e,t,r){let o;try{const{content:t}=await PageResourceLoader.instance().loadResource(e,r);o=t,")]}"===t.slice(0,3)&&(o=t.substring(t.indexOf("\n")))}catch(s){throw new Error(i18nString(UIStrings.couldNotLoadContentForSS,{PH1:e,PH2:s.message}))}try{const s=JSON.parse(o);return new TextSourceMap(t,e,s,r)}catch(s){throw new Error(i18nString(UIStrings.couldNotParseContentForSS,{PH1:e,PH2:s.message}))}}compiledURL(){return this._compiledURL}url(){return this._sourceMappingURL}sourceURLs(){return[...this._sourceInfos.keys()]}sourceContentProvider(e,t){const r=this._sourceInfos.get(e);return r&&r.content?TextUtils.StaticContentProvider.StaticContentProvider.fromString(e,t,r.content):new CompilerSourceMappingContentProvider(e,t,this._initiator)}embeddedContentByURL(e){const t=this._sourceInfos.get(e);return t?t.content:null}findEntry(e,t){const r=this.mappings(),o=Platform.ArrayUtilities.upperBound(r,void 0,((r,o)=>e-o.lineNumber||t-o.columnNumber));return o?r[o-1]:null}sourceLineMapping(e,t,r){const o=this._reversedMappings(e),s=Platform.ArrayUtilities.lowerBound(o,t,c),n=Platform.ArrayUtilities.upperBound(o,t,c);if(s>=o.length||o[s].sourceLineNumber!==t)return null;const i=o.slice(s,n);if(!i.length)return null;const u=Platform.ArrayUtilities.lowerBound(i,r,((e,t)=>e-t.sourceColumnNumber));return u>=i.length?i[i.length-1]:i[u];function c(e,t){return e-t.sourceLineNumber}}findReverseEntries(e,t,r){const o=this._reversedMappings(e),s=Platform.ArrayUtilities.upperBound(o,void 0,((e,o)=>t-o.sourceLineNumber||r-o.sourceColumnNumber));let n=s;for(;n>0&&o[n-1].sourceLineNumber===o[s-1].sourceLineNumber&&o[n-1].sourceColumnNumber===o[s-1].sourceColumnNumber;)--n;return o.slice(n,s)}mappings(){return null===this._mappings&&(this._mappings=[],this._eachSection(this._parseMap.bind(this)),this._json=null),this._mappings}_reversedMappings(e){const t=this._sourceInfos.get(e);if(!t)return[];const r=this.mappings();return null===t.reverseMappings&&(t.reverseMappings=r.filter((t=>t.sourceURL===e)).sort((function(e,t){if(e.sourceLineNumber!==t.sourceLineNumber)return e.sourceLineNumber-t.sourceLineNumber;if(e.sourceColumnNumber!==t.sourceColumnNumber)return e.sourceColumnNumber-t.sourceColumnNumber;if(e.lineNumber!==t.lineNumber)return e.lineNumber-t.lineNumber;return e.columnNumber-t.columnNumber}))),t.reverseMappings}_eachSection(e){if(this._json)if(this._json.sections)for(const t of this._json.sections)e(t.map,t.offset.line,t.offset.column);else e(this._json,0,0)}_parseSources(e){const t=[];let r=e.sourceRoot||"";r&&!r.endsWith("/")&&(r+="/");for(let o=0;o<e.sources.length;++o){const s=r+e.sources[o];let n=Common.ParsedURL.ParsedURL.completeURL(this._baseURL,s)||s;const i=e.sourcesContent&&e.sourcesContent[o];n===this._compiledURL&&i&&(n+="? [sm]"),this._sourceInfos.set(n,new TextSourceMap.SourceInfo(i||null,null)),t.push(n)}sourceMapToSourceList.set(e,t)}_parseMap(e,t,r){let o=0,s=0,n=0,i=0;const u=sourceMapToSourceList.get(e),c=e.names||[],a=new TextSourceMap.StringCharIterator(e.mappings);let l=u&&u[o];for(;;){if(","===a.peek())a.next();else{for(;";"===a.peek();)t+=1,r=0,a.next();if(!a.hasNext())break}if(r+=this._decodeVLQ(a),!a.hasNext()||this._isSeparator(a.peek())){this.mappings().push(new SourceMapEntry(t,r));continue}const e=this._decodeVLQ(a);e&&(o+=e,u&&(l=u[o])),s+=this._decodeVLQ(a),n+=this._decodeVLQ(a),a.hasNext()&&!this._isSeparator(a.peek())?(i+=this._decodeVLQ(a),this.mappings().push(new SourceMapEntry(t,r,l,s,n,c[i]))):this.mappings().push(new SourceMapEntry(t,r,l,s,n))}this.mappings().sort(SourceMapEntry.compare)}_isSeparator(e){return","===e||";"===e}_decodeVLQ(e){let t=0,r=0,o=TextSourceMap._VLQ_CONTINUATION_MASK;for(;o&TextSourceMap._VLQ_CONTINUATION_MASK;)o=base64Map.get(e.next())||0,t+=(o&TextSourceMap._VLQ_BASE_MASK)<<r,r+=TextSourceMap._VLQ_BASE_SHIFT;const s=1&t;return t>>=1,s?-t:t}reverseMapTextRange(e,t){function r(e,t){return e.lineNumber!==t.sourceLineNumber?e.lineNumber-t.sourceLineNumber:e.columnNumber-t.sourceColumnNumber}const o=this._reversedMappings(e);if(!o.length)return null;const s=Platform.ArrayUtilities.lowerBound(o,{lineNumber:t.startLine,columnNumber:t.startColumn},r),n=Platform.ArrayUtilities.upperBound(o,{lineNumber:t.endLine,columnNumber:t.endColumn},r),i=o[s],u=o[n];return new TextUtils.TextRange.TextRange(i.lineNumber,i.columnNumber,u.lineNumber,u.columnNumber)}}TextSourceMap._VLQ_BASE_SHIFT=5,TextSourceMap._VLQ_BASE_MASK=31,TextSourceMap._VLQ_CONTINUATION_MASK=32,TextSourceMap.StringCharIterator=class{constructor(e){this._string=e,this._position=0}next(){return this._string.charAt(this._position++)}peek(){return this._string.charAt(this._position)}hasNext(){return this._position<this._string.length}},TextSourceMap.SourceInfo=class{constructor(e,t){this.content=e,this.reverseMappings=t}};