import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import*as UI from"../ui/ui.js";import{SearchConfig}from"./SearchConfig.js";import{SearchResultsPane}from"./SearchResultsPane.js";const UIStrings={search:"Search",searchQuery:"Search Query",matchCase:"Match Case",useRegularExpression:"Use Regular Expression",refresh:"Refresh",clear:"Clear",indexing:"Indexing\u2026",searching:"Searching\u2026",indexingInterrupted:"Indexing interrupted.",foundMatchingLineInFile:"Found 1 matching line in 1 file.",foundDMatchingLinesInFile:"Found {PH1} matching lines in 1 file.",foundDMatchingLinesInDFiles:"Found {PH1} matching lines in {PH2} files.",noMatchesFound:"No matches found.",searchFinished:"Search finished.",searchInterrupted:"Search interrupted."},str_=i18n.i18n.registerUIStrings("search/SearchView.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class SearchView extends UI.Widget.VBox{constructor(e){super(!0),this.setMinimumSize(0,40),this.registerRequiredCSS("search/searchView.css",{enableLegacyPatching:!0}),this._focusOnShow=!1,this._isIndexing=!1,this._searchId=1,this._searchMatchesCount=0,this._searchResultsCount=0,this._nonEmptySearchResultsCount=0,this._searchingView=null,this._notFoundView=null,this._searchConfig=null,this._pendingSearchConfig=null,this._searchResultsPane=null,this._progressIndicator=null,this._visiblePane=null,this.contentElement.classList.add("search-view"),this._searchPanelElement=this.contentElement.createChild("div","search-drawer-header"),this._searchResultsElement=this.contentElement.createChild("div"),this._searchResultsElement.className="search-results";const s=document.createElement("div");s.style.flex="auto",s.style.justifyContent="start",s.style.maxWidth="300px",this._search=UI.HistoryInput.HistoryInput.create(),this._search.addEventListener("keydown",(e=>{this._onKeyDown(e)})),s.appendChild(this._search),this._search.placeholder=i18nString(UIStrings.search),this._search.setAttribute("type","text"),this._search.setAttribute("results","0"),this._search.setAttribute("size","42"),UI.ARIAUtils.setAccessibleName(this._search,i18nString(UIStrings.searchQuery));const t=new UI.Toolbar.ToolbarItem(s),i=new UI.Toolbar.Toolbar("search-toolbar",this._searchPanelElement);this._matchCaseButton=SearchView._appendToolbarToggle(i,"Aa",i18nString(UIStrings.matchCase)),this._regexButton=SearchView._appendToolbarToggle(i,".*",i18nString(UIStrings.useRegularExpression)),i.appendToolbarItem(t);const n=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.refresh),"largeicon-refresh"),r=new UI.Toolbar.ToolbarButton(i18nString(UIStrings.clear),"largeicon-clear");i.appendToolbarItem(n),i.appendToolbarItem(r),n.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,(()=>this._onAction())),r.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,(()=>{this._resetSearch(),this._onSearchInputClear()}));const h=this.contentElement.createChild("div","search-toolbar-summary");this._searchMessageElement=h.createChild("div","search-message"),this._searchProgressPlaceholderElement=h.createChild("div","flex-centered"),this._searchResultsMessageElement=h.createChild("div","search-message"),this._advancedSearchConfig=Common.Settings.Settings.instance().createLocalSetting(e+"SearchConfig",new SearchConfig("",!0,!1).toPlainObject()),this._load(),this._searchScope=null}static _appendToolbarToggle(e,s,t){const i=new UI.Toolbar.ToolbarToggle(t);return i.setText(s),i.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,(()=>i.setToggled(!i.toggled()))),e.appendToolbarItem(i),i}_buildSearchConfig(){return new SearchConfig(this._search.value,!this._matchCaseButton.toggled(),this._regexButton.toggled())}async toggle(e,s){e&&(this._search.value=e),this.isShowing()?this.focus():this._focusOnShow=!0,this._initScope(),s?this._onAction():this._startIndexing()}createScope(){throw new Error("Not implemented")}_initScope(){this._searchScope=this.createScope()}wasShown(){this._focusOnShow&&(this.focus(),this._focusOnShow=!1)}_onIndexingFinished(){if(!this._progressIndicator)return;const e=!this._progressIndicator.isCanceled();if(this._progressIndicator.done(),this._progressIndicator=null,this._isIndexing=!1,this._indexingFinished(e),e||(this._pendingSearchConfig=null),!this._pendingSearchConfig)return;const s=this._pendingSearchConfig;this._pendingSearchConfig=null,this._innerStartSearch(s)}_startIndexing(){this._isIndexing=!0,this._progressIndicator&&this._progressIndicator.done(),this._progressIndicator=new UI.ProgressIndicator.ProgressIndicator,this._searchMessageElement.textContent=i18nString(UIStrings.indexing),this._progressIndicator.show(this._searchProgressPlaceholderElement),this._searchScope&&this._searchScope.performIndexing(new Common.Progress.ProgressProxy(this._progressIndicator,this._onIndexingFinished.bind(this)))}_onSearchInputClear(){this._search.value="",this._save(),this.focus()}_onSearchResult(e,s){e===this._searchId&&this._progressIndicator&&(this._progressIndicator&&this._progressIndicator.isCanceled()?this._onIndexingFinished():(this._addSearchResult(s),s.matchesCount()&&(this._searchResultsPane||(this._searchResultsPane=new SearchResultsPane(this._searchConfig),this._showPane(this._searchResultsPane)),this._searchResultsPane.addSearchResult(s))))}_onSearchFinished(e,s){e===this._searchId&&this._progressIndicator&&(this._searchResultsPane||this._nothingFound(),this._searchFinished(s),this._searchConfig=null,UI.ARIAUtils.alert(this._searchMessageElement.textContent+" "+this._searchResultsMessageElement.textContent,this._searchMessageElement))}async _startSearch(e){this._resetSearch(),++this._searchId,this._initScope(),this._isIndexing||this._startIndexing(),this._pendingSearchConfig=e}_innerStartSearch(e){this._searchConfig=e,this._progressIndicator&&this._progressIndicator.done(),this._progressIndicator=new UI.ProgressIndicator.ProgressIndicator,this._searchStarted(this._progressIndicator),this._searchScope&&this._searchScope.performSearch(e,this._progressIndicator,this._onSearchResult.bind(this,this._searchId),this._onSearchFinished.bind(this,this._searchId))}_resetSearch(){this._stopSearch(),this._showPane(null),this._searchResultsPane=null,this._clearSearchMessage()}_clearSearchMessage(){this._searchMessageElement.textContent="",this._searchResultsMessageElement.textContent=""}_stopSearch(){this._progressIndicator&&!this._isIndexing&&this._progressIndicator.cancel(),this._searchScope&&this._searchScope.stopSearch(),this._searchConfig=null}_searchStarted(e){this._resetCounters(),this._searchingView||(this._searchingView=new UI.EmptyWidget.EmptyWidget(i18nString(UIStrings.searching))),this._showPane(this._searchingView),this._searchMessageElement.textContent=i18nString(UIStrings.searching),e.show(this._searchProgressPlaceholderElement),this._updateSearchResultsMessage()}_indexingFinished(e){this._searchMessageElement.textContent=e?"":i18nString(UIStrings.indexingInterrupted)}_updateSearchResultsMessage(){this._searchMatchesCount&&this._searchResultsCount?1===this._searchMatchesCount&&1===this._nonEmptySearchResultsCount?this._searchResultsMessageElement.textContent=i18nString(UIStrings.foundMatchingLineInFile):this._searchMatchesCount>1&&1===this._nonEmptySearchResultsCount?this._searchResultsMessageElement.textContent=i18nString(UIStrings.foundDMatchingLinesInFile,{PH1:this._searchMatchesCount}):this._searchResultsMessageElement.textContent=i18nString(UIStrings.foundDMatchingLinesInDFiles,{PH1:this._searchMatchesCount,PH2:this._nonEmptySearchResultsCount}):this._searchResultsMessageElement.textContent=""}_showPane(e){this._visiblePane&&this._visiblePane.detach(),e&&e.show(this._searchResultsElement),this._visiblePane=e}_resetCounters(){this._searchMatchesCount=0,this._searchResultsCount=0,this._nonEmptySearchResultsCount=0}_nothingFound(){this._notFoundView||(this._notFoundView=new UI.EmptyWidget.EmptyWidget(i18nString(UIStrings.noMatchesFound))),this._showPane(this._notFoundView),this._searchResultsMessageElement.textContent=i18nString(UIStrings.noMatchesFound)}_addSearchResult(e){const s=e.matchesCount();this._searchMatchesCount+=s,this._searchResultsCount++,s&&this._nonEmptySearchResultsCount++,this._updateSearchResultsMessage()}_searchFinished(e){this._searchMessageElement.textContent=i18nString(e?UIStrings.searchFinished:UIStrings.searchInterrupted)}focus(){this._search.focus(),this._search.select()}willHide(){this._stopSearch()}_onKeyDown(e){if(this._save(),e.keyCode===UI.KeyboardShortcut.Keys.Enter.code)this._onAction()}_save(){this._advancedSearchConfig.set(this._buildSearchConfig().toPlainObject())}_load(){const e=SearchConfig.fromPlainObject(this._advancedSearchConfig.get());this._search.value=e.query(),this._matchCaseButton.setToggled(!e.ignoreCase()),this._regexButton.setToggled(e.isRegex())}_onAction(){UI.ARIAUtils.alert(" ",this._searchMessageElement);const e=this._buildSearchConfig();e.query()&&e.query().length&&this._startSearch(e)}}