import*as Common from"../common/common.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as Network from"../network/network.js";import*as SDK from"../sdk/sdk.js";import*as UI from"../ui/ui.js";import{Events,SecurityModel,SecurityStyleExplanation,SummaryMessages}from"./SecurityModel.js";const UIStrings={overview:"Overview",mainOrigin:"Main origin",nonsecureOrigins:"Non-secure origins",secureOrigins:"Secure origins",unknownCanceled:"Unknown / canceled",reloadToViewDetails:"Reload to view details",mainOriginSecure:"Main origin (secure)",mainOriginNonsecure:"Main origin (non-secure)",securityOverview:"Security overview",secure:"Secure",info:"Info",notSecure:"Not secure",viewCertificate:"View certificate",theSecurityOfThisPageIsUnknown:"The security of this page is unknown.",thisPageIsNotSecure:"This page is not secure.",thisPageIsSecureValidHttps:"This page is secure (valid HTTPS).",thisPageIsNotSecureBrokenHttps:"This page is not secure (broken HTTPS).",notSecureBroken:"Not secure (broken)",thisPageIsDangerousFlaggedBy:"This page is dangerous (flagged by Google Safe Browsing).",flaggedByGoogleSafeBrowsing:"Flagged by Google Safe Browsing",toCheckThisPagesStatusVisit:"To check this page's status, visit g.co/safebrowsingstatus.",thisIsAnErrorPage:"This is an error page.",thisPageIsInsecureUnencrypted:"This page is insecure (unencrypted HTTP).",formFieldEditedOnANonsecurePage:"Form field edited on a non-secure page",dataWasEnteredInAFieldOnA:"Data was entered in a field on a non-secure page. A warning has been added to the URL bar.",thisPageHasANonhttpsSecureOrigin:"This page has a non-HTTPS secure origin.",thisPageIsSuspicious:"This page is suspicious",chromeHasDeterminedThatThisSiteS:"Chrome has determined that this site could be fake or fraudulent.",ifYouBelieveThisIsShownIn:"If you believe this is shown in error please visit https://bugs.chromium.org/p/chromium/issues/entry?template=Safety+Tips+Appeals.",possibleSpoofingUrl:"Possible spoofing URL",thisSitesHostnameLooksSimilarToP:"This site's hostname looks similar to {PH1}. Attackers sometimes mimic sites by making small, hard-to-see changes to the domain name.",ifYouBelieveThisIsShownInErrorSafety:"If you believe this is shown in error please visit https://bugs.chromium.org/p/chromium/issues/entry?template=Safety+Tips+Appeals.",thisPageIsSuspiciousFlaggedBy:"This page is suspicious (flagged by Chrome).",certificate:"Certificate",insecureSha:"insecure (SHA-1)",theCertificateChainForThisSite:"The certificate chain for this site contains a certificate signed using SHA-1.",subjectAlternativeNameMissing:"`Subject Alternative Name` missing",theCertificateForThisSiteDoesNot:"The certificate for this site does not contain a `Subject Alternative Name` extension containing a domain name or IP address.",missing:"missing",thisSiteIsMissingAValidTrusted:"This site is missing a valid, trusted certificate ({PH1}).",validAndTrusted:"valid and trusted",theConnectionToThisSiteIsUsingA:"The connection to this site is using a valid, trusted server certificate issued by {PH1}.",publickeypinningBypassed:"Public-Key-Pinning bypassed",publickeypinningWasBypassedByA:"Public-Key-Pinning was bypassed by a local root certificate.",certificateExpiresSoon:"Certificate expires soon",theCertificateForThisSiteExpires:"The certificate for this site expires in less than 48 hours and needs to be renewed.",connection:"Connection",secureConnectionSettings:"secure connection settings",theConnectionToThisSiteIs:"The connection to this site is encrypted and authenticated using {PH1}, {PH2}, and {PH3}.",sIsObsoleteEnableTlsOrLater:"{PH1} is obsolete. Enable TLS 1.2 or later.",rsaKeyExchangeIsObsoleteEnableAn:"RSA key exchange is obsolete. Enable an ECDHE-based cipher suite.",sIsObsoleteEnableAnAesgcmbased:"{PH1} is obsolete. Enable an AES-GCM-based cipher suite.",theServerSignatureUsesShaWhichIs:"The server signature uses SHA-1, which is obsolete. Enable a SHA-2 signature algorithm instead. (Note this is different from the signature in the certificate.)",obsoleteConnectionSettings:"obsolete connection settings",resources:"Resources",activeMixedContent:"active mixed content",youHaveRecentlyAllowedNonsecure:"You have recently allowed non-secure content (such as scripts or iframes) to run on this site.",mixedContent:"mixed content",thisPageIncludesHttpResources:"This page includes HTTP resources.",nonsecureForm:"non-secure form",thisPageIncludesAFormWithA:'This page includes a form with a non-secure "action" attribute.',activeContentWithCertificate:"active content with certificate errors",youHaveRecentlyAllowedContent:"You have recently allowed content loaded with certificate errors (such as scripts or iframes) to run on this site.",contentWithCertificateErrors:"content with certificate errors",thisPageIncludesResourcesThat:"This page includes resources that were loaded with certificate errors.",allServedSecurely:"all served securely",allResourcesOnThisPageAreServed:"All resources on this page are served securely.",blockedMixedContent:"Blocked mixed content",yourPageRequestedNonsecure:"Your page requested non-secure resources that were blocked.",reloadThePageToRecordRequestsFor:"Reload the page to record requests for HTTP resources.",viewDRequestInNetworkPanel:"View 1 request in Network Panel",viewDRequestsInNetworkPanel:"View {PH1} requests in Network Panel",origin:"Origin",viewRequestsInNetworkPanel:"View requests in Network Panel",protocol:"Protocol",keyExchange:"Key exchange",keyExchangeGroup:"Key exchange group",cipher:"Cipher",certificateTransparency:"Certificate Transparency",subject:"Subject",san:"`SAN`",validFrom:"Valid from",validUntil:"Valid until",issuer:"Issuer",openFullCertificateDetails:"Open full certificate details",sct:"SCT",logName:"Log name",logId:"Log ID",validationStatus:"Validation status",source:"Source",issuedAt:"Issued at",hashAlgorithm:"Hash algorithm",signatureAlgorithm:"Signature algorithm",signatureData:"Signature data",showFullDetails:"Show full details",hideFullDetails:"Hide full details",thisRequestCompliesWithChromes:"This request complies with `Chrome`'s Certificate Transparency policy.",thisRequestDoesNotComplyWith:"This request does not comply with `Chrome`'s Certificate Transparency policy.",thisResponseWasLoadedFromCache:"This response was loaded from cache. Some security details might be missing.",theSecurityDetailsAboveAreFrom:"The security details above are from the first inspected response.",thisOriginIsANonhttpsSecure:"This origin is a non-HTTPS secure origin.",yourConnectionToThisOriginIsNot:"Your connection to this origin is not secure.",noSecurityInformation:"No security information",noSecurityDetailsAreAvailableFor:"No security details are available for this origin.",na:"(n/a)",showLess:"Show less",showMoreSTotal:"Show more ({PH1} total)"},str_=i18n.i18n.registerUIStrings("security/SecurityPanel.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);let securityPanelInstance;export class SecurityPanel extends UI.Panel.PanelWithSidebar{constructor(){super("security"),this._mainView=new SecurityMainView(this);const e=document.createElement("span");e.classList.add("title"),e.textContent=i18nString(UIStrings.overview),this._sidebarMainViewElement=new SecurityPanelSidebarTreeElement(e,this._setVisibleView.bind(this,this._mainView),"security-main-view-sidebar-tree-item","lock-icon"),this._sidebarMainViewElement.tooltip=e.textContent,this._sidebarTree=new SecurityPanelSidebarTree(this._sidebarMainViewElement,this.showOrigin.bind(this)),this.panelSidebarElement().appendChild(this._sidebarTree.element),this._lastResponseReceivedForLoaderId=new Map,this._origins=new Map,this._filterRequestCounts=new Map,SDK.SDKModel.TargetManager.instance().observeModels(SecurityModel,this),this._visibleView=null,this._eventListeners=[],this._securityModel=null}static instance(e={forceNew:null}){const{forceNew:t}=e;return securityPanelInstance&&!t||(securityPanelInstance=new SecurityPanel),securityPanelInstance}static _instance(){return SecurityPanel.instance()}static createCertificateViewerButtonForOrigin(e,t){const i=UI.UIUtils.createTextButton(e,(async e=>{e.consume();const i=await SDK.NetworkManager.MultitargetNetworkManager.instance().getCertificate(t);i.length>0&&Host.InspectorFrontendHost.InspectorFrontendHostInstance.showCertificateViewer(i)}),"origin-button");return UI.ARIAUtils.markAsButton(i),i}static createCertificateViewerButtonForCert(e,t){const i=UI.UIUtils.createTextButton(e,(e=>{e.consume(),Host.InspectorFrontendHost.InspectorFrontendHostInstance.showCertificateViewer(t)}),"origin-button");return UI.ARIAUtils.markAsButton(i),i}static createHighlightedUrl(e,t){const i="://",n=e.indexOf(i);if(-1===n){const t=document.createElement("span");return t.textContent=e,t}const r=document.createElement("span"),s=e.substr(0,n),o=e.substr(n+i.length);return r.createChild("span","url-scheme-"+t).textContent=s,r.createChild("span","url-scheme-separator").textContent=i,r.createChild("span").textContent=o,r}_updateSecurityState(e,t,i){this._sidebarMainViewElement.setSecurityState(e),this._mainView.updateSecurityState(e,t,i)}_onSecurityStateChanged(e){const t=e.data,i=t.securityState,n=t.explanations,r=t.summary;this._updateSecurityState(i,n,r)}_updateVisibleSecurityState(e){this._sidebarMainViewElement.setSecurityState(e.securityState),this._mainView.updateVisibleSecurityState(e)}_onVisibleSecurityStateChanged(e){const t=e.data;this._updateVisibleSecurityState(t)}selectAndSwitchToMainView(){this._sidebarMainViewElement.select(!0)}showOrigin(e){const t=this._origins.get(e);t&&(t.originView||(t.originView=new SecurityOriginView(this,e,t)),this._setVisibleView(t.originView))}wasShown(){super.wasShown(),this._visibleView||this.selectAndSwitchToMainView()}focus(){this._sidebarTree.focus()}_setVisibleView(e){this._visibleView!==e&&(this._visibleView&&this._visibleView.detach(),this._visibleView=e,e&&this.splitWidget().setMainWidget(e))}_onResponseReceived(e){const t=e.data.request;t.resourceType()===Common.ResourceType.resourceTypes.Document&&this._lastResponseReceivedForLoaderId.set(t.loaderId,t)}_processRequest(e){const t=Common.ParsedURL.ParsedURL.extractOrigin(e.url());if(!t)return;let i=e.securityState();e.mixedContentType!==Protocol.Security.MixedContentType.Blockable&&e.mixedContentType!==Protocol.Security.MixedContentType.OptionallyBlockable||(i=Protocol.Security.SecurityState.Insecure);const n=this._origins.get(t);if(n){const r=n.securityState;if(n.securityState=this._securityStateMin(r,i),r!==n.securityState){const r=e.securityDetails();r&&(n.securityDetails=r),this._sidebarTree.updateOrigin(t,i),n.originView&&n.originView.setSecurityState(i)}}else{const n={securityState:i,securityDetails:e.securityDetails(),loadedFromCache:e.cached(),originView:void 0};this._origins.set(t,n),this._sidebarTree.addOrigin(t,i)}}_onRequestFinished(e){const t=e.data;this._updateFilterRequestCounts(t),this._processRequest(t)}_updateFilterRequestCounts(e){if(e.mixedContentType===Protocol.Security.MixedContentType.None)return;let t=Network.NetworkLogView.MixedContentFilterValues.All;e.wasBlocked()?t=Network.NetworkLogView.MixedContentFilterValues.Blocked:e.mixedContentType===Protocol.Security.MixedContentType.Blockable?t=Network.NetworkLogView.MixedContentFilterValues.BlockOverridden:e.mixedContentType===Protocol.Security.MixedContentType.OptionallyBlockable&&(t=Network.NetworkLogView.MixedContentFilterValues.Displayed);const i=this._filterRequestCounts.get(t);i?this._filterRequestCounts.set(t,i+1):this._filterRequestCounts.set(t,1),this._mainView.refreshExplanations()}filterRequestCount(e){return this._filterRequestCounts.get(e)||0}_securityStateMin(e,t){return SecurityModel.SecurityStateComparator(e,t)<0?e:t}modelAdded(e){if(this._securityModel)return;this._securityModel=e;const t=e.resourceTreeModel(),i=e.networkManager();this._eventListeners=[e.addEventListener(Events.VisibleSecurityStateChanged,this._onVisibleSecurityStateChanged,this),t.addEventListener(SDK.ResourceTreeModel.Events.MainFrameNavigated,this._onMainFrameNavigated,this),t.addEventListener(SDK.ResourceTreeModel.Events.InterstitialShown,this._onInterstitialShown,this),t.addEventListener(SDK.ResourceTreeModel.Events.InterstitialHidden,this._onInterstitialHidden,this),i.addEventListener(SDK.NetworkManager.Events.ResponseReceived,this._onResponseReceived,this),i.addEventListener(SDK.NetworkManager.Events.RequestFinished,this._onRequestFinished,this)],t.isInterstitialShowing()&&this._onInterstitialShown()}modelRemoved(e){this._securityModel===e&&(this._securityModel=null,Common.EventTarget.EventTarget.removeEventListeners(this._eventListeners))}_onMainFrameNavigated(e){const t=e.data,i=this._lastResponseReceivedForLoaderId.get(t.loaderId);this.selectAndSwitchToMainView(),this._sidebarTree.clearOrigins(),this._origins.clear(),this._lastResponseReceivedForLoaderId.clear(),this._filterRequestCounts.clear(),this._mainView.refreshExplanations();const n=Common.ParsedURL.ParsedURL.extractOrigin(i?i.url():t.url);this._sidebarTree.setMainOrigin(n),i&&this._processRequest(i)}_onInterstitialShown(){this.selectAndSwitchToMainView(),this._sidebarTree.toggleOriginsList(!0)}_onInterstitialHidden(){this._sidebarTree.toggleOriginsList(!1)}}export class SecurityPanelSidebarTree extends UI.TreeOutline.TreeOutlineInShadow{constructor(e,t){super(),this.registerRequiredCSS("security/sidebar.css",{enableLegacyPatching:!0}),this.registerRequiredCSS("security/lockIcon.css",{enableLegacyPatching:!0}),this.appendChild(e),this._showOriginInPanel=t,this._mainOrigin=null,this._originGroupTitles=new Map([[OriginGroup.MainOrigin,i18nString(UIStrings.mainOrigin)],[OriginGroup.NonSecure,i18nString(UIStrings.nonsecureOrigins)],[OriginGroup.Secure,i18nString(UIStrings.secureOrigins)],[OriginGroup.Unknown,i18nString(UIStrings.unknownCanceled)]]),this._originGroups=new Map;for(const n of Object.values(OriginGroup)){const e=this._createOriginGroupElement(this._originGroupTitles.get(n));this._originGroups.set(n,e),this.appendChild(e)}this._clearOriginGroups();const i=new UI.TreeOutline.TreeElement(i18nString(UIStrings.reloadToViewDetails));i.selectable=!1,i.listItemElement.classList.add("security-main-view-reload-message");this._originGroups.get(OriginGroup.MainOrigin).appendChild(i),this._elementsByOrigin=new Map}_originGroupTitle(e){return this._originGroupTitles.get(e)}_originGroupElement(e){return this._originGroups.get(e)}_createOriginGroupElement(e){const t=new UI.TreeOutline.TreeElement(e,!0);return t.selectable=!1,t.setCollapsible(!1),t.expand(),t.listItemElement.classList.add("security-sidebar-origins"),UI.ARIAUtils.setAccessibleName(t.childrenListElement,e),t}toggleOriginsList(e){for(const t of this._originGroups.values())t.hidden=e}addOrigin(e,t){const i=new SecurityPanelSidebarTreeElement(SecurityPanel.createHighlightedUrl(e,t),this._showOriginInPanel.bind(this,e),"security-sidebar-tree-item","security-property");i.tooltip=e,this._elementsByOrigin.set(e,i),this.updateOrigin(e,t)}setMainOrigin(e){this._mainOrigin=e}updateOrigin(e,t){const i=this._elementsByOrigin.get(e);let n;if(i.setSecurityState(t),e===this._mainOrigin)n=this._originGroups.get(OriginGroup.MainOrigin),t===Protocol.Security.SecurityState.Secure?n.title=i18nString(UIStrings.mainOriginSecure):n.title=i18nString(UIStrings.mainOriginNonsecure),UI.ARIAUtils.setAccessibleName(n.childrenListElement,n.title);else switch(t){case Protocol.Security.SecurityState.Secure:n=this._originGroupElement(OriginGroup.Secure);break;case Protocol.Security.SecurityState.Unknown:n=this._originGroupElement(OriginGroup.Unknown);break;default:n=this._originGroupElement(OriginGroup.NonSecure)}const r=i.parent;r!==n&&(r&&(r.removeChild(i),0===r.childCount()&&(r.hidden=!0)),n.appendChild(i),n.hidden=!1)}_clearOriginGroups(){for(const t of this._originGroups.values())t.removeChildren(),t.hidden=!0;const e=this._originGroupElement(OriginGroup.MainOrigin);e.title=this._originGroupTitle(OriginGroup.MainOrigin),e.hidden=!1}clearOrigins(){this._clearOriginGroups(),this._elementsByOrigin.clear()}}export var OriginGroup;!function(e){e.MainOrigin="MainOrigin",e.NonSecure="NonSecure",e.Secure="Secure",e.Unknown="Unknown"}(OriginGroup||(OriginGroup={}));export class SecurityPanelSidebarTreeElement extends UI.TreeOutline.TreeElement{constructor(e,t,i,n){super("",!1),this._selectCallback=t,this._cssPrefix=n,this.listItemElement.classList.add(i),this._iconElement=this.listItemElement.createChild("div","icon"),this._iconElement.classList.add(this._cssPrefix),this.listItemElement.appendChild(e),this._securityState=null,this.setSecurityState(Protocol.Security.SecurityState.Unknown)}setSecurityState(e){this._securityState&&this._iconElement.classList.remove(this._cssPrefix+"-"+this._securityState),this._securityState=e,this._iconElement.classList.add(this._cssPrefix+"-"+e)}securityState(){return this._securityState}onselect(){return this._selectCallback(),!0}}export class SecurityMainView extends UI.Widget.VBox{constructor(e){super(!0),this.registerRequiredCSS("security/mainView.css",{enableLegacyPatching:!0}),this.registerRequiredCSS("security/lockIcon.css",{enableLegacyPatching:!0}),this.setMinimumSize(200,100),this.contentElement.classList.add("security-main-view"),this._panel=e,this._summarySection=this.contentElement.createChild("div","security-summary"),this._securityExplanationsMain=this.contentElement.createChild("div","security-explanation-list security-explanations-main"),this._securityExplanationsExtra=this.contentElement.createChild("div","security-explanation-list security-explanations-extra");const t=this._summarySection.createChild("div","security-summary-section-title");t.textContent=i18nString(UIStrings.securityOverview),UI.ARIAUtils.markAsHeading(t,1);const i=this._summarySection.createChild("div","lock-spectrum");this._lockSpectrum=new Map([[Protocol.Security.SecurityState.Secure,i.createChild("div","lock-icon lock-icon-secure")],[Protocol.Security.SecurityState.Neutral,i.createChild("div","lock-icon lock-icon-neutral")],[Protocol.Security.SecurityState.Insecure,i.createChild("div","lock-icon lock-icon-insecure")]]),UI.Tooltip.Tooltip.install(this.getLockSpectrumDiv(Protocol.Security.SecurityState.Secure),i18nString(UIStrings.secure)),UI.Tooltip.Tooltip.install(this.getLockSpectrumDiv(Protocol.Security.SecurityState.Neutral),i18nString(UIStrings.info)),UI.Tooltip.Tooltip.install(this.getLockSpectrumDiv(Protocol.Security.SecurityState.Insecure),i18nString(UIStrings.notSecure)),this._summarySection.createChild("div","triangle-pointer-container").createChild("div","triangle-pointer-wrapper").createChild("div","triangle-pointer"),this._summaryText=this._summarySection.createChild("div","security-summary-text"),UI.ARIAUtils.markAsHeading(this._summaryText,2),this._explanations=null,this._securityState=null}getLockSpectrumDiv(e){const t=this._lockSpectrum.get(e);if(!t)throw new Error(`Invalid argument: ${e}`);return t}_addExplanation(e,t){const i=e.createChild("div","security-explanation");i.classList.add("security-explanation-"+t.securityState),i.createChild("div","security-property").classList.add("security-property-"+t.securityState);const n=i.createChild("div","security-explanation-text"),r=n.createChild("div","security-explanation-title");if(t.title?(r.createChild("span").textContent=t.title+" - ",r.createChild("span","security-explanation-title-"+t.securityState).textContent=t.summary):r.textContent=t.summary,n.createChild("div").textContent=t.description,t.certificate.length&&n.appendChild(SecurityPanel.createCertificateViewerButtonForCert(i18nString(UIStrings.viewCertificate),t.certificate)),t.recommendations&&t.recommendations.length){const e=n.createChild("ul","security-explanation-recommendations");for(const i of t.recommendations)e.createChild("li").textContent=i}return n}updateSecurityState(e,t,i){this._summarySection.classList.remove("security-summary-"+this._securityState),this._securityState=e,this._summarySection.classList.add("security-summary-"+this._securityState);const n=new Map([[Protocol.Security.SecurityState.Unknown,i18nString(UIStrings.theSecurityOfThisPageIsUnknown)],[Protocol.Security.SecurityState.Insecure,i18nString(UIStrings.thisPageIsNotSecure)],[Protocol.Security.SecurityState.Neutral,i18nString(UIStrings.thisPageIsNotSecure)],[Protocol.Security.SecurityState.Secure,i18nString(UIStrings.thisPageIsSecureValidHttps)],[Protocol.Security.SecurityState.InsecureBroken,i18nString(UIStrings.thisPageIsNotSecureBrokenHttps)]]);this._securityState===Protocol.Security.SecurityState.Insecure?(this.getLockSpectrumDiv(Protocol.Security.SecurityState.Insecure).classList.add("lock-icon-insecure"),this.getLockSpectrumDiv(Protocol.Security.SecurityState.Insecure).classList.remove("lock-icon-insecure-broken"),UI.Tooltip.Tooltip.install(this.getLockSpectrumDiv(Protocol.Security.SecurityState.Insecure),i18nString(UIStrings.notSecure))):this._securityState===Protocol.Security.SecurityState.InsecureBroken&&(this.getLockSpectrumDiv(Protocol.Security.SecurityState.Insecure).classList.add("lock-icon-insecure-broken"),this.getLockSpectrumDiv(Protocol.Security.SecurityState.Insecure).classList.remove("lock-icon-insecure"),UI.Tooltip.Tooltip.install(this.getLockSpectrumDiv(Protocol.Security.SecurityState.Insecure),i18nString(UIStrings.notSecureBroken))),this._summaryText.textContent=i||n.get(this._securityState)||"",this._explanations=t,this.refreshExplanations()}updateVisibleSecurityState(e){this._summarySection.classList.remove("security-summary-"+this._securityState),this._securityState=e.securityState,this._summarySection.classList.add("security-summary-"+this._securityState),this._securityState===Protocol.Security.SecurityState.Insecure?(this.getLockSpectrumDiv(Protocol.Security.SecurityState.Insecure).classList.add("lock-icon-insecure"),this.getLockSpectrumDiv(Protocol.Security.SecurityState.Insecure).classList.remove("lock-icon-insecure-broken"),UI.Tooltip.Tooltip.install(this.getLockSpectrumDiv(Protocol.Security.SecurityState.Insecure),i18nString(UIStrings.notSecure))):this._securityState===Protocol.Security.SecurityState.InsecureBroken&&(this.getLockSpectrumDiv(Protocol.Security.SecurityState.Insecure).classList.add("lock-icon-insecure-broken"),this.getLockSpectrumDiv(Protocol.Security.SecurityState.Insecure).classList.remove("lock-icon-insecure"),UI.Tooltip.Tooltip.install(this.getLockSpectrumDiv(Protocol.Security.SecurityState.Insecure),i18nString(UIStrings.notSecureBroken)));const{summary:t,explanations:i}=this._getSecuritySummaryAndExplanations(e);this._summaryText.textContent=t||SummaryMessages[this._securityState](),this._explanations=this._orderExplanations(i),this.refreshExplanations()}_getSecuritySummaryAndExplanations(e){const{securityState:t,securityStateIssueIds:i}=e;let n;const r=[];if(n=this._explainSafetyTipSecurity(e,n,r),i.includes("malicious-content"))n=i18nString(UIStrings.thisPageIsDangerousFlaggedBy),r.unshift(new SecurityStyleExplanation(Protocol.Security.SecurityState.Insecure,void 0,i18nString(UIStrings.flaggedByGoogleSafeBrowsing),i18nString(UIStrings.toCheckThisPagesStatusVisit)));else{if(i.includes("is-error-page")&&(null===e.certificateSecurityState||null===e.certificateSecurityState.certificateNetworkError))return n=i18nString(UIStrings.thisIsAnErrorPage),{summary:n,explanations:r};t===Protocol.Security.SecurityState.InsecureBroken&&i.includes("scheme-is-not-cryptographic")&&(n=n||i18nString(UIStrings.thisPageIsInsecureUnencrypted),i.includes("insecure-input-events")&&r.push(new SecurityStyleExplanation(Protocol.Security.SecurityState.Insecure,void 0,i18nString(UIStrings.formFieldEditedOnANonsecurePage),i18nString(UIStrings.dataWasEnteredInAFieldOnA))))}return i.includes("scheme-is-not-cryptographic")?(t!==Protocol.Security.SecurityState.Neutral||i.includes("insecure-origin")||(n=i18nString(UIStrings.thisPageHasANonhttpsSecureOrigin)),{summary:n,explanations:r}):(this._explainCertificateSecurity(e,r),this._explainConnectionSecurity(e,r),this._explainContentSecurity(e,r),{summary:n,explanations:r})}_explainSafetyTipSecurity(e,t,i){const{securityStateIssueIds:n,safetyTipInfo:r}=e,s=[];if(n.includes("bad_reputation")){const e=`${i18nString(UIStrings.chromeHasDeterminedThatThisSiteS)}\n\n${i18nString(UIStrings.ifYouBelieveThisIsShownIn)}`;s.push({summary:i18nString(UIStrings.thisPageIsSuspicious),description:e})}else if(n.includes("lookalike")&&r&&r.safeUrl){const e=new URL(r.safeUrl).hostname,t=`${i18nString(UIStrings.thisSitesHostnameLooksSimilarToP,{PH1:e})}\n\n${i18nString(UIStrings.ifYouBelieveThisIsShownInErrorSafety)}`;s.push({summary:i18nString(UIStrings.possibleSpoofingUrl),description:t})}return s.length>0&&(t=t||i18nString(UIStrings.thisPageIsSuspiciousFlaggedBy),i.push(new SecurityStyleExplanation(Protocol.Security.SecurityState.Insecure,void 0,s[0].summary,s[0].description))),t}_explainCertificateSecurity(e,t){const{certificateSecurityState:i,securityStateIssueIds:n}=e,r=i18nString(UIStrings.certificate);if(i&&i.certificateHasSha1Signature){const e=i18nString(UIStrings.insecureSha),n=i18nString(UIStrings.theCertificateChainForThisSite);i.certificateHasWeakSignature?t.push(new SecurityStyleExplanation(Protocol.Security.SecurityState.Insecure,r,e,n,i.certificate,Protocol.Security.MixedContentType.None)):t.push(new SecurityStyleExplanation(Protocol.Security.SecurityState.Neutral,r,e,n,i.certificate,Protocol.Security.MixedContentType.None))}i&&n.includes("cert-missing-subject-alt-name")&&t.push(new SecurityStyleExplanation(Protocol.Security.SecurityState.Insecure,r,i18nString(UIStrings.subjectAlternativeNameMissing),i18nString(UIStrings.theCertificateForThisSiteDoesNot),i.certificate,Protocol.Security.MixedContentType.None)),i&&null!==i.certificateNetworkError?t.push(new SecurityStyleExplanation(Protocol.Security.SecurityState.Insecure,r,i18nString(UIStrings.missing),i18nString(UIStrings.thisSiteIsMissingAValidTrusted,{PH1:i.certificateNetworkError}),i.certificate,Protocol.Security.MixedContentType.None)):i&&!i.certificateHasSha1Signature&&t.push(new SecurityStyleExplanation(Protocol.Security.SecurityState.Secure,r,i18nString(UIStrings.validAndTrusted),i18nString(UIStrings.theConnectionToThisSiteIsUsingA,{PH1:i.issuer}),i.certificate,Protocol.Security.MixedContentType.None)),n.includes("pkp-bypassed")&&t.push(new SecurityStyleExplanation(Protocol.Security.SecurityState.Info,r,i18nString(UIStrings.publickeypinningBypassed),i18nString(UIStrings.publickeypinningWasBypassedByA))),i&&i.isCertificateExpiringSoon()&&t.push(new SecurityStyleExplanation(Protocol.Security.SecurityState.Info,void 0,i18nString(UIStrings.certificateExpiresSoon),i18nString(UIStrings.theCertificateForThisSiteExpires)))}_explainConnectionSecurity(e,t){const i=e.certificateSecurityState;if(!i)return;const n=i18nString(UIStrings.connection);if(i.modernSSL)return void t.push(new SecurityStyleExplanation(Protocol.Security.SecurityState.Secure,n,i18nString(UIStrings.secureConnectionSettings),i18nString(UIStrings.theConnectionToThisSiteIs,{PH1:i.protocol,PH2:i.getKeyExchangeName(),PH3:i.getCipherFullName()})));const r=[];i.obsoleteSslProtocol&&r.push(i18nString(UIStrings.sIsObsoleteEnableTlsOrLater,{PH1:i.protocol})),i.obsoleteSslKeyExchange&&r.push(i18nString(UIStrings.rsaKeyExchangeIsObsoleteEnableAn)),i.obsoleteSslCipher&&r.push(i18nString(UIStrings.sIsObsoleteEnableAnAesgcmbased,{PH1:i.cipher})),i.obsoleteSslSignature&&r.push(i18nString(UIStrings.theServerSignatureUsesShaWhichIs)),t.push(new SecurityStyleExplanation(Protocol.Security.SecurityState.Info,n,i18nString(UIStrings.obsoleteConnectionSettings),i18nString(UIStrings.theConnectionToThisSiteIs,{PH1:i.protocol,PH2:i.getKeyExchangeName(),PH3:i.getCipherFullName()}),void 0,void 0,r))}_explainContentSecurity(e,t){let i=!0;const n=i18nString(UIStrings.resources),r=e.securityStateIssueIds;r.includes("ran-mixed-content")&&(i=!1,t.push(new SecurityStyleExplanation(Protocol.Security.SecurityState.Insecure,n,i18nString(UIStrings.activeMixedContent),i18nString(UIStrings.youHaveRecentlyAllowedNonsecure),[],Protocol.Security.MixedContentType.Blockable))),r.includes("displayed-mixed-content")&&(i=!1,t.push(new SecurityStyleExplanation(Protocol.Security.SecurityState.Neutral,n,i18nString(UIStrings.mixedContent),i18nString(UIStrings.thisPageIncludesHttpResources),[],Protocol.Security.MixedContentType.OptionallyBlockable))),r.includes("contained-mixed-form")&&(i=!1,t.push(new SecurityStyleExplanation(Protocol.Security.SecurityState.Neutral,n,i18nString(UIStrings.nonsecureForm),i18nString(UIStrings.thisPageIncludesAFormWithA)))),null!==e.certificateSecurityState&&null!==e.certificateSecurityState.certificateNetworkError||(r.includes("ran-content-with-cert-error")&&(i=!1,t.push(new SecurityStyleExplanation(Protocol.Security.SecurityState.Insecure,n,i18nString(UIStrings.activeContentWithCertificate),i18nString(UIStrings.youHaveRecentlyAllowedContent)))),r.includes("displayed-content-with-cert-errors")&&(i=!1,t.push(new SecurityStyleExplanation(Protocol.Security.SecurityState.Neutral,n,i18nString(UIStrings.contentWithCertificateErrors),i18nString(UIStrings.thisPageIncludesResourcesThat))))),i&&(r.includes("scheme-is-not-cryptographic")||t.push(new SecurityStyleExplanation(Protocol.Security.SecurityState.Secure,n,i18nString(UIStrings.allServedSecurely),i18nString(UIStrings.allResourcesOnThisPageAreServed))))}_orderExplanations(e){if(0===e.length)return e;const t=[Protocol.Security.SecurityState.Insecure,Protocol.Security.SecurityState.Neutral,Protocol.Security.SecurityState.Secure,Protocol.Security.SecurityState.Info],i=[];for(const n of t)i.push(...e.filter((e=>e.securityState===n)));return i}refreshExplanations(){if(this._securityExplanationsMain.removeChildren(),this._securityExplanationsExtra.removeChildren(),this._explanations){for(const e of this._explanations)if(e.securityState===Protocol.Security.SecurityState.Info)this._addExplanation(this._securityExplanationsExtra,e);else switch(e.mixedContentType){case Protocol.Security.MixedContentType.Blockable:this._addMixedContentExplanation(this._securityExplanationsMain,e,Network.NetworkLogView.MixedContentFilterValues.BlockOverridden);break;case Protocol.Security.MixedContentType.OptionallyBlockable:this._addMixedContentExplanation(this._securityExplanationsMain,e,Network.NetworkLogView.MixedContentFilterValues.Displayed);break;default:this._addExplanation(this._securityExplanationsMain,e)}if(this._panel.filterRequestCount(Network.NetworkLogView.MixedContentFilterValues.Blocked)>0){const e={securityState:Protocol.Security.SecurityState.Info,summary:i18nString(UIStrings.blockedMixedContent),description:i18nString(UIStrings.yourPageRequestedNonsecure),mixedContentType:Protocol.Security.MixedContentType.Blockable,certificate:[],title:""};this._addMixedContentExplanation(this._securityExplanationsMain,e,Network.NetworkLogView.MixedContentFilterValues.Blocked)}}}_addMixedContentExplanation(e,t,i){const n=this._addExplanation(e,t),r=this._panel.filterRequestCount(i);if(!r){return void(n.createChild("div","security-mixed-content").textContent=i18nString(UIStrings.reloadThePageToRecordRequestsFor))}const s=n.createChild("div","security-mixed-content devtools-link");UI.ARIAUtils.markAsLink(s),s.tabIndex=0,s.textContent=1===r?i18nString(UIStrings.viewDRequestInNetworkPanel):i18nString(UIStrings.viewDRequestsInNetworkPanel,{PH1:r}),s.addEventListener("click",this.showNetworkFilter.bind(this,i)),s.addEventListener("keydown",(e=>{"Enter"===e.key&&this.showNetworkFilter(i,e)}))}showNetworkFilter(e,t){t.consume(),Network.NetworkPanel.NetworkPanel.revealAndFilter([{filterType:Network.NetworkLogView.FilterType.MixedContent,filterValue:e}])}}export class SecurityOriginView extends UI.Widget.VBox{constructor(e,t,i){super(),this._panel=e,this.setMinimumSize(200,100),this.element.classList.add("security-origin-view"),this.registerRequiredCSS("security/originView.css",{enableLegacyPatching:!0}),this.registerRequiredCSS("security/lockIcon.css",{enableLegacyPatching:!0});const n=this.element.createChild("div","title-section"),r=n.createChild("div","title-section-header");r.textContent=i18nString(UIStrings.origin),UI.ARIAUtils.markAsHeading(r,1);const s=n.createChild("div","origin-display");this._originLockIcon=s.createChild("span","security-property"),this._originLockIcon.classList.add("security-property-"+i.securityState),s.appendChild(SecurityPanel.createHighlightedUrl(t,i.securityState));const o=n.createChild("div","view-network-button"),a=UI.UIUtils.createTextButton(i18nString(UIStrings.viewRequestsInNetworkPanel),(e=>{e.consume();const i=new Common.ParsedURL.ParsedURL(t);Network.NetworkPanel.NetworkPanel.revealAndFilter([{filterType:Network.NetworkLogView.FilterType.Domain,filterValue:i.host},{filterType:Network.NetworkLogView.FilterType.Scheme,filterValue:i.scheme}])}));if(o.appendChild(a),UI.ARIAUtils.markAsLink(a),i.securityDetails){const e=this.element.createChild("div","origin-view-section"),n=e.createChild("div","origin-view-section-title");n.textContent=i18nString(UIStrings.connection),UI.ARIAUtils.markAsHeading(n,2);let r=new SecurityDetailsTable;e.appendChild(r.element()),r.addRow(i18nString(UIStrings.protocol),i.securityDetails.protocol),i.securityDetails.keyExchange&&r.addRow(i18nString(UIStrings.keyExchange),i.securityDetails.keyExchange),i.securityDetails.keyExchangeGroup&&r.addRow(i18nString(UIStrings.keyExchangeGroup),i.securityDetails.keyExchangeGroup),r.addRow(i18nString(UIStrings.cipher),i.securityDetails.cipher+(i.securityDetails.mac?" with "+i.securityDetails.mac:""));const s=this.element.createChild("div","origin-view-section"),o=s.createChild("div","origin-view-section-title");o.textContent=i18nString(UIStrings.certificate),UI.ARIAUtils.markAsHeading(o,2);const a=i.securityDetails.signedCertificateTimestampList.length,c=i.securityDetails.certificateTransparencyCompliance;let l;if(a||c!==Protocol.Network.CertificateTransparencyCompliance.Unknown){l=this.element.createChild("div","origin-view-section");const e=l.createChild("div","origin-view-section-title");e.textContent=i18nString(UIStrings.certificateTransparency),UI.ARIAUtils.markAsHeading(e,2)}const u=this._createSanDiv(i.securityDetails.sanList),S=new Date(1e3*i.securityDetails.validFrom).toUTCString(),d=new Date(1e3*i.securityDetails.validTo).toUTCString();if(r=new SecurityDetailsTable,s.appendChild(r.element()),r.addRow(i18nString(UIStrings.subject),i.securityDetails.subjectName),r.addRow(i18nString(UIStrings.san),u),r.addRow(i18nString(UIStrings.validFrom),S),r.addRow(i18nString(UIStrings.validUntil),d),r.addRow(i18nString(UIStrings.issuer),i.securityDetails.issuer),r.addRow("",SecurityPanel.createCertificateViewerButtonForOrigin(i18nString(UIStrings.openFullCertificateDetails),t)),!l)return;const g=new SecurityDetailsTable;g.element().classList.add("sct-summary"),l.appendChild(g.element());for(let t=0;t<a;t++){const e=i.securityDetails.signedCertificateTimestampList[t];g.addRow(i18nString(UIStrings.sct),e.logDescription+" ("+e.origin+", "+e.status+")")}const h=l.createChild("div","sct-details");h.classList.add("hidden");for(let t=0;t<a;t++){const e=new SecurityDetailsTable;h.appendChild(e.element());const n=i.securityDetails.signedCertificateTimestampList[t];e.addRow(i18nString(UIStrings.logName),n.logDescription),e.addRow(i18nString(UIStrings.logId),n.logId.replace(/(.{2})/g,"$1 ")),e.addRow(i18nString(UIStrings.validationStatus),n.status),e.addRow(i18nString(UIStrings.source),n.origin),e.addRow(i18nString(UIStrings.issuedAt),new Date(n.timestamp).toUTCString()),e.addRow(i18nString(UIStrings.hashAlgorithm),n.hashAlgorithm),e.addRow(i18nString(UIStrings.signatureAlgorithm),n.signatureAlgorithm),e.addRow(i18nString(UIStrings.signatureData),n.signatureData.replace(/(.{2})/g,"$1 "))}if(a){function e(){let e;const i=!h.classList.contains("hidden");e=i18nString(i?UIStrings.showFullDetails:UIStrings.hideFullDetails),t.textContent=e,UI.ARIAUtils.setAccessibleName(t,e),UI.ARIAUtils.setExpanded(t,!i),g.element().classList.toggle("hidden"),h.classList.toggle("hidden")}const t=UI.UIUtils.createTextButton(i18nString(UIStrings.showFullDetails),e,"details-toggle");l.appendChild(t)}switch(c){case Protocol.Network.CertificateTransparencyCompliance.Compliant:l.createChild("div","origin-view-section-notes").textContent=i18nString(UIStrings.thisRequestCompliesWithChromes);break;case Protocol.Network.CertificateTransparencyCompliance.NotCompliant:l.createChild("div","origin-view-section-notes").textContent=i18nString(UIStrings.thisRequestDoesNotComplyWith);case Protocol.Network.CertificateTransparencyCompliance.Unknown:}const y=this.element.createChild("div","origin-view-section origin-view-notes");i.loadedFromCache&&(y.createChild("div").textContent=i18nString(UIStrings.thisResponseWasLoadedFromCache)),y.createChild("div").textContent=i18nString(UIStrings.theSecurityDetailsAboveAreFrom)}else if(i.securityState===Protocol.Security.SecurityState.Secure){const e=this.element.createChild("div","origin-view-section"),t=e.createChild("div","origin-view-section-title");t.textContent=i18nString(UIStrings.secure),UI.ARIAUtils.markAsHeading(t,2),e.createChild("div").textContent=i18nString(UIStrings.thisOriginIsANonhttpsSecure)}else if(i.securityState!==Protocol.Security.SecurityState.Unknown){const e=this.element.createChild("div","origin-view-section"),t=e.createChild("div","origin-view-section-title");t.textContent=i18nString(UIStrings.notSecure),UI.ARIAUtils.markAsHeading(t,2),e.createChild("div").textContent=i18nString(UIStrings.yourConnectionToThisOriginIsNot)}else{const e=this.element.createChild("div","origin-view-section"),t=e.createChild("div","origin-view-section-title");t.textContent=i18nString(UIStrings.noSecurityInformation),UI.ARIAUtils.markAsHeading(t,2),e.createChild("div").textContent=i18nString(UIStrings.noSecurityDetailsAreAvailableFor)}}_createSanDiv(e){const t=document.createElement("div");if(0===e.length)t.textContent=i18nString(UIStrings.na),t.classList.add("empty-san");else{const i=2,n=e.length>i+1;for(let r=0;r<e.length;r++){const s=t.createChild("span","san-entry");s.textContent=e[r],n&&r>=i&&s.classList.add("truncated-entry")}if(n){function i(){const i=t.classList.contains("truncated-san");let r;i?(t.classList.remove("truncated-san"),r=i18nString(UIStrings.showLess)):(t.classList.add("truncated-san"),r=i18nString(UIStrings.showMoreSTotal,{PH1:e.length})),n.textContent=r,UI.ARIAUtils.setAccessibleName(n,r),UI.ARIAUtils.setExpanded(n,i)}const n=UI.UIUtils.createTextButton(i18nString(UIStrings.showMoreSTotal,{PH1:e.length}),i);t.appendChild(n),i()}}return t}setSecurityState(e){for(const t of Array.prototype.slice.call(this._originLockIcon.classList))t.startsWith("security-property-")&&this._originLockIcon.classList.remove(t);this._originLockIcon.classList.add("security-property-"+e)}}export class SecurityDetailsTable{constructor(){this._element=document.createElement("table"),this._element.classList.add("details-table")}element(){return this._element}addRow(e,t){const i=this._element.createChild("div","details-table-row");i.createChild("div").textContent=e;const n=i.createChild("div");"string"===typeof t?n.textContent=t:n.appendChild(t)}}