import*as Common from"../common/common.js";import*as Formatter from"../formatter/formatter.js";import*as i18n from"../i18n/i18n.js";import*as Platform from"../platform/platform.js";import*as TextUtils from"../text_utils/text_utils.js";import*as UI from"../ui/ui.js";import{Events,SourcesTextEditor}from"./SourcesTextEditor.js";const UIStrings={source:"Source",prettyPrint:"Pretty print",loading:"Loading\u2026",dSelectionRegions:"{PH1} selection regions",bytecodePositionXs:"Bytecode position `0x`{PH1}",lineSColumnS:"Line {PH1}, Column {PH2}",dCharactersSelected:"{PH1} characters selected",dLinesDCharactersSelected:"{PH1} lines, {PH2} characters selected"},str_=i18n.i18n.registerUIStrings("source_frame/SourceFrame.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class SourceFrameImpl extends UI.View.SimpleView{constructor(t,e){super(i18nString(UIStrings.source)),this._lazyContent=t,this._pretty=!1,this._rawContent=null,this._formattedContentPromise=null,this._formattedMap=null,this._prettyToggle=new UI.Toolbar.ToolbarToggle(i18nString(UIStrings.prettyPrint),"largeicon-pretty-print"),this._prettyToggle.addEventListener(UI.Toolbar.ToolbarButton.Events.Click,(()=>{this._setPretty(!this._prettyToggle.toggled())})),this._shouldAutoPrettyPrint=!1,this._prettyToggle.setVisible(!1),this._progressToolbarItem=new UI.Toolbar.ToolbarItem(document.createElement("div")),this._textEditor=new SourcesTextEditor(this,e),this._textEditor.show(this.element),this._prettyCleanGeneration=null,this._cleanGeneration=0,this._searchConfig=null,this._delayedFindSearchMatches=null,this._currentSearchResultIndex=-1,this._searchResults=[],this._searchRegex=null,this._loadError=!1,this._textEditor.addEventListener(Events.EditorFocused,this._resetCurrentSearchResultIndex,this),this._textEditor.addEventListener(Events.SelectionChanged,this._updateSourcePosition,this),this._textEditor.addEventListener(UI.TextEditor.Events.TextChanged,(t=>{this._muteChangeEventsForSetContent||this.onTextChanged(t.data.oldRange,t.data.newRange)})),this._muteChangeEventsForSetContent=!1,this._sourcePosition=new UI.Toolbar.ToolbarText,this._searchableView=null,this._editable=!1,this._textEditor.setReadOnly(!0),this._positionToReveal=null,this._lineToScrollTo=null,this._selectionToSet=null,this._loaded=!1,this._contentRequested=!1,this._highlighterType="",this._wasmDisassembly=null}get wasmDisassembly(){return this._wasmDisassembly}editorLocationToUILocation(t,e){return this._wasmDisassembly?(e=this._wasmDisassembly.lineNumberToBytecodeOffset(t),t=0):this._pretty&&([t,e]=this._prettyToRawLocation(t,e)),{lineNumber:t,columnNumber:e}}uiLocationToEditorLocation(t,e=0){return this._wasmDisassembly?(t=this._wasmDisassembly.bytecodeOffsetToLineNumber(e),e=0):this._pretty&&([t,e]=this._rawToPrettyLocation(t,e)),{lineNumber:t,columnNumber:e}}setCanPrettyPrint(t,e){this._shouldAutoPrettyPrint=t&&Boolean(e),this._prettyToggle.setVisible(t)}async _setPretty(t){this._pretty=t,this._prettyToggle.setEnabled(!1);const e=this.loaded,i=this.selection();let s;if(this._pretty){const t=await this._requestFormattedContent();this._formattedMap=t.map,this.setContent(t.content,null),this._prettyCleanGeneration=this._textEditor.markClean();const e=this._rawToPrettyLocation(i.startLine,i.startColumn),r=this._rawToPrettyLocation(i.endLine,i.endColumn);s=new TextUtils.TextRange.TextRange(e[0],e[1],r[0],r[1])}else{this.setContent(this._rawContent,null),this._cleanGeneration=this._textEditor.markClean();const t=this._prettyToRawLocation(i.startLine,i.startColumn),e=this._prettyToRawLocation(i.endLine,i.endColumn);s=new TextUtils.TextRange.TextRange(t[0],t[1],e[0],e[1])}e&&(this.textEditor.revealPosition(s.endLine,s.endColumn,this._editable),this.textEditor.setSelection(s)),this._prettyToggle.setEnabled(!0),this._updatePrettyPrintState()}_updateLineNumberFormatter(){if(this._wasmDisassembly){const t=this._wasmDisassembly,e=t.lineNumberToBytecodeOffset(t.lineNumbers-1).toString(16).length+1;this._textEditor.setLineNumberFormatter((i=>`0x${t.lineNumberToBytecodeOffset(i-1).toString(16).padStart(e,"0")}`))}else this._pretty?this._textEditor.setLineNumberFormatter((t=>{const e=this._prettyToRawLocation(t-1,0)[0]+1;return 1===t||e!==this._prettyToRawLocation(t-2,0)[0]+1?String(e):"-"})):this._textEditor.setLineNumberFormatter((t=>String(t)))}_updatePrettyPrintState(){this._prettyToggle.setToggled(this._pretty),this._textEditor.element.classList.toggle("pretty-printed",this._pretty),this._updateLineNumberFormatter()}_prettyToRawLocation(t,e=0){return this._formattedMap?this._formattedMap.formattedToOriginal(t,e):[t,e]}_rawToPrettyLocation(t,e){return this._formattedMap?this._formattedMap.originalToFormatted(t,e):[t,e]}setEditable(t){this._editable=t,this._loaded&&this._textEditor.setReadOnly(!t)}hasLoadError(){return this._loadError}wasShown(){this._ensureContentLoaded(),this._wasShownOrLoaded()}willHide(){super.willHide(),this._clearPositionToReveal()}async toolbarItems(){return[this._prettyToggle,this._sourcePosition,this._progressToolbarItem]}get loaded(){return this._loaded}get textEditor(){return this._textEditor}get pretty(){return this._pretty}async _ensureContentLoaded(){if(!this._contentRequested){this._contentRequested=!0;const e=new UI.ProgressIndicator.ProgressIndicator;e.setTitle(i18nString(UIStrings.loading)),e.setTotalWork(100),this._progressToolbarItem.element.appendChild(e.element);const i=await this._lazyContent();let s,r;if(null===i.content?(s=i.error,this._rawContent=i.error):(r=i.content,this._rawContent=i.content),e.setWorked(1),!s&&"application/wasm"===this._highlighterType){const i=Common.Worker.WorkerWrapper.fromURL(new URL("../wasmparser_worker/wasmparser_worker-entrypoint.js",import.meta.url)),n=new Promise(((t,s)=>{i.onmessage=({data:i})=>{if("event"in i){if("progress"===i.event)e.setWorked(i.params.percentage)}else if("method"in i&&"disassemble"===i.method)"error"in i?s(i.error):"result"in i&&t(i.result)},i.onerror=s}));i.postMessage({method:"disassemble",params:{content:r}});try{const{source:t,offsets:e,functionBodyOffsets:s}=await n;this._rawContent=r=t,this._wasmDisassembly=new Common.WasmDisassembly.WasmDisassembly(e,s)}catch(t){this._rawContent=r=s=t.message}finally{i.terminate()}}e.setWorked(100),e.done(),this._formattedContentPromise=null,this._formattedMap=null,this._prettyToggle.setEnabled(!0),s?(this.setContent(null,s),this._prettyToggle.setEnabled(!1),setTimeout((()=>this.setHighlighterType("text/plain")),50)):this._shouldAutoPrettyPrint&&TextUtils.TextUtils.isMinified(r)?await this._setPretty(!0):this.setContent(this._rawContent,null)}}_requestFormattedContent(){if(this._formattedContentPromise)return this._formattedContentPromise;let t;return this._formattedContentPromise=new Promise((e=>{t=e})),new Formatter.ScriptFormatter.ScriptFormatter(this._highlighterType,this._rawContent||"",(async(e,i)=>{t({content:e,map:i})})),this._formattedContentPromise}revealPosition(t,e,i){this._lineToScrollTo=null,this._selectionToSet=null,this._positionToReveal={line:t,column:e,shouldHighlight:i},this._innerRevealPositionIfNeeded()}_innerRevealPositionIfNeeded(){if(!this._positionToReveal)return;if(!this.loaded||!this.isShowing())return;const{lineNumber:t,columnNumber:e}=this.uiLocationToEditorLocation(this._positionToReveal.line,this._positionToReveal.column);this._textEditor.revealPosition(t,e,this._positionToReveal.shouldHighlight),this._positionToReveal=null}_clearPositionToReveal(){this._textEditor.clearPositionHighlight(),this._positionToReveal=null}scrollToLine(t){this._clearPositionToReveal(),this._lineToScrollTo=t,this._innerScrollToLineIfNeeded()}_innerScrollToLineIfNeeded(){null!==this._lineToScrollTo&&this.loaded&&this.isShowing()&&(this._textEditor.scrollToLine(this._lineToScrollTo),this._lineToScrollTo=null)}selection(){return this.textEditor.selection()}setSelection(t){this._selectionToSet=t,this._innerSetSelectionIfNeeded()}_innerSetSelectionIfNeeded(){this._selectionToSet&&this.loaded&&this.isShowing()&&(this._textEditor.setSelection(this._selectionToSet,!0),this._selectionToSet=null)}_wasShownOrLoaded(){this._innerRevealPositionIfNeeded(),this._innerSetSelectionIfNeeded(),this._innerScrollToLineIfNeeded()}onTextChanged(t,e){const i=this.pretty;this._pretty=null!==this._prettyCleanGeneration&&this.textEditor.isClean(this._prettyCleanGeneration),this._pretty!==i&&this._updatePrettyPrintState(),this._prettyToggle.setEnabled(this.isClean()),this._searchConfig&&this._searchableView&&this.performSearch(this._searchConfig,!1,!1)}isClean(){return this.textEditor.isClean(this._cleanGeneration)||null!==this._prettyCleanGeneration&&this.textEditor.isClean(this._prettyCleanGeneration)}contentCommitted(){this._cleanGeneration=this._textEditor.markClean(),this._prettyCleanGeneration=null,this._rawContent=this.textEditor.text(),this._formattedMap=null,this._formattedContentPromise=null,this._pretty&&(this._pretty=!1,this._updatePrettyPrintState()),this._prettyToggle.setEnabled(!0)}_simplifyMimeType(t,e){return e?e.indexOf("typescript")>=0?"text/typescript-jsx":e.indexOf("javascript")>=0||e.indexOf("jscript")>=0||e.indexOf("ecmascript")>=0?"text/jsx":"text/x-php"===e&&t.match(/\<\?.*\?\>/g)?"application/x-httpd-php":"application/wasm"===e?"text/webassembly":e:""}setHighlighterType(t){this._highlighterType=t,this._updateHighlighterType("")}highlighterType(){return this._highlighterType}_updateHighlighterType(t){this._textEditor.setMimeType(this._simplifyMimeType(t,this._highlighterType))}setContent(t,e){if(this._muteChangeEventsForSetContent=!0,this._loaded){const e=this._textEditor.scrollTop(),i=this._textEditor.selection();this._textEditor.setText(t||""),this._textEditor.setScrollTop(e),this._textEditor.setSelection(i)}else this._loaded=!0,e?(this._textEditor.setText(e||""),this._highlighterType="text/plain",this._textEditor.setReadOnly(!0),this._loadError=!0):(this._textEditor.setText(t||""),this._cleanGeneration=this._textEditor.markClean(),this._textEditor.setReadOnly(!this._editable),this._loadError=!1);if(this._wasmDisassembly)for(const i of this._wasmDisassembly.nonBreakableLineNumbers())this._textEditor.toggleLineClass(i,"cm-non-breakable-line",!0);this._updateLineNumberFormatter(),this._updateHighlighterType(t||""),this._wasShownOrLoaded(),this._delayedFindSearchMatches&&(this._delayedFindSearchMatches(),this._delayedFindSearchMatches=null),this._muteChangeEventsForSetContent=!1}setSearchableView(t){this._searchableView=t}_doFindSearchMatches(t,e,i){this._currentSearchResultIndex=-1,this._searchResults=[];const s=t.toSearchRegex();this._searchRegex=s,this._searchResults=this._collectRegexMatches(s),this._searchableView&&this._searchableView.updateSearchMatchesCount(this._searchResults.length),this._searchResults.length?e&&i?this.jumpToPreviousSearchResult():e?this.jumpToNextSearchResult():this._textEditor.highlightSearchResults(s,null):this._textEditor.cancelSearchResultsHighlight()}performSearch(t,e,i){this._searchableView&&this._searchableView.updateSearchMatchesCount(0),this._resetSearch(),this._searchConfig=t,this.loaded?this._doFindSearchMatches(t,e,Boolean(i)):this._delayedFindSearchMatches=this._doFindSearchMatches.bind(this,t,e,Boolean(i)),this._ensureContentLoaded()}_resetCurrentSearchResultIndex(){this._searchResults.length&&(this._currentSearchResultIndex=-1,this._searchableView&&this._searchableView.updateCurrentMatchIndex(this._currentSearchResultIndex),this._textEditor.highlightSearchResults(this._searchRegex,null))}_resetSearch(){this._searchConfig=null,this._delayedFindSearchMatches=null,this._currentSearchResultIndex=-1,this._searchResults=[],this._searchRegex=null}searchCanceled(){const t=-1!==this._currentSearchResultIndex?this._searchResults[this._currentSearchResultIndex]:null;this._resetSearch(),this.loaded&&(this._textEditor.cancelSearchResultsHighlight(),t&&this.setSelection(t))}jumpToLastSearchResult(){this.jumpToSearchResult(this._searchResults.length-1)}_searchResultIndexForCurrentSelection(){return Platform.ArrayUtilities.lowerBound(this._searchResults,this._textEditor.selection().collapseToEnd(),TextUtils.TextRange.TextRange.comparator)}jumpToNextSearchResult(){const t=this._searchResultIndexForCurrentSelection(),e=-1===this._currentSearchResultIndex?t:t+1;this.jumpToSearchResult(e)}jumpToPreviousSearchResult(){const t=this._searchResultIndexForCurrentSelection();this.jumpToSearchResult(t-1)}supportsCaseSensitiveSearch(){return!0}supportsRegexSearch(){return!0}jumpToSearchResult(t){this.loaded&&this._searchResults.length&&(this._currentSearchResultIndex=(t+this._searchResults.length)%this._searchResults.length,this._searchableView&&this._searchableView.updateCurrentMatchIndex(this._currentSearchResultIndex),this._textEditor.highlightSearchResults(this._searchRegex,this._searchResults[this._currentSearchResultIndex]))}replaceSelectionWith(t,e){const i=this._searchResults[this._currentSearchResultIndex];if(!i)return;this._textEditor.highlightSearchResults(this._searchRegex,null);const s=this._textEditor.text(i),r=t.toSearchRegex();let n;n=r.__fromRegExpQuery?s.replace(r,e):s.replace(r,(function(){return e}));const o=this._textEditor.editRange(i,n);this._textEditor.setSelection(o.collapseToEnd())}replaceAllWith(t,e){this._resetCurrentSearchResultIndex();let i=this._textEditor.text();const s=this._textEditor.fullRange(),r=t.toSearchRegex(!0);i=r.__fromRegExpQuery?i.replace(r,e):i.replace(r,(function(){return e}));const n=this._collectRegexMatches(r);if(!n.length)return;const o=Platform.ArrayUtilities.lowerBound(n,this._textEditor.selection(),TextUtils.TextRange.TextRange.comparator),a=n[Platform.NumberUtilities.mod(o-1,n.length)],h=Platform.StringUtilities.findLineEndingIndexes(e),l=h.length,c=a.startLine+h.length-1;let d=a.startColumn;h.length>1&&(d=h[l-1]-h[l-2]-1),this._textEditor.editRange(s,i),this._textEditor.revealPosition(c,d),this._textEditor.setSelection(TextUtils.TextRange.TextRange.createFromLocation(c,d))}_collectRegexMatches(t){const e=[];for(let i=0;i<this._textEditor.linesCount;++i){let s,r=this._textEditor.line(i),n=0;do{if(s=t.exec(r),s){const t=s.index+Math.max(s[0].length,1);s[0].length&&e.push(new TextUtils.TextRange.TextRange(i,n+s.index,i,n+t)),n+=t,r=r.substring(t)}}while(s&&r)}return e}populateLineGutterContextMenu(t,e){return Promise.resolve()}populateTextAreaContextMenu(t,e,i){return Promise.resolve()}canEditSource(){return this._editable}_updateSourcePosition(){const t=this._textEditor.selections();if(!t.length)return;if(t.length>1)return void this._sourcePosition.setText(i18nString(UIStrings.dSelectionRegions,{PH1:t.length}));let e=t[0];if(e.isEmpty()){const t=this._prettyToRawLocation(e.endLine,e.endColumn);if(this._wasmDisassembly){const e=this._wasmDisassembly,i=e.lineNumberToBytecodeOffset(e.lineNumbers-1).toString(16).length,s=e.lineNumberToBytecodeOffset(t[0]);this._sourcePosition.setText(i18nString(UIStrings.bytecodePositionXs,{PH1:s.toString(16).padStart(i,"0")}))}else this._textEditor.revealPosition(t[0],t[1],!this.canEditSource()),this._sourcePosition.setText(i18nString(UIStrings.lineSColumnS,{PH1:t[0]+1,PH2:t[1]+1}));return}e=e.normalize();const i=this._textEditor.text(e);e.startLine===e.endLine?this._sourcePosition.setText(i18nString(UIStrings.dCharactersSelected,{PH1:i.length})):this._sourcePosition.setText(i18nString(UIStrings.dLinesDCharactersSelected,{PH1:e.endLine-e.startLine+1,PH2:i.length}))}}const registeredLineDecorators=[];export function registerLineDecorator(t){registeredLineDecorators.push(t)}export function getRegisteredLineDecorators(){return registeredLineDecorators}export var DecoratorType;!function(t){t.PERFORMANCE="performance",t.MEMORY="memory",t.COVERAGE="coverage"}(DecoratorType||(DecoratorType={}));