import*as Bindings from"../bindings/bindings.js";import*as Common from"../common/common.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as Persistence from"../persistence/persistence.js";import*as Platform from"../platform/platform.js";import*as SDK from"../sdk/sdk.js";import*as UI from"../ui/ui.js";import*as Workspace from"../workspace/workspace.js";const UIStrings={callStack:"Call Stack",notPaused:"Not paused",onIgnoreList:"on ignore list",showIgnorelistedFrames:"Show ignore-listed frames",showMore:"Show more",restartFrame:"Restart frame",copyStackTrace:"Copy stack trace",removeFromIgnoreList:"Remove from ignore list",addScriptToIgnoreList:"Add script to ignore list",removeAllContentScriptsFrom:"Remove all content scripts from ignore list",addAllContentScriptsToIgnoreList:"Add all content scripts to ignore list"},str_=i18n.i18n.registerUIStrings("sources/CallStackSidebarPane.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);let callstackSidebarPaneInstance;export class CallStackSidebarPane extends UI.View.SimpleView{constructor(){super(i18nString(UIStrings.callStack),!0),this.registerRequiredCSS("sources/callStackSidebarPane.css",{enableLegacyPatching:!0}),this._ignoreListMessageElement=this._createIgnoreListMessageElement(),this.contentElement.appendChild(this._ignoreListMessageElement),this._notPausedMessageElement=this.contentElement.createChild("div","gray-info-message"),this._notPausedMessageElement.textContent=i18nString(UIStrings.notPaused),this._notPausedMessageElement.tabIndex=-1,this._items=new UI.ListModel.ListModel,this._list=new UI.ListControl.ListControl(this._items,this,UI.ListControl.ListMode.NonViewport),this.contentElement.appendChild(this._list.element),this._list.element.addEventListener("contextmenu",this._onContextMenu.bind(this),!1),self.onInvokeElement(this._list.element,(e=>{const t=this._list.itemForNode(e.target);t&&(this._activateItem(t),e.consume(!0))})),this._showMoreMessageElement=this._createShowMoreMessageElement(),this._showMoreMessageElement.classList.add("hidden"),this.contentElement.appendChild(this._showMoreMessageElement),this._showIgnoreListed=!1,this._locationPool=new Bindings.LiveLocation.LiveLocationPool,this._updateThrottler=new Common.Throttler.Throttler(100),this._maxAsyncStackChainDepth=defaultMaxAsyncStackChainDepth,this._update(),this._updateItemThrottler=new Common.Throttler.Throttler(100),this._scheduledForUpdateItems=new Set}static instance(e={forceNew:null}){const{forceNew:t}=e;return callstackSidebarPaneInstance&&!t||(callstackSidebarPaneInstance=new CallStackSidebarPane),callstackSidebarPaneInstance}flavorChanged(e){this._showIgnoreListed=!1,this._maxAsyncStackChainDepth=defaultMaxAsyncStackChainDepth,this._update()}_update(){this._updateThrottler.schedule((()=>this._doUpdate()))}async _doUpdate(){this._locationPool.disposeAll();const e=UI.Context.Context.instance().flavor(SDK.DebuggerModel.DebuggerPausedDetails);if(!e)return this._notPausedMessageElement.classList.remove("hidden"),this._ignoreListMessageElement.classList.add("hidden"),this._showMoreMessageElement.classList.add("hidden"),this._items.replaceAll([]),void UI.Context.Context.instance().setFlavor(SDK.DebuggerModel.CallFrame,null);let t=e.debuggerModel;this._notPausedMessageElement.classList.add("hidden");const s=[];for(const r of e.callFrames){const e=Item.createForDebuggerCallFrame(r,this._locationPool,this._refreshItem.bind(this)).then((e=>(itemToCallFrame.set(e,r),e)));s.push(e)}const i=await Promise.all(s);let n=e.asyncStackTrace;!n&&e.asyncStackTraceId&&(e.asyncStackTraceId.debuggerId&&(t=await SDK.DebuggerModel.DebuggerModel.modelForDebuggerId(e.asyncStackTraceId.debuggerId)),n=t?await t.fetchAsyncStackTrace(e.asyncStackTraceId):null);let a=e.callFrames,o=this._maxAsyncStackChainDepth;for(;n&&o>0;){let e="";if("async function"===n.description&&a.length&&n.callFrames.length){const t=a[a.length-1],s=UI.UIUtils.beautifyFunctionName(t.functionName);e=UI.UIUtils.asyncStackTraceLabel("await in "+s)}else e=UI.UIUtils.asyncStackTraceLabel(n.description);i.push(...await Item.createItemsForAsyncStack(e,t,n.callFrames,this._locationPool,this._refreshItem.bind(this))),--o,a=n.callFrames,n.parent?n=n.parent:n.parentId?(n.parentId.debuggerId&&(t=await SDK.DebuggerModel.DebuggerModel.modelForDebuggerId(n.parentId.debuggerId)),n=t?await t.fetchAsyncStackTrace(n.parentId):null):n=null}if(this._showMoreMessageElement.classList.toggle("hidden",!n),this._items.replaceAll(i),this._maxAsyncStackChainDepth===defaultMaxAsyncStackChainDepth){this._list.selectNextItem(!0,!1);const e=this._list.selectedItem();e&&this._activateItem(e)}this._updatedForTest()}_updatedForTest(){}_refreshItem(e){this._scheduledForUpdateItems.add(e),this._updateItemThrottler.schedule((async()=>{const e=Array.from(this._scheduledForUpdateItems);if(this._scheduledForUpdateItems.clear(),this._muteActivateItem=!0,!this._showIgnoreListed&&this._items.every((e=>e.isIgnoreListed))){this._showIgnoreListed=!0;for(let e=0;e<this._items.length;++e)this._list.refreshItemByIndex(e);this._ignoreListMessageElement.classList.toggle("hidden",!0)}else{const t=new Set(e);let s=!1;for(let e=0;e<this._items.length;++e){const i=this._items.at(e);t.has(i)&&this._list.refreshItemByIndex(e),s=s||i.isIgnoreListed}this._ignoreListMessageElement.classList.toggle("hidden",this._showIgnoreListed||!s)}delete this._muteActivateItem}))}createElementForItem(e){const t=document.createElement("div");t.classList.add("call-frame-item");const s=t.createChild("div","call-frame-item-title").createChild("div","call-frame-title-text");if(s.textContent=e.title,e.isAsyncHeader)t.classList.add("async-header");else{UI.Tooltip.Tooltip.install(s,e.title);const i=t.createChild("div","call-frame-location");i.textContent=Platform.StringUtilities.trimMiddle(e.linkText,30),UI.Tooltip.Tooltip.install(i,e.linkText),t.classList.toggle("ignore-listed-call-frame",e.isIgnoreListed),e.isIgnoreListed&&UI.ARIAUtils.setDescription(t,i18nString(UIStrings.onIgnoreList)),itemToCallFrame.has(e)||UI.ARIAUtils.setDisabled(t,!0)}const i=itemToCallFrame.get(e)===UI.Context.Context.instance().flavor(SDK.DebuggerModel.CallFrame);return t.classList.toggle("selected",i),UI.ARIAUtils.setSelected(t,i),t.classList.toggle("hidden",!this._showIgnoreListed&&e.isIgnoreListed),t.appendChild(UI.Icon.Icon.create("smallicon-thick-right-arrow","selected-call-frame-icon")),t.tabIndex=e===this._list.selectedItem()?0:-1,t}heightForItem(e){return console.assert(!1),0}isItemSelectable(e){return!0}selectedItemChanged(e,t,s,i){s&&(s.tabIndex=-1),i&&(this.setDefaultFocusedElement(i),i.tabIndex=0,this.hasFocus()&&i.focus())}updateSelectedItemARIA(e,t){return!0}_createIgnoreListMessageElement(){const e=document.createElement("div");e.classList.add("ignore-listed-message"),e.createChild("span");const t=e.createChild("span","link");t.textContent=i18nString(UIStrings.showIgnorelistedFrames),UI.ARIAUtils.markAsLink(t),t.tabIndex=0;const s=()=>{this._showIgnoreListed=!0;for(const e of this._items)this._refreshItem(e);this._ignoreListMessageElement.classList.toggle("hidden",!0)};return t.addEventListener("click",s),t.addEventListener("keydown",(e=>"Enter"===e.key&&s())),e}_createShowMoreMessageElement(){const e=document.createElement("div");e.classList.add("show-more-message"),e.createChild("span");const t=e.createChild("span","link");return t.textContent=i18nString(UIStrings.showMore),t.addEventListener("click",(()=>{this._maxAsyncStackChainDepth+=defaultMaxAsyncStackChainDepth,this._update()}),!1),e}_onContextMenu(e){const t=this._list.itemForNode(e.target);if(!t)return;const s=new UI.ContextMenu.ContextMenu(e),i=itemToCallFrame.get(t);i&&s.defaultSection().appendItem(i18nString(UIStrings.restartFrame),(()=>i.restart())),s.defaultSection().appendItem(i18nString(UIStrings.copyStackTrace),this._copyStackTrace.bind(this)),t.uiLocation&&this.appendIgnoreListURLContextMenuItems(s,t.uiLocation.uiSourceCode),s.show()}_onClick(e){const t=this._list.itemForNode(e.target);t&&this._activateItem(t)}_activateItem(e){const t=e.uiLocation;if(this._muteActivateItem||!t)return;this._list.selectItem(e);const s=itemToCallFrame.get(e),i=this.activeCallFrameItem();s&&i!==e?(s.debuggerModel.setSelectedCallFrame(s),UI.Context.Context.instance().setFlavor(SDK.DebuggerModel.CallFrame,s),i&&this._refreshItem(i),this._refreshItem(e)):Common.Revealer.reveal(t)}activeCallFrameItem(){const e=UI.Context.Context.instance().flavor(SDK.DebuggerModel.CallFrame);return e&&this._items.find((t=>itemToCallFrame.get(t)===e))||null}appendIgnoreListURLContextMenuItems(e,t){const s=Persistence.Persistence.PersistenceImpl.instance().binding(t);if(s&&(t=s.network),t.project().type()===Workspace.Workspace.projectTypes.FileSystem)return;const i=Bindings.IgnoreListManager.IgnoreListManager.instance().canIgnoreListUISourceCode(t),n=Bindings.IgnoreListManager.IgnoreListManager.instance().isIgnoreListedUISourceCode(t),a=t.project().type()===Workspace.Workspace.projectTypes.ContentScripts,o=Bindings.IgnoreListManager.IgnoreListManager.instance();i&&(n?e.defaultSection().appendItem(i18nString(UIStrings.removeFromIgnoreList),o.unIgnoreListUISourceCode.bind(o,t)):e.defaultSection().appendItem(i18nString(UIStrings.addScriptToIgnoreList),o.ignoreListUISourceCode.bind(o,t))),a&&(n?e.defaultSection().appendItem(i18nString(UIStrings.removeAllContentScriptsFrom),o.ignoreListContentScripts.bind(o)):e.defaultSection().appendItem(i18nString(UIStrings.addAllContentScriptsToIgnoreList),o.unIgnoreListContentScripts.bind(o)))}_selectNextCallFrameOnStack(){const e=this.activeCallFrameItem();for(let t=e?this._items.indexOf(e)+1:0;t<this._items.length;t++){const e=this._items.at(t);if(itemToCallFrame.has(e)){this._activateItem(e);break}}}_selectPreviousCallFrameOnStack(){const e=this.activeCallFrameItem();for(let t=e?this._items.indexOf(e)-1:this._items.length-1;t>=0;t--){const e=this._items.at(t);if(itemToCallFrame.has(e)){this._activateItem(e);break}}}_copyStackTrace(){const e=[];for(const t of this._items){let s=t.title;t.uiLocation&&(s+=" ("+t.uiLocation.linkText(!0)+")"),e.push(s)}Host.InspectorFrontendHost.InspectorFrontendHostInstance.copyText(e.join("\n"))}}const itemToCallFrame=new WeakMap;export const elementSymbol=Symbol("element");export const defaultMaxAsyncStackChainDepth=32;let actionDelegateInstance;export class ActionDelegate{static instance(e={forceNew:null}){const{forceNew:t}=e;return actionDelegateInstance&&!t||(actionDelegateInstance=new ActionDelegate),actionDelegateInstance}handleAction(e,t){switch(t){case"debugger.next-call-frame":return CallStackSidebarPane.instance()._selectNextCallFrameOnStack(),!0;case"debugger.previous-call-frame":return CallStackSidebarPane.instance()._selectPreviousCallFrameOnStack(),!0}return!1}}export class Item{static async createForDebuggerCallFrame(e,t,s){const i=new Item(UI.UIUtils.beautifyFunctionName(e.functionName),s);return await Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().createCallFrameLiveLocation(e.location(),i._update.bind(i),t),i}static async createItemsForAsyncStack(e,t,s,i,n){const a=new WeakMap,o=new Item(e,n);a.set(o,new Set),o.isAsyncHeader=!0;const r=[],l=[];for(const d of s){const e=new Item(UI.UIUtils.beautifyFunctionName(d.functionName),c),s=t?t.createRawLocationByScriptId(d.scriptId,d.lineNumber,d.columnNumber):null;s?l.push(Bindings.DebuggerWorkspaceBinding.DebuggerWorkspaceBinding.instance().createCallFrameLiveLocation(s,e._update.bind(e),i)):(e.linkText=(d.url||"<unknown>")+":"+(d.lineNumber+1),e.updateDelegate(e)),r.push(e)}return await Promise.all(l),n(o),[o,...r];function c(e){n(e);let t=!1;const s=a.get(o);s&&(e.isIgnoreListed?(s.delete(e),t=0===s.size):(t=0===s.size,s.add(e)),o.isIgnoreListed=0===s.size),t&&n(o)}}constructor(e,t){this.isIgnoreListed=!1,this.title=e,this.linkText="",this.uiLocation=null,this.isAsyncHeader=!1,this.updateDelegate=t}async _update(e){const t=await e.uiLocation();this.isIgnoreListed=await e.isIgnoreListed(),this.linkText=t?t.linkText():"",this.uiLocation=t,this.updateDelegate(this)}}