import*as Bindings from"../bindings/bindings.js";import*as Common from"../common/common.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as Persistence from"../persistence/persistence.js";import*as Platform from"../platform/platform.js";import*as SDK from"../sdk/sdk.js";import*as Snippets from"../snippets/snippets.js";import*as UI from"../ui/ui.js";import*as Workspace from"../workspace/workspace.js";import{SearchSourcesView}from"./SearchSourcesView.js";const UIStrings={searchInFolder:"Search in folder",searchInAllFiles:"Search in all files",noDomain:"(no domain)",areYouSureYouWantToExcludeThis:"Are you sure you want to exclude this folder?",areYouSureYouWantToDeleteThis:"Are you sure you want to delete this file?",rename:"Rename\u2026",makeACopy:"Make a copy\u2026",delete:"Delete",areYouSureYouWantToDeleteAll:"Are you sure you want to delete all overrides contained in this folder?",openFolder:"Open folder",newFile:"New file",excludeFolder:"Exclude folder",removeFolderFromWorkspace:"Remove folder from workspace",areYouSureYouWantToRemoveThis:"Are you sure you want to remove this folder?",deleteAllOverrides:"Delete all overrides",sFromSourceMap:"{PH1} (from source map)"},str_=i18n.i18n.registerUIStrings("sources/NavigatorView.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export const Types={Domain:"domain",File:"file",FileSystem:"fs",FileSystemFolder:"fs-folder",Frame:"frame",NetworkFolder:"nw-folder",Root:"root",SourceMapFolder:"sm-folder",Worker:"worker"};const TYPE_ORDERS=new Map([[Types.Root,1],[Types.Domain,10],[Types.FileSystemFolder,1],[Types.NetworkFolder,1],[Types.SourceMapFolder,2],[Types.File,10],[Types.Frame,70],[Types.Worker,90],[Types.FileSystem,100]]);export class NavigatorView extends UI.Widget.VBox{constructor(){super(!0),this.registerRequiredCSS("sources/navigatorView.css",{enableLegacyPatching:!1}),this._placeholder=null,this._scriptsTree=new UI.TreeOutline.TreeOutlineInShadow,this._scriptsTree.registerRequiredCSS("sources/navigatorTree.css",{enableLegacyPatching:!0}),this._scriptsTree.setComparator(NavigatorView._treeElementsCompare),this._scriptsTree.setFocusable(!1),this.contentElement.appendChild(this._scriptsTree.element),this.setDefaultFocusedElement(this._scriptsTree.element),this._uiSourceCodeNodes=new Platform.MapUtilities.Multimap,this._subfolderNodes=new Map,this._rootNode=new NavigatorRootTreeNode(this),this._rootNode.populate(),this._frameNodes=new Map,this.contentElement.addEventListener("contextmenu",this.handleContextMenu.bind(this),!1),UI.ShortcutRegistry.ShortcutRegistry.instance().addShortcutListener(this.contentElement,{"sources.rename":this._renameShortcut.bind(this)}),this._navigatorGroupByFolderSetting=Common.Settings.Settings.instance().moduleSetting("navigatorGroupByFolder"),this._navigatorGroupByFolderSetting.addChangeListener(this._groupingChanged.bind(this)),this._initGrouping(),Persistence.Persistence.PersistenceImpl.instance().addEventListener(Persistence.Persistence.Events.BindingCreated,this._onBindingChanged,this),Persistence.Persistence.PersistenceImpl.instance().addEventListener(Persistence.Persistence.Events.BindingRemoved,this._onBindingChanged,this),SDK.SDKModel.TargetManager.instance().addEventListener(SDK.SDKModel.Events.NameChanged,this._targetNameChanged,this),SDK.SDKModel.TargetManager.instance().observeTargets(this),this._resetWorkspace(Workspace.Workspace.WorkspaceImpl.instance()),this._workspace.uiSourceCodes().forEach(this._addUISourceCode.bind(this)),Bindings.NetworkProject.NetworkProjectManager.instance().addEventListener(Bindings.NetworkProject.Events.FrameAttributionAdded,this._frameAttributionAdded,this),Bindings.NetworkProject.NetworkProjectManager.instance().addEventListener(Bindings.NetworkProject.Events.FrameAttributionRemoved,this._frameAttributionRemoved,this),this._workspace}static _treeElementOrder(e){if(boostOrderForNode.has(e))return 0;const t=e;let i=TYPE_ORDERS.get(t._nodeType)||0;if(t._uiSourceCode){const e=t._uiSourceCode.contentType();e.isDocument()?i+=3:e.isScript()?i+=5:e.isStyleSheet()?i+=10:i+=15}return i}static appendSearchItem(e,t){let i=i18nString(UIStrings.searchInFolder);t&&t.trim()||(t="*",i=i18nString(UIStrings.searchInAllFiles)),e.viewSection().appendItem(i,(()=>{t&&SearchSourcesView.openSearch(`file:${t.trim()}`)}))}static _treeElementsCompare(e,t){const i=NavigatorView._treeElementOrder(e),r=NavigatorView._treeElementOrder(t);return i>r?1:i<r?-1:Platform.StringUtilities.compare(e.titleAsText(),t.titleAsText())}setPlaceholder(e){function t(){const t=this._scriptsTree.firstChild();t?e.hideWidget():e.showWidget(),this._scriptsTree.element.classList.toggle("hidden",!t)}console.assert(!this._placeholder,"A placeholder widget was already set"),this._placeholder=e,e.show(this.contentElement,this.contentElement.firstChild),t.call(this),this._scriptsTree.addEventListener(UI.TreeOutline.Events.ElementAttached,t.bind(this)),this._scriptsTree.addEventListener(UI.TreeOutline.Events.ElementsDetached,t.bind(this))}_onBindingChanged(e){const t=e.data,i=this._uiSourceCodeNodes.get(t.network);for(const d of i)d.updateTitle();const r=this._uiSourceCodeNodes.get(t.fileSystem);for(const d of r)d.updateTitle();const s=Persistence.FileSystemWorkspaceBinding.FileSystemWorkspaceBinding.relativePath(t.fileSystem);let o="";for(let d=0;d<s.length-1;++d){o+=s[d];const e=this._folderNodeId(t.fileSystem.project(),null,null,t.fileSystem.origin(),o),i=this._subfolderNodes.get(e);i&&i.updateTitle(),o+="/"}const n=this._rootNode.child(t.fileSystem.project().id());n&&n.updateTitle()}focus(){this._scriptsTree.focus()}appendChild(e,t){this._scriptsTree.setFocusable(!0),e.appendChild(t)}removeChild(e,t){e.removeChild(t),0===this._scriptsTree.rootElement().childCount()&&this._scriptsTree.setFocusable(!1)}_resetWorkspace(e){this._workspace&&(this._workspace.removeEventListener(Workspace.Workspace.Events.UISourceCodeAdded,this._uiSourceCodeAdded,this),this._workspace.removeEventListener(Workspace.Workspace.Events.UISourceCodeRemoved,this._uiSourceCodeRemoved,this),this._workspace.removeEventListener(Workspace.Workspace.Events.ProjectAdded,this._projectAddedCallback,this),this._workspace.removeEventListener(Workspace.Workspace.Events.ProjectRemoved,this._projectRemovedCallback,this)),this._workspace=e,this._workspace.addEventListener(Workspace.Workspace.Events.UISourceCodeAdded,this._uiSourceCodeAdded,this),this._workspace.addEventListener(Workspace.Workspace.Events.UISourceCodeRemoved,this._uiSourceCodeRemoved,this),this._workspace.addEventListener(Workspace.Workspace.Events.ProjectAdded,this._projectAddedCallback,this),this._workspace.addEventListener(Workspace.Workspace.Events.ProjectRemoved,this._projectRemovedCallback,this),this._workspace.projects().forEach(this._projectAdded.bind(this)),this._computeUniqueFileSystemProjectNames()}_projectAddedCallback(e){const t=e.data;this._projectAdded(t),t.type()===Workspace.Workspace.projectTypes.FileSystem&&this._computeUniqueFileSystemProjectNames()}_projectRemovedCallback(e){const t=e.data;this._removeProject(t),t.type()===Workspace.Workspace.projectTypes.FileSystem&&this._computeUniqueFileSystemProjectNames()}workspace(){return this._workspace}acceptProject(e){return!e.isServiceProject()}_frameAttributionAdded(e){const t=e.data.uiSourceCode;if(!this._acceptsUISourceCode(t))return;const i=e.data.frame;this._addUISourceCodeNode(t,i)}_frameAttributionRemoved(e){const t=e.data.uiSourceCode;if(!this._acceptsUISourceCode(t))return;const i=e.data.frame,r=Array.from(this._uiSourceCodeNodes.get(t)).find((e=>e.frame()===i));this._removeUISourceCodeNode(r)}_acceptsUISourceCode(e){return this.acceptProject(e.project())}_addUISourceCode(e){if(!this._acceptsUISourceCode(e))return;const t=Bindings.NetworkProject.NetworkProject.framesForUISourceCode(e);if(t.length)for(const i of t)this._addUISourceCodeNode(e,i);else this._addUISourceCodeNode(e,null);this.uiSourceCodeAdded(e)}_addUISourceCodeNode(e,t){const i=e.contentType().isFromSourceMap();let r;r=e.project().type()===Workspace.Workspace.projectTypes.FileSystem?Persistence.FileSystemWorkspaceBinding.FileSystemWorkspaceBinding.relativePath(e).slice(0,-1):Common.ParsedURL.ParsedURL.extractPath(e.url()).split("/").slice(1,-1);const s=e.project(),o=Bindings.NetworkProject.NetworkProject.targetForUISourceCode(e),n=this._folderNode(e,s,o,t,e.origin(),r,i),d=new NavigatorUISourceCodeTreeNode(this,e,t);n.appendChild(d),this._uiSourceCodeNodes.set(e,d),this._selectDefaultTreeNode()}uiSourceCodeAdded(e){}_uiSourceCodeAdded(e){const t=e.data;this._addUISourceCode(t)}_uiSourceCodeRemoved(e){const t=e.data;this._removeUISourceCode(t)}tryAddProject(e){this._projectAdded(e),e.uiSourceCodes().forEach(this._addUISourceCode.bind(this))}_projectAdded(e){!this.acceptProject(e)||e.type()!==Workspace.Workspace.projectTypes.FileSystem||Snippets.ScriptSnippetFileSystem.isSnippetsProject(e)||this._rootNode.child(e.id())||(this._rootNode.appendChild(new NavigatorGroupTreeNode(this,e,e.id(),Types.FileSystem,e.displayName())),this._selectDefaultTreeNode())}_selectDefaultTreeNode(){const e=this._rootNode.children();e.length&&!this._scriptsTree.selectedTreeElement&&e[0].treeNode().select(!0,!1)}_computeUniqueFileSystemProjectNames(){const e=this._workspace.projectsForType(Workspace.Workspace.projectTypes.FileSystem);if(!e.length)return;const t=new Persistence.Persistence.PathEncoder,i=e.map((e=>{const i=e;return Platform.StringUtilities.reverse(t.encode(i.fileSystemPath()))})),r=new Common.Trie.Trie;for(const s of i)r.add(s);for(let s=0;s<e.length;++s){const o=i[s],n=e[s];r.remove(o);const d=r.longestPrefix(o,!1);r.add(o);const a=o.substring(0,d.length+1),l=t.decode(Platform.StringUtilities.reverse(a)),c=this._rootNode.child(n.id());c&&c.setTitle(l)}}_removeProject(e){const t=e.uiSourceCodes();for(let r=0;r<t.length;++r)this._removeUISourceCode(t[r]);if(e.type()!==Workspace.Workspace.projectTypes.FileSystem)return;const i=this._rootNode.child(e.id());i&&this._rootNode.removeChild(i)}_folderNodeId(e,t,i,r,s){return(t?t.id():"")+":"+(e.type()===Workspace.Workspace.projectTypes.FileSystem?e.id():"")+":"+(this._groupByFrame&&i?i.id:"")+":"+r+":"+s}_folderNode(e,t,i,r,s,o,n){if(Snippets.ScriptSnippetFileSystem.isSnippetsUISourceCode(e))return this._rootNode;if(i&&!this._groupByFolder&&!n)return this._domainNode(e,t,i,r,s);const d=o.join("/"),a=this._folderNodeId(t,i,r,s,d);let l=this._subfolderNodes.get(a);if(l)return l;if(!o.length)return i?this._domainNode(e,t,i,r,s):this._rootNode.child(t.id());const c=this._folderNode(e,t,i,r,s,o.slice(0,-1),n);let h=n?Types.SourceMapFolder:Types.NetworkFolder;t.type()===Workspace.Workspace.projectTypes.FileSystem&&(h=Types.FileSystemFolder);const p=o[o.length-1];return l=new NavigatorFolderTreeNode(this,t,a,h,d,p),this._subfolderNodes.set(a,l),c.appendChild(l),l}_domainNode(e,t,i,r,s){const o=this._frameNode(t,i,r);if(!this._groupByDomain)return o;let n=o.child(s);return n||(n=new NavigatorGroupTreeNode(this,t,s,Types.Domain,this._computeProjectDisplayName(i,s)),r&&s===Common.ParsedURL.ParsedURL.extractOrigin(r.url)&&boostOrderForNode.add(n.treeNode()),o.appendChild(n),n)}_frameNode(e,t,i){if(!this._groupByFrame||!i)return this._targetNode(e,t);let r=this._frameNodes.get(i);if(r)return r;r=new NavigatorGroupTreeNode(this,e,t.id()+":"+i.id,Types.Frame,i.displayName()),r.setHoverCallback((function(e){if(e){const e=t.model(SDK.OverlayModel.OverlayModel);e&&i&&e.highlightFrame(i.id)}else SDK.OverlayModel.OverlayModel.hideDOMNodeHighlight()})),this._frameNodes.set(i,r);const s=i.parentFrame();return this._frameNode(e,s?s.resourceTreeModel().target():t,s).appendChild(r),s||(boostOrderForNode.add(r.treeNode()),r.treeNode().expand()),r}_targetNode(e,t){if(t===SDK.SDKModel.TargetManager.instance().mainTarget())return this._rootNode;let i=this._rootNode.child("target:"+t.id());return i||(i=new NavigatorGroupTreeNode(this,e,"target:"+t.id(),t.type()===SDK.SDKModel.Type.Frame?Types.Frame:Types.Worker,t.name()),this._rootNode.appendChild(i)),i}_computeProjectDisplayName(e,t){const i=e.model(SDK.RuntimeModel.RuntimeModel),r=i?i.executionContexts():[];for(const o of r)if(o.name&&o.origin&&t.startsWith(o.origin))return o.name;if(!t)return i18nString(UIStrings.noDomain);const s=new Common.ParsedURL.ParsedURL(t);return(s.isValid?s.host+(s.port?":"+s.port:""):"")||t}revealUISourceCode(e,t){const i=this._uiSourceCodeNodes.get(e);if(0===i.size)return null;const r=i.values().next().value;return r?(this._scriptsTree.selectedTreeElement&&this._scriptsTree.selectedTreeElement.deselect(),this._lastSelectedUISourceCode=e,r.reveal(t),r):null}_sourceSelected(e,t){this._lastSelectedUISourceCode=e,Common.Revealer.reveal(e,!t)}_removeUISourceCode(e){const t=this._uiSourceCodeNodes.get(e);for(const i of t)this._removeUISourceCodeNode(i)}_removeUISourceCodeNode(e){const t=e.uiSourceCode();this._uiSourceCodeNodes.delete(t,e);const i=t.project(),r=Bindings.NetworkProject.NetworkProject.targetForUISourceCode(t),s=e.frame();let o=e.parent;if(!o)return;o.removeChild(e);let n=o;for(;n&&(o=n.parent,o&&n.isEmpty())&&(o!==this._rootNode||i.type()!==Workspace.Workspace.projectTypes.FileSystem)&&(n instanceof NavigatorGroupTreeNode||n instanceof NavigatorFolderTreeNode);){if(n._type===Types.Frame){this._discardFrame(s);break}const e=this._folderNodeId(i,r,s,t.origin(),n instanceof NavigatorFolderTreeNode&&n._folderPath||"");this._subfolderNodes.delete(e),o.removeChild(n),n=o}}reset(){for(const e of this._uiSourceCodeNodes.valuesArray())e.dispose();this._scriptsTree.removeChildren(),this._scriptsTree.setFocusable(!1),this._uiSourceCodeNodes.clear(),this._subfolderNodes.clear(),this._frameNodes.clear(),this._rootNode.reset(),this._resetWorkspace(Workspace.Workspace.WorkspaceImpl.instance())}handleContextMenu(e){}async _renameShortcut(){const e=this._scriptsTree.selectedTreeElement,t=e&&e._node;return!!(t&&t._uiSourceCode&&t._uiSourceCode.canRename())&&(this.rename(t,!1),!0)}_handleContextMenuCreate(e,t,i){if(i){const e=Persistence.FileSystemWorkspaceBinding.FileSystemWorkspaceBinding.relativePath(i);e.pop(),t=e.join("/")}this.create(e,t,i)}_handleContextMenuRename(e){this.rename(e,!1)}_handleContextMenuExclude(e,t){window.confirm(i18nString(UIStrings.areYouSureYouWantToExcludeThis))&&(UI.UIUtils.startBatchUpdate(),e.excludeFolder(Persistence.FileSystemWorkspaceBinding.FileSystemWorkspaceBinding.completeURL(e,t)),UI.UIUtils.endBatchUpdate())}_handleContextMenuDelete(e){window.confirm(i18nString(UIStrings.areYouSureYouWantToDeleteThis))&&e.project().deleteFile(e)}handleFileContextMenu(e,t){const i=t.uiSourceCode(),r=new UI.ContextMenu.ContextMenu(e);r.appendApplicableItems(i);const s=i.project();s.type()===Workspace.Workspace.projectTypes.FileSystem&&(r.editSection().appendItem(i18nString(UIStrings.rename),this._handleContextMenuRename.bind(this,t)),r.editSection().appendItem(i18nString(UIStrings.makeACopy),this._handleContextMenuCreate.bind(this,s,"",i)),r.editSection().appendItem(i18nString(UIStrings.delete),this._handleContextMenuDelete.bind(this,i))),r.show()}_handleDeleteOverrides(e){window.confirm(i18nString(UIStrings.areYouSureYouWantToDeleteAll))&&this._handleDeleteOverridesHelper(e)}_handleDeleteOverridesHelper(e){if(e._children.forEach((e=>{this._handleDeleteOverridesHelper(e)})),e instanceof NavigatorUISourceCodeTreeNode){Persistence.Persistence.PersistenceImpl.instance().binding(e.uiSourceCode())&&e.uiSourceCode().project().deleteFile(e.uiSourceCode())}}handleFolderContextMenu(e,t){const i=t._folderPath||"",r=t._project||null,s=new UI.ContextMenu.ContextMenu(e);if(NavigatorView.appendSearchItem(s,i),r){if(r.type()===Workspace.Workspace.projectTypes.FileSystem){const e=Common.ParsedURL.ParsedURL.urlToPlatformPath(Persistence.FileSystemWorkspaceBinding.FileSystemWorkspaceBinding.completeURL(r,i),Host.Platform.isWin());s.revealSection().appendItem(i18nString(UIStrings.openFolder),(()=>Host.InspectorFrontendHost.InspectorFrontendHostInstance.showItemInFolder(e))),r.canCreateFile()&&s.defaultSection().appendItem(i18nString(UIStrings.newFile),(()=>{this._handleContextMenuCreate(r,i,void 0)}))}r.canExcludeFolder(i)&&s.defaultSection().appendItem(i18nString(UIStrings.excludeFolder),this._handleContextMenuExclude.bind(this,r,i)),r.type()===Workspace.Workspace.projectTypes.FileSystem&&(s.defaultSection().appendAction("sources.add-folder-to-workspace",void 0,!0),t instanceof NavigatorGroupTreeNode&&s.defaultSection().appendItem(i18nString(UIStrings.removeFolderFromWorkspace),(()=>{window.confirm(i18nString(UIStrings.areYouSureYouWantToRemoveThis))&&r.remove()})),"overrides"===r.fileSystem().type()&&s.defaultSection().appendItem(i18nString(UIStrings.deleteAllOverrides),this._handleDeleteOverrides.bind(this,t))),s.show()}}rename(e,t){const i=e.uiSourceCode();e.rename(function(r){if(!t)return;r?e._treeElement&&e._treeElement.listItemElement.hasFocus()&&this._sourceSelected(i,!0):i.remove()}.bind(this))}async create(e,t,i){let r="";i&&(r=(await i.requestContent()).content||"");const s=await e.createFile(t,null,r);if(!s)return;this._sourceSelected(s,!1);const o=this.revealUISourceCode(s,!0);o&&this.rename(o,!0)}_groupingChanged(){this.reset(),this._initGrouping(),this._workspace.uiSourceCodes().forEach(this._addUISourceCode.bind(this))}_initGrouping(){this._groupByFrame=!0,this._groupByDomain=this._navigatorGroupByFolderSetting.get(),this._groupByFolder=this._groupByDomain}_resetForTest(){this.reset(),this._workspace.uiSourceCodes().forEach(this._addUISourceCode.bind(this))}_discardFrame(e){const t=this._frameNodes.get(e);if(t){t.parent&&t.parent.removeChild(t),this._frameNodes.delete(e);for(const t of e.childFrames)this._discardFrame(t)}}targetAdded(e){}targetRemoved(e){const t=this._rootNode.child("target:"+e.id());t&&this._rootNode.removeChild(t)}_targetNameChanged(e){const t=e.data,i=this._rootNode.child("target:"+t.id());i&&i.setTitle(t.name())}}const boostOrderForNode=new WeakSet;export class NavigatorFolderTreeElement extends UI.TreeOutline.TreeElement{constructor(e,t,i,r){super("",!0),this.listItemElement.classList.add("navigator-"+t+"-tree-item","navigator-folder-tree-item"),UI.ARIAUtils.setAccessibleName(this.listItemElement,`${i}, ${t}`),this._nodeType=t,this.title=i,this.tooltip=i,this._navigatorView=e,this._hoverCallback=r;let s="largeicon-navigator-folder";t===Types.Domain?s="largeicon-navigator-domain":t===Types.Frame?s="largeicon-navigator-frame":t===Types.Worker&&(s="largeicon-navigator-worker"),this.setLeadingIcons([UI.Icon.Icon.create(s,"icon")]),this._node}async onpopulate(){this._node.populate()}onattach(){this.collapse(),this._node.onattach(),this.listItemElement.addEventListener("contextmenu",this._handleContextMenuEvent.bind(this),!1),this.listItemElement.addEventListener("mousemove",this._mouseMove.bind(this),!1),this.listItemElement.addEventListener("mouseleave",this._mouseLeave.bind(this),!1)}setNode(e){this._node=e;const t=[];let i=e;for(;i&&!i.isRoot();)t.push(i._title),i=i.parent;t.reverse(),this.tooltip=t.join("/"),UI.ARIAUtils.setAccessibleName(this.listItemElement,`${this.title}, ${this._nodeType}`)}_handleContextMenuEvent(e){this._node&&(this.select(),this._navigatorView.handleFolderContextMenu(e,this._node))}_mouseMove(e){!this._hovered&&this._hoverCallback&&(this._hovered=!0,this._hoverCallback(!0))}_mouseLeave(e){this._hoverCallback&&(this._hovered=!1,this._hoverCallback(!1))}}export class NavigatorSourceTreeElement extends UI.TreeOutline.TreeElement{constructor(e,t,i,r){super("",!1),this._nodeType=Types.File,this._node=r,this.title=i,this.listItemElement.classList.add("navigator-"+t.contentType().name()+"-tree-item","navigator-file-tree-item"),this.tooltip=t.url(),UI.ARIAUtils.setAccessibleName(this.listItemElement,`${t.name()}, ${this._nodeType}`),Common.EventTarget.fireEvent("source-tree-file-added",t.fullDisplayName()),this._navigatorView=e,this._uiSourceCode=t,this.updateIcon()}updateIcon(){const e=Persistence.Persistence.PersistenceImpl.instance().binding(this._uiSourceCode);if(e){const t=document.createElement("span");t.classList.add("icon-stack");let i="largeicon-navigator-file-sync";Snippets.ScriptSnippetFileSystem.isSnippetsUISourceCode(e.fileSystem)&&(i="largeicon-navigator-snippet");const r=UI.Icon.Icon.create(i,"icon"),s=UI.Icon.Icon.create("badge-navigator-file-sync","icon-badge");Persistence.NetworkPersistenceManager.NetworkPersistenceManager.instance().project()===e.fileSystem.project()&&(s.style.filter="hue-rotate(160deg)"),t.appendChild(r),t.appendChild(s),UI.Tooltip.Tooltip.install(t,Persistence.PersistenceUtils.PersistenceUtils.tooltipForUISourceCode(this._uiSourceCode)),this.setLeadingIcons([t])}else{let e="largeicon-navigator-file";Snippets.ScriptSnippetFileSystem.isSnippetsUISourceCode(this._uiSourceCode)&&(e="largeicon-navigator-snippet");const t=UI.Icon.Icon.create(e,"icon");this.setLeadingIcons([t])}}get uiSourceCode(){return this._uiSourceCode}onattach(){this.listItemElement.draggable=!0,this.listItemElement.addEventListener("click",this._onclick.bind(this),!1),this.listItemElement.addEventListener("contextmenu",this._handleContextMenuEvent.bind(this),!1),this.listItemElement.addEventListener("dragstart",this._ondragstart.bind(this),!1)}_shouldRenameOnMouseDown(){if(!this._uiSourceCode.canRename())return!1;if(!this.treeOutline)return!1;return this===this.treeOutline.selectedTreeElement&&this.treeOutline.element.hasFocus()&&!UI.UIUtils.isBeingEdited(this.treeOutline.element)}selectOnMouseDown(e){1===e.which&&this._shouldRenameOnMouseDown()?setTimeout(function(){this._shouldRenameOnMouseDown()&&this._navigatorView.rename(this._node,!1)}.bind(this),300):super.selectOnMouseDown(e)}_ondragstart(e){e.dataTransfer&&(e.dataTransfer.setData("text/plain",this._uiSourceCode.url()),e.dataTransfer.effectAllowed="copy")}onspace(){return this._navigatorView._sourceSelected(this.uiSourceCode,!0),!0}_onclick(e){this._navigatorView._sourceSelected(this.uiSourceCode,!1)}ondblclick(e){const t=1===e.button;return this._navigatorView._sourceSelected(this.uiSourceCode,!t),!1}onenter(){return this._navigatorView._sourceSelected(this.uiSourceCode,!0),!0}ondelete(){return!0}_handleContextMenuEvent(e){this.select(),this._navigatorView.handleFileContextMenu(e,this._node)}}export class NavigatorTreeNode{constructor(e,t,i){this.id=t,this._navigatorView=e,this._type=i,this._children=new Map,this._populated=!1,this._isMerged=!1,this.parent,this._title}treeNode(){throw"Not implemented"}dispose(){}updateTitle(){}isRoot(){return!1}hasChildren(){return!0}onattach(){}setTitle(e){throw"Not implemented"}populate(){this.isPopulated()||(this.parent&&this.parent.populate(),this._populated=!0,this.wasPopulated())}wasPopulated(){const e=this.children();for(let t=0;t<e.length;++t)this._navigatorView.appendChild(this.treeNode(),e[t].treeNode())}didAddChild(e){this.isPopulated()&&this._navigatorView.appendChild(this.treeNode(),e.treeNode())}willRemoveChild(e){this.isPopulated()&&this._navigatorView.removeChild(this.treeNode(),e.treeNode())}isPopulated(){return this._populated}isEmpty(){return!this._children.size}children(){return[...this._children.values()]}child(e){return this._children.get(e)||null}appendChild(e){this._children.set(e.id,e),e.parent=this,this.didAddChild(e)}removeChild(e){this.willRemoveChild(e),this._children.delete(e.id),e.parent=null,e.dispose()}reset(){this._children.clear()}}export class NavigatorRootTreeNode extends NavigatorTreeNode{constructor(e){super(e,"",Types.Root)}isRoot(){return!0}treeNode(){return this._navigatorView._scriptsTree.rootElement()}}export class NavigatorUISourceCodeTreeNode extends NavigatorTreeNode{constructor(e,t,i){super(e,t.project().id()+":"+t.url(),Types.File),this._uiSourceCode=t,this._treeElement=null,this._eventListeners=[],this._frame=i}frame(){return this._frame}uiSourceCode(){return this._uiSourceCode}treeNode(){if(this._treeElement)return this._treeElement;this._treeElement=new NavigatorSourceTreeElement(this._navigatorView,this._uiSourceCode,"",this),this.updateTitle();const e=this.updateTitle.bind(this,void 0);return this._eventListeners=[this._uiSourceCode.addEventListener(Workspace.UISourceCode.Events.TitleChanged,e),this._uiSourceCode.addEventListener(Workspace.UISourceCode.Events.WorkingCopyChanged,e),this._uiSourceCode.addEventListener(Workspace.UISourceCode.Events.WorkingCopyCommitted,e)],this._treeElement}updateTitle(e){if(!this._treeElement)return;let t=this._uiSourceCode.displayName();!e&&this._uiSourceCode.isDirty()&&(t="*"+t),this._treeElement.title=t,this._treeElement.updateIcon();let i=this._uiSourceCode.url();this._uiSourceCode.contentType().isFromSourceMap()&&(i=i18nString(UIStrings.sFromSourceMap,{PH1:this._uiSourceCode.displayName()})),this._treeElement.tooltip=i}hasChildren(){return!1}dispose(){Common.EventTarget.EventTarget.removeEventListeners(this._eventListeners)}reveal(e){this.parent&&(this.parent.populate(),this.parent.treeNode().expand()),this._treeElement&&(this._treeElement.reveal(!0),e&&this._treeElement.select(!0))}rename(e){if(!this._treeElement)return;if(this._treeElement.listItemElement.focus(),!this._treeElement.treeOutline)return;const t=this._treeElement.treeOutline.element;function i(i){if(!i)return UI.UIUtils.markBeingEdited(t,!1),this.updateTitle(),void this.rename(e);r.call(this,!0)}function r(i){UI.UIUtils.markBeingEdited(t,!1),this.updateTitle(),e&&e(i)}UI.UIUtils.markBeingEdited(t,!0),this.updateTitle(!0),this._treeElement.startEditingTitle(new UI.InplaceEditor.Config(function(e,t,s){if(t!==s)return this._treeElement&&(this._treeElement.title=t),void this._uiSourceCode.rename(t).then(i.bind(this));r.call(this,!0)}.bind(this),r.bind(this,!1)))}}export class NavigatorFolderTreeNode extends NavigatorTreeNode{constructor(e,t,i,r,s,o){super(e,i,r),this._project=t,this._folderPath=s,this._title=o,this._treeElement}treeNode(){return this._treeElement||(this._treeElement=this._createTreeElement(this._title,this),this.updateTitle()),this._treeElement}updateTitle(){if(!this._treeElement||!this._project||this._project.type()!==Workspace.Workspace.projectTypes.FileSystem)return;const e=Persistence.FileSystemWorkspaceBinding.FileSystemWorkspaceBinding.fileSystemPath(this._project.id())+"/"+this._folderPath,t=Persistence.Persistence.PersistenceImpl.instance().filePathHasBindings(e);this._treeElement.listItemElement.classList.toggle("has-mapped-files",t)}_createTreeElement(e,t){if(this._project&&this._project.type()!==Workspace.Workspace.projectTypes.FileSystem)try{e=decodeURI(e)}catch(r){}const i=new NavigatorFolderTreeElement(this._navigatorView,this._type,e);return i.setNode(t),i}wasPopulated(){this._treeElement&&this._treeElement._node===this&&this._addChildrenRecursive()}_addChildrenRecursive(){const e=this.children();for(let t=0;t<e.length;++t){const i=e[t];this.didAddChild(i),i instanceof NavigatorFolderTreeNode&&i._addChildrenRecursive()}}_shouldMerge(e){return this._type!==Types.Domain&&e instanceof NavigatorFolderTreeNode}didAddChild(e){if(!this._treeElement)return;let t,i=this.children();if(1===i.length&&this._shouldMerge(e))return e._isMerged=!0,this._treeElement.title=this._treeElement.title+"/"+e._title,e._treeElement=this._treeElement,void this._treeElement.setNode(e);if(2===i.length&&(t=i[0]!==e?i[0]:i[1]),t&&t._isMerged){t._isMerged=!1;const e=[];e.push(this);let r=this;for(;r&&r._isMerged;)r=r.parent,r&&e.push(r);e.reverse();const s=e.map((e=>e._title)).join("/"),o=[];r=t;do{o.push(r),i=r.children(),r=1===i.length?i[0]:null}while(r&&r._isMerged);if(!this.isPopulated()){this._treeElement.title=s,this._treeElement.setNode(this);for(let e=0;e<o.length;++e)o[e]._treeElement=null,o[e]._isMerged=!1;return}const n=this._treeElement,d=this._createTreeElement(s,this);for(let t=0;t<e.length;++t)e[t]._treeElement=d;n.parent&&this._navigatorView.appendChild(n.parent,d),n.setNode(o[o.length-1]),n.title=o.map((e=>e._title)).join("/"),n.parent&&this._navigatorView.removeChild(n.parent,n),this._navigatorView.appendChild(this._treeElement,n),n.expanded&&d.expand()}this.isPopulated()&&this._navigatorView.appendChild(this._treeElement,e.treeNode())}willRemoveChild(e){const t=e;!t._isMerged&&this.isPopulated()&&this._treeElement&&t._treeElement&&this._navigatorView.removeChild(this._treeElement,t._treeElement)}}export class NavigatorGroupTreeNode extends NavigatorTreeNode{constructor(e,t,i,r,s){super(e,i,r),this._project=t,this._title=s,this.populate()}setHoverCallback(e){this._hoverCallback=e}treeNode(){return this._treeElement||(this._treeElement=new NavigatorFolderTreeElement(this._navigatorView,this._type,this._title,this._hoverCallback),this._treeElement.setNode(this)),this._treeElement}onattach(){this.updateTitle()}updateTitle(){if(!this._treeElement||this._project.type()!==Workspace.Workspace.projectTypes.FileSystem)return;const e=Persistence.FileSystemWorkspaceBinding.FileSystemWorkspaceBinding.fileSystemPath(this._project.id()),t=this._treeElement.listItemElement.classList.contains("has-mapped-files"),i=Persistence.Persistence.PersistenceImpl.instance().filePathHasBindings(e);t!==i&&(this._treeElement.listItemElement.classList.toggle("has-mapped-files",i),this._treeElement.childrenListElement.hasFocus()||(i?this._treeElement.expand():this._treeElement.collapse()))}setTitle(e){this._title=e,this._treeElement&&(this._treeElement.title=this._title)}}