import*as Bindings from"../bindings/bindings.js";import*as Common from"../common/common.js";import*as Components from"../components/components.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as LinearMemoryInspector from"../linear_memory_inspector/linear_memory_inspector.js";import*as ObjectUI from"../object_ui/object_ui.js";import*as SDK from"../sdk/sdk.js";import*as UI from"../ui/ui.js";import{resolveScopeChain,resolveScopeInObject,resolveThisObject}from"./SourceMapNamesResolver.js";const UIStrings={loading:"Loading...",notPaused:"Not paused",noVariables:"No variables",closureS:"Closure ({PH1})",closure:"Closure",exception:"Exception",returnValue:"Return value",revealInMemoryInspectorPanel:"Reveal in Memory Inspector panel",couldNotOpenLinearMemory:"Could not open linear memory inspector: failed locating buffer."},str_=i18n.i18n.registerUIStrings("sources/ScopeChainSidebarPane.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);let scopeChainSidebarPaneInstance,openLinearMemoryInspectorInstance;export class ScopeChainSidebarPane extends UI.Widget.VBox{constructor(){super(!0),this.registerRequiredCSS("sources/scopeChainSidebarPane.css",{enableLegacyPatching:!1}),this._treeOutline=new ObjectUI.ObjectPropertiesSection.ObjectPropertiesSectionsTreeOutline,this._treeOutline.registerRequiredCSS("sources/scopeChainSidebarPane.css",{enableLegacyPatching:!1}),this._treeOutline.setShowSelectionOnKeyboardFocus(!0),this._expandController=new ObjectUI.ObjectPropertiesSection.ObjectPropertiesSectionsTreeExpandController(this._treeOutline),this._linkifier=new Components.Linkifier.Linkifier,this._infoElement=document.createElement("div"),this._infoElement.className="gray-info-message",this._infoElement.tabIndex=-1,this._update()}static instance(){return scopeChainSidebarPaneInstance||(scopeChainSidebarPaneInstance=new ScopeChainSidebarPane),scopeChainSidebarPaneInstance}flavorChanged(e){this._update()}focus(){this.hasFocus()||UI.Context.Context.instance().flavor(SDK.DebuggerModel.DebuggerPausedDetails)&&this._treeOutline.forceSelect()}async _update(){this._infoElement.textContent=i18nString(UIStrings.loading),this.contentElement.removeChildren(),this.contentElement.appendChild(this._infoElement),this._linkifier.reset();const e=UI.Context.Context.instance().flavor(SDK.DebuggerModel.CallFrame),[t,n]=await Promise.all([resolveThisObject(e),resolveScopeChain(e)]);if(e===UI.Context.Context.instance().flavor(SDK.DebuggerModel.CallFrame)){const o=UI.Context.Context.instance().flavor(SDK.DebuggerModel.DebuggerPausedDetails);if(this._treeOutline.removeChildren(),!o||!e||!n)return void(this._infoElement.textContent=i18nString(UIStrings.notPaused));this.contentElement.removeChildren(),this.contentElement.appendChild(this._treeOutline.element);let r=!1;for(let i=0;i<n.length;++i){const s=n[i],a=this._extraPropertiesForScope(s,o,e,t,0===i);s.type()===Protocol.Debugger.ScopeType.Local&&(r=!0);const c=this._createScopeSectionTreeElement(s,a);s.type()===Protocol.Debugger.ScopeType.Global?c.collapse():r&&s.type()!==Protocol.Debugger.ScopeType.Local||c.expand(),this._treeOutline.appendChild(c),0===i&&c.select(!0)}this._sidebarPaneUpdatedForTest()}}_createScopeSectionTreeElement(e,t){let n=null;(e.type()===Protocol.Debugger.ScopeType.Local||Protocol.Debugger.ScopeType.Closure)&&(n=i18nString(UIStrings.noVariables));let o=e.typeName();if(e.type()===Protocol.Debugger.ScopeType.Closure){const t=e.name();o=t?i18nString(UIStrings.closureS,{PH1:UI.UIUtils.beautifyFunctionName(t)}):i18nString(UIStrings.closure)}let r=e.description();o&&o!==r||(r=null);const i=e.icon(),s=document.createElement("div");if(s.classList.add("scope-chain-sidebar-pane-section-header"),s.classList.add("tree-element-title"),i){const e=document.createElement("img");e.classList.add("scope-chain-sidebar-pane-section-icon"),e.src=i,s.appendChild(e)}s.createChild("div","scope-chain-sidebar-pane-section-subtitle").textContent=r,s.createChild("div","scope-chain-sidebar-pane-section-title").textContent=o;const a=new ObjectUI.ObjectPropertiesSection.RootElement(resolveScopeInObject(e),this._linkifier,n,!0,t);return a.title=s,a.listItemElement.classList.add("scope-chain-sidebar-pane-section"),a.listItemElement.setAttribute("aria-label",o),this._expandController.watchSection(o+(r?":"+r:""),a),a}_extraPropertiesForScope(e,t,n,o,r){if(e.type()!==Protocol.Debugger.ScopeType.Local||n.script.isWasm())return[];const i=[];if(o&&i.push(new SDK.RemoteObject.RemoteObjectProperty("this",o)),r){const e=t.exception();e&&i.push(new SDK.RemoteObject.RemoteObjectProperty(i18nString(UIStrings.exception),e,void 0,void 0,void 0,void 0,void 0,!0));const o=n.returnValue();o&&i.push(new SDK.RemoteObject.RemoteObjectProperty(i18nString(UIStrings.returnValue),o,void 0,void 0,void 0,void 0,void 0,!0,n.setReturnValue.bind(n)))}return i}_sidebarPaneUpdatedForTest(){}}export class OpenLinearMemoryInspector extends UI.Widget.VBox{static instance(e={forceNew:null}){const{forceNew:t}=e;return openLinearMemoryInspectorInstance&&!t||(openLinearMemoryInspectorInstance=new OpenLinearMemoryInspector),openLinearMemoryInspectorInstance}_isMemoryObjectProperty(e){if("object"===e.type&&e.subtype&&LinearMemoryInspector.LinearMemoryInspectorController.ACCEPTED_MEMORY_TYPES.includes(e.subtype))return!0;if(e instanceof Bindings.DebuggerLanguagePlugins.ValueNode){return void 0!==e.inspectableAddress}return!1}appendApplicableItems(e,t,n){n instanceof ObjectUI.ObjectPropertiesSection.ObjectPropertyTreeElement&&n.property&&n.property.value&&this._isMemoryObjectProperty(n.property.value)&&t.debugSection().appendItem(i18nString(UIStrings.revealInMemoryInspectorPanel),this._openMemoryInspector.bind(this,n.property.value))}async _openMemoryInspector(e){const t=LinearMemoryInspector.LinearMemoryInspectorController.LinearMemoryInspectorController.instance();let n=0,o=e;if(e instanceof Bindings.DebuggerLanguagePlugins.ValueNode){const t=e;n=t.inspectableAddress||0;const r=t.callFrame,i=await e.debuggerModel()._agent.invoke_evaluateOnCallFrame({callFrameId:r.id,expression:"memories[0]"}),s=i.getError();s&&(console.error(s),Common.Console.Console.instance().error(i18nString(UIStrings.couldNotOpenLinearMemory)));o=e.debuggerModel().runtimeModel().createRemoteObject(i.result)}Host.userMetrics.linearMemoryInspectorRevealedFrom(Host.UserMetrics.LinearMemoryInspectorRevealedFrom.ContextMenu),t.openInspectorView(o,n)}}