import{isNode}from"../environment.js";import{assert}from"./assert.js";import{TimeoutError}from"./Errors.js";import{debugError,helper}from"./helper.js";import{LifecycleWatcher}from"./LifecycleWatcher.js";import{getQueryHandlerAndSelector}from"./QueryHandler.js";export class DOMWorld{constructor(t,e,n){this._documentPromise=null,this._contextPromise=null,this._contextResolveCallback=null,this._detached=!1,this._waitTasks=new Set,this._boundFunctions=new Map,this._ctxBindings=new Set,this._settingUpBinding=null,this._frameManager=t,this._frame=e,this._timeoutSettings=n,this._setContext(null),t._client.on("Runtime.bindingCalled",(t=>this._onBindingCalled(t)))}frame(){return this._frame}async _setContext(t){if(t){this._contextResolveCallback.call(null,t),this._contextResolveCallback=null;for(const t of this._waitTasks)t.rerun()}else this._documentPromise=null,this._contextPromise=new Promise((t=>{this._contextResolveCallback=t}))}_hasContext(){return!this._contextResolveCallback}_detach(){this._detached=!0;for(const t of this._waitTasks)t.terminate(new Error("waitForFunction failed: frame got detached."))}executionContext(){if(this._detached)throw new Error(`Execution context is not available in detached frame "${this._frame.url()}" (are you trying to evaluate?)`);return this._contextPromise}async evaluateHandle(t,...e){return(await this.executionContext()).evaluateHandle(t,...e)}async evaluate(t,...e){return(await this.executionContext()).evaluate(t,...e)}async $(t){const e=await this._document();return await e.$(t)}async _document(){return this._documentPromise||(this._documentPromise=this.executionContext().then((async t=>(await t.evaluateHandle("document")).asElement()))),this._documentPromise}async $x(t){const e=await this._document();return await e.$x(t)}async $eval(t,e,...n){return(await this._document()).$eval(t,e,...n)}async $$eval(t,e,...n){const i=await this._document();return await i.$$eval(t,e,...n)}async $$(t){const e=await this._document();return await e.$$(t)}async content(){return await this.evaluate((()=>{let t="";return document.doctype&&(t=(new XMLSerializer).serializeToString(document.doctype)),document.documentElement&&(t+=document.documentElement.outerHTML),t}))}async setContent(t,e={}){const{waitUntil:n=["load"],timeout:i=this._timeoutSettings.navigationTimeout()}=e;await this.evaluate((t=>{document.open(),document.write(t),document.close()}),t);const a=new LifecycleWatcher(this._frameManager,this._frame,n,i),o=await Promise.race([a.timeoutOrTerminationPromise(),a.lifecyclePromise()]);if(a.dispose(),o)throw o}async addScriptTag(t){const{url:e=null,path:n=null,content:i=null,type:a=""}=t;if(null!==e)try{const t=await this.executionContext();return(await t.evaluateHandle((async function(t,e){const n=document.createElement("script");n.src=t,e&&(n.type=e);const i=new Promise(((t,e)=>{n.onload=t,n.onerror=e}));return document.head.appendChild(n),await i,n}),e,a)).asElement()}catch(r){throw new Error(`Loading script from ${e} failed`)}if(null!==n){if(!isNode)throw new Error("Cannot pass a filepath to addScriptTag in the browser environment.");const t=await helper.importFSModule();let e=await t.promises.readFile(n,"utf8");e+="//# sourceURL="+n.replace(/\n/g,"");const i=await this.executionContext();return(await i.evaluateHandle(o,e,a)).asElement()}if(null!==i){const t=await this.executionContext();return(await t.evaluateHandle(o,i,a)).asElement()}throw new Error("Provide an object with a `url`, `path` or `content` property");function o(t,e="text/javascript"){const n=document.createElement("script");n.type=e,n.text=t;let i=null;if(n.onerror=t=>i=t,document.head.appendChild(n),i)throw i;return n}}async addStyleTag(t){const{url:e=null,path:n=null,content:i=null}=t;if(null!==e)try{const t=await this.executionContext();return(await t.evaluateHandle((async function(t){const e=document.createElement("link");e.rel="stylesheet",e.href=t;const n=new Promise(((t,n)=>{e.onload=t,e.onerror=n}));return document.head.appendChild(e),await n,e}),e)).asElement()}catch(o){throw new Error(`Loading style from ${e} failed`)}if(null!==n){if(!isNode)throw new Error("Cannot pass a filepath to addStyleTag in the browser environment.");const t=await helper.importFSModule();let e=await t.promises.readFile(n,"utf8");e+="/*# sourceURL="+n.replace(/\n/g,"")+"*/";const i=await this.executionContext();return(await i.evaluateHandle(a,e)).asElement()}if(null!==i){const t=await this.executionContext();return(await t.evaluateHandle(a,i)).asElement()}throw new Error("Provide an object with a `url`, `path` or `content` property");async function a(t){const e=document.createElement("style");e.type="text/css",e.appendChild(document.createTextNode(t));const n=new Promise(((t,n)=>{e.onload=t,e.onerror=n}));return document.head.appendChild(e),await n,e}}async click(t,e){const n=await this.$(t);assert(n,"No node found for selector: "+t),await n.click(e),await n.dispose()}async focus(t){const e=await this.$(t);assert(e,"No node found for selector: "+t),await e.focus(),await e.dispose()}async hover(t){const e=await this.$(t);assert(e,"No node found for selector: "+t),await e.hover(),await e.dispose()}async select(t,...e){const n=await this.$(t);assert(n,"No node found for selector: "+t);const i=await n.select(...e);return await n.dispose(),i}async tap(t){const e=await this.$(t);await e.tap(),await e.dispose()}async type(t,e,n){const i=await this.$(t);assert(i,"No node found for selector: "+t),await i.type(e,n),await i.dispose()}async waitForSelector(t,e){const{updatedSelector:n,queryHandler:i}=getQueryHandlerAndSelector(t);return i.waitFor(this,n,e)}async addBindingToContext(t,e){if(this._ctxBindings.has(DOMWorld.bindingIdentifier(e,t._contextId)))return;if(this._settingUpBinding)return await this._settingUpBinding,this.addBindingToContext(t,e);this._settingUpBinding=(async e=>{const n=helper.pageBindingInitString("internal",e);try{await t._client.send("Runtime.addBinding",{name:e,executionContextName:t._contextName}),await t.evaluate(n)}catch(i){const t=i.message.includes("Execution context was destroyed"),e=i.message.includes("Cannot find context with specified id");return t||e?void 0:void debugError(i)}this._ctxBindings.add(DOMWorld.bindingIdentifier(e,t._contextId))})(e),await this._settingUpBinding,this._settingUpBinding=null}async _onBindingCalled(t){let e;if(!this._hasContext())return;const n=await this.executionContext();try{e=JSON.parse(t.payload)}catch{return}const{type:i,name:a,seq:o,args:r}=e;if("internal"===i&&this._ctxBindings.has(DOMWorld.bindingIdentifier(a,n._contextId))&&n._contextId===t.executionContextId)try{const t=await this._boundFunctions.get(a)(...r);await n.evaluate((function(t,e,n){globalThis[t].callbacks.get(e).resolve(n),globalThis[t].callbacks.delete(e)}),a,o,t)}catch(s){if(s.message.includes("Protocol error"))return;debugError(s)}}async waitForSelectorInPage(t,e,n,i){const{visible:a=!1,hidden:o=!1,timeout:r=this._timeoutSettings.timeout()}=n,s=a||o?"raf":"mutation",c=`selector \`${e}\`${o?" to be hidden":""}`;const l={domWorld:this,predicateBody:helper.makePredicateString((async function(t,e,n){const i=predicateQueryHandler?await predicateQueryHandler(document,t):document.querySelector(t);return checkWaitForOptions(i,e,n)}),t),title:c,polling:s,timeout:r,args:[e,a,o],binding:i},d=new WaitTask(l),u=await d.promise,h=u.asElement();return h||(await u.dispose(),null)}async waitForXPath(t,e){const{visible:n=!1,hidden:i=!1,timeout:a=this._timeoutSettings.timeout()}=e,o=n||i?"raf":"mutation",r=`XPath \`${t}\`${i?" to be hidden":""}`;const s={domWorld:this,predicateBody:helper.makePredicateString((function(t,e,n){const i=document.evaluate(t,document,null,XPathResult.FIRST_ORDERED_NODE_TYPE,null).singleNodeValue;return checkWaitForOptions(i,e,n)})),title:r,polling:o,timeout:a,args:[t,n,i]},c=new WaitTask(s),l=await c.promise,d=l.asElement();return d||(await l.dispose(),null)}waitForFunction(t,e={},...n){const{polling:i="raf",timeout:a=this._timeoutSettings.timeout()}=e;return new WaitTask({domWorld:this,predicateBody:t,title:"function",polling:i,timeout:a,args:n}).promise}async title(){return this.evaluate((()=>document.title))}}DOMWorld.bindingIdentifier=(t,e)=>`${t}_${e}`;export class WaitTask{constructor(t){if(this._runCount=0,this._terminated=!1,helper.isString(t.polling))assert("raf"===t.polling||"mutation"===t.polling,"Unknown polling option: "+t.polling);else{if(!helper.isNumber(t.polling))throw new Error("Unknown polling options: "+t.polling);assert(t.polling>0,"Cannot poll with non-positive interval: "+t.polling)}var e;if(this._domWorld=t.domWorld,this._polling=t.polling,this._timeout=t.timeout,this._predicateBody=(e=t.predicateBody,helper.isString(e)?`return (${e});`:`return (${e})(...args);`),this._args=t.args,this._binding=t.binding,this._runCount=0,this._domWorld._waitTasks.add(this),this._binding&&this._domWorld._boundFunctions.set(this._binding.name,this._binding.pptrFunction),this.promise=new Promise(((t,e)=>{this._resolve=t,this._reject=e})),t.timeout){const e=new TimeoutError(`waiting for ${t.title} failed: timeout ${t.timeout}ms exceeded`);this._timeoutTimer=setTimeout((()=>this.terminate(e)),t.timeout)}this.rerun()}terminate(t){this._terminated=!0,this._reject(t),this._cleanup()}async rerun(){const t=++this._runCount;let e=null,n=null;const i=await this._domWorld.executionContext();if(!this._terminated&&t===this._runCount&&(this._binding&&await this._domWorld.addBindingToContext(i,this._binding.name),!this._terminated&&t===this._runCount)){try{e=await i.evaluateHandle(waitForPredicatePageFunction,this._predicateBody,this._polling,this._timeout,...this._args)}catch(a){n=a}if(this._terminated||t!==this._runCount)e&&await e.dispose();else if(n||!await this._domWorld.evaluate((t=>!t),e).catch((()=>!0))){if(n){if(n.message.includes("TypeError: binding is not a function"))return this.rerun();if(n.message.includes("Execution context is not available in detached frame"))return void this.terminate(new Error("waitForFunction failed: frame got detached."));if(n.message.includes("Execution context was destroyed"))return;if(n.message.includes("Cannot find context with specified id"))return;this._reject(n)}else this._resolve(e);this._cleanup()}else await e.dispose()}}_cleanup(){clearTimeout(this._timeoutTimer),this._domWorld._waitTasks.delete(this)}}async function waitForPredicatePageFunction(t,e,n,...i){const a=new Function("...args",t);let o=!1;if(n&&setTimeout((()=>o=!0),n),"raf"===e)return await async function(){let t;const e=new Promise((e=>t=e));return await async function e(){if(o)return void t();const n=await a(...i);n?t(n):requestAnimationFrame(e)}(),e}();if("mutation"===e)return await async function(){const t=await a(...i);if(t)return Promise.resolve(t);let e;const n=new Promise((t=>e=t)),r=new MutationObserver((async()=>{o&&(r.disconnect(),e());const t=await a(...i);t&&(r.disconnect(),e(t))}));return r.observe(document,{childList:!0,subtree:!0,attributes:!0}),n}();if("number"===typeof e)return await async function(t){let e;const n=new Promise((t=>e=t));return await r(),n;async function r(){if(o)return void e();const n=await a(...i);n?e(n):setTimeout(r,t)}}(e)}