import{assert}from"./assert.js";import{EventEmitter}from"./EventEmitter.js";import{debugError,helper}from"./helper.js";import{HTTPRequest}from"./HTTPRequest.js";import{HTTPResponse}from"./HTTPResponse.js";export const NetworkManagerEmittedEvents={Request:Symbol("NetworkManager.Request"),Response:Symbol("NetworkManager.Response"),RequestFailed:Symbol("NetworkManager.RequestFailed"),RequestFinished:Symbol("NetworkManager.RequestFinished")};export class NetworkManager extends EventEmitter{constructor(e,t,s){super(),this._requestIdToRequest=new Map,this._requestIdToRequestWillBeSentEvent=new Map,this._extraHTTPHeaders={},this._credentials=null,this._attemptedAuthentications=new Set,this._userRequestInterceptionEnabled=!1,this._protocolRequestInterceptionEnabled=!1,this._userCacheDisabled=!1,this._requestIdToInterceptionId=new Map,this._emulatedNetworkConditions={offline:!1,upload:-1,download:-1,latency:0},this._client=e,this._ignoreHTTPSErrors=t,this._frameManager=s,this._client.on("Fetch.requestPaused",this._onRequestPaused.bind(this)),this._client.on("Fetch.authRequired",this._onAuthRequired.bind(this)),this._client.on("Network.requestWillBeSent",this._onRequestWillBeSent.bind(this)),this._client.on("Network.requestServedFromCache",this._onRequestServedFromCache.bind(this)),this._client.on("Network.responseReceived",this._onResponseReceived.bind(this)),this._client.on("Network.loadingFinished",this._onLoadingFinished.bind(this)),this._client.on("Network.loadingFailed",this._onLoadingFailed.bind(this))}async initialize(){await this._client.send("Network.enable"),this._ignoreHTTPSErrors&&await this._client.send("Security.setIgnoreCertificateErrors",{ignore:!0})}async authenticate(e){this._credentials=e,await this._updateProtocolRequestInterception()}async setExtraHTTPHeaders(e){this._extraHTTPHeaders={};for(const t of Object.keys(e)){const s=e[t];assert(helper.isString(s),`Expected value of header "${t}" to be String, but "${typeof s}" is found.`),this._extraHTTPHeaders[t.toLowerCase()]=s}await this._client.send("Network.setExtraHTTPHeaders",{headers:this._extraHTTPHeaders})}extraHTTPHeaders(){return Object.assign({},this._extraHTTPHeaders)}async setOfflineMode(e){this._emulatedNetworkConditions.offline=e,await this._updateNetworkConditions()}async emulateNetworkConditions(e){this._emulatedNetworkConditions.upload=e?e.upload:-1,this._emulatedNetworkConditions.download=e?e.download:-1,this._emulatedNetworkConditions.latency=e?e.latency:0,await this._updateNetworkConditions()}async _updateNetworkConditions(){await this._client.send("Network.emulateNetworkConditions",{offline:this._emulatedNetworkConditions.offline,latency:this._emulatedNetworkConditions.latency,uploadThroughput:this._emulatedNetworkConditions.upload,downloadThroughput:this._emulatedNetworkConditions.download})}async setUserAgent(e){await this._client.send("Network.setUserAgentOverride",{userAgent:e})}async setCacheEnabled(e){this._userCacheDisabled=!e,await this._updateProtocolCacheDisabled()}async setRequestInterception(e){this._userRequestInterceptionEnabled=e,await this._updateProtocolRequestInterception()}async _updateProtocolRequestInterception(){const e=this._userRequestInterceptionEnabled||!!this._credentials;e!==this._protocolRequestInterceptionEnabled&&(this._protocolRequestInterceptionEnabled=e,e?await Promise.all([this._updateProtocolCacheDisabled(),this._client.send("Fetch.enable",{handleAuthRequests:!0,patterns:[{urlPattern:"*"}]})]):await Promise.all([this._updateProtocolCacheDisabled(),this._client.send("Fetch.disable")]))}async _updateProtocolCacheDisabled(){await this._client.send("Network.setCacheDisabled",{cacheDisabled:this._userCacheDisabled||this._protocolRequestInterceptionEnabled})}_onRequestWillBeSent(e){if(!this._protocolRequestInterceptionEnabled||e.request.url.startsWith("data:"))this._onRequest(e,null);else{const t=e.requestId,s=this._requestIdToInterceptionId.get(t);s?(this._onRequest(e,s),this._requestIdToInterceptionId.delete(t)):this._requestIdToRequestWillBeSentEvent.set(e.requestId,e)}}_onAuthRequired(e){let t="Default";this._attemptedAuthentications.has(e.requestId)?t="CancelAuth":this._credentials&&(t="ProvideCredentials",this._attemptedAuthentications.add(e.requestId));const{username:s,password:i}=this._credentials||{username:void 0,password:void 0};this._client.send("Fetch.continueWithAuth",{requestId:e.requestId,authChallengeResponse:{response:t,username:s,password:i}}).catch(debugError)}_onRequestPaused(e){!this._userRequestInterceptionEnabled&&this._protocolRequestInterceptionEnabled&&this._client.send("Fetch.continueRequest",{requestId:e.requestId}).catch(debugError);const t=e.networkId,s=e.requestId;if(t&&this._requestIdToRequestWillBeSentEvent.has(t)){const e=this._requestIdToRequestWillBeSentEvent.get(t);this._onRequest(e,s),this._requestIdToRequestWillBeSentEvent.delete(t)}else this._requestIdToInterceptionId.set(t,s)}_onRequest(e,t){let s=[];if(e.redirectResponse){const t=this._requestIdToRequest.get(e.requestId);t&&(this._handleRequestRedirect(t,e.redirectResponse),s=t._redirectChain)}const i=e.frameId?this._frameManager.frame(e.frameId):null,n=new HTTPRequest(this._client,i,t,this._userRequestInterceptionEnabled,e,s);this._requestIdToRequest.set(e.requestId,n),this.emit(NetworkManagerEmittedEvents.Request,n)}_onRequestServedFromCache(e){const t=this._requestIdToRequest.get(e.requestId);t&&(t._fromMemoryCache=!0)}_handleRequestRedirect(e,t){const s=new HTTPResponse(this._client,e,t);e._response=s,e._redirectChain.push(e),s._resolveBody(new Error("Response body is unavailable for redirect responses")),this._requestIdToRequest.delete(e._requestId),this._attemptedAuthentications.delete(e._interceptionId),this.emit(NetworkManagerEmittedEvents.Response,s),this.emit(NetworkManagerEmittedEvents.RequestFinished,e)}_onResponseReceived(e){const t=this._requestIdToRequest.get(e.requestId);if(!t)return;const s=new HTTPResponse(this._client,t,e.response);t._response=s,this.emit(NetworkManagerEmittedEvents.Response,s)}_onLoadingFinished(e){const t=this._requestIdToRequest.get(e.requestId);t&&(t.response()&&t.response()._resolveBody(null),this._requestIdToRequest.delete(t._requestId),this._attemptedAuthentications.delete(t._interceptionId),this.emit(NetworkManagerEmittedEvents.RequestFinished,t))}_onLoadingFailed(e){const t=this._requestIdToRequest.get(e.requestId);if(!t)return;t._failureText=e.errorText;const s=t.response();s&&s._resolveBody(null),this._requestIdToRequest.delete(t._requestId),this._attemptedAuthentications.delete(t._interceptionId),this.emit(NetworkManagerEmittedEvents.RequestFailed,t)}}