import{bytesToString,isTypeIndex,OperatorCodeNames}from"./WasmParser.js";const NAME_SECTION_NAME="name",INVALID_NAME_SYMBOLS_REGEX=/[^0-9A-Za-z!#$%&'*+.:<=>?@^_`|~\/\-]/,INVALID_NAME_SYMBOLS_REGEX_GLOBAL=new RegExp(INVALID_NAME_SYMBOLS_REGEX.source,"g");function typeToString(e){switch(e){case-1:return"i32";case-2:return"i64";case-3:return"f32";case-4:return"f64";case-5:return"v128";case-16:return"funcref";case-17:return"externref";default:throw new Error(`Unexpected type ${e}`)}}function formatFloat32(e){if(0===e)return 1/e<0?"-0.0":"0.0";if(isFinite(e))return e.toString();if(!isNaN(e))return e<0?"-inf":"inf";var t=new DataView(new ArrayBuffer(8));t.setFloat32(0,e,!0);var s=t.getInt32(0,!0),a=8388607&s;const r=4194304;return s>0&&a===r?"nan":a===r?"-nan":(s<0?"-":"+")+"nan:0x"+a.toString(16)}function formatFloat64(e){if(0===e)return 1/e<0?"-0.0":"0.0";if(isFinite(e))return e.toString();if(!isNaN(e))return e<0?"-inf":"inf";var t=new DataView(new ArrayBuffer(8));t.setFloat64(0,e,!0);var s=t.getUint32(0,!0),a=t.getInt32(4,!0),r=s+4294967296*(1048575&a);const n=0x8000000000000;return a>0&&r===n?"nan":r===n?"-nan":(a<0?"-":"+")+"nan:0x"+r.toString(16)}function formatI32Array(e,t){for(var s=new DataView(e.buffer,e.byteOffset,e.byteLength),a=[],r=0;r<t;r++)a.push(`0x${formatHex(s.getInt32(r<<2,!0),8)}`);return a.join(" ")}function formatI8Array(e,t){for(var s=new DataView(e.buffer,e.byteOffset,e.byteLength),a=[],r=0;r<t;r++)a.push(`${s.getInt8(r)}`);return a.join(" ")}function memoryAddressToString(e,t){var s;switch(t){case 64768:case 64769:case 64770:case 64771:case 64772:case 64773:case 64774:case 64775:case 64776:case 64777:case 64778:case 64779:s=4;break;case 41:case 55:case 43:case 57:case 65026:case 65041:case 65048:case 65055:case 65062:case 65069:case 65076:case 65083:case 65090:case 65097:case 65021:s=3;break;case 40:case 52:case 53:case 54:case 62:case 42:case 56:case 65024:case 65025:case 65040:case 65046:case 65047:case 65053:case 65054:case 65060:case 65061:case 65067:case 65068:case 65074:case 65075:case 65081:case 65082:case 65088:case 65089:case 65095:case 65096:case 65102:case 65020:s=2;break;case 46:case 47:case 50:case 51:case 59:case 61:case 65043:case 65045:case 65050:case 65052:case 65057:case 65059:case 65064:case 65066:case 65071:case 65073:case 65078:case 65080:case 65085:case 65087:case 65092:case 65094:case 65099:case 65101:s=1;break;case 44:case 45:case 48:case 49:case 58:case 60:case 65042:case 65044:case 65049:case 65051:case 65056:case 65058:case 65063:case 65065:case 65070:case 65072:case 65077:case 65079:case 65084:case 65086:case 65091:case 65093:case 65098:case 65100:s=0}return e.flags==s?e.offset?`offset=${e.offset}`:null:e.offset?`offset=${0|e.offset} align=${1<<e.flags}`:"align="+(1<<e.flags)}function globalTypeToString(e){const t=typeToString(e.contentType);return e.mutability?`(mut ${t})`:t}function limitsToString(e){return e.initial+(void 0!==e.maximum?" "+e.maximum:"")}var paddingCache=["0","00","000"];function formatHex(e,t){var s=(e>>>0).toString(16).toUpperCase();if(void 0===t||s.length>=t)return s;for(var a=t-s.length-1;a>=paddingCache.length;)paddingCache.push(paddingCache[paddingCache.length-1]+"0");return paddingCache[a]+s}const IndentIncrement="  ";function isValidName(e){return!INVALID_NAME_SYMBOLS_REGEX.test(e)}export class DefaultNameResolver{getTypeName(e,t){return"$type"+e}getTableName(e,t){return"$table"+e}getMemoryName(e,t){return"$memory"+e}getGlobalName(e,t){return"$global"+e}getElementName(e,t){return`$elem${e}`}getFunctionName(e,t,s){return(t?"$import":"$func")+e}getVariableName(e,t,s){return"$var"+t}getLabel(e){return"$label"+e}}const EMPTY_STRING_ARRAY=[];class DevToolsExportMetadata{constructor(e,t,s,a){this._functionExportNames=e,this._globalExportNames=t,this._memoryExportNames=s,this._tableExportNames=a}getFunctionExportNames(e){var t;return null!==(t=this._functionExportNames[e])&&void 0!==t?t:EMPTY_STRING_ARRAY}getGlobalExportNames(e){var t;return null!==(t=this._globalExportNames[e])&&void 0!==t?t:EMPTY_STRING_ARRAY}getMemoryExportNames(e){var t;return null!==(t=this._memoryExportNames[e])&&void 0!==t?t:EMPTY_STRING_ARRAY}getTableExportNames(e){var t;return null!==(t=this._tableExportNames[e])&&void 0!==t?t:EMPTY_STRING_ARRAY}}export class NumericNameResolver{getTypeName(e,t){return t?""+e:`(;${e};)`}getTableName(e,t){return t?""+e:`(;${e};)`}getMemoryName(e,t){return t?""+e:`(;${e};)`}getGlobalName(e,t){return t?""+e:`(;${e};)`}getElementName(e,t){return t?""+e:`(;${e};)`}getFunctionName(e,t,s){return s?""+e:`(;${e};)`}getVariableName(e,t,s){return s?""+t:`(;${t};)`}getLabel(e){return null}}export var LabelMode;!function(e){e[e.Depth=0]="Depth",e[e.WhenUsed=1]="WhenUsed",e[e.Always=2]="Always"}(LabelMode||(LabelMode={}));export class WasmDisassembler{constructor(){this._skipTypes=!0,this._exportMetadata=null,this._lines=[],this._offsets=[],this._buffer="",this._indent=null,this._indentLevel=0,this._addOffsets=!1,this._done=!1,this._currentPosition=0,this._nameResolver=new DefaultNameResolver,this._labelMode=LabelMode.WhenUsed,this._functionBodyOffsets=[],this._currentFunctionBodyOffset=0,this._currentSectionId=-1,this._logFirstInstruction=!1,this._reset()}_reset(){this._types=[],this._funcIndex=0,this._funcTypes=[],this._importCount=0,this._globalCount=0,this._memoryCount=0,this._tableCount=0,this._elementCount=0,this._expression=[],this._backrefLabels=null,this._labelIndex=0}get addOffsets(){return this._addOffsets}set addOffsets(e){if(this._currentPosition)throw new Error("Cannot switch addOffsets during processing.");this._addOffsets=e}get skipTypes(){return this._skipTypes}set skipTypes(e){if(this._currentPosition)throw new Error("Cannot switch skipTypes during processing.");this._skipTypes=e}get labelMode(){return this._labelMode}set labelMode(e){if(this._currentPosition)throw new Error("Cannot switch labelMode during processing.");this._labelMode=e}get exportMetadata(){return this._exportMetadata}set exportMetadata(e){if(this._currentPosition)throw new Error("Cannot switch exportMetadata during processing.");this._exportMetadata=e}get nameResolver(){return this._nameResolver}set nameResolver(e){if(this._currentPosition)throw new Error("Cannot switch nameResolver during processing.");this._nameResolver=e}appendBuffer(e){this._buffer+=e}newLine(){this.addOffsets&&this._offsets.push(this._currentPosition),this._lines.push(this._buffer),this._buffer=""}logStartOfFunctionBodyOffset(){this.addOffsets&&(this._currentFunctionBodyOffset=this._currentPosition)}logEndOfFunctionBodyOffset(){this.addOffsets&&this._functionBodyOffsets.push({start:this._currentFunctionBodyOffset,end:this._currentPosition})}printFuncType(e){var t=this._types[e];if(-32!==t.form)throw new Error("NYI other function form");if(t.params.length>0){this.appendBuffer(" (param");for(var s=0;s<t.params.length;s++)this.appendBuffer(" "),this.appendBuffer(typeToString(t.params[s]));this.appendBuffer(")")}if(t.returns.length>0){this.appendBuffer(" (result");for(s=0;s<t.returns.length;s++)this.appendBuffer(" "),this.appendBuffer(typeToString(t.returns[s]));this.appendBuffer(")")}}printBlockType(e){if(-64!==e){if(isTypeIndex(e))return this.printFuncType(e);this.appendBuffer(" (result "),this.appendBuffer(typeToString(e)),this.appendBuffer(")")}}printString(e){this.appendBuffer('"');for(var t=0;t<e.length;t++){var s=e[t];s<32||s>=127||34==s||92==s?this.appendBuffer("\\"+(s>>4).toString(16)+(15&s).toString(16)):this.appendBuffer(String.fromCharCode(s))}this.appendBuffer('"')}printExpression(e){for(const t of e)this.appendBuffer("("),this.printOperator(t),this.appendBuffer(")")}useLabel(e){if(!this._backrefLabels)return""+e;var t=this._backrefLabels.length-e-1;if(t<0)return""+e;var s=this._backrefLabels[t];if(!s.useLabel){s.useLabel=!0,s.label=this._nameResolver.getLabel(this._labelIndex);var a=this._lines[s.line];this._lines[s.line]=a.substring(0,s.position)+" "+s.label+a.substring(s.position),this._labelIndex++}return s.label||""+e}printOperator(e){var t=e.code;switch(this.appendBuffer(OperatorCodeNames[t]),t){case 2:case 3:case 4:if(this._labelMode!==LabelMode.Depth){const e={line:this._lines.length,position:this._buffer.length,useLabel:!1,label:null};this._labelMode===LabelMode.Always&&(e.useLabel=!0,e.label=this._nameResolver.getLabel(this._labelIndex++),e.label&&(this.appendBuffer(" "),this.appendBuffer(e.label))),this._backrefLabels.push(e)}this.printBlockType(e.blockType);break;case 11:if(this._labelMode===LabelMode.Depth)break;const t=this._backrefLabels.pop();t.label&&(this.appendBuffer(" "),this.appendBuffer(t.label));break;case 12:case 13:this.appendBuffer(" "),this.appendBuffer(this.useLabel(e.brDepth));break;case 14:for(var s=0;s<e.brTable.length;s++)this.appendBuffer(" "),this.appendBuffer(this.useLabel(e.brTable[s]));break;case 208:switch(e.refType){case-16:this.appendBuffer(" func");break;case-17:this.appendBuffer(" extern");break;default:throw new Error(`Unknown refedtype ${e.refType}`)}break;case 16:case 18:case 210:var a=this._nameResolver.getFunctionName(e.funcIndex,e.funcIndex<this._importCount,!0);this.appendBuffer(` ${a}`);break;case 17:case 19:this.printFuncType(e.typeIndex);break;case 32:case 33:case 34:var r=this._nameResolver.getVariableName(this._funcIndex,e.localIndex,!0);this.appendBuffer(` ${r}`);break;case 35:case 36:var n=this._nameResolver.getGlobalName(e.globalIndex,!0);this.appendBuffer(` ${n}`);break;case 40:case 41:case 42:case 43:case 44:case 45:case 46:case 47:case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:case 58:case 59:case 60:case 61:case 62:case 65024:case 65025:case 65026:case 65040:case 65041:case 65042:case 65043:case 65044:case 65045:case 65046:case 65047:case 65048:case 65049:case 65050:case 65051:case 65052:case 65053:case 65054:case 65055:case 65056:case 65057:case 65058:case 65059:case 65060:case 65061:case 65062:case 65063:case 65064:case 65065:case 65066:case 65067:case 65068:case 65069:case 65070:case 65071:case 65072:case 65073:case 65074:case 65075:case 65076:case 65077:case 65078:case 65079:case 65080:case 65081:case 65082:case 65083:case 65084:case 65085:case 65086:case 65087:case 65088:case 65089:case 65090:case 65091:case 65092:case 65093:case 65094:case 65095:case 65096:case 65097:case 65098:case 65099:case 65100:case 65101:case 65102:case 64768:case 64769:case 64770:case 64771:case 64772:case 64773:case 64774:case 64775:case 64776:case 64777:case 64778:case 64779:case 65020:case 65021:var i=memoryAddressToString(e.memoryAddress,e.code);null!==i&&(this.appendBuffer(" "),this.appendBuffer(i));break;case 63:case 64:break;case 65:case 66:this.appendBuffer(` ${e.literal.toString()}`);break;case 67:this.appendBuffer(` ${formatFloat32(e.literal)}`);break;case 68:this.appendBuffer(` ${formatFloat64(e.literal)}`);break;case 64780:this.appendBuffer(` i32x4 ${formatI32Array(e.literal,4)}`);break;case 64781:this.appendBuffer(` ${formatI8Array(e.lines,16)}`);break;case 64789:case 64790:case 64791:case 64792:case 64793:case 64794:case 64795:case 64796:case 64799:case 64800:case 64797:case 64798:case 64801:case 64802:this.appendBuffer(` ${e.lineIndex}`);break;case 64520:case 64521:this.appendBuffer(` ${e.segmentIndex}`);break;case 64525:const o=this._nameResolver.getElementName(e.segmentIndex,!0);this.appendBuffer(` ${o}`);break;case 38:case 37:case 64529:{const t=this._nameResolver.getTableName(e.tableIndex,!0);this.appendBuffer(` ${t}`);break}case 64526:if(0!==e.tableIndex||0!==e.destinationIndex){const t=this._nameResolver.getTableName(e.tableIndex,!0),s=this._nameResolver.getTableName(e.destinationIndex,!0);this.appendBuffer(` ${s} ${t}`)}break;case 64524:{if(0!==e.tableIndex){const t=this._nameResolver.getTableName(e.tableIndex,!0);this.appendBuffer(` ${t}`)}const t=this._nameResolver.getElementName(e.segmentIndex,!0);this.appendBuffer(` ${t}`);break}}}printImportSource(e){this.printString(e.module),this.appendBuffer(" "),this.printString(e.field)}increaseIndent(){this._indent+="  ",this._indentLevel++}decreaseIndent(){this._indent=this._indent.slice(0,-"  ".length),this._indentLevel--}disassemble(e){if(!this.disassembleChunk(e))return null;let t=this._lines;this._addOffsets&&(t=t.map(((e,t)=>e+" ;; @"+formatHex(this._offsets[t],4)))),t.push("");const s=t.join("\n");return this._lines.length=0,this._offsets.length=0,this._functionBodyOffsets.length=0,s}getResult(){let e=this._lines.length;if(this._backrefLabels&&this._labelMode===LabelMode.WhenUsed&&this._backrefLabels.some((t=>!t.useLabel&&(e=t.line,!0))),0===e)return{lines:[],offsets:this._addOffsets?[]:void 0,done:this._done,functionBodyOffsets:this._addOffsets?[]:void 0};if(e===this._lines.length){const e={lines:this._lines,offsets:this._addOffsets?this._offsets:void 0,done:this._done,functionBodyOffsets:this._addOffsets?this._functionBodyOffsets:void 0};return this._lines=[],this._addOffsets&&(this._offsets=[],this._functionBodyOffsets=[]),e}const t={lines:this._lines.splice(0,e),offsets:this._addOffsets?this._offsets.splice(0,e):void 0,done:!1,functionBodyOffsets:this._addOffsets?this._functionBodyOffsets:void 0};return this._backrefLabels&&this._backrefLabels.forEach((t=>{t.line-=e})),t}disassembleChunk(e,t=0){if(this._done)throw new Error("Invalid state: disassembly process was already finished.");for(;;){if(this._currentPosition=e.position+t,!e.read())return!1;switch(e.state){case 2:if(this.appendBuffer(")"),this.newLine(),this._reset(),!e.hasMoreBytes())return this._done=!0,!0;break;case-1:throw e.error;case 1:this.appendBuffer("(module"),this.newLine();break;case 4:this._currentSectionId=-1;break;case 3:var s=e.result;switch(s.id){case 1:case 2:case 7:case 6:case 3:case 8:case 10:case 5:case 11:case 4:case 9:this._currentSectionId=s.id;break;default:e.skipSection()}break;case 15:var a=e.result,r=this._memoryCount++,n=this._nameResolver.getMemoryName(r,!1);if(this.appendBuffer(`  (memory ${n}`),null!==this._exportMetadata)for(const e of this._exportMetadata.getMemoryExportNames(r))this.appendBuffer(` (export "${e}")`);this.appendBuffer(` ${limitsToString(a.limits)}`),a.shared&&this.appendBuffer(" shared"),this.appendBuffer(")"),this.newLine();break;case 14:var i=e.result,o=this._tableCount++,c=this._nameResolver.getTableName(o,!1);if(this.appendBuffer(`  (table ${c}`),null!==this._exportMetadata)for(const e of this._exportMetadata.getTableExportNames(o))this.appendBuffer(` (export "${e}")`);this.appendBuffer(` ${limitsToString(i.limits)} ${typeToString(i.elementType)})`),this.newLine();break;case 17:if(null===this._exportMetadata){var h=e.result;switch(this.appendBuffer("  (export "),this.printString(h.field),this.appendBuffer(" "),h.kind){case 0:var f=this._nameResolver.getFunctionName(h.index,h.index<this._importCount,!0);this.appendBuffer(`(func ${f})`);break;case 1:c=this._nameResolver.getTableName(h.index,!0);this.appendBuffer(`(table ${c})`);break;case 2:n=this._nameResolver.getMemoryName(h.index,!0);this.appendBuffer(`(memory ${n})`);break;case 3:var l=this._nameResolver.getGlobalName(h.index,!0);this.appendBuffer(`(global ${l})`);break;default:throw new Error(`Unsupported export ${h.kind}`)}this.appendBuffer(")"),this.newLine()}break;case 12:var p=e.result;switch(p.kind){case 0:this._importCount++;var u=this._funcIndex++;f=this._nameResolver.getFunctionName(u,!0,!1);if(this.appendBuffer(`  (func ${f}`),null!==this._exportMetadata)for(const e of this._exportMetadata.getFunctionExportNames(u))this.appendBuffer(` (export "${e}")`);this.appendBuffer(" (import "),this.printImportSource(p),this.appendBuffer(")"),this.printFuncType(p.funcTypeIndex),this.appendBuffer(")");break;case 3:var d=p.type,m=this._globalCount++;l=this._nameResolver.getGlobalName(m,!1);if(this.appendBuffer(`  (global ${l}`),null!==this._exportMetadata)for(const e of this._exportMetadata.getGlobalExportNames(m))this.appendBuffer(` (export "${e}")`);this.appendBuffer(" (import "),this.printImportSource(p),this.appendBuffer(`) ${globalTypeToString(d)})`);break;case 2:var _=p.type;r=this._memoryCount++,n=this._nameResolver.getMemoryName(r,!1);if(this.appendBuffer(`  (memory ${n}`),null!==this._exportMetadata)for(const e of this._exportMetadata.getMemoryExportNames(r))this.appendBuffer(` (export "${e}")`);this.appendBuffer(" (import "),this.printImportSource(p),this.appendBuffer(`) ${limitsToString(_.limits)}`),_.shared&&this.appendBuffer(" shared"),this.appendBuffer(")");break;case 1:var b=p.type;o=this._tableCount++,c=this._nameResolver.getTableName(o,!1);if(this.appendBuffer(`  (table ${c}`),null!==this._exportMetadata)for(const e of this._exportMetadata.getTableExportNames(o))this.appendBuffer(` (export "${e}")`);this.appendBuffer(" (import "),this.printImportSource(p),this.appendBuffer(`) ${limitsToString(b.limits)} ${typeToString(b.elementType)})`);break;default:throw new Error(`NYI other import types: ${p.kind}`)}this.newLine();break;case 33:var N=e.result,g=this._elementCount++,x=this._nameResolver.getElementName(g,!1);switch(this.appendBuffer(`  (elem ${x}`),N.mode){case 0:if(0!==N.tableIndex){const e=this._nameResolver.getTableName(N.tableIndex,!1);this.appendBuffer(` (table ${e})`)}break;case 1:break;case 2:this.appendBuffer(" declare")}break;case 35:this.appendBuffer(")"),this.newLine();break;case 34:const t=e.result;this.appendBuffer(` ${typeToString(t.elementType)}`);break;case 39:var y=e.result;m=this._globalCount++,l=this._nameResolver.getGlobalName(m,!1);if(this.appendBuffer(`  (global ${l}`),null!==this._exportMetadata)for(const e of this._exportMetadata.getGlobalExportNames(m))this.appendBuffer(` (export "${e}")`);this.appendBuffer(` ${globalTypeToString(y.type)}`);break;case 40:this.appendBuffer(")"),this.newLine();break;case 11:var B=e.result,k=this._types.length;if(this._types.push(B),!this._skipTypes){var v=this._nameResolver.getTypeName(k,!1);this.appendBuffer(`  (type ${v} (func`),this.printFuncType(k),this.appendBuffer("))"),this.newLine()}break;case 22:var $=e.result;f=this._nameResolver.getFunctionName($.index,$.index<this._importCount,!0);this.appendBuffer(`  (start ${f})`),this.newLine();break;case 36:this.appendBuffer("  (data");break;case 37:var E=e.result;this.appendBuffer(" "),this.printString(E.data);break;case 38:this.appendBuffer(")"),this.newLine();break;case 25:case 44:this._expression=[];break;case 26:case 45:11!==(R=e.result).code&&this._expression.push(R);break;case 46:this._expression.length>1?(this.appendBuffer(" (offset "),this.printExpression(this._expression),this.appendBuffer(")")):(this.appendBuffer(" "),this.printExpression(this._expression)),this._expression=[];break;case 27:this._expression.length>1&&9===this._currentSectionId?(this.appendBuffer(" (item "),this.printExpression(this._expression),this.appendBuffer(")")):(this.appendBuffer(" "),this.printExpression(this._expression)),this._expression=[];break;case 13:this._funcTypes.push(e.result.typeIndex);break;case 28:var T=e.result,w=this._types[this._funcTypes[this._funcIndex-this._importCount]];if(this.appendBuffer("  (func "),this.appendBuffer(this._nameResolver.getFunctionName(this._funcIndex,!1,!1)),null!==this._exportMetadata)for(const e of this._exportMetadata.getFunctionExportNames(this._funcIndex))this.appendBuffer(` (export "${e}")`);for(var I=0;I<w.params.length;I++){var S=this._nameResolver.getVariableName(this._funcIndex,I,!1);this.appendBuffer(` (param ${S} ${typeToString(w.params[I])})`)}for(I=0;I<w.returns.length;I++)this.appendBuffer(` (result ${typeToString(w.returns[I])})`);this.newLine();var L=w.params.length;if(T.locals.length>0){for(var M of(this.appendBuffer("   "),T.locals))for(I=0;I<M.count;I++){S=this._nameResolver.getVariableName(this._funcIndex,L++,!1);this.appendBuffer(` (local ${S} ${typeToString(M.type)})`)}this.newLine()}this._indent="    ",this._indentLevel=0,this._labelIndex=0,this._backrefLabels=this._labelMode===LabelMode.Depth?null:[],this._logFirstInstruction=!0;break;case 30:var R;if(this._logFirstInstruction&&(this.logStartOfFunctionBodyOffset(),this._logFirstInstruction=!1),11==(R=e.result).code&&0==this._indentLevel){this.appendBuffer("  )"),this.newLine();break}switch(R.code){case 11:case 5:this.decreaseIndent()}switch(this.appendBuffer(this._indent),this.printOperator(R),this.newLine(),R.code){case 4:case 2:case 3:case 5:this.increaseIndent()}break;case 31:this._funcIndex++,this._backrefLabels=null,this.logEndOfFunctionBodyOffset();break;default:throw new Error(`Expectected state: ${e.state}`)}}}}const UNKNOWN_FUNCTION_PREFIX="unknown";class NameSectionNameResolver extends DefaultNameResolver{constructor(e,t,s,a,r,n){super(),this._functionNames=e,this._localNames=t,this._typeNames=s,this._tableNames=a,this._memoryNames=r,this._globalNames=n}getTypeName(e,t){const s=this._typeNames[e];return s?t?`$${s}`:`$${s} (;${e};)`:super.getTypeName(e,t)}getTableName(e,t){const s=this._tableNames[e];return s?t?`$${s}`:`$${s} (;${e};)`:super.getTableName(e,t)}getMemoryName(e,t){const s=this._memoryNames[e];return s?t?`$${s}`:`$${s} (;${e};)`:super.getMemoryName(e,t)}getGlobalName(e,t){const s=this._globalNames[e];return s?t?`$${s}`:`$${s} (;${e};)`:super.getGlobalName(e,t)}getFunctionName(e,t,s){const a=this._functionNames[e];return a?s?`$${a}`:`$${a} (;${e};)`:`$unknown${e}`}getVariableName(e,t,s){const a=this._localNames[e]&&this._localNames[e][t];return a?s?`$${a}`:`$${a} (;${t};)`:super.getVariableName(e,t,s)}}export class NameSectionReader{constructor(){this._done=!1,this._functionsCount=0,this._functionImportsCount=0,this._functionNames=null,this._functionLocalNames=null,this._typeNames=null,this._tableNames=null,this._memoryNames=null,this._globalNames=null,this._hasNames=!1}read(e){if(this._done)throw new Error("Invalid state: disassembly process was already finished.");for(;;){if(!e.read())return!1;switch(e.state){case 2:if(!e.hasMoreBytes())return this._done=!0,!0;break;case-1:throw e.error;case 1:this._functionsCount=0,this._functionImportsCount=0,this._functionNames=[],this._functionLocalNames=[],this._typeNames=[],this._tableNames=[],this._memoryNames=[],this._globalNames=[],this._hasNames=!1;break;case 4:break;case 3:var t=e.result;if(0===t.id&&"name"===bytesToString(t.name))break;if(3===t.id||2===t.id)break;e.skipSection();break;case 12:0===e.result.kind&&this._functionImportsCount++;break;case 13:this._functionsCount++;break;case 19:const s=e.result;if(1===s.type){const{names:e}=s;e.forEach((({index:e,name:t})=>{this._functionNames[e]=bytesToString(t)})),this._hasNames=!0}else if(2===s.type){const{funcs:e}=s;e.forEach((({index:e,locals:t})=>{const s=this._functionLocalNames[e]=[];t.forEach((({index:e,name:t})=>{s[e]=bytesToString(t)}))})),this._hasNames=!0}else if(4===s.type){const{names:e}=s;e.forEach((({index:e,name:t})=>{this._typeNames[e]=bytesToString(t)})),this._hasNames=!0}else if(5===s.type){const{names:e}=s;e.forEach((({index:e,name:t})=>{this._tableNames[e]=bytesToString(t)})),this._hasNames=!0}else if(6===s.type){const{names:e}=s;e.forEach((({index:e,name:t})=>{this._memoryNames[e]=bytesToString(t)})),this._hasNames=!0}else if(7===s.type){const{names:e}=s;e.forEach((({index:e,name:t})=>{this._globalNames[e]=bytesToString(t)})),this._hasNames=!0}break;default:throw new Error(`Expectected state: ${e.state}`)}}}hasValidNames(){return this._hasNames}getNameResolver(){if(!this.hasValidNames())throw new Error("Has no valid name section");const e=this._functionImportsCount+this._functionsCount,t=this._functionNames.slice(0,e),s=Object.create(null);for(let a=0;a<t.length;a++){const e=t[a];if(!e)continue;!(e in s)&&isValidName(e)&&0!==e.indexOf("unknown")?s[e]=a:(s[e]>=0&&(t[s[e]]=null,s[e]=-1),t[a]=null)}return new NameSectionNameResolver(t,this._functionLocalNames,this._typeNames,this._tableNames,this._memoryNames,this._globalNames)}}export class DevToolsNameResolver extends NameSectionNameResolver{constructor(e,t,s,a,r,n){super(e,t,s,a,r,n)}getFunctionName(e,t,s){const a=this._functionNames[e];return a?s?`$${a}`:`$${a} (;${e};)`:t?`$import${e}`:`$func${e}`}}export class DevToolsNameGenerator{constructor(){this._done=!1,this._functionImportsCount=0,this._memoryImportsCount=0,this._tableImportsCount=0,this._globalImportsCount=0,this._functionNames=null,this._functionLocalNames=null,this._memoryNames=null,this._typeNames=null,this._tableNames=null,this._globalNames=null,this._functionExportNames=null,this._globalExportNames=null,this._memoryExportNames=null,this._tableExportNames=null}_addExportName(e,t,s){const a=e[t];a?a.push(s):e[t]=[s]}_setName(e,t,s,a){if(s)if(a){if(!isValidName(s))return;e[t]=s}else e[t]||(e[t]=s.replace(INVALID_NAME_SYMBOLS_REGEX_GLOBAL,"_"))}read(e){if(this._done)throw new Error("Invalid state: disassembly process was already finished.");for(;;){if(!e.read())return!1;switch(e.state){case 2:if(!e.hasMoreBytes())return this._done=!0,!0;break;case-1:throw e.error;case 1:this._functionImportsCount=0,this._memoryImportsCount=0,this._tableImportsCount=0,this._globalImportsCount=0,this._functionNames=[],this._functionLocalNames=[],this._memoryNames=[],this._typeNames=[],this._tableNames=[],this._globalNames=[],this._functionExportNames=[],this._globalExportNames=[],this._memoryExportNames=[],this._tableExportNames=[];break;case 4:break;case 3:var t=e.result;if(0===t.id&&"name"===bytesToString(t.name))break;switch(t.id){case 2:case 7:break;default:e.skipSection()}break;case 12:var s=e.result;const r=`${bytesToString(s.module)}.${bytesToString(s.field)}`;switch(s.kind){case 0:this._setName(this._functionNames,this._functionImportsCount++,r,!1);break;case 1:this._setName(this._tableNames,this._tableImportsCount++,r,!1);break;case 2:this._setName(this._memoryNames,this._memoryImportsCount++,r,!1);break;case 3:this._setName(this._globalNames,this._globalImportsCount++,r,!1);break;default:throw new Error(`Unsupported export ${s.kind}`)}break;case 19:const n=e.result;if(1===n.type){const{names:e}=n;e.forEach((({index:e,name:t})=>{this._setName(this._functionNames,e,bytesToString(t),!0)}))}else if(2===n.type){const{funcs:e}=n;e.forEach((({index:e,locals:t})=>{const s=this._functionLocalNames[e]=[];t.forEach((({index:e,name:t})=>{s[e]=bytesToString(t)}))}))}else if(4===n.type){const{names:e}=n;e.forEach((({index:e,name:t})=>{this._setName(this._typeNames,e,bytesToString(t),!0)}))}else if(5===n.type){const{names:e}=n;e.forEach((({index:e,name:t})=>{this._setName(this._tableNames,e,bytesToString(t),!0)}))}else if(6===n.type){const{names:e}=n;e.forEach((({index:e,name:t})=>{this._setName(this._memoryNames,e,bytesToString(t),!0)}))}else if(7===n.type){const{names:e}=n;e.forEach((({index:e,name:t})=>{this._setName(this._globalNames,e,bytesToString(t),!0)}))}break;case 17:var a=e.result;const i=bytesToString(a.field);switch(a.kind){case 0:this._addExportName(this._functionExportNames,a.index,i),this._setName(this._functionNames,a.index,i,!1);break;case 3:this._addExportName(this._globalExportNames,a.index,i),this._setName(this._globalNames,a.index,i,!1);break;case 2:this._addExportName(this._memoryExportNames,a.index,i),this._setName(this._memoryNames,a.index,i,!1);break;case 1:this._addExportName(this._tableExportNames,a.index,i),this._setName(this._tableNames,a.index,i,!1);break;default:throw new Error(`Unsupported export ${a.kind}`)}break;default:throw new Error(`Expectected state: ${e.state}`)}}}getExportMetadata(){return new DevToolsExportMetadata(this._functionExportNames,this._globalExportNames,this._memoryExportNames,this._tableExportNames)}getNameResolver(){return new DevToolsNameResolver(this._functionNames,this._functionLocalNames,this._typeNames,this._tableNames,this._memoryNames,this._globalNames)}}