import*as Common from"../common/common.js";import*as Host from"../host/host.js";import*as i18n from"../i18n/i18n.js";import*as PerfUI from"../perf_ui/perf_ui.js";import*as Platform from"../platform/platform.js";import*as ThemeSupport from"../theme_support/theme_support.js";import*as UI from"../ui/ui.js";import{FlameChartStyle,Selection}from"./TimelineFlameChartView.js";import{TimelineSelection}from"./TimelinePanel.js";import{TimelineUIUtils}from"./TimelineUIUtils.js";const UIStrings={network:"Network"},str_=i18n.i18n.registerUIStrings("timeline/TimelineFlameChartNetworkDataProvider.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class TimelineFlameChartNetworkDataProvider{constructor(){this._font="11px "+Host.Platform.fontFamily(),this.setModel(null),this._style={padding:4,height:17,collapsible:!0,color:ThemeSupport.ThemeSupport.instance().patchColorText("#222",ThemeSupport.ThemeSupport.ColorUsage.Foreground),font:this._font,backgroundColor:ThemeSupport.ThemeSupport.instance().patchColorText("white",ThemeSupport.ThemeSupport.ColorUsage.Background),nestingLevel:0,useFirstLineForOverview:!1,useDecoratorsForOverview:!0,shareHeaderLine:!1},this._group={startLevel:0,name:i18nString(UIStrings.network),expanded:!1,style:this._style},this._minimumBoundary=0,this._maximumBoundary=0,this._timeSpan=0,this._requests=[],this._maxLevel=0}setModel(e){this._model=e&&e.timelineModel(),this._timelineData=null}isEmpty(){return this.timelineData(),!this._requests.length}maxStackDepth(){return this._maxLevel}timelineData(){return this._timelineData||(this._requests=[],this._timelineData=new PerfUI.FlameChart.TimelineData([],[],[],[]),this._model&&this._appendTimelineData()),this._timelineData}minimumBoundary(){return this._minimumBoundary}totalTime(){return this._timeSpan}setWindowTimes(e,t){this._startTime=e,this._endTime=t,this._updateTimelineData()}createSelection(e){if(-1===e)return null;const t=this._requests[e];return this._lastSelection=new Selection(TimelineSelection.fromNetworkRequest(t),e),this._lastSelection.timelineSelection}entryIndexForSelection(e){if(!e)return-1;if(this._lastSelection&&this._lastSelection.timelineSelection.object()===e.object())return this._lastSelection.entryIndex;if(e.type()!==TimelineSelection.Type.NetworkRequest)return-1;const t=e.object(),i=this._requests.indexOf(t);return-1!==i&&(this._lastSelection=new Selection(TimelineSelection.fromNetworkRequest(t),i)),i}entryColor(e){const t=this._requests[e],i=TimelineUIUtils.networkRequestCategory(t);return TimelineUIUtils.networkCategoryColor(i)}textColor(e){return FlameChartStyle.textColor}entryTitle(e){const t=this._requests[e],i=new Common.ParsedURL.ParsedURL(t.url||"");return i.isValid?`${i.displayName} (${i.host})`:t.url||null}entryFont(e){return this._font}decorateEntry(e,t,i,r,n,o,s,l,a){const m=this._requests[e];if(!m.timing)return!1;const h=m.timing,u=m.beginTime(),p=e=>Math.floor(l+(e-u)*a),c=m.getStartTime(),d=m.endTime,{sendStartTime:_,headersEndTime:T}=m.getSendReceiveTiming(),f=Math.max(p(_),l),y=Math.max(p(T),f),S=Math.max(p(m.finishTime||d),y+2),g=p(c),x=Math.max(p(d),S);if(t.fillStyle="hsla(0, 100%, 100%, 0.8)",t.fillRect(f+.5,n+.5,y-f-.5,s-2),t.fillStyle=ThemeSupport.ThemeSupport.instance().patchColorText("white",ThemeSupport.ThemeSupport.ColorUsage.Background),t.fillRect(r,n-.5,f-r,s),t.fillRect(S,n-.5,r+o-S,s),!m.cached()&&h.pushStart){const i=p(1e3*h.pushStart),r=h.pushEnd?p(1e3*h.pushEnd):g,o=Platform.NumberUtilities.clamp(r-i-2,0,4),l=1;if(t.save(),t.beginPath(),t.moveTo(i+o,n+s/2),t.lineTo(i,n+l),t.lineTo(r-o,n+l),t.lineTo(r,n+s/2),t.lineTo(r-o,n+s-l),t.lineTo(i,n+s-l),t.closePath(),h.pushEnd)t.fillStyle=this.entryColor(e);else{const n=t.createLinearGradient(i,0,r,0);n.addColorStop(0,this.entryColor(e)),n.addColorStop(1,"white"),t.fillStyle=n}t.globalAlpha=.3,t.fill(),t.restore()}function C(e,i,r){t.moveTo(e,r-3),t.lineTo(e,r+3),t.moveTo(e,r),t.lineTo(i,r)}t.beginPath(),t.lineWidth=1,t.strokeStyle="#ccc";const v=Math.floor(n+s/2)+.5,w=x-.5;if(C(g+.5,f,v),C(w,S,v),t.stroke(),"string"===typeof m.priority){const e=this._colorForPriority(m.priority);e&&(t.fillStyle=e,t.fillRect(f+.5,n+.5,3.5,3.5))}const D=Math.max(f,0),U=S-D;if(U>=20&&(i=this.entryTitle(e)||"",m.fromServiceWorker&&(i="\u2699 "+i),i)){const e=4,r=s-5,o=UI.UIUtils.trimTextEnd(t,i,U-2*e);t.fillStyle="#333",t.fillText(o,D+e,n+r)}return!0}forceDecoration(e){return!0}prepareHighlightedEntryInfo(e){const t=this._requests[e];if(!t.url)return null;const i=document.createElement("div"),r=UI.Utils.createShadowRootWithCoreStyles(i,{cssFile:"timeline/timelineFlamechartPopover.css",enableLegacyPatching:!0,delegatesFocus:void 0}).createChild("div","timeline-flamechart-popover"),n=t.getStartTime(),o=t.endTime-n;if(n&&isFinite(o)&&(r.createChild("span","timeline-info-network-time").textContent=Number.millisToString(o,!0)),"string"===typeof t.priority){const e=r.createChild("span");e.textContent=PerfUI.NetworkPriorities.uiLabelForNetworkPriority(t.priority),e.style.color=this._colorForPriority(t.priority)||"black"}return r.createChild("span").textContent=Platform.StringUtilities.trimMiddle(t.url,80),i}_colorForPriority(e){if(!this._priorityToValue){const e=Protocol.Network.ResourcePriority;this._priorityToValue=new Map([[e.VeryLow,1],[e.Low,2],[e.Medium,3],[e.High,4],[e.VeryHigh,5]])}const t=this._priorityToValue.get(e);return t?`hsla(214, 80%, 50%, ${t/5})`:null}_appendTimelineData(){this._model&&(this._minimumBoundary=this._model.minimumRecordTime(),this._maximumBoundary=this._model.maximumRecordTime(),this._timeSpan=this._model.isEmpty()?1e3:this._maximumBoundary-this._minimumBoundary,this._model.networkRequests().forEach(this._appendEntry.bind(this)),this._updateTimelineData())}_updateTimelineData(){if(!this._timelineData)return;const e=[];let t=0;for(let i=0;i<this._requests.length;++i){const r=this._requests[i],n=r.beginTime(),o=this._startTime;if(n<this._endTime&&r.endTime>o){for(;e.length&&e[e.length-1]<=n;)e.pop();this._timelineData.entryLevels[i]=e.length,e.push(r.endTime),t=Math.max(t,e.length)}else this._timelineData.entryLevels[i]=-1}for(let i=0;i<this._requests.length;++i)-1===this._timelineData.entryLevels[i]&&(this._timelineData.entryLevels[i]=t);this._timelineData=new PerfUI.FlameChart.TimelineData(this._timelineData.entryLevels,this._timelineData.entryTotalTimes,this._timelineData.entryStartTimes,[this._group]),this._maxLevel=t}_appendEntry(e){this._requests.push(e),this._timelineData.entryStartTimes.push(e.beginTime()),this._timelineData.entryTotalTimes.push(e.endTime-e.beginTime()),this._timelineData.entryLevels.push(this._requests.length-1)}preferredHeight(){return this._style.height*(this._group.expanded?Platform.NumberUtilities.clamp(this._maxLevel+1,4,8.5):1)}isExpanded(){return this._group&&Boolean(this._group.expanded)}formatValue(e,t){return Number.preciseMillisToString(e,t)}canJumpToEntry(e){return!1}navStartTimes(){return this._model?this._model.navStartTimes():new Map}}