import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";const UIStrings={twoFlingsAtTheSameTimeSVsS:"Two flings at the same time? {PH1} vs {PH2}",twoTouchesAtTheSameTimeSVsS:"Two touches at the same time? {PH1} vs {PH2}"},str_=i18n.i18n.registerUIStrings("timeline_model/TimelineIRModel.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_),eventToPhase=new WeakMap;export class TimelineIRModel{constructor(){this.reset()}static phaseForEvent(e){return eventToPhase.get(e)}populate(e,n){if(this.reset(),!e)return;this._processInputLatencies(e),n&&this._processAnimations(n);const s=new Common.SegmentedRange.SegmentedRange;s.appendRange(this._drags),s.appendRange(this._cssAnimations),s.appendRange(this._scrolls),s.appendRange(this._responses),this._segments=s.segments()}_processInputLatencies(e){const n=InputEvents,s=Phases,t=TimelineIRModel._mergeThresholdsMs;let o,r,i,a,l,m,c;for(let g=0;g<e.length;++g){const p=e[g];g>0&&e[g].startTime<e[g-1].startTime&&console.assert(!1,"Unordered input events");switch(this._inputEventType(p.name)){case n.ScrollBegin:this._scrolls.append(this._segmentForEvent(p,s.Scroll)),o=p;break;case n.ScrollEnd:o?this._scrolls.append(this._segmentForEventRange(o,p,s.Scroll)):this._scrolls.append(this._segmentForEvent(p,s.Scroll)),o=null;break;case n.ScrollUpdate:i=null,this._scrolls.append(this._segmentForEvent(p,s.Scroll));break;case n.FlingStart:if(r){Common.Console.Console.instance().error(i18nString(UIStrings.twoFlingsAtTheSameTimeSVsS,{PH1:r.startTime,PH2:p.startTime}));break}r=p;break;case n.FlingCancel:if(!r)break;this._scrolls.append(this._segmentForEventRange(r,p,s.Fling)),r=null;break;case n.ImplSideFling:this._scrolls.append(this._segmentForEvent(p,s.Fling));break;case n.ShowPress:case n.Tap:case n.KeyDown:case n.KeyDownRaw:case n.KeyUp:case n.Char:case n.Click:case n.ContextMenu:this._responses.append(this._segmentForEvent(p,s.Response));break;case n.TouchStart:if(i){Common.Console.Console.instance().error(i18nString(UIStrings.twoTouchesAtTheSameTimeSVsS,{PH1:i.startTime,PH2:p.startTime}));break}i=p,this._setPhaseForEvent(p,s.Response),a=null;break;case n.TouchCancel:i=null;break;case n.TouchMove:a?this._drags.append(this._segmentForEvent(p,s.Drag)):i&&(a=p,this._responses.append(this._segmentForEventRange(i,p,s.Response)));break;case n.TouchEnd:i=null;break;case n.MouseDown:m=p,c=null;break;case n.MouseMove:m&&!c&&m.startTime+t.mouse>p.startTime?(this._responses.append(this._segmentForEvent(m,s.Response)),this._responses.append(this._segmentForEvent(p,s.Response))):m&&this._drags.append(this._segmentForEvent(p,s.Drag)),c=p;break;case n.MouseUp:this._responses.append(this._segmentForEvent(p,s.Response)),m=null;break;case n.MouseWheel:l&&h(t.mouse,l,p)?this._scrolls.append(this._segmentForEventRange(l,p,s.Scroll)):this._scrolls.append(this._segmentForEvent(p,s.Scroll)),l=p}}function h(e,n,s){return void 0!==n.endTime&&(n.endTime<s.startTime&&s.startTime<n.endTime+e)}}_processAnimations(e){for(let n=0;n<e.length;++n)this._cssAnimations.append(this._segmentForEvent(e[n],Phases.Animation))}_segmentForEvent(e,n){return this._setPhaseForEvent(e,n),new Common.SegmentedRange.Segment(e.startTime,void 0!==e.endTime?e.endTime:Number.MAX_SAFE_INTEGER,n)}_segmentForEventRange(e,n,s){return this._setPhaseForEvent(e,s),this._setPhaseForEvent(n,s),new Common.SegmentedRange.Segment(e.startTime,void 0!==e.endTime?e.endTime:Number.MAX_SAFE_INTEGER,s)}_setPhaseForEvent(e,n){eventToPhase.set(e.steps[0],n)}interactionRecords(){return this._segments}reset(){const e=TimelineIRModel._mergeThresholdsMs;function n(e,n,s){return n.end+e>=s.begin&&n.data===s.data?n:null}this._segments=[],this._drags=new Common.SegmentedRange.SegmentedRange(n.bind(null,e.mouse)),this._cssAnimations=new Common.SegmentedRange.SegmentedRange(n.bind(null,e.animation)),this._responses=new Common.SegmentedRange.SegmentedRange(n.bind(null,0)),this._scrolls=new Common.SegmentedRange.SegmentedRange(n.bind(null,e.animation))}_inputEventType(e){const n="InputLatency::";if(!e.startsWith(n)){const n=e;return n===InputEvents.ImplSideFling?n:(console.error("Unrecognized input latency event: "+e),null)}return e.substr(n.length)}}export var Phases;!function(e){e.Idle="Idle",e.Response="Response",e.Scroll="Scroll",e.Fling="Fling",e.Drag="Drag",e.Animation="Animation",e.Uncategorized="Uncategorized"}(Phases||(Phases={}));export var InputEvents;!function(e){e.Char="Char",e.Click="GestureClick",e.ContextMenu="ContextMenu",e.FlingCancel="GestureFlingCancel",e.FlingStart="GestureFlingStart",e.ImplSideFling="InputHandlerProxy::HandleGestureFling::started",e.KeyDown="KeyDown",e.KeyDownRaw="RawKeyDown",e.KeyUp="KeyUp",e.LatencyScrollUpdate="ScrollUpdate",e.MouseDown="MouseDown",e.MouseMove="MouseMove",e.MouseUp="MouseUp",e.MouseWheel="MouseWheel",e.PinchBegin="GesturePinchBegin",e.PinchEnd="GesturePinchEnd",e.PinchUpdate="GesturePinchUpdate",e.ScrollBegin="GestureScrollBegin",e.ScrollEnd="GestureScrollEnd",e.ScrollUpdate="GestureScrollUpdate",e.ScrollUpdateRenderer="ScrollUpdate",e.ShowPress="GestureShowPress",e.Tap="GestureTap",e.TapCancel="GestureTapCancel",e.TapDown="GestureTapDown",e.TouchCancel="TouchCancel",e.TouchEnd="TouchEnd",e.TouchMove="TouchMove",e.TouchStart="TouchStart"}(InputEvents||(InputEvents={})),function(e){e._mergeThresholdsMs={animation:1,mouse:40},e._eventIRPhase=Symbol("eventIRPhase")}(TimelineIRModel||(TimelineIRModel={}));