import*as Common from"../common/common.js";import*as i18n from"../i18n/i18n.js";import*as ARIAUtils from"./ARIAUtils.js";import{HistoryInput}from"./HistoryInput.js";import{InspectorView}from"./InspectorView.js";import{Toolbar,ToolbarButton,ToolbarToggle}from"./Toolbar.js";import{Tooltip}from"./Tooltip.js";import{createTextButton}from"./UIUtils.js";import{VBox}from"./Widget.js";const UIStrings={replace:"Replace",findString:"Find",searchPrevious:"Search previous",searchNext:"Search next",matchCase:"Match Case",useRegularExpression:"Use Regular Expression",cancel:"Cancel",replaceAll:"Replace all",dOfD:"{PH1} of {PH2}",matchString:"1 match",dMatches:"{PH1} matches"},str_=i18n.i18n.registerUIStrings("ui/SearchableView.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class SearchableView extends VBox{constructor(e,t,s){super(!0),this.registerRequiredCSS("ui/searchableView.css",{enableLegacyPatching:!0}),searchableViewsByElement.set(this.element,this),this._searchProvider=e,this._replaceProvider=t,this._setting=s?Common.Settings.Settings.instance().createSetting(s,{}):null,this._replaceable=!1,this.contentElement.createChild("slot"),this._footerElementContainer=this.contentElement.createChild("div","search-bar hidden"),this._footerElementContainer.style.order="100",this._footerElement=this._footerElementContainer.createChild("div","toolbar-search");const i=new Toolbar("replace-toggle-toolbar",this._footerElement);this._replaceToggleButton=new ToolbarToggle(i18nString(UIStrings.replace),"mediumicon-replace"),this._replaceToggleButton.addEventListener(ToolbarButton.Events.Click,this._toggleReplace,this),i.appendToolbarItem(this._replaceToggleButton);const r=this._footerElement.createChild("div","toolbar-search-inputs"),n=r.createChild("div","toolbar-search-control");this._searchInputElement=HistoryInput.create(),this._searchInputElement.type="search",this._searchInputElement.classList.add("search-replace","custom-search-input"),this._searchInputElement.id="search-input-field",this._searchInputElement.placeholder=i18nString(UIStrings.findString),n.appendChild(this._searchInputElement),this._matchesElement=n.createChild("label","search-results-matches"),this._matchesElement.setAttribute("for","search-input-field");const a=n.createChild("div","toolbar-search-navigation-controls");this._searchNavigationPrevElement=a.createChild("div","toolbar-search-navigation toolbar-search-navigation-prev"),this._searchNavigationPrevElement.addEventListener("click",this._onPrevButtonSearch.bind(this),!1),Tooltip.install(this._searchNavigationPrevElement,i18nString(UIStrings.searchPrevious)),ARIAUtils.setAccessibleName(this._searchNavigationPrevElement,i18nString(UIStrings.searchPrevious)),this._searchNavigationNextElement=a.createChild("div","toolbar-search-navigation toolbar-search-navigation-next"),this._searchNavigationNextElement.addEventListener("click",this._onNextButtonSearch.bind(this),!1),Tooltip.install(this._searchNavigationNextElement,i18nString(UIStrings.searchNext)),ARIAUtils.setAccessibleName(this._searchNavigationNextElement,i18nString(UIStrings.searchNext)),this._searchInputElement.addEventListener("keydown",this._onSearchKeyDown.bind(this),!0),this._searchInputElement.addEventListener("input",this._onInput.bind(this),!1),this._replaceInputElement=r.createChild("input","search-replace toolbar-replace-control hidden"),this._replaceInputElement.addEventListener("keydown",this._onReplaceKeyDown.bind(this),!0),this._replaceInputElement.placeholder=i18nString(UIStrings.replace),this._buttonsContainer=this._footerElement.createChild("div","toolbar-search-buttons");const h=this._buttonsContainer.createChild("div","first-row-buttons"),o=new Toolbar("toolbar-search-options",h);this._searchProvider.supportsCaseSensitiveSearch()&&(this._caseSensitiveButton=new ToolbarToggle(i18nString(UIStrings.matchCase)),this._caseSensitiveButton.setText("Aa"),this._caseSensitiveButton.addEventListener(ToolbarButton.Events.Click,this._toggleCaseSensitiveSearch,this),o.appendToolbarItem(this._caseSensitiveButton)),this._searchProvider.supportsRegexSearch()&&(this._regexButton=new ToolbarToggle(i18nString(UIStrings.useRegularExpression)),this._regexButton.setText(".*"),this._regexButton.addEventListener(ToolbarButton.Events.Click,this._toggleRegexSearch,this),o.appendToolbarItem(this._regexButton));const c=createTextButton(i18nString(UIStrings.cancel),this.closeSearch.bind(this),"search-action-button");h.appendChild(c),this._secondRowButtons=this._buttonsContainer.createChild("div","second-row-buttons hidden"),this._replaceButtonElement=createTextButton(i18nString(UIStrings.replace),this._replace.bind(this),"search-action-button"),this._replaceButtonElement.disabled=!0,this._secondRowButtons.appendChild(this._replaceButtonElement),this._replaceAllButtonElement=createTextButton(i18nString(UIStrings.replaceAll),this._replaceAll.bind(this),"search-action-button"),this._secondRowButtons.appendChild(this._replaceAllButtonElement),this._replaceAllButtonElement.disabled=!0,this._minimalSearchQuerySize=3,this._loadSetting()}static fromElement(e){let t=null;for(;e&&!t;)t=searchableViewsByElement.get(e)||null,e=e.parentElementOrShadowHost();return t}_toggleCaseSensitiveSearch(){this._caseSensitiveButton&&this._caseSensitiveButton.setToggled(!this._caseSensitiveButton.toggled()),this._saveSetting(),this._performSearch(!1,!0)}_toggleRegexSearch(){this._regexButton&&this._regexButton.setToggled(!this._regexButton.toggled()),this._saveSetting(),this._performSearch(!1,!0)}_toggleReplace(){this._replaceToggleButton.setToggled(!this._replaceToggleButton.toggled()),this._updateSecondRowVisibility()}_saveSetting(){if(!this._setting)return;const e=this._setting.get()||{};this._caseSensitiveButton&&(e.caseSensitive=this._caseSensitiveButton.toggled()),this._regexButton&&(e.isRegex=this._regexButton.toggled()),this._setting.set(e)}_loadSetting(){const e=this._setting&&this._setting.get()||{};this._searchProvider.supportsCaseSensitiveSearch()&&this._caseSensitiveButton&&this._caseSensitiveButton.setToggled(Boolean(e.caseSensitive)),this._searchProvider.supportsRegexSearch()&&this._regexButton&&this._regexButton.setToggled(Boolean(e.isRegex))}setMinimalSearchQuerySize(e){this._minimalSearchQuerySize=e}setPlaceholder(e,t){this._searchInputElement.placeholder=e,t&&ARIAUtils.setAccessibleName(this._searchInputElement,t)}setReplaceable(e){this._replaceable=e}updateSearchMatchesCount(e){const t=this._searchProvider;t.currentSearchMatches!==e&&(t.currentSearchMatches=e,this._updateSearchMatchesCountAndCurrentMatchIndex(t.currentQuery?e:0,-1))}updateCurrentMatchIndex(e){const t=this._searchProvider;this._updateSearchMatchesCountAndCurrentMatchIndex(t.currentSearchMatches,e)}isSearchVisible(){return Boolean(this._searchIsVisible)}closeSearch(){this.cancelSearch(),this._footerElementContainer.hasFocus()&&this.focus()}_toggleSearchBar(e){this._footerElementContainer.classList.toggle("hidden",!e),this.doResize()}cancelSearch(){this._searchIsVisible&&(this.resetSearch(),delete this._searchIsVisible,this._toggleSearchBar(!1))}resetSearch(){this._clearSearch(),this._updateReplaceVisibility(),this._matchesElement.textContent=""}refreshSearch(){this._searchIsVisible&&(this.resetSearch(),this._performSearch(!1,!1))}handleFindNextShortcut(){return!!this._searchIsVisible&&(this._searchProvider.jumpToNextSearchResult(),!0)}handleFindPreviousShortcut(){return!!this._searchIsVisible&&(this._searchProvider.jumpToPreviousSearchResult(),!0)}handleFindShortcut(){return this.showSearchField(),!0}handleCancelSearchShortcut(){return!!this._searchIsVisible&&(this.closeSearch(),!0)}_updateSearchNavigationButtonState(e){this._replaceButtonElement.disabled=!e,this._replaceAllButtonElement.disabled=!e,this._searchNavigationPrevElement.classList.toggle("enabled",e),this._searchNavigationNextElement.classList.toggle("enabled",e)}_updateSearchMatchesCountAndCurrentMatchIndex(e,t){this._currentQuery?this._matchesElement.textContent=0===e||t>=0?i18nString(UIStrings.dOfD,{PH1:t+1,PH2:e}):1===e?i18nString(UIStrings.matchString):i18nString(UIStrings.dMatches,{PH1:e}):this._matchesElement.textContent="",this._updateSearchNavigationButtonState(e>0)}showSearchField(){let e;if(this._searchIsVisible&&this.cancelSearch(),!this._searchInputElement.hasFocus()){const t=InspectorView.instance().element.window().getSelection();t&&t.rangeCount&&(e=t.toString().replace(/\r?\n.*/,""))}this._toggleSearchBar(!0),this._updateReplaceVisibility(),e&&(this._searchInputElement.value=e),this._performSearch(!1,!1),this._searchInputElement.focus(),this._searchInputElement.select(),this._searchIsVisible=!0}_updateReplaceVisibility(){this._replaceToggleButton.setVisible(this._replaceable),this._replaceable||(this._replaceToggleButton.setToggled(!1),this._updateSecondRowVisibility())}_onSearchKeyDown(e){const t=e;if(isEscKey(t))return this.closeSearch(),void t.consume(!0);"Enter"===t.key&&(this._currentQuery?this._jumpToNextSearchResult(t.shiftKey):this._performSearch(!0,!0,t.shiftKey))}_onReplaceKeyDown(e){"Enter"===e.key&&this._replace()}_jumpToNextSearchResult(e){this._currentQuery&&(e?this._searchProvider.jumpToPreviousSearchResult():this._searchProvider.jumpToNextSearchResult())}_onNextButtonSearch(e){this._searchNavigationNextElement.classList.contains("enabled")&&(this._jumpToNextSearchResult(),this._searchInputElement.focus())}_onPrevButtonSearch(e){this._searchNavigationPrevElement.classList.contains("enabled")&&(this._jumpToNextSearchResult(!0),this._searchInputElement.focus())}_onFindClick(e){this._currentQuery?this._jumpToNextSearchResult():this._performSearch(!0,!0),this._searchInputElement.focus()}_onPreviousClick(e){this._currentQuery?this._jumpToNextSearchResult(!0):this._performSearch(!0,!0,!0),this._searchInputElement.focus()}_clearSearch(){const e=this._searchProvider;delete this._currentQuery,Boolean(e.currentQuery)&&(delete e.currentQuery,this._searchProvider.searchCanceled()),this._updateSearchMatchesCountAndCurrentMatchIndex(0,-1)}_performSearch(e,t,s){const i=this._searchInputElement.value;if(!i||!e&&i.length<this._minimalSearchQuerySize&&!this._currentQuery)return void this._clearSearch();this._currentQuery=i,this._searchProvider.currentQuery=i;const r=this._currentSearchConfig();this._searchProvider.performSearch(r,t,s)}_currentSearchConfig(){const e=this._searchInputElement.value,t=!!this._caseSensitiveButton&&this._caseSensitiveButton.toggled(),s=!!this._regexButton&&this._regexButton.toggled();return new SearchConfig(e,t,s)}_updateSecondRowVisibility(){const e=this._replaceToggleButton.toggled();this._footerElementContainer.classList.toggle("replaceable",e),this._secondRowButtons.classList.toggle("hidden",!e),this._replaceInputElement.classList.toggle("hidden",!e),e?this._replaceInputElement.focus():this._searchInputElement.focus(),this.doResize()}_replace(){if(!this._replaceProvider)throw new Error("No 'replacable' provided to SearchableView!");const e=this._currentSearchConfig();this._replaceProvider.replaceSelectionWith(e,this._replaceInputElement.value),delete this._currentQuery,this._performSearch(!0,!0)}_replaceAll(){if(!this._replaceProvider)throw new Error("No 'replacable' provided to SearchableView!");const e=this._currentSearchConfig();this._replaceProvider.replaceAllWith(e,this._replaceInputElement.value)}_onInput(e){this._valueChangedTimeoutId&&clearTimeout(this._valueChangedTimeoutId);const t=this._searchInputElement.value.length<3?200:0;this._valueChangedTimeoutId=setTimeout(this._onValueChanged.bind(this),t)}_onValueChanged(){this._searchIsVisible&&(delete this._valueChangedTimeoutId,this._performSearch(!1,!0))}}export const _symbol=Symbol("searchableView");const searchableViewsByElement=new WeakMap;export class Searchable{searchCanceled(){}performSearch(e,t,s){}jumpToNextSearchResult(){}jumpToPreviousSearchResult(){}supportsCaseSensitiveSearch(){throw new Error("not implemented yet")}supportsRegexSearch(){throw new Error("not implemented yet")}}export class Replaceable{replaceSelectionWith(e,t){}replaceAllWith(e,t){}}export class SearchConfig{constructor(e,t,s){this.query=e,this.caseSensitive=t,this.isRegex=s}toSearchRegex(e){let t=this.caseSensitive?"":"i";e&&(t+="g");const s=this.isRegex?"/"+this.query+"/":this.query;let i;try{/^\/.+\/$/.test(s)&&(i=new RegExp(s.substring(1,s.length-1),t),i.__fromRegExpQuery=!0)}catch(r){}return i||(i=createPlainTextSearchRegex(s,t)),i}}