import*as i18n from"../i18n/i18n.js";import*as Platform from"../platform/platform.js";import*as ARIAUtils from"./ARIAUtils.js";import{ContextMenu}from"./ContextMenu.js";import{Constraints,Size}from"./Geometry.js";import{Icon}from"./Icon.js";import{Toolbar}from"./Toolbar.js";import{Tooltip}from"./Tooltip.js";import{installDragHandle,invokeOnceAfterBatchUpdate}from"./UIUtils.js";import{VBox}from"./Widget.js";import{Events as ZoomManagerEvents,ZoomManager}from"./ZoomManager.js";const UIStrings={moreTabs:"More tabs",closeS:"Close {PH1}",close:"Close",closeOthers:"Close others",closeTabsToTheRight:"Close tabs to the right",closeAll:"Close all"},str_=i18n.i18n.registerUIStrings("ui/TabbedPane.js",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);export class TabbedPane extends VBox{constructor(){super(!0),this.registerRequiredCSS("ui/tabbedPane.css",{enableLegacyPatching:!0}),this.element.classList.add("tabbed-pane"),this.contentElement.classList.add("tabbed-pane-shadow"),this.contentElement.tabIndex=-1,this.setDefaultFocusedElement(this.contentElement),this._headerElement=this.contentElement.createChild("div","tabbed-pane-header"),this._headerContentsElement=this._headerElement.createChild("div","tabbed-pane-header-contents"),this._tabSlider=document.createElement("div"),this._tabSlider.classList.add("tabbed-pane-tab-slider"),this._tabsElement=this._headerContentsElement.createChild("div","tabbed-pane-header-tabs"),this._tabsElement.setAttribute("role","tablist"),this._tabsElement.addEventListener("keydown",this._keyDown.bind(this),!1),this._contentElement=this.contentElement.createChild("div","tabbed-pane-content"),this._contentElement.createChild("slot"),this._tabs=[],this._tabsHistory=[],this._tabsById=new Map,this._currentTabLocked=!1,this._autoSelectFirstItemOnShow=!0,this._triggerDropDownTimeout=null,this._dropDownButton=this._createDropDownButton(),this._currentDevicePixelRatio=window.devicePixelRatio,ZoomManager.instance().addEventListener(ZoomManagerEvents.ZoomChanged,this._zoomChanged,this),this.makeTabSlider()}setAccessibleName(t){ARIAUtils.setAccessibleName(this._tabsElement,t)}setCurrentTabLocked(t){this._currentTabLocked=t,this._headerElement.classList.toggle("locked",this._currentTabLocked)}setAutoSelectFirstItemOnShow(t){this._autoSelectFirstItemOnShow=t}get visibleView(){return this._currentTab?this._currentTab.view:null}tabIds(){return this._tabs.map((t=>t._id))}tabIndex(t){return this._tabs.findIndex((e=>e.id===t))}tabViews(){return this._tabs.map((t=>t.view))}tabView(t){const e=this._tabsById.get(t);return e?e.view:null}get selectedTabId(){return this._currentTab?this._currentTab.id:null}setShrinkableTabs(t){this._shrinkableTabs=t}makeVerticalTabLayout(){this._verticalTabLayout=!0,this._setTabSlider(!1),this.contentElement.classList.add("vertical-tab-layout"),this.invalidateConstraints()}setCloseableTabs(t){this._closeableTabs=t}focus(){this.visibleView?this.visibleView.focus():this.contentElement.focus()}focusSelectedTabHeader(){const t=this._currentTab;t&&t.tabElement.focus()}headerElement(){return this._headerElement}isTabCloseable(t){const e=this._tabsById.get(t);return!!e&&e.isCloseable()}setTabDelegate(t){const e=this._tabs.slice();for(let s=0;s<e.length;++s)e[s].setDelegate(t);this._delegate=t}appendTab(t,e,s,i,n,a,o){const l="boolean"===typeof a?a:Boolean(this._closeableTabs),r=new TabbedPaneTab(this,t,e,l,s,i);r.setDelegate(this._delegate),console.assert(!this._tabsById.has(t),`Tabbed pane already contains a tab with id '${t}'`),this._tabsById.set(t,r),void 0!==o?this._tabs.splice(o,0,r):this._tabs.push(r),this._tabsHistory.push(r),this._tabsHistory[0]===r&&this.isShowing()&&this.selectTab(r.id,n),this._updateTabElements()}closeTab(t,e){this.closeTabs([t],e)}closeTabs(t,e){const s=this.hasFocus();for(let i=0;i<t.length;++i)this._innerCloseTab(t[i],e);this._updateTabElements(),this._tabsHistory.length&&this.selectTab(this._tabsHistory[0].id,!1),s&&this.focus()}_innerCloseTab(t,e){const s=this._tabsById.get(t);if(!s)return;if(e&&!s._closeable)return;this._currentTab&&this._currentTab.id===t&&this._hideCurrentTab(),this._tabsById.delete(t),this._tabsHistory.splice(this._tabsHistory.indexOf(s),1),this._tabs.splice(this._tabs.indexOf(s),1),s._shown&&this._hideTabElement(s);const i={prevTabId:void 0,tabId:t,view:s.view,isUserGesture:e};return this.dispatchEventToListeners(Events.TabClosed,i),!0}hasTab(t){return this._tabsById.has(t)}otherTabs(t){const e=[];for(let s=0;s<this._tabs.length;++s)this._tabs[s].id!==t&&e.push(this._tabs[s].id);return e}_tabsToTheRight(t){let e=-1;for(let s=0;s<this._tabs.length;++s)if(this._tabs[s].id===t){e=s;break}return-1===e?[]:this._tabs.slice(e+1).map((function(t){return t.id}))}_viewHasFocus(){if(this.visibleView&&this.visibleView.hasFocus())return!0;const t=this.contentElement.getComponentRoot();return t instanceof Document&&this.contentElement===t.activeElement}selectTab(t,e,s){if(this._currentTabLocked)return!1;const i=this._viewHasFocus(),n=this._tabsById.get(t);if(!n)return!1;const a={prevTabId:this._currentTab?this._currentTab.id:void 0,tabId:t,view:n.view,isUserGesture:e};return this.dispatchEventToListeners(Events.TabInvoked,a),this._currentTab&&this._currentTab.id===t||(this.suspendInvalidations(),this._hideCurrentTab(),this._showTab(n),this.resumeInvalidations(),this._currentTab=n,this._tabsHistory.splice(this._tabsHistory.indexOf(n),1),this._tabsHistory.splice(0,0,n),this._updateTabElements(),(i||s)&&this.focus(),this.dispatchEventToListeners(Events.TabSelected,a)),!0}selectNextTab(){const t=this._tabs.indexOf(this._currentTab),e=Platform.NumberUtilities.mod(t+1,this._tabs.length);this.selectTab(this._tabs[e].id,!0)}selectPrevTab(){const t=this._tabs.indexOf(this._currentTab),e=Platform.NumberUtilities.mod(t-1,this._tabs.length);this.selectTab(this._tabs[e].id,!0)}lastOpenedTabIds(t){return this._tabsHistory.slice(0,t).map((function(t){return t.id}))}setTabIcon(t,e){const s=this._tabsById.get(t);s&&(s._setIcon(e),this._updateTabElements())}setTabEnabled(t,e){const s=this._tabsById.get(t);s&&s.tabElement.classList.toggle("disabled",!e)}toggleTabClass(t,e,s){const i=this._tabsById.get(t);i&&i._toggleClass(e,s)&&this._updateTabElements()}_zoomChanged(t){this._clearMeasuredWidths(),this.isShowing()&&this._updateTabElements()}_clearMeasuredWidths(){for(let t=0;t<this._tabs.length;++t)delete this._tabs[t]._measuredWidth}changeTabTitle(t,e,s){const i=this._tabsById.get(t);i&&void 0!==s&&(i.tooltip=s),i&&i.title!==e&&(i.title=e,ARIAUtils.setAccessibleName(i.tabElement,e),this._updateTabElements())}changeTabView(t,e){const s=this._tabsById.get(t);if(!s||s.view===e)return;this.suspendInvalidations();const i=this._currentTab&&this._currentTab.id===t,n=s.view.hasFocus();i&&this._hideTab(s),s.view=e,i&&this._showTab(s),n&&s.view.focus(),this.resumeInvalidations()}onResize(){this._currentDevicePixelRatio!==window.devicePixelRatio&&(this._clearMeasuredWidths(),this._currentDevicePixelRatio=window.devicePixelRatio),this._updateTabElements()}headerResized(){this._updateTabElements()}wasShown(){const t=this._currentTab||this._tabsHistory[0];t&&this._autoSelectFirstItemOnShow&&this.selectTab(t.id)}makeTabSlider(){this._verticalTabLayout||this._setTabSlider(!0)}_setTabSlider(t){this._sliderEnabled=t,this._tabSlider.classList.toggle("enabled",t)}calculateConstraints(){let t=super.calculateConstraints();const e=new Constraints(new Size(0,0),new Size(50,50));return t=t.widthToMax(e).heightToMax(e),t=this._verticalTabLayout?t.addWidth(new Constraints(new Size(120,0))):t.addHeight(new Constraints(new Size(0,30))),t}_updateTabElements(){invokeOnceAfterBatchUpdate(this,this._innerUpdateTabElements)}setPlaceholderElement(t,e){this._placeholderElement=t,e&&(this._focusedPlaceholderElement=e),this._placeholderContainerElement&&(this._placeholderContainerElement.removeChildren(),this._placeholderContainerElement.appendChild(t))}async waitForTabElementUpdate(){this._innerUpdateTabElements()}_innerUpdateTabElements(){this.isShowing()&&(this._tabs.length?(this._contentElement.classList.remove("has-no-tabs"),this._placeholderContainerElement&&(this._placeholderContainerElement.remove(),this.setDefaultFocusedElement(this.contentElement),delete this._placeholderContainerElement)):(this._contentElement.classList.add("has-no-tabs"),this._placeholderElement&&!this._placeholderContainerElement&&(this._placeholderContainerElement=this._contentElement.createChild("div","tabbed-pane-placeholder fill"),this._placeholderContainerElement.appendChild(this._placeholderElement),this._focusedPlaceholderElement&&this.setDefaultFocusedElement(this._focusedPlaceholderElement))),this._measureDropDownButton(),this._updateWidths(),this._updateTabsDropDown(),this._updateTabSlider())}_showTabElement(t,e){t>=this._tabsElement.children.length?this._tabsElement.appendChild(e.tabElement):this._tabsElement.insertBefore(e.tabElement,this._tabsElement.children[t]),e._shown=!0}_hideTabElement(t){this._tabsElement.removeChild(t.tabElement),t._shown=!1}_createDropDownButton(){const t=document.createElement("div");t.classList.add("tabbed-pane-header-tabs-drop-down-container");const e=Icon.create("largeicon-chevron","chevron-icon");return ARIAUtils.markAsMenuButton(t),ARIAUtils.setAccessibleName(t,i18nString(UIStrings.moreTabs)),t.tabIndex=0,t.appendChild(e),t.addEventListener("click",this._dropDownClicked.bind(this)),t.addEventListener("keydown",this._dropDownKeydown.bind(this)),t.addEventListener("mousedown",(t=>{1!==t.which||this._triggerDropDownTimeout||(this._triggerDropDownTimeout=setTimeout(this._dropDownClicked.bind(this,t),200))})),t}_dropDownClicked(t){const e=t;if(1!==e.which)return;this._triggerDropDownTimeout&&(clearTimeout(this._triggerDropDownTimeout),this._triggerDropDownTimeout=null);const s=this._dropDownButton.getBoundingClientRect(),i=new ContextMenu(e,!1,s.left,s.bottom);for(const n of this._tabs)n._shown||(0===this._numberOfTabsShown()&&this._tabsHistory[0]===n?i.defaultSection().appendCheckboxItem(n.title,this._dropDownMenuItemSelected.bind(this,n),!0):i.defaultSection().appendItem(n.title,this._dropDownMenuItemSelected.bind(this,n)));i.show()}_dropDownKeydown(t){isEnterOrSpaceKey(t)&&(this._dropDownButton.click(),t.consume(!0))}_dropDownMenuItemSelected(t){this._lastSelectedOverflowTab=t,this.selectTab(t.id,!0,!0)}_totalWidth(){return this._headerContentsElement.getBoundingClientRect().width}_numberOfTabsShown(){let t=0;for(const e of this._tabs)e._shown&&t++;return t}disableOverflowMenu(){this._overflowDisabled=!0}_updateTabsDropDown(){const t=this._tabsToShowIndexes(this._tabs,this._tabsHistory,this._totalWidth(),this._measuredDropDownButtonWidth||0);if(this._lastSelectedOverflowTab&&this._numberOfTabsShown()!==t.length)return delete this._lastSelectedOverflowTab,void this._updateTabsDropDown();for(let e=0;e<this._tabs.length;++e)this._tabs[e]._shown&&-1===t.indexOf(e)&&this._hideTabElement(this._tabs[e]);for(let e=0;e<t.length;++e){const s=this._tabs[t[e]];s._shown||this._showTabElement(e,s)}this._overflowDisabled||this._maybeShowDropDown(t.length!==this._tabs.length)}_maybeShowDropDown(t){t&&!this._dropDownButton.parentElement?this._headerContentsElement.appendChild(this._dropDownButton):!t&&this._dropDownButton.parentElement&&this._headerContentsElement.removeChild(this._dropDownButton)}_measureDropDownButton(){this._overflowDisabled||this._measuredDropDownButtonWidth||(this._dropDownButton.classList.add("measuring"),this._headerContentsElement.appendChild(this._dropDownButton),this._measuredDropDownButtonWidth=this._dropDownButton.getBoundingClientRect().width,this._headerContentsElement.removeChild(this._dropDownButton),this._dropDownButton.classList.remove("measuring"))}_updateWidths(){const t=this._measureWidths(),e=this._shrinkableTabs?this._calculateMaxWidth(t.slice(),this._totalWidth()):Number.MAX_VALUE;let s=0;for(const i of this._tabs)i.setWidth(this._verticalTabLayout?-1:Math.min(e,t[s++]))}_measureWidths(){this._tabsElement.style.setProperty("width","2000px");const t=new Map;for(const s of this._tabs){if("number"===typeof s._measuredWidth)continue;const e=s._createTabElement(!0);t.set(e,s),this._tabsElement.appendChild(e)}for(const[s,i]of t){const t=s.getBoundingClientRect().width;i._measuredWidth=Math.ceil(t)}for(const s of t.keys())s.remove();const e=[];for(const s of this._tabs)e.push(s._measuredWidth||0);return this._tabsElement.style.removeProperty("width"),e}_calculateMaxWidth(t,e){if(!t.length)return 0;t.sort((function(t,e){return t-e}));let s=0;for(let n=0;n<t.length;++n)s+=t[n];if(e>=s)return t[t.length-1];let i=0;for(let n=t.length-1;n>0;--n){const a=t[n]-t[n-1];if(i+=(t.length-n)*a,e+i>=s)return t[n-1]+(e+i-s)/(t.length-n)}return e/t.length}_tabsToShowIndexes(t,e,s,i){const n=[];let a=0;const o=t.length,l=t.slice(0);void 0!==this._currentTab&&l.unshift(l.splice(l.indexOf(this._currentTab),1)[0]),void 0!==this._lastSelectedOverflowTab&&l.unshift(l.splice(l.indexOf(this._lastSelectedOverflowTab),1)[0]);for(let r=0;r<o;++r){const h=this._automaticReorder?e[r]:l[r];a+=h.width();let d=a;if(r!==o-1&&(d+=i),!this._verticalTabLayout&&d>s)break;n.push(t.indexOf(h))}return n.sort((function(t,e){return t-e})),n}_hideCurrentTab(){this._currentTab&&(this._hideTab(this._currentTab),delete this._currentTab)}_showTab(t){t.tabElement.tabIndex=0,t.tabElement.classList.add("selected"),ARIAUtils.setSelected(t.tabElement,!0),t.view.show(this.element),this._updateTabSlider()}_updateTabSlider(){if(!this._sliderEnabled)return;if(!this._currentTab)return void(this._tabSlider.style.width="0");let t=0;for(let i=0;i<this._tabs.length&&this._currentTab!==this._tabs[i];i++)this._tabs[i]._shown&&(t+=this._tabs[i]._measuredWidth||0);const e=this._currentTab._shown?this._currentTab._measuredWidth:this._dropDownButton.offsetWidth,s=window.devicePixelRatio>=1.5?" scaleY(0.75)":"";this._tabSlider.style.transform="translateX("+t+"px)"+s,this._tabSlider.style.width=e+"px",this._tabSlider.parentElement!==this._headerContentsElement&&this._headerContentsElement.appendChild(this._tabSlider)}_hideTab(t){t.tabElement.removeAttribute("tabIndex"),t.tabElement.classList.remove("selected"),t.tabElement.setAttribute("aria-selected","false"),t.view.detach()}elementsToRestoreScrollPositionsFor(){return[this._contentElement]}_insertBefore(t,e){this._tabsElement.insertBefore(t.tabElement,this._tabsElement.childNodes[e]);const s=this._tabs.indexOf(t);this._tabs.splice(s,1),s<e&&--e,this._tabs.splice(e,0,t);const i={prevTabId:void 0,tabId:t.id,view:t.view,isUserGesture:void 0};this.dispatchEventToListeners(Events.TabOrderChanged,i)}leftToolbar(){return this._leftToolbar||(this._leftToolbar=new Toolbar("tabbed-pane-left-toolbar"),this._headerElement.insertBefore(this._leftToolbar.element,this._headerElement.firstChild)),this._leftToolbar}rightToolbar(){return this._rightToolbar||(this._rightToolbar=new Toolbar("tabbed-pane-right-toolbar"),this._headerElement.appendChild(this._rightToolbar.element)),this._rightToolbar}setAllowTabReorder(t,e){this._allowTabReorder=t,this._automaticReorder=e}_keyDown(t){if(!this._currentTab)return;let e=null;switch(t.key){case"ArrowUp":case"ArrowLeft":e=this._currentTab.tabElement.previousElementSibling,e||this._dropDownButton.parentElement||(e=this._currentTab.tabElement.parentElement?this._currentTab.tabElement.parentElement.lastElementChild:null);break;case"ArrowDown":case"ArrowRight":e=this._currentTab.tabElement.nextElementSibling,e||this._dropDownButton.parentElement||(e=this._currentTab.tabElement.parentElement?this._currentTab.tabElement.parentElement.firstElementChild:null);break;case"Enter":case" ":return void this._currentTab.view.focus();default:return}if(!e)return void this._dropDownButton.click();const s=this._tabs.find((t=>t.tabElement===e));s&&this.selectTab(s.id,!0),e.focus()}}export let EventData;export const Events={TabInvoked:Symbol("TabInvoked"),TabSelected:Symbol("TabSelected"),TabClosed:Symbol("TabClosed"),TabOrderChanged:Symbol("TabOrderChanged")};export class TabbedPaneTab{constructor(t,e,s,i,n,a){this._closeable=i,this._tabbedPane=t,this._id=e,this._title=s,this._tooltip=a,this._view=n,this._shown=!1,this._measuredWidth,this._tabElement,this._iconContainer=null}get id(){return this._id}get title(){return this._title}set title(t){t!==this._title&&(this._title=t,this._titleElement&&(this._titleElement.textContent=t),delete this._measuredWidth)}isCloseable(){return this._closeable}_setIcon(t){this._icon=t,this._tabElement&&this._titleElement&&this._createIconElement(this._tabElement,this._titleElement,!1),delete this._measuredWidth}_toggleClass(t,e){const s=this.tabElement;return s.classList.contains(t)!==e&&(s.classList.toggle(t,e),delete this._measuredWidth,!0)}get view(){return this._view}set view(t){this._view=t}get tooltip(){return this._tooltip}set tooltip(t){this._tooltip=t,this._titleElement&&Tooltip.install(this._titleElement,t||"")}get tabElement(){return this._tabElement||(this._tabElement=this._createTabElement(!1)),this._tabElement}width(){return this._width||0}setWidth(t){this.tabElement.style.width=-1===t?"":t+"px",this._width=t}setDelegate(t){this._delegate=t}_createIconElement(t,e,s){const i=tabIcons.get(t);if(i&&(i.remove(),tabIcons.delete(t)),!this._icon)return;const n=document.createElement("span");n.classList.add("tabbed-pane-header-tab-icon");const a=s?this._icon.cloneNode(!0):this._icon;n.appendChild(a),t.insertBefore(n,e),tabIcons.set(t,n)}_createTabElement(t){const e=document.createElement("div");e.classList.add("tabbed-pane-header-tab"),e.id="tab-"+this._id,ARIAUtils.markAsTab(e),ARIAUtils.setSelected(e,!1),ARIAUtils.setAccessibleName(e,this.title);const s=e.createChild("span","tabbed-pane-header-tab-title");if(s.textContent=this.title,Tooltip.install(s,this.tooltip||""),this._createIconElement(e,s,t),t||(this._titleElement=s),this._closeable){const t=e.createChild("div","tabbed-pane-close-button","dt-close-button");t.gray=!0,t.setAccessibleName(i18nString(UIStrings.closeS,{PH1:this.title})),e.classList.add("closeable")}return t?e.classList.add("measuring"):(e.addEventListener("click",this._tabClicked.bind(this),!1),e.addEventListener("auxclick",this._tabClicked.bind(this),!1),e.addEventListener("mousedown",this._tabMouseDown.bind(this),!1),e.addEventListener("mouseup",this._tabMouseUp.bind(this),!1),e.addEventListener("contextmenu",this._tabContextMenu.bind(this),!1),this._tabbedPane._allowTabReorder&&installDragHandle(e,this._startTabDragging.bind(this),this._tabDragging.bind(this),this._endTabDragging.bind(this),"-webkit-grabbing","pointer",200)),e}_tabClicked(t){const e=t,s=1===e.button;this._closeable&&(s||e.target.classList.contains("tabbed-pane-close-button"))?(this._closeTabs([this.id]),e.consume(!0)):this._tabbedPane.focus()}_tabMouseDown(t){const e=t;e.target.classList.contains("tabbed-pane-close-button")||1===e.button||this._tabbedPane.selectTab(this.id,!0)}_tabMouseUp(t){const e=t;1===e.button&&e.consume(!0)}_closeTabs(t){this._delegate?this._delegate.closeTabs(this._tabbedPane,t):this._tabbedPane.closeTabs(t,!0)}_tabContextMenu(t){const e=new ContextMenu(t);this._closeable&&(e.defaultSection().appendItem(i18nString(UIStrings.close),function(){this._closeTabs([this.id])}.bind(this)),e.defaultSection().appendItem(i18nString(UIStrings.closeOthers),function(){this._closeTabs(this._tabbedPane.otherTabs(this.id))}.bind(this)),e.defaultSection().appendItem(i18nString(UIStrings.closeTabsToTheRight),function(){this._closeTabs(this._tabbedPane._tabsToTheRight(this.id))}.bind(this)),e.defaultSection().appendItem(i18nString(UIStrings.closeAll),function(){this._closeTabs(this._tabbedPane.tabIds())}.bind(this))),this._delegate&&this._delegate.onContextMenu(this.id,e),e.show()}_startTabDragging(t){const e=t;return!e.target.classList.contains("tabbed-pane-close-button")&&(this._dragStartX=e.pageX,this._tabElement&&this._tabElement.classList.add("dragging"),this._tabbedPane._tabSlider.remove(),!0)}_tabDragging(t){const e=t,s=this._tabbedPane._tabsElement.childNodes;for(let a=0;a<s.length;++a){let t=s[a];if(!this._tabElement||t===this._tabElement)continue;if(!(t.offsetLeft+t.clientWidth>this._tabElement.offsetLeft&&this._tabElement.offsetLeft+this._tabElement.clientWidth>t.offsetLeft))continue;const i=this._dragStartX;if(Math.abs(e.pageX-i)<t.clientWidth/2+5)break;e.pageX-i>0&&(t=t.nextSibling,++a);const n=this._tabElement.offsetLeft;this._tabbedPane._insertBefore(this,a),this._dragStartX=i+this._tabElement.offsetLeft-n;break}const i=this._dragStartX,n=this._tabElement;!n.previousSibling&&e.pageX-i<0||!n.nextSibling&&e.pageX-i>0?n.style.setProperty("left","0px"):n.style.setProperty("left",e.pageX-i+"px")}_endTabDragging(t){const e=this._tabElement;e.classList.remove("dragging"),e.style.removeProperty("left"),delete this._dragStartX,this._tabbedPane._updateTabSlider()}}const tabIcons=new WeakMap;export class TabbedPaneTabDelegate{closeTabs(t,e){}onContextMenu(t,e){}}