import*as i18n from"../i18n/i18n.js";import*as SDK from"../sdk/sdk.js";import*as UI from"../ui/ui.js";import{ContextDetailBuilder,ContextSummaryBuilder}from"./AudioContextContentBuilder.js";import{AudioContextSelector}from"./AudioContextSelector.js";import{GraphManager}from"./graph_visualizer/GraphManager.js";import{WebAudioModel}from"./WebAudioModel.js";const UIStrings={openAPageThatUsesWebAudioApiTo:"Open a page that uses Web Audio API to start monitoring."},str_=i18n.i18n.registerUIStrings("web_audio/WebAudioView.ts",UIStrings),i18nString=i18n.i18n.getLocalizedString.bind(void 0,str_);let webAudioViewInstance;export class WebAudioView extends UI.ThrottledWidget.ThrottledWidget{constructor(){super(!0,1e3),this.element.classList.add("web-audio-drawer"),this.registerRequiredCSS("web_audio/webAudio.css",{enableLegacyPatching:!1});const e=this.contentElement.createChild("div","web-audio-toolbar-container vbox");this._contextSelector=new AudioContextSelector;const t=new UI.Toolbar.Toolbar("web-audio-toolbar",e);t.appendToolbarItem(UI.Toolbar.Toolbar.createActionButtonForId("components.collect-garbage")),t.appendSeparator(),t.appendToolbarItem(this._contextSelector.toolbarItem()),this._contentContainer=this.contentElement.createChild("div","web-audio-content-container vbox flex-auto"),this._detailViewContainer=this._contentContainer.createChild("div","web-audio-details-container vbox flex-auto"),this._graphManager=new GraphManager,this._landingPage=new UI.Widget.VBox,this._landingPage.contentElement.classList.add("web-audio-landing-page","fill"),this._landingPage.contentElement.appendChild(UI.Fragment.html`
  <div>
  <p>${i18nString(UIStrings.openAPageThatUsesWebAudioApiTo)}</p>
  </div>
  `),this._landingPage.show(this._detailViewContainer),this._summaryBarContainer=this._contentContainer.createChild("div","web-audio-summary-container"),this._contextSelector.addEventListener("ContextSelected",(e=>{const t=e.data;this._updateDetailView(t),this.doUpdate()})),SDK.SDKModel.TargetManager.instance().observeModels(WebAudioModel,this)}static instance(e={forceNew:null}){const{forceNew:t}=e;return webAudioViewInstance&&!t||(webAudioViewInstance=new WebAudioView),webAudioViewInstance}wasShown(){super.wasShown();for(const e of SDK.SDKModel.TargetManager.instance().models(WebAudioModel))this._addEventListeners(e)}willHide(){for(const e of SDK.SDKModel.TargetManager.instance().models(WebAudioModel))this._removeEventListeners(e)}modelAdded(e){this.isShowing()&&this._addEventListeners(e)}modelRemoved(e){this._removeEventListeners(e)}async doUpdate(){await this._pollRealtimeData(),this.update()}_addEventListeners(e){e.ensureEnabled(),e.addEventListener("ContextCreated",this._contextCreated,this),e.addEventListener("ContextDestroyed",this._contextDestroyed,this),e.addEventListener("ContextChanged",this._contextChanged,this),e.addEventListener("ModelReset",this._reset,this),e.addEventListener("ModelSuspend",this._suspendModel,this),e.addEventListener("AudioListenerCreated",this._audioListenerCreated,this),e.addEventListener("AudioListenerWillBeDestroyed",this._audioListenerWillBeDestroyed,this),e.addEventListener("AudioNodeCreated",this._audioNodeCreated,this),e.addEventListener("AudioNodeWillBeDestroyed",this._audioNodeWillBeDestroyed,this),e.addEventListener("AudioParamCreated",this._audioParamCreated,this),e.addEventListener("AudioParamWillBeDestroyed",this._audioParamWillBeDestroyed,this),e.addEventListener("NodesConnected",this._nodesConnected,this),e.addEventListener("NodesDisconnected",this._nodesDisconnected,this),e.addEventListener("NodeParamConnected",this._nodeParamConnected,this),e.addEventListener("NodeParamDisconnected",this._nodeParamDisconnected,this)}_removeEventListeners(e){e.removeEventListener("ContextCreated",this._contextCreated,this),e.removeEventListener("ContextDestroyed",this._contextDestroyed,this),e.removeEventListener("ContextChanged",this._contextChanged,this),e.removeEventListener("ModelReset",this._reset,this),e.removeEventListener("ModelSuspend",this._suspendModel,this),e.removeEventListener("AudioListenerCreated",this._audioListenerCreated,this),e.removeEventListener("AudioListenerWillBeDestroyed",this._audioListenerWillBeDestroyed,this),e.removeEventListener("AudioNodeCreated",this._audioNodeCreated,this),e.removeEventListener("AudioNodeWillBeDestroyed",this._audioNodeWillBeDestroyed,this),e.removeEventListener("AudioParamCreated",this._audioParamCreated,this),e.removeEventListener("AudioParamWillBeDestroyed",this._audioParamWillBeDestroyed,this),e.removeEventListener("NodesConnected",this._nodesConnected,this),e.removeEventListener("NodesDisconnected",this._nodesDisconnected,this),e.removeEventListener("NodeParamConnected",this._nodeParamConnected,this),e.removeEventListener("NodeParamDisconnected",this._nodeParamDisconnected,this)}_contextCreated(e){const t=e.data;this._graphManager.createContext(t.contextId),this._contextSelector.contextCreated(e)}_contextDestroyed(e){const t=e.data;this._graphManager.destroyContext(t),this._contextSelector.contextDestroyed(e)}_contextChanged(e){const t=e.data;this._graphManager.hasContext(t.contextId)&&this._contextSelector.contextChanged(e)}_reset(){this._landingPage.isShowing()&&this._landingPage.detach(),this._contextSelector.reset(),this._detailViewContainer.removeChildren(),this._landingPage.show(this._detailViewContainer),this._graphManager.clearGraphs()}_suspendModel(){this._graphManager.clearGraphs()}_audioListenerCreated(e){const t=e.data,n=this._graphManager.getGraph(t.contextId);n&&n.addNode({nodeId:t.listenerId,nodeType:"Listener",numberOfInputs:0,numberOfOutputs:0})}_audioListenerWillBeDestroyed(e){const{contextId:t,listenerId:n}=e.data,o=this._graphManager.getGraph(t);o&&o.removeNode(n)}_audioNodeCreated(e){const t=e.data,n=this._graphManager.getGraph(t.contextId);n&&n.addNode({nodeId:t.nodeId,nodeType:t.nodeType,numberOfInputs:t.numberOfInputs,numberOfOutputs:t.numberOfOutputs})}_audioNodeWillBeDestroyed(e){const{contextId:t,nodeId:n}=e.data,o=this._graphManager.getGraph(t);o&&o.removeNode(n)}_audioParamCreated(e){const t=e.data,n=this._graphManager.getGraph(t.contextId);n&&n.addParam({paramId:t.paramId,paramType:t.paramType,nodeId:t.nodeId})}_audioParamWillBeDestroyed(e){const{contextId:t,paramId:n}=e.data,o=this._graphManager.getGraph(t);o&&o.removeParam(n)}_nodesConnected(e){const{contextId:t,sourceId:n,destinationId:o,sourceOutputIndex:a,destinationInputIndex:i}=e.data,d=this._graphManager.getGraph(t);d&&d.addNodeToNodeConnection({sourceId:n,destinationId:o,sourceOutputIndex:a,destinationInputIndex:i})}_nodesDisconnected(e){const{contextId:t,sourceId:n,destinationId:o,sourceOutputIndex:a,destinationInputIndex:i}=e.data,d=this._graphManager.getGraph(t);d&&d.removeNodeToNodeConnection({sourceId:n,destinationId:o,sourceOutputIndex:a,destinationInputIndex:i})}_nodeParamConnected(e){const{contextId:t,sourceId:n,destinationId:o,sourceOutputIndex:a}=e.data,i=this._graphManager.getGraph(t);if(!i)return;const d=i.getNodeIdByParamId(o);d&&i.addNodeToParamConnection({sourceId:n,destinationId:d,sourceOutputIndex:a,destinationParamId:o})}_nodeParamDisconnected(e){const{contextId:t,sourceId:n,destinationId:o,sourceOutputIndex:a}=e.data,i=this._graphManager.getGraph(t);if(!i)return;const d=i.getNodeIdByParamId(o);d&&i.removeNodeToParamConnection({sourceId:n,destinationId:d,sourceOutputIndex:a,destinationParamId:o})}_updateDetailView(e){this._landingPage.isShowing()&&this._landingPage.detach();const t=new ContextDetailBuilder(e);this._detailViewContainer.removeChildren(),this._detailViewContainer.appendChild(t.getFragment())}_updateSummaryBar(e,t){const n=new ContextSummaryBuilder(e,t);this._summaryBarContainer.removeChildren(),this._summaryBarContainer.appendChild(n.getFragment())}_clearSummaryBar(){this._summaryBarContainer.removeChildren()}async _pollRealtimeData(){const e=this._contextSelector.selectedContext();if(e)for(const t of SDK.SDKModel.TargetManager.instance().models(WebAudioModel))if("realtime"===e.contextType){if(!this._graphManager.hasContext(e.contextId))continue;const n=await t.requestRealtimeData(e.contextId);n&&this._updateSummaryBar(e.contextId,n)}else this._clearSummaryBar();else this._clearSummaryBar()}}